#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2831
#define LARGE_STATE_COUNT 189
#define SYMBOL_COUNT 271
#define ALIAS_COUNT 4
#define TOKEN_COUNT 108
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 140

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_import = 3,
  anon_sym_DOT = 4,
  anon_sym_from = 5,
  anon_sym___future__ = 6,
  anon_sym_LPAREN = 7,
  anon_sym_RPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_as = 10,
  anon_sym_STAR = 11,
  anon_sym_print = 12,
  anon_sym_GT_GT = 13,
  anon_sym_assert = 14,
  anon_sym_COLON_EQ = 15,
  anon_sym_return = 16,
  anon_sym_del = 17,
  anon_sym_raise = 18,
  anon_sym_pass = 19,
  anon_sym_break = 20,
  anon_sym_continue = 21,
  anon_sym_if = 22,
  anon_sym_COLON = 23,
  anon_sym_elif = 24,
  anon_sym_else = 25,
  anon_sym_match = 26,
  anon_sym_case = 27,
  anon_sym_async = 28,
  anon_sym_for = 29,
  anon_sym_in = 30,
  anon_sym_while = 31,
  anon_sym_try = 32,
  anon_sym_except = 33,
  anon_sym_except_STAR = 34,
  anon_sym_finally = 35,
  anon_sym_with = 36,
  anon_sym_def = 37,
  anon_sym_DASH_GT = 38,
  anon_sym_STAR_STAR = 39,
  anon_sym_global = 40,
  anon_sym_nonlocal = 41,
  anon_sym_exec = 42,
  anon_sym_type = 43,
  anon_sym_EQ = 44,
  anon_sym_class = 45,
  anon_sym_LBRACK = 46,
  anon_sym_RBRACK = 47,
  anon_sym_AT = 48,
  anon_sym_DASH = 49,
  anon_sym__ = 50,
  anon_sym_PIPE = 51,
  anon_sym_LBRACE = 52,
  anon_sym_RBRACE = 53,
  anon_sym_PLUS = 54,
  anon_sym_not = 55,
  anon_sym_and = 56,
  anon_sym_or = 57,
  anon_sym_SLASH = 58,
  anon_sym_PERCENT = 59,
  anon_sym_SLASH_SLASH = 60,
  anon_sym_AMP = 61,
  anon_sym_CARET = 62,
  anon_sym_LT_LT = 63,
  anon_sym_TILDE = 64,
  anon_sym_LT = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_EQ_EQ = 67,
  anon_sym_BANG_EQ = 68,
  anon_sym_GT_EQ = 69,
  anon_sym_GT = 70,
  anon_sym_LT_GT = 71,
  anon_sym_is = 72,
  anon_sym_lambda = 73,
  anon_sym_PLUS_EQ = 74,
  anon_sym_DASH_EQ = 75,
  anon_sym_STAR_EQ = 76,
  anon_sym_SLASH_EQ = 77,
  anon_sym_AT_EQ = 78,
  anon_sym_SLASH_SLASH_EQ = 79,
  anon_sym_PERCENT_EQ = 80,
  anon_sym_STAR_STAR_EQ = 81,
  anon_sym_GT_GT_EQ = 82,
  anon_sym_LT_LT_EQ = 83,
  anon_sym_AMP_EQ = 84,
  anon_sym_CARET_EQ = 85,
  anon_sym_PIPE_EQ = 86,
  anon_sym_yield = 87,
  sym_ellipsis = 88,
  sym_escape_sequence = 89,
  anon_sym_BSLASH = 90,
  aux_sym_format_specifier_token1 = 91,
  sym_type_conversion = 92,
  sym_integer = 93,
  sym_float = 94,
  anon_sym_await = 95,
  sym_true = 96,
  sym_false = 97,
  sym_none = 98,
  sym_comment = 99,
  sym_line_continuation = 100,
  sym__newline = 101,
  sym__indent = 102,
  sym__dedent = 103,
  sym_string_start = 104,
  sym__string_content = 105,
  sym_escape_interpolation = 106,
  sym_string_end = 107,
  sym_module = 108,
  sym__statement = 109,
  sym__simple_statements = 110,
  sym_import_statement = 111,
  sym_import_prefix = 112,
  sym_relative_import = 113,
  sym_future_import_statement = 114,
  sym_import_from_statement = 115,
  sym__import_list = 116,
  sym_aliased_import = 117,
  sym_wildcard_import = 118,
  sym_print_statement = 119,
  sym_chevron = 120,
  sym_assert_statement = 121,
  sym_expression_statement = 122,
  sym_named_expression = 123,
  sym__named_expression_lhs = 124,
  sym_return_statement = 125,
  sym_delete_statement = 126,
  sym_raise_statement = 127,
  sym_pass_statement = 128,
  sym_break_statement = 129,
  sym_continue_statement = 130,
  sym_if_statement = 131,
  sym_elif_clause = 132,
  sym_else_clause = 133,
  sym_match_statement = 134,
  sym__match_block = 135,
  sym_case_clause = 136,
  sym_for_statement = 137,
  sym_while_statement = 138,
  sym_try_statement = 139,
  sym_except_clause = 140,
  sym_except_group_clause = 141,
  sym_finally_clause = 142,
  sym_with_statement = 143,
  sym_with_clause = 144,
  sym_with_item = 145,
  sym_function_definition = 146,
  sym_parameters = 147,
  sym_lambda_parameters = 148,
  sym_list_splat = 149,
  sym_dictionary_splat = 150,
  sym_global_statement = 151,
  sym_nonlocal_statement = 152,
  sym_exec_statement = 153,
  sym_type_alias_statement = 154,
  sym_class_definition = 155,
  sym_type_parameter = 156,
  sym_parenthesized_list_splat = 157,
  sym_argument_list = 158,
  sym_decorated_definition = 159,
  sym_decorator = 160,
  sym_block = 161,
  sym_expression_list = 162,
  sym_dotted_name = 163,
  sym_case_pattern = 164,
  sym__simple_pattern = 165,
  sym__as_pattern = 166,
  sym_union_pattern = 167,
  sym__list_pattern = 168,
  sym__tuple_pattern = 169,
  sym_dict_pattern = 170,
  sym__key_value_pattern = 171,
  sym_keyword_pattern = 172,
  sym_splat_pattern = 173,
  sym_class_pattern = 174,
  sym_complex_pattern = 175,
  sym__parameters = 176,
  sym__patterns = 177,
  sym_parameter = 178,
  sym_pattern = 179,
  sym_tuple_pattern = 180,
  sym_list_pattern = 181,
  sym_default_parameter = 182,
  sym_typed_default_parameter = 183,
  sym_list_splat_pattern = 184,
  sym_dictionary_splat_pattern = 185,
  sym_as_pattern = 186,
  sym__expression_within_for_in_clause = 187,
  sym_expression = 188,
  sym_primary_expression = 189,
  sym_not_operator = 190,
  sym_boolean_operator = 191,
  sym_binary_operator = 192,
  sym_unary_operator = 193,
  sym_comparison_operator = 194,
  sym_lambda = 195,
  sym_lambda_within_for_in_clause = 196,
  sym_assignment = 197,
  sym_augmented_assignment = 198,
  sym_pattern_list = 199,
  sym__right_hand_side = 200,
  sym_yield = 201,
  sym_attribute = 202,
  sym_subscript = 203,
  sym_slice = 204,
  sym_call = 205,
  sym_typed_parameter = 206,
  sym_type = 207,
  sym_splat_type = 208,
  sym_generic_type = 209,
  sym_union_type = 210,
  sym_constrained_type = 211,
  sym_member_type = 212,
  sym_keyword_argument = 213,
  sym_list = 214,
  sym_set = 215,
  sym_tuple = 216,
  sym_dictionary = 217,
  sym_pair = 218,
  sym_list_comprehension = 219,
  sym_dictionary_comprehension = 220,
  sym_set_comprehension = 221,
  sym_generator_expression = 222,
  sym__comprehension_clauses = 223,
  sym_parenthesized_expression = 224,
  sym__collection_elements = 225,
  sym_for_in_clause = 226,
  sym_if_clause = 227,
  sym_conditional_expression = 228,
  sym_concatenated_string = 229,
  sym_string = 230,
  sym_string_content = 231,
  sym_interpolation = 232,
  sym__f_expression = 233,
  sym__not_escape_sequence = 234,
  sym_format_specifier = 235,
  sym_await = 236,
  sym_positional_separator = 237,
  sym_keyword_separator = 238,
  aux_sym_module_repeat1 = 239,
  aux_sym__simple_statements_repeat1 = 240,
  aux_sym_import_prefix_repeat1 = 241,
  aux_sym__import_list_repeat1 = 242,
  aux_sym_print_statement_repeat1 = 243,
  aux_sym_assert_statement_repeat1 = 244,
  aux_sym_if_statement_repeat1 = 245,
  aux_sym_match_statement_repeat1 = 246,
  aux_sym__match_block_repeat1 = 247,
  aux_sym_case_clause_repeat1 = 248,
  aux_sym_try_statement_repeat1 = 249,
  aux_sym_try_statement_repeat2 = 250,
  aux_sym_with_clause_repeat1 = 251,
  aux_sym_global_statement_repeat1 = 252,
  aux_sym_type_parameter_repeat1 = 253,
  aux_sym_argument_list_repeat1 = 254,
  aux_sym_decorated_definition_repeat1 = 255,
  aux_sym_dotted_name_repeat1 = 256,
  aux_sym_union_pattern_repeat1 = 257,
  aux_sym_dict_pattern_repeat1 = 258,
  aux_sym__parameters_repeat1 = 259,
  aux_sym__patterns_repeat1 = 260,
  aux_sym_comparison_operator_repeat1 = 261,
  aux_sym_subscript_repeat1 = 262,
  aux_sym_dictionary_repeat1 = 263,
  aux_sym__comprehension_clauses_repeat1 = 264,
  aux_sym__collection_elements_repeat1 = 265,
  aux_sym_for_in_clause_repeat1 = 266,
  aux_sym_concatenated_string_repeat1 = 267,
  aux_sym_string_repeat1 = 268,
  aux_sym_string_content_repeat1 = 269,
  aux_sym_format_specifier_repeat1 = 270,
  alias_sym_as_pattern_target = 271,
  alias_sym_format_expression = 272,
  anon_alias_sym_isnot = 273,
  anon_alias_sym_notin = 274,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_match] = "match",
  [anon_sym_case] = "case",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_except_STAR] = "except*",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT] = "@",
  [anon_sym_DASH] = "-",
  [anon_sym__] = "_",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PLUS] = "+",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_await] = "await",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_comment] = "comment",
  [sym_line_continuation] = "line_continuation",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_string_start] = "string_start",
  [sym__string_content] = "_string_content",
  [sym_escape_interpolation] = "escape_interpolation",
  [sym_string_end] = "string_end",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym__named_expression_lhs] = "_named_expression_lhs",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_match_statement] = "match_statement",
  [sym__match_block] = "block",
  [sym_case_clause] = "case_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_except_group_clause] = "except_group_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_type_alias_statement] = "type_alias_statement",
  [sym_class_definition] = "class_definition",
  [sym_type_parameter] = "type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym_case_pattern] = "case_pattern",
  [sym__simple_pattern] = "_simple_pattern",
  [sym__as_pattern] = "as_pattern",
  [sym_union_pattern] = "union_pattern",
  [sym__list_pattern] = "list_pattern",
  [sym__tuple_pattern] = "tuple_pattern",
  [sym_dict_pattern] = "dict_pattern",
  [sym__key_value_pattern] = "_key_value_pattern",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym_splat_pattern] = "splat_pattern",
  [sym_class_pattern] = "class_pattern",
  [sym_complex_pattern] = "complex_pattern",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_splat_type] = "splat_type",
  [sym_generic_type] = "generic_type",
  [sym_union_type] = "union_type",
  [sym_constrained_type] = "constrained_type",
  [sym_member_type] = "member_type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym_generator_expression] = "generator_expression",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [sym_format_specifier] = "format_specifier",
  [sym_await] = "await",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_match_statement_repeat1] = "match_statement_repeat1",
  [aux_sym__match_block_repeat1] = "_match_block_repeat1",
  [aux_sym_case_clause_repeat1] = "case_clause_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_try_statement_repeat2] = "try_statement_repeat2",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_type_parameter_repeat1] = "type_parameter_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_union_pattern_repeat1] = "union_pattern_repeat1",
  [aux_sym_dict_pattern_repeat1] = "dict_pattern_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym__patterns_repeat1] = "_patterns_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [alias_sym_as_pattern_target] = "as_pattern_target",
  [alias_sym_format_expression] = "format_expression",
  [anon_alias_sym_isnot] = "is not",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_except_STAR] = anon_sym_except_STAR,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym__] = anon_sym__,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_await] = anon_sym_await,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_comment] = sym_comment,
  [sym_line_continuation] = sym_line_continuation,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_string_start] = sym_string_start,
  [sym__string_content] = sym__string_content,
  [sym_escape_interpolation] = sym_escape_interpolation,
  [sym_string_end] = sym_string_end,
  [sym_module] = sym_module,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym__named_expression_lhs] = sym__named_expression_lhs,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_match_statement] = sym_match_statement,
  [sym__match_block] = sym_block,
  [sym_case_clause] = sym_case_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_except_group_clause] = sym_except_group_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_alias_statement] = sym_type_alias_statement,
  [sym_class_definition] = sym_class_definition,
  [sym_type_parameter] = sym_type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_decorated_definition] = sym_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_dotted_name] = sym_dotted_name,
  [sym_case_pattern] = sym_case_pattern,
  [sym__simple_pattern] = sym__simple_pattern,
  [sym__as_pattern] = sym_as_pattern,
  [sym_union_pattern] = sym_union_pattern,
  [sym__list_pattern] = sym_list_pattern,
  [sym__tuple_pattern] = sym_tuple_pattern,
  [sym_dict_pattern] = sym_dict_pattern,
  [sym__key_value_pattern] = sym__key_value_pattern,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym_splat_pattern] = sym_splat_pattern,
  [sym_class_pattern] = sym_class_pattern,
  [sym_complex_pattern] = sym_complex_pattern,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_splat_type] = sym_splat_type,
  [sym_generic_type] = sym_generic_type,
  [sym_union_type] = sym_union_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_member_type] = sym_member_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_generator_expression] = sym_generator_expression,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string] = sym_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [sym_format_specifier] = sym_format_specifier,
  [sym_await] = sym_await,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_match_statement_repeat1] = aux_sym_match_statement_repeat1,
  [aux_sym__match_block_repeat1] = aux_sym__match_block_repeat1,
  [aux_sym_case_clause_repeat1] = aux_sym_case_clause_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_try_statement_repeat2] = aux_sym_try_statement_repeat2,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_type_parameter_repeat1] = aux_sym_type_parameter_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_decorated_definition_repeat1] = aux_sym_decorated_definition_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_union_pattern_repeat1] = aux_sym_union_pattern_repeat1,
  [aux_sym_dict_pattern_repeat1] = aux_sym_dict_pattern_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym__patterns_repeat1] = aux_sym__patterns_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [alias_sym_as_pattern_target] = alias_sym_as_pattern_target,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [anon_alias_sym_isnot] = anon_alias_sym_isnot,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__named_expression_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_except_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_case_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_union_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dict_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__key_value_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_class_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_complex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dict_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_as_pattern_target] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_isnot] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_definition = 11,
  field_expression = 12,
  field_format_specifier = 13,
  field_function = 14,
  field_guard = 15,
  field_key = 16,
  field_left = 17,
  field_module_name = 18,
  field_name = 19,
  field_object = 20,
  field_operator = 21,
  field_operators = 22,
  field_parameters = 23,
  field_return_type = 24,
  field_right = 25,
  field_subject = 26,
  field_subscript = 27,
  field_superclasses = 28,
  field_type = 29,
  field_type_conversion = 30,
  field_type_parameters = 31,
  field_value = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_expression] = "expression",
  [field_format_specifier] = "format_specifier",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subject] = "subject",
  [field_subscript] = "subscript",
  [field_superclasses] = "superclasses",
  [field_type] = "type",
  [field_type_conversion] = "type_conversion",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 2},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 1},
  [12] = {.index = 10, .length = 1},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 1},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 1},
  [17] = {.index = 17, .length = 1},
  [18] = {.index = 18, .length = 2},
  [19] = {.index = 20, .length = 2},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 24, .length = 3},
  [22] = {.index = 27, .length = 1},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 30, .length = 1},
  [25] = {.index = 31, .length = 2},
  [26] = {.index = 33, .length = 1},
  [27] = {.index = 34, .length = 1},
  [28] = {.index = 35, .length = 2},
  [29] = {.index = 37, .length = 2},
  [30] = {.index = 39, .length = 1},
  [31] = {.index = 40, .length = 2},
  [32] = {.index = 42, .length = 1},
  [34] = {.index = 43, .length = 1},
  [35] = {.index = 44, .length = 2},
  [36] = {.index = 46, .length = 1},
  [37] = {.index = 47, .length = 2},
  [38] = {.index = 49, .length = 1},
  [39] = {.index = 50, .length = 3},
  [40] = {.index = 53, .length = 2},
  [41] = {.index = 55, .length = 2},
  [42] = {.index = 17, .length = 1},
  [43] = {.index = 57, .length = 1},
  [44] = {.index = 58, .length = 2},
  [45] = {.index = 60, .length = 2},
  [46] = {.index = 62, .length = 1},
  [47] = {.index = 63, .length = 2},
  [48] = {.index = 65, .length = 2},
  [49] = {.index = 67, .length = 2},
  [50] = {.index = 67, .length = 2},
  [52] = {.index = 69, .length = 2},
  [53] = {.index = 71, .length = 2},
  [54] = {.index = 73, .length = 1},
  [55] = {.index = 74, .length = 3},
  [56] = {.index = 77, .length = 3},
  [57] = {.index = 80, .length = 3},
  [58] = {.index = 83, .length = 3},
  [59] = {.index = 86, .length = 4},
  [60] = {.index = 90, .length = 1},
  [61] = {.index = 91, .length = 3},
  [62] = {.index = 94, .length = 3},
  [63] = {.index = 97, .length = 2},
  [64] = {.index = 99, .length = 2},
  [65] = {.index = 101, .length = 3},
  [66] = {.index = 104, .length = 3},
  [67] = {.index = 107, .length = 3},
  [68] = {.index = 110, .length = 3},
  [69] = {.index = 113, .length = 3},
  [70] = {.index = 18, .length = 2},
  [71] = {.index = 116, .length = 1},
  [72] = {.index = 117, .length = 3},
  [73] = {.index = 120, .length = 2},
  [74] = {.index = 122, .length = 2},
  [75] = {.index = 124, .length = 2},
  [76] = {.index = 126, .length = 3},
  [77] = {.index = 129, .length = 1},
  [78] = {.index = 130, .length = 2},
  [79] = {.index = 132, .length = 2},
  [80] = {.index = 134, .length = 4},
  [81] = {.index = 138, .length = 2},
  [82] = {.index = 140, .length = 4},
  [83] = {.index = 144, .length = 4},
  [84] = {.index = 148, .length = 1},
  [85] = {.index = 149, .length = 4},
  [86] = {.index = 153, .length = 2},
  [87] = {.index = 155, .length = 3},
  [88] = {.index = 158, .length = 3},
  [89] = {.index = 161, .length = 4},
  [91] = {.index = 165, .length = 4},
  [92] = {.index = 169, .length = 4},
  [93] = {.index = 173, .length = 4},
  [94] = {.index = 177, .length = 4},
  [95] = {.index = 181, .length = 4},
  [96] = {.index = 185, .length = 3},
  [97] = {.index = 188, .length = 3},
  [98] = {.index = 191, .length = 2},
  [99] = {.index = 193, .length = 3},
  [100] = {.index = 196, .length = 5},
  [101] = {.index = 201, .length = 3},
  [102] = {.index = 204, .length = 4},
  [103] = {.index = 208, .length = 4},
  [104] = {.index = 212, .length = 4},
  [105] = {.index = 216, .length = 4},
  [107] = {.index = 220, .length = 4},
  [108] = {.index = 224, .length = 5},
  [109] = {.index = 229, .length = 5},
  [110] = {.index = 234, .length = 3},
  [111] = {.index = 237, .length = 2},
  [112] = {.index = 239, .length = 1},
  [113] = {.index = 240, .length = 4},
  [114] = {.index = 244, .length = 4},
  [115] = {.index = 248, .length = 4},
  [116] = {.index = 252, .length = 5},
  [117] = {.index = 257, .length = 5},
  [118] = {.index = 262, .length = 5},
  [119] = {.index = 267, .length = 5},
  [120] = {.index = 272, .length = 4},
  [121] = {.index = 276, .length = 4},
  [122] = {.index = 280, .length = 2},
  [123] = {.index = 282, .length = 1},
  [124] = {.index = 283, .length = 2},
  [125] = {.index = 285, .length = 2},
  [126] = {.index = 287, .length = 5},
  [127] = {.index = 292, .length = 5},
  [128] = {.index = 297, .length = 5},
  [130] = {.index = 302, .length = 6},
  [131] = {.index = 308, .length = 2},
  [132] = {.index = 310, .length = 2},
  [133] = {.index = 312, .length = 3},
  [134] = {.index = 315, .length = 1},
  [135] = {.index = 316, .length = 6},
  [136] = {.index = 322, .length = 3},
  [137] = {.index = 325, .length = 2},
  [138] = {.index = 327, .length = 2},
  [139] = {.index = 329, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_argument, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_code, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_operators, 1, .inherited = true},
  [10] =
    {field_definition, 1},
  [11] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [13] =
    {field_argument, 2, .inherited = true},
  [14] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [16] =
    {field_cause, 2},
  [17] =
    {field_body, 2},
  [18] =
    {field_name, 0},
    {field_value, 2},
  [20] =
    {field_left, 0},
    {field_type, 2},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [27] =
    {field_alias, 2},
  [28] =
    {field_attribute, 2},
    {field_object, 0},
  [30] =
    {field_operators, 0},
  [31] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [33] =
    {field_expression, 1},
  [34] =
    {field_name, 1},
  [35] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [37] =
    {field_alias, 2},
    {field_name, 0},
  [39] =
    {field_name, 3, .inherited = true},
  [40] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [42] =
    {field_module_name, 1},
  [43] =
    {field_body, 1},
  [44] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [46] =
    {field_cause, 3},
  [47] =
    {field_condition, 1},
    {field_consequence, 3},
  [49] =
    {field_subject, 1},
  [50] =
    {field_alternative, 3, .inherited = true},
    {field_body, 3},
    {field_subject, 1},
  [53] =
    {field_subject, 0, .inherited = true},
    {field_subject, 1, .inherited = true},
  [55] =
    {field_body, 3},
    {field_condition, 1},
  [57] =
    {field_body, 3},
  [58] =
    {field_body, 3},
    {field_name, 1},
  [60] =
    {field_key, 0},
    {field_value, 2},
  [62] =
    {field_type, 2},
  [63] =
    {field_body, 3},
    {field_parameters, 1},
  [65] =
    {field_subscript, 2},
    {field_value, 0},
  [67] =
    {field_operators, 0},
    {field_operators, 1},
  [69] =
    {field_expression, 1},
    {field_type_conversion, 2},
  [71] =
    {field_expression, 1},
    {field_format_specifier, 2},
  [73] =
    {field_alternative, 0},
  [74] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [77] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [80] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [83] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
  [86] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [90] =
    {field_body, 4},
  [91] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [94] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [97] =
    {field_body, 2},
    {field_body, 3},
  [99] =
    {field_body, 3},
    {field_body, 4},
  [101] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [104] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [107] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [110] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [113] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [116] =
    {field_subscript, 1},
  [117] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [120] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [122] =
    {field_expression, 1},
    {field_type_conversion, 3},
  [124] =
    {field_expression, 1},
    {field_format_specifier, 3},
  [126] =
    {field_expression, 1},
    {field_format_specifier, 3},
    {field_type_conversion, 2},
  [129] =
    {field_name, 4, .inherited = true},
  [130] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [132] =
    {field_left, 1},
    {field_right, 3},
  [134] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [138] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [140] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [144] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [148] =
    {field_alternative, 1, .inherited = true},
  [149] =
    {field_alternative, 5, .inherited = true},
    {field_body, 5},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [153] =
    {field_body, 4},
    {field_body, 5},
  [155] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [158] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [161] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [165] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [169] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [173] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [177] =
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [181] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [185] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [188] =
    {field_expression, 1},
    {field_format_specifier, 4},
    {field_type_conversion, 3},
  [191] =
    {field_left, 2},
    {field_right, 4},
  [193] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [196] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [201] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [204] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [208] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [212] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [216] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [220] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [224] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [229] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [234] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [237] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [239] =
    {field_consequence, 3},
  [240] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [244] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [248] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [252] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [257] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [262] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [267] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [272] =
    {field_key, 1, .inherited = true},
    {field_key, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [276] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [280] =
    {field_key, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [282] =
    {field_consequence, 4},
  [283] =
    {field_consequence, 3},
    {field_consequence, 4},
  [285] =
    {field_consequence, 4},
    {field_guard, 2},
  [287] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [292] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [297] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [302] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [308] =
    {field_consequence, 4},
    {field_consequence, 5},
  [310] =
    {field_consequence, 5},
    {field_guard, 3},
  [312] =
    {field_consequence, 4},
    {field_consequence, 5},
    {field_guard, 2},
  [315] =
    {field_consequence, 5},
  [316] =
    {field_body, 8},
    {field_body, 9},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [322] =
    {field_consequence, 5},
    {field_consequence, 6},
    {field_guard, 3},
  [325] =
    {field_consequence, 5},
    {field_consequence, 6},
  [327] =
    {field_consequence, 6},
    {field_guard, 4},
  [329] =
    {field_consequence, 6},
    {field_consequence, 7},
    {field_guard, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = sym_list_splat,
  },
  [5] = {
    [1] = sym_identifier,
  },
  [22] = {
    [2] = alias_sym_as_pattern_target,
  },
  [33] = {
    [1] = sym_parenthesized_expression,
  },
  [37] = {
    [3] = sym_block,
  },
  [41] = {
    [3] = sym_block,
  },
  [42] = {
    [2] = sym_block,
  },
  [43] = {
    [3] = sym_block,
  },
  [44] = {
    [3] = sym_block,
  },
  [49] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [50] = {
    [0] = anon_alias_sym_isnot,
    [1] = anon_alias_sym_isnot,
  },
  [51] = {
    [0] = alias_sym_format_expression,
  },
  [55] = {
    [3] = sym_block,
  },
  [56] = {
    [3] = sym_block,
  },
  [60] = {
    [4] = sym_block,
  },
  [61] = {
    [3] = sym_block,
  },
  [65] = {
    [4] = sym_block,
  },
  [67] = {
    [4] = sym_block,
  },
  [68] = {
    [4] = sym_block,
  },
  [70] = {
    [0] = sym_identifier,
  },
  [80] = {
    [3] = sym_block,
  },
  [87] = {
    [5] = sym_block,
  },
  [88] = {
    [5] = sym_block,
  },
  [90] = {
    [2] = sym_block,
  },
  [92] = {
    [5] = sym_block,
  },
  [94] = {
    [5] = sym_block,
  },
  [101] = {
    [6] = sym_block,
  },
  [103] = {
    [6] = sym_block,
  },
  [104] = {
    [5] = sym_block,
  },
  [106] = {
    [3] = sym_block,
  },
  [107] = {
    [6] = sym_block,
  },
  [112] = {
    [3] = sym_block,
  },
  [113] = {
    [6] = sym_block,
  },
  [115] = {
    [7] = sym_block,
  },
  [119] = {
    [7] = sym_block,
  },
  [123] = {
    [4] = sym_block,
  },
  [125] = {
    [4] = sym_block,
  },
  [128] = {
    [8] = sym_block,
  },
  [129] = {
    [5] = sym_block,
  },
  [132] = {
    [5] = sym_block,
  },
  [134] = {
    [5] = sym_block,
  },
  [138] = {
    [6] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_list_splat_pattern, 2,
    sym_list_splat_pattern,
    sym_list_splat,
  sym_expression, 2,
    sym_expression,
    alias_sym_as_pattern_target,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 2,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 3,
  [36] = 4,
  [37] = 5,
  [38] = 6,
  [39] = 7,
  [40] = 8,
  [41] = 9,
  [42] = 10,
  [43] = 11,
  [44] = 12,
  [45] = 13,
  [46] = 14,
  [47] = 15,
  [48] = 16,
  [49] = 17,
  [50] = 18,
  [51] = 19,
  [52] = 20,
  [53] = 21,
  [54] = 22,
  [55] = 23,
  [56] = 25,
  [57] = 26,
  [58] = 29,
  [59] = 59,
  [60] = 31,
  [61] = 59,
  [62] = 62,
  [63] = 63,
  [64] = 62,
  [65] = 65,
  [66] = 65,
  [67] = 65,
  [68] = 65,
  [69] = 65,
  [70] = 65,
  [71] = 65,
  [72] = 65,
  [73] = 73,
  [74] = 73,
  [75] = 75,
  [76] = 76,
  [77] = 75,
  [78] = 78,
  [79] = 76,
  [80] = 80,
  [81] = 78,
  [82] = 80,
  [83] = 83,
  [84] = 83,
  [85] = 85,
  [86] = 85,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 98,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 99,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 97,
  [111] = 96,
  [112] = 90,
  [113] = 113,
  [114] = 93,
  [115] = 91,
  [116] = 116,
  [117] = 92,
  [118] = 109,
  [119] = 119,
  [120] = 120,
  [121] = 120,
  [122] = 122,
  [123] = 113,
  [124] = 122,
  [125] = 94,
  [126] = 107,
  [127] = 104,
  [128] = 101,
  [129] = 105,
  [130] = 95,
  [131] = 131,
  [132] = 103,
  [133] = 108,
  [134] = 102,
  [135] = 135,
  [136] = 89,
  [137] = 137,
  [138] = 137,
  [139] = 137,
  [140] = 140,
  [141] = 140,
  [142] = 140,
  [143] = 140,
  [144] = 140,
  [145] = 137,
  [146] = 140,
  [147] = 137,
  [148] = 140,
  [149] = 137,
  [150] = 140,
  [151] = 137,
  [152] = 137,
  [153] = 153,
  [154] = 154,
  [155] = 154,
  [156] = 156,
  [157] = 157,
  [158] = 154,
  [159] = 156,
  [160] = 156,
  [161] = 161,
  [162] = 157,
  [163] = 157,
  [164] = 164,
  [165] = 165,
  [166] = 157,
  [167] = 157,
  [168] = 156,
  [169] = 161,
  [170] = 154,
  [171] = 164,
  [172] = 157,
  [173] = 165,
  [174] = 161,
  [175] = 157,
  [176] = 176,
  [177] = 156,
  [178] = 157,
  [179] = 161,
  [180] = 165,
  [181] = 161,
  [182] = 154,
  [183] = 156,
  [184] = 161,
  [185] = 161,
  [186] = 161,
  [187] = 156,
  [188] = 176,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 189,
  [194] = 192,
  [195] = 190,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 190,
  [200] = 191,
  [201] = 189,
  [202] = 190,
  [203] = 191,
  [204] = 189,
  [205] = 190,
  [206] = 191,
  [207] = 191,
  [208] = 189,
  [209] = 190,
  [210] = 191,
  [211] = 189,
  [212] = 190,
  [213] = 191,
  [214] = 189,
  [215] = 190,
  [216] = 191,
  [217] = 189,
  [218] = 190,
  [219] = 190,
  [220] = 190,
  [221] = 189,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 224,
  [226] = 224,
  [227] = 227,
  [228] = 224,
  [229] = 227,
  [230] = 227,
  [231] = 231,
  [232] = 227,
  [233] = 231,
  [234] = 234,
  [235] = 235,
  [236] = 234,
  [237] = 237,
  [238] = 238,
  [239] = 234,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 242,
  [245] = 238,
  [246] = 238,
  [247] = 237,
  [248] = 238,
  [249] = 222,
  [250] = 250,
  [251] = 238,
  [252] = 242,
  [253] = 253,
  [254] = 238,
  [255] = 255,
  [256] = 256,
  [257] = 238,
  [258] = 258,
  [259] = 259,
  [260] = 223,
  [261] = 250,
  [262] = 238,
  [263] = 263,
  [264] = 264,
  [265] = 235,
  [266] = 235,
  [267] = 235,
  [268] = 234,
  [269] = 258,
  [270] = 240,
  [271] = 242,
  [272] = 272,
  [273] = 273,
  [274] = 272,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 275,
  [280] = 273,
  [281] = 281,
  [282] = 281,
  [283] = 281,
  [284] = 273,
  [285] = 281,
  [286] = 273,
  [287] = 276,
  [288] = 277,
  [289] = 278,
  [290] = 275,
  [291] = 278,
  [292] = 272,
  [293] = 276,
  [294] = 281,
  [295] = 273,
  [296] = 273,
  [297] = 272,
  [298] = 276,
  [299] = 277,
  [300] = 278,
  [301] = 275,
  [302] = 272,
  [303] = 276,
  [304] = 276,
  [305] = 281,
  [306] = 273,
  [307] = 277,
  [308] = 278,
  [309] = 276,
  [310] = 277,
  [311] = 278,
  [312] = 275,
  [313] = 278,
  [314] = 275,
  [315] = 275,
  [316] = 276,
  [317] = 277,
  [318] = 275,
  [319] = 281,
  [320] = 277,
  [321] = 278,
  [322] = 281,
  [323] = 273,
  [324] = 272,
  [325] = 277,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 176,
  [330] = 327,
  [331] = 328,
  [332] = 327,
  [333] = 333,
  [334] = 334,
  [335] = 333,
  [336] = 336,
  [337] = 333,
  [338] = 338,
  [339] = 339,
  [340] = 339,
  [341] = 334,
  [342] = 338,
  [343] = 334,
  [344] = 344,
  [345] = 339,
  [346] = 338,
  [347] = 328,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 349,
  [352] = 348,
  [353] = 348,
  [354] = 350,
  [355] = 349,
  [356] = 349,
  [357] = 357,
  [358] = 349,
  [359] = 348,
  [360] = 348,
  [361] = 256,
  [362] = 350,
  [363] = 256,
  [364] = 349,
  [365] = 256,
  [366] = 349,
  [367] = 348,
  [368] = 348,
  [369] = 348,
  [370] = 349,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 373,
  [375] = 372,
  [376] = 371,
  [377] = 372,
  [378] = 156,
  [379] = 372,
  [380] = 373,
  [381] = 371,
  [382] = 373,
  [383] = 383,
  [384] = 373,
  [385] = 372,
  [386] = 372,
  [387] = 371,
  [388] = 344,
  [389] = 371,
  [390] = 373,
  [391] = 372,
  [392] = 392,
  [393] = 371,
  [394] = 373,
  [395] = 372,
  [396] = 371,
  [397] = 326,
  [398] = 371,
  [399] = 373,
  [400] = 400,
  [401] = 373,
  [402] = 372,
  [403] = 373,
  [404] = 371,
  [405] = 405,
  [406] = 406,
  [407] = 371,
  [408] = 372,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 416,
  [422] = 422,
  [423] = 176,
  [424] = 410,
  [425] = 414,
  [426] = 426,
  [427] = 417,
  [428] = 428,
  [429] = 416,
  [430] = 176,
  [431] = 422,
  [432] = 410,
  [433] = 417,
  [434] = 434,
  [435] = 405,
  [436] = 344,
  [437] = 326,
  [438] = 422,
  [439] = 156,
  [440] = 176,
  [441] = 441,
  [442] = 344,
  [443] = 326,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 415,
  [449] = 449,
  [450] = 415,
  [451] = 415,
  [452] = 415,
  [453] = 415,
  [454] = 415,
  [455] = 415,
  [456] = 415,
  [457] = 415,
  [458] = 446,
  [459] = 428,
  [460] = 414,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 462,
  [468] = 464,
  [469] = 469,
  [470] = 470,
  [471] = 470,
  [472] = 465,
  [473] = 461,
  [474] = 466,
  [475] = 344,
  [476] = 326,
  [477] = 477,
  [478] = 477,
  [479] = 469,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 480,
  [497] = 497,
  [498] = 486,
  [499] = 483,
  [500] = 491,
  [501] = 481,
  [502] = 485,
  [503] = 503,
  [504] = 490,
  [505] = 505,
  [506] = 492,
  [507] = 493,
  [508] = 508,
  [509] = 509,
  [510] = 508,
  [511] = 511,
  [512] = 487,
  [513] = 488,
  [514] = 483,
  [515] = 491,
  [516] = 490,
  [517] = 505,
  [518] = 518,
  [519] = 519,
  [520] = 494,
  [521] = 505,
  [522] = 508,
  [523] = 482,
  [524] = 484,
  [525] = 486,
  [526] = 487,
  [527] = 488,
  [528] = 503,
  [529] = 491,
  [530] = 530,
  [531] = 495,
  [532] = 495,
  [533] = 490,
  [534] = 505,
  [535] = 503,
  [536] = 495,
  [537] = 537,
  [538] = 482,
  [539] = 490,
  [540] = 505,
  [541] = 482,
  [542] = 484,
  [543] = 486,
  [544] = 487,
  [545] = 488,
  [546] = 503,
  [547] = 483,
  [548] = 495,
  [549] = 549,
  [550] = 503,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 508,
  [555] = 482,
  [556] = 484,
  [557] = 486,
  [558] = 487,
  [559] = 488,
  [560] = 490,
  [561] = 495,
  [562] = 562,
  [563] = 490,
  [564] = 503,
  [565] = 565,
  [566] = 566,
  [567] = 484,
  [568] = 482,
  [569] = 484,
  [570] = 486,
  [571] = 487,
  [572] = 488,
  [573] = 495,
  [574] = 503,
  [575] = 505,
  [576] = 482,
  [577] = 484,
  [578] = 486,
  [579] = 487,
  [580] = 488,
  [581] = 495,
  [582] = 503,
  [583] = 511,
  [584] = 491,
  [585] = 511,
  [586] = 586,
  [587] = 511,
  [588] = 482,
  [589] = 511,
  [590] = 519,
  [591] = 511,
  [592] = 592,
  [593] = 511,
  [594] = 594,
  [595] = 511,
  [596] = 537,
  [597] = 530,
  [598] = 518,
  [599] = 599,
  [600] = 600,
  [601] = 594,
  [602] = 484,
  [603] = 600,
  [604] = 486,
  [605] = 487,
  [606] = 488,
  [607] = 549,
  [608] = 490,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 613,
  [618] = 612,
  [619] = 619,
  [620] = 620,
  [621] = 611,
  [622] = 614,
  [623] = 620,
  [624] = 619,
  [625] = 615,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 635,
  [637] = 626,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 630,
  [643] = 643,
  [644] = 643,
  [645] = 645,
  [646] = 641,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 650,
  [653] = 649,
  [654] = 654,
  [655] = 647,
  [656] = 656,
  [657] = 647,
  [658] = 658,
  [659] = 650,
  [660] = 658,
  [661] = 650,
  [662] = 658,
  [663] = 663,
  [664] = 649,
  [665] = 658,
  [666] = 666,
  [667] = 648,
  [668] = 647,
  [669] = 650,
  [670] = 670,
  [671] = 658,
  [672] = 649,
  [673] = 673,
  [674] = 656,
  [675] = 651,
  [676] = 651,
  [677] = 649,
  [678] = 651,
  [679] = 663,
  [680] = 680,
  [681] = 681,
  [682] = 223,
  [683] = 666,
  [684] = 651,
  [685] = 680,
  [686] = 670,
  [687] = 673,
  [688] = 654,
  [689] = 647,
  [690] = 690,
  [691] = 681,
  [692] = 222,
  [693] = 647,
  [694] = 690,
  [695] = 649,
  [696] = 658,
  [697] = 650,
  [698] = 651,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 700,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 699,
  [712] = 706,
  [713] = 709,
  [714] = 710,
  [715] = 701,
  [716] = 702,
  [717] = 705,
  [718] = 704,
  [719] = 703,
  [720] = 708,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 722,
  [725] = 723,
  [726] = 721,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 727,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 223,
  [763] = 763,
  [764] = 764,
  [765] = 734,
  [766] = 766,
  [767] = 742,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 222,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 731,
  [778] = 778,
  [779] = 738,
  [780] = 741,
  [781] = 781,
  [782] = 760,
  [783] = 783,
  [784] = 761,
  [785] = 763,
  [786] = 764,
  [787] = 766,
  [788] = 768,
  [789] = 773,
  [790] = 790,
  [791] = 772,
  [792] = 792,
  [793] = 778,
  [794] = 783,
  [795] = 792,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 790,
  [800] = 796,
  [801] = 740,
  [802] = 797,
  [803] = 803,
  [804] = 804,
  [805] = 730,
  [806] = 739,
  [807] = 745,
  [808] = 752,
  [809] = 756,
  [810] = 728,
  [811] = 759,
  [812] = 769,
  [813] = 770,
  [814] = 776,
  [815] = 781,
  [816] = 816,
  [817] = 803,
  [818] = 818,
  [819] = 774,
  [820] = 820,
  [821] = 821,
  [822] = 729,
  [823] = 818,
  [824] = 798,
  [825] = 732,
  [826] = 733,
  [827] = 735,
  [828] = 736,
  [829] = 737,
  [830] = 775,
  [831] = 804,
  [832] = 832,
  [833] = 820,
  [834] = 746,
  [835] = 747,
  [836] = 749,
  [837] = 750,
  [838] = 751,
  [839] = 821,
  [840] = 753,
  [841] = 754,
  [842] = 755,
  [843] = 757,
  [844] = 758,
  [845] = 748,
  [846] = 728,
  [847] = 743,
  [848] = 832,
  [849] = 748,
  [850] = 816,
  [851] = 851,
  [852] = 851,
  [853] = 851,
  [854] = 851,
  [855] = 851,
  [856] = 851,
  [857] = 857,
  [858] = 857,
  [859] = 859,
  [860] = 859,
  [861] = 859,
  [862] = 859,
  [863] = 859,
  [864] = 859,
  [865] = 859,
  [866] = 859,
  [867] = 867,
  [868] = 868,
  [869] = 867,
  [870] = 870,
  [871] = 867,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 874,
  [881] = 870,
  [882] = 867,
  [883] = 883,
  [884] = 875,
  [885] = 872,
  [886] = 873,
  [887] = 874,
  [888] = 875,
  [889] = 876,
  [890] = 877,
  [891] = 878,
  [892] = 879,
  [893] = 870,
  [894] = 872,
  [895] = 873,
  [896] = 874,
  [897] = 875,
  [898] = 876,
  [899] = 877,
  [900] = 878,
  [901] = 879,
  [902] = 870,
  [903] = 870,
  [904] = 867,
  [905] = 868,
  [906] = 906,
  [907] = 876,
  [908] = 883,
  [909] = 867,
  [910] = 910,
  [911] = 877,
  [912] = 878,
  [913] = 883,
  [914] = 879,
  [915] = 872,
  [916] = 873,
  [917] = 874,
  [918] = 875,
  [919] = 876,
  [920] = 877,
  [921] = 878,
  [922] = 879,
  [923] = 910,
  [924] = 872,
  [925] = 906,
  [926] = 868,
  [927] = 906,
  [928] = 883,
  [929] = 872,
  [930] = 873,
  [931] = 874,
  [932] = 870,
  [933] = 867,
  [934] = 868,
  [935] = 875,
  [936] = 906,
  [937] = 876,
  [938] = 877,
  [939] = 883,
  [940] = 878,
  [941] = 879,
  [942] = 868,
  [943] = 906,
  [944] = 873,
  [945] = 874,
  [946] = 870,
  [947] = 867,
  [948] = 875,
  [949] = 876,
  [950] = 868,
  [951] = 877,
  [952] = 906,
  [953] = 868,
  [954] = 906,
  [955] = 872,
  [956] = 868,
  [957] = 873,
  [958] = 906,
  [959] = 878,
  [960] = 879,
  [961] = 872,
  [962] = 873,
  [963] = 874,
  [964] = 875,
  [965] = 876,
  [966] = 877,
  [967] = 878,
  [968] = 879,
  [969] = 868,
  [970] = 868,
  [971] = 868,
  [972] = 868,
  [973] = 868,
  [974] = 870,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 978,
  [982] = 982,
  [983] = 983,
  [984] = 977,
  [985] = 985,
  [986] = 986,
  [987] = 977,
  [988] = 975,
  [989] = 976,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 975,
  [997] = 978,
  [998] = 976,
  [999] = 993,
  [1000] = 979,
  [1001] = 640,
  [1002] = 634,
  [1003] = 992,
  [1004] = 977,
  [1005] = 975,
  [1006] = 1006,
  [1007] = 976,
  [1008] = 990,
  [1009] = 632,
  [1010] = 639,
  [1011] = 995,
  [1012] = 977,
  [1013] = 645,
  [1014] = 1014,
  [1015] = 994,
  [1016] = 975,
  [1017] = 991,
  [1018] = 979,
  [1019] = 993,
  [1020] = 980,
  [1021] = 627,
  [1022] = 975,
  [1023] = 991,
  [1024] = 976,
  [1025] = 633,
  [1026] = 976,
  [1027] = 983,
  [1028] = 977,
  [1029] = 985,
  [1030] = 978,
  [1031] = 1031,
  [1032] = 992,
  [1033] = 990,
  [1034] = 978,
  [1035] = 1035,
  [1036] = 986,
  [1037] = 977,
  [1038] = 975,
  [1039] = 986,
  [1040] = 975,
  [1041] = 976,
  [1042] = 995,
  [1043] = 994,
  [1044] = 985,
  [1045] = 978,
  [1046] = 978,
  [1047] = 1047,
  [1048] = 980,
  [1049] = 982,
  [1050] = 983,
  [1051] = 982,
  [1052] = 1052,
  [1053] = 977,
  [1054] = 616,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 629,
  [1060] = 1060,
  [1061] = 983,
  [1062] = 1062,
  [1063] = 1052,
  [1064] = 991,
  [1065] = 979,
  [1066] = 979,
  [1067] = 1067,
  [1068] = 991,
  [1069] = 979,
  [1070] = 1031,
  [1071] = 991,
  [1072] = 979,
  [1073] = 1031,
  [1074] = 1047,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1047,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 634,
  [1083] = 992,
  [1084] = 995,
  [1085] = 994,
  [1086] = 993,
  [1087] = 980,
  [1088] = 982,
  [1089] = 983,
  [1090] = 995,
  [1091] = 985,
  [1092] = 986,
  [1093] = 994,
  [1094] = 993,
  [1095] = 980,
  [1096] = 982,
  [1097] = 983,
  [1098] = 1098,
  [1099] = 985,
  [1100] = 986,
  [1101] = 990,
  [1102] = 632,
  [1103] = 639,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 992,
  [1110] = 990,
  [1111] = 990,
  [1112] = 645,
  [1113] = 995,
  [1114] = 994,
  [1115] = 993,
  [1116] = 980,
  [1117] = 982,
  [1118] = 983,
  [1119] = 985,
  [1120] = 986,
  [1121] = 1121,
  [1122] = 976,
  [1123] = 992,
  [1124] = 990,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1035,
  [1130] = 1006,
  [1131] = 1014,
  [1132] = 627,
  [1133] = 633,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 640,
  [1138] = 1138,
  [1139] = 985,
  [1140] = 986,
  [1141] = 982,
  [1142] = 995,
  [1143] = 978,
  [1144] = 994,
  [1145] = 1145,
  [1146] = 993,
  [1147] = 1147,
  [1148] = 980,
  [1149] = 1149,
  [1150] = 975,
  [1151] = 1151,
  [1152] = 612,
  [1153] = 610,
  [1154] = 628,
  [1155] = 638,
  [1156] = 1035,
  [1157] = 1006,
  [1158] = 1014,
  [1159] = 991,
  [1160] = 992,
  [1161] = 1125,
  [1162] = 1105,
  [1163] = 1077,
  [1164] = 1078,
  [1165] = 1106,
  [1166] = 634,
  [1167] = 634,
  [1168] = 1121,
  [1169] = 1135,
  [1170] = 628,
  [1171] = 638,
  [1172] = 1151,
  [1173] = 1138,
  [1174] = 1149,
  [1175] = 629,
  [1176] = 629,
  [1177] = 1047,
  [1178] = 1075,
  [1179] = 632,
  [1180] = 1078,
  [1181] = 1080,
  [1182] = 639,
  [1183] = 645,
  [1184] = 627,
  [1185] = 1047,
  [1186] = 633,
  [1187] = 975,
  [1188] = 1127,
  [1189] = 1031,
  [1190] = 629,
  [1191] = 1145,
  [1192] = 1151,
  [1193] = 1147,
  [1194] = 632,
  [1195] = 639,
  [1196] = 645,
  [1197] = 1121,
  [1198] = 1136,
  [1199] = 626,
  [1200] = 1081,
  [1201] = 635,
  [1202] = 1062,
  [1203] = 1031,
  [1204] = 641,
  [1205] = 1098,
  [1206] = 628,
  [1207] = 1104,
  [1208] = 1108,
  [1209] = 1134,
  [1210] = 638,
  [1211] = 1035,
  [1212] = 1006,
  [1213] = 1014,
  [1214] = 643,
  [1215] = 1056,
  [1216] = 1057,
  [1217] = 1052,
  [1218] = 991,
  [1219] = 627,
  [1220] = 633,
  [1221] = 1060,
  [1222] = 616,
  [1223] = 979,
  [1224] = 1135,
  [1225] = 1107,
  [1226] = 1105,
  [1227] = 640,
  [1228] = 1035,
  [1229] = 640,
  [1230] = 1006,
  [1231] = 1106,
  [1232] = 1014,
  [1233] = 1035,
  [1234] = 1031,
  [1235] = 1056,
  [1236] = 1057,
  [1237] = 612,
  [1238] = 1055,
  [1239] = 1060,
  [1240] = 610,
  [1241] = 1149,
  [1242] = 992,
  [1243] = 1047,
  [1244] = 1047,
  [1245] = 1127,
  [1246] = 1076,
  [1247] = 1136,
  [1248] = 1035,
  [1249] = 1006,
  [1250] = 1014,
  [1251] = 1077,
  [1252] = 1081,
  [1253] = 1098,
  [1254] = 1104,
  [1255] = 1006,
  [1256] = 1014,
  [1257] = 1145,
  [1258] = 975,
  [1259] = 1075,
  [1260] = 612,
  [1261] = 1147,
  [1262] = 616,
  [1263] = 995,
  [1264] = 994,
  [1265] = 1031,
  [1266] = 1080,
  [1267] = 1055,
  [1268] = 1058,
  [1269] = 1058,
  [1270] = 1062,
  [1271] = 610,
  [1272] = 1108,
  [1273] = 1076,
  [1274] = 1125,
  [1275] = 993,
  [1276] = 980,
  [1277] = 1052,
  [1278] = 982,
  [1279] = 983,
  [1280] = 1107,
  [1281] = 985,
  [1282] = 986,
  [1283] = 1134,
  [1284] = 990,
  [1285] = 975,
  [1286] = 1138,
  [1287] = 1062,
  [1288] = 635,
  [1289] = 629,
  [1290] = 643,
  [1291] = 629,
  [1292] = 1127,
  [1293] = 1076,
  [1294] = 1136,
  [1295] = 1077,
  [1296] = 1076,
  [1297] = 1077,
  [1298] = 1134,
  [1299] = 631,
  [1300] = 626,
  [1301] = 1135,
  [1302] = 1081,
  [1303] = 1098,
  [1304] = 1104,
  [1305] = 635,
  [1306] = 1151,
  [1307] = 1076,
  [1308] = 1077,
  [1309] = 641,
  [1310] = 640,
  [1311] = 1121,
  [1312] = 1125,
  [1313] = 626,
  [1314] = 1108,
  [1315] = 635,
  [1316] = 1149,
  [1317] = 641,
  [1318] = 628,
  [1319] = 638,
  [1320] = 629,
  [1321] = 640,
  [1322] = 1121,
  [1323] = 1055,
  [1324] = 1060,
  [1325] = 1058,
  [1326] = 643,
  [1327] = 1056,
  [1328] = 1057,
  [1329] = 628,
  [1330] = 1060,
  [1331] = 638,
  [1332] = 1035,
  [1333] = 1006,
  [1334] = 1014,
  [1335] = 1056,
  [1336] = 1057,
  [1337] = 1060,
  [1338] = 1149,
  [1339] = 1107,
  [1340] = 1134,
  [1341] = 1127,
  [1342] = 1136,
  [1343] = 1135,
  [1344] = 1151,
  [1345] = 1108,
  [1346] = 631,
  [1347] = 1149,
  [1348] = 1062,
  [1349] = 1081,
  [1350] = 1098,
  [1351] = 1104,
  [1352] = 1055,
  [1353] = 1127,
  [1354] = 1136,
  [1355] = 1081,
  [1356] = 1125,
  [1357] = 1067,
  [1358] = 1126,
  [1359] = 1128,
  [1360] = 1098,
  [1361] = 1104,
  [1362] = 1058,
  [1363] = 634,
  [1364] = 1125,
  [1365] = 634,
  [1366] = 643,
  [1367] = 1056,
  [1368] = 1138,
  [1369] = 1145,
  [1370] = 1147,
  [1371] = 632,
  [1372] = 632,
  [1373] = 1107,
  [1374] = 639,
  [1375] = 645,
  [1376] = 1107,
  [1377] = 1134,
  [1378] = 1135,
  [1379] = 1151,
  [1380] = 1108,
  [1381] = 639,
  [1382] = 645,
  [1383] = 1055,
  [1384] = 1134,
  [1385] = 1135,
  [1386] = 1151,
  [1387] = 1108,
  [1388] = 1058,
  [1389] = 1055,
  [1390] = 1058,
  [1391] = 627,
  [1392] = 633,
  [1393] = 1105,
  [1394] = 1138,
  [1395] = 1145,
  [1396] = 1147,
  [1397] = 1106,
  [1398] = 627,
  [1399] = 1105,
  [1400] = 1106,
  [1401] = 633,
  [1402] = 628,
  [1403] = 638,
  [1404] = 1062,
  [1405] = 1057,
  [1406] = 1138,
  [1407] = 1138,
  [1408] = 1145,
  [1409] = 1147,
  [1410] = 1145,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1060,
  [1414] = 1147,
  [1415] = 1081,
  [1416] = 1098,
  [1417] = 1105,
  [1418] = 1106,
  [1419] = 1104,
  [1420] = 629,
  [1421] = 1062,
  [1422] = 1127,
  [1423] = 1105,
  [1424] = 1106,
  [1425] = 1136,
  [1426] = 640,
  [1427] = 1107,
  [1428] = 1121,
  [1429] = 1076,
  [1430] = 1077,
  [1431] = 1149,
  [1432] = 634,
  [1433] = 1125,
  [1434] = 632,
  [1435] = 1121,
  [1436] = 639,
  [1437] = 645,
  [1438] = 627,
  [1439] = 633,
  [1440] = 629,
  [1441] = 1031,
  [1442] = 628,
  [1443] = 638,
  [1444] = 629,
  [1445] = 1047,
  [1446] = 1056,
  [1447] = 1057,
  [1448] = 626,
  [1449] = 641,
  [1450] = 1098,
  [1451] = 629,
  [1452] = 628,
  [1453] = 638,
  [1454] = 1075,
  [1455] = 1078,
  [1456] = 1080,
  [1457] = 1076,
  [1458] = 1056,
  [1459] = 1057,
  [1460] = 1077,
  [1461] = 1060,
  [1462] = 1080,
  [1463] = 631,
  [1464] = 1149,
  [1465] = 1062,
  [1466] = 1127,
  [1467] = 1136,
  [1468] = 1081,
  [1469] = 633,
  [1470] = 1121,
  [1471] = 1125,
  [1472] = 1075,
  [1473] = 1078,
  [1474] = 1080,
  [1475] = 1107,
  [1476] = 1134,
  [1477] = 1135,
  [1478] = 1151,
  [1479] = 1108,
  [1480] = 1055,
  [1481] = 1058,
  [1482] = 1075,
  [1483] = 1138,
  [1484] = 1145,
  [1485] = 1147,
  [1486] = 1105,
  [1487] = 1106,
  [1488] = 631,
  [1489] = 1078,
  [1490] = 640,
  [1491] = 634,
  [1492] = 632,
  [1493] = 639,
  [1494] = 645,
  [1495] = 627,
  [1496] = 1104,
  [1497] = 1412,
  [1498] = 639,
  [1499] = 641,
  [1500] = 640,
  [1501] = 629,
  [1502] = 629,
  [1503] = 645,
  [1504] = 633,
  [1505] = 628,
  [1506] = 638,
  [1507] = 626,
  [1508] = 629,
  [1509] = 629,
  [1510] = 643,
  [1511] = 634,
  [1512] = 632,
  [1513] = 1411,
  [1514] = 635,
  [1515] = 627,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1518,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1518,
  [1525] = 1525,
  [1526] = 1519,
  [1527] = 1523,
  [1528] = 1528,
  [1529] = 1519,
  [1530] = 1528,
  [1531] = 1523,
  [1532] = 1532,
  [1533] = 1525,
  [1534] = 1528,
  [1535] = 1523,
  [1536] = 1528,
  [1537] = 1522,
  [1538] = 1532,
  [1539] = 1532,
  [1540] = 1525,
  [1541] = 1541,
  [1542] = 1541,
  [1543] = 1541,
  [1544] = 1519,
  [1545] = 1520,
  [1546] = 1522,
  [1547] = 1525,
  [1548] = 1541,
  [1549] = 1520,
  [1550] = 1520,
  [1551] = 1522,
  [1552] = 1532,
  [1553] = 1518,
  [1554] = 1554,
  [1555] = 1554,
  [1556] = 1554,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1560,
  [1561] = 1559,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1563,
  [1566] = 1563,
  [1567] = 1562,
  [1568] = 1564,
  [1569] = 1560,
  [1570] = 1559,
  [1571] = 1564,
  [1572] = 1559,
  [1573] = 1564,
  [1574] = 1560,
  [1575] = 1560,
  [1576] = 1562,
  [1577] = 1562,
  [1578] = 1563,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1581,
  [1583] = 1581,
  [1584] = 1580,
  [1585] = 1581,
  [1586] = 1580,
  [1587] = 1580,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 643,
  [1591] = 1411,
  [1592] = 1589,
  [1593] = 1412,
  [1594] = 626,
  [1595] = 1589,
  [1596] = 1588,
  [1597] = 641,
  [1598] = 635,
  [1599] = 1588,
  [1600] = 1588,
  [1601] = 1589,
  [1602] = 1588,
  [1603] = 1588,
  [1604] = 1589,
  [1605] = 1589,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 628,
  [1610] = 1610,
  [1611] = 1589,
  [1612] = 1612,
  [1613] = 638,
  [1614] = 629,
  [1615] = 1589,
  [1616] = 1588,
  [1617] = 1588,
  [1618] = 626,
  [1619] = 1612,
  [1620] = 635,
  [1621] = 641,
  [1622] = 629,
  [1623] = 1411,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1624,
  [1627] = 643,
  [1628] = 1624,
  [1629] = 626,
  [1630] = 1624,
  [1631] = 635,
  [1632] = 1624,
  [1633] = 1624,
  [1634] = 641,
  [1635] = 1624,
  [1636] = 643,
  [1637] = 1637,
  [1638] = 1624,
  [1639] = 1624,
  [1640] = 1411,
  [1641] = 1412,
  [1642] = 1608,
  [1643] = 1412,
  [1644] = 1644,
  [1645] = 641,
  [1646] = 1624,
  [1647] = 1647,
  [1648] = 1412,
  [1649] = 643,
  [1650] = 626,
  [1651] = 628,
  [1652] = 1606,
  [1653] = 635,
  [1654] = 638,
  [1655] = 1411,
  [1656] = 1637,
  [1657] = 1657,
  [1658] = 1647,
  [1659] = 1610,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1625,
  [1664] = 1661,
  [1665] = 1657,
  [1666] = 1657,
  [1667] = 1657,
  [1668] = 1662,
  [1669] = 1657,
  [1670] = 1607,
  [1671] = 1657,
  [1672] = 1657,
  [1673] = 1644,
  [1674] = 1657,
  [1675] = 1661,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1677,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1679,
  [1682] = 1682,
  [1683] = 1682,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1684,
  [1689] = 1684,
  [1690] = 1684,
  [1691] = 1691,
  [1692] = 1684,
  [1693] = 1693,
  [1694] = 1684,
  [1695] = 1684,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1684,
  [1701] = 1701,
  [1702] = 1701,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1701,
  [1708] = 1708,
  [1709] = 1703,
  [1710] = 1706,
  [1711] = 1701,
  [1712] = 1708,
  [1713] = 1713,
  [1714] = 1706,
  [1715] = 1701,
  [1716] = 1708,
  [1717] = 1703,
  [1718] = 1713,
  [1719] = 1706,
  [1720] = 1701,
  [1721] = 1708,
  [1722] = 1703,
  [1723] = 1706,
  [1724] = 1701,
  [1725] = 1708,
  [1726] = 1703,
  [1727] = 1706,
  [1728] = 1701,
  [1729] = 1708,
  [1730] = 1703,
  [1731] = 1706,
  [1732] = 1706,
  [1733] = 1701,
  [1734] = 1708,
  [1735] = 1735,
  [1736] = 1703,
  [1737] = 1706,
  [1738] = 1708,
  [1739] = 1713,
  [1740] = 1713,
  [1741] = 1713,
  [1742] = 1713,
  [1743] = 1713,
  [1744] = 1713,
  [1745] = 1703,
  [1746] = 1687,
  [1747] = 1693,
  [1748] = 1696,
  [1749] = 1698,
  [1750] = 1691,
  [1751] = 1699,
  [1752] = 1685,
  [1753] = 1698,
  [1754] = 1691,
  [1755] = 1755,
  [1756] = 1697,
  [1757] = 1757,
  [1758] = 1686,
  [1759] = 1759,
  [1760] = 1697,
  [1761] = 1686,
  [1762] = 1687,
  [1763] = 1755,
  [1764] = 1693,
  [1765] = 1696,
  [1766] = 1699,
  [1767] = 1685,
  [1768] = 1693,
  [1769] = 1691,
  [1770] = 1770,
  [1771] = 1698,
  [1772] = 1691,
  [1773] = 1697,
  [1774] = 1686,
  [1775] = 1755,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1698,
  [1780] = 1687,
  [1781] = 1691,
  [1782] = 1697,
  [1783] = 1696,
  [1784] = 1698,
  [1785] = 1686,
  [1786] = 1755,
  [1787] = 1687,
  [1788] = 1693,
  [1789] = 1789,
  [1790] = 1696,
  [1791] = 1699,
  [1792] = 1686,
  [1793] = 1685,
  [1794] = 1699,
  [1795] = 1795,
  [1796] = 1687,
  [1797] = 1685,
  [1798] = 1693,
  [1799] = 1696,
  [1800] = 1699,
  [1801] = 1685,
  [1802] = 1802,
  [1803] = 1697,
  [1804] = 1686,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1687,
  [1808] = 1795,
  [1809] = 1693,
  [1810] = 1757,
  [1811] = 1811,
  [1812] = 1696,
  [1813] = 1699,
  [1814] = 1685,
  [1815] = 1811,
  [1816] = 1816,
  [1817] = 1698,
  [1818] = 1818,
  [1819] = 1811,
  [1820] = 1691,
  [1821] = 1770,
  [1822] = 1822,
  [1823] = 1770,
  [1824] = 1824,
  [1825] = 1811,
  [1826] = 1824,
  [1827] = 1827,
  [1828] = 1811,
  [1829] = 1811,
  [1830] = 1830,
  [1831] = 1822,
  [1832] = 1806,
  [1833] = 1770,
  [1834] = 1818,
  [1835] = 1824,
  [1836] = 1697,
  [1837] = 1837,
  [1838] = 1811,
  [1839] = 1691,
  [1840] = 1811,
  [1841] = 1841,
  [1842] = 1811,
  [1843] = 1698,
  [1844] = 1687,
  [1845] = 1845,
  [1846] = 1693,
  [1847] = 1847,
  [1848] = 1696,
  [1849] = 1811,
  [1850] = 1699,
  [1851] = 1686,
  [1852] = 1685,
  [1853] = 1822,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1697,
  [1857] = 1857,
  [1858] = 1818,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1830,
  [1862] = 1862,
  [1863] = 1827,
  [1864] = 1757,
  [1865] = 1857,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1789,
  [1869] = 1776,
  [1870] = 1776,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1867,
  [1875] = 1802,
  [1876] = 1876,
  [1877] = 1802,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1857,
  [1882] = 1880,
  [1883] = 1880,
  [1884] = 1884,
  [1885] = 1876,
  [1886] = 1886,
  [1887] = 1867,
  [1888] = 1888,
  [1889] = 1879,
  [1890] = 1789,
  [1891] = 1867,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1789,
  [1895] = 1757,
  [1896] = 1886,
  [1897] = 1867,
  [1898] = 1888,
  [1899] = 1899,
  [1900] = 1857,
  [1901] = 1901,
  [1902] = 1886,
  [1903] = 1867,
  [1904] = 1776,
  [1905] = 1905,
  [1906] = 1892,
  [1907] = 1888,
  [1908] = 1892,
  [1909] = 1802,
  [1910] = 1867,
  [1911] = 1911,
  [1912] = 1867,
  [1913] = 1872,
  [1914] = 1914,
  [1915] = 1860,
  [1916] = 1916,
  [1917] = 1871,
  [1918] = 1802,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1911,
  [1922] = 1916,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1919,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1871,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1920,
  [1935] = 1916,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1924,
  [1940] = 1940,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1936,
  [1944] = 1944,
  [1945] = 1607,
  [1946] = 1916,
  [1947] = 1795,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1933,
  [1955] = 1860,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1958,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1923,
  [1968] = 1968,
  [1969] = 1968,
  [1970] = 1970,
  [1971] = 1919,
  [1972] = 1610,
  [1973] = 1871,
  [1974] = 1974,
  [1975] = 1960,
  [1976] = 1951,
  [1977] = 1925,
  [1978] = 1929,
  [1979] = 1961,
  [1980] = 1911,
  [1981] = 1927,
  [1982] = 1956,
  [1983] = 1778,
  [1984] = 1789,
  [1985] = 1985,
  [1986] = 1911,
  [1987] = 1778,
  [1988] = 1951,
  [1989] = 1795,
  [1990] = 1990,
  [1991] = 1776,
  [1992] = 1927,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1860,
  [1996] = 1956,
  [1997] = 1997,
  [1998] = 1940,
  [1999] = 1941,
  [2000] = 1924,
  [2001] = 1953,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 1923,
  [2005] = 2002,
  [2006] = 2006,
  [2007] = 1778,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 1855,
  [2011] = 1920,
  [2012] = 1952,
  [2013] = 2013,
  [2014] = 1925,
  [2015] = 1795,
  [2016] = 2016,
  [2017] = 1968,
  [2018] = 2018,
  [2019] = 2003,
  [2020] = 1929,
  [2021] = 2021,
  [2022] = 1956,
  [2023] = 1951,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 1892,
  [2031] = 2027,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2033,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2006,
  [2043] = 2009,
  [2044] = 1937,
  [2045] = 2041,
  [2046] = 2006,
  [2047] = 2040,
  [2048] = 2009,
  [2049] = 2029,
  [2050] = 2006,
  [2051] = 2027,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 1938,
  [2057] = 1985,
  [2058] = 1647,
  [2059] = 1985,
  [2060] = 1993,
  [2061] = 1994,
  [2062] = 1993,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2027,
  [2066] = 1940,
  [2067] = 1941,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 1933,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 1994,
  [2075] = 2075,
  [2076] = 1938,
  [2077] = 2077,
  [2078] = 2027,
  [2079] = 1644,
  [2080] = 1994,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 1933,
  [2084] = 2084,
  [2085] = 2027,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 1637,
  [2089] = 2027,
  [2090] = 2040,
  [2091] = 1860,
  [2092] = 2053,
  [2093] = 1997,
  [2094] = 2072,
  [2095] = 2073,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2098,
  [2099] = 1625,
  [2100] = 2100,
  [2101] = 1958,
  [2102] = 1940,
  [2103] = 2033,
  [2104] = 2075,
  [2105] = 2098,
  [2106] = 1941,
  [2107] = 2082,
  [2108] = 2021,
  [2109] = 2013,
  [2110] = 1960,
  [2111] = 1961,
  [2112] = 2112,
  [2113] = 1958,
  [2114] = 2041,
  [2115] = 1960,
  [2116] = 2075,
  [2117] = 2117,
  [2118] = 2028,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 1961,
  [2122] = 2122,
  [2123] = 2040,
  [2124] = 1938,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 1968,
  [2128] = 2027,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 1985,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 1993,
  [2138] = 2009,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2129,
  [2143] = 2130,
  [2144] = 2132,
  [2145] = 2145,
  [2146] = 2133,
  [2147] = 2081,
  [2148] = 2026,
  [2149] = 2029,
  [2150] = 2032,
  [2151] = 2151,
  [2152] = 2038,
  [2153] = 2153,
  [2154] = 2039,
  [2155] = 2052,
  [2156] = 2055,
  [2157] = 2064,
  [2158] = 2068,
  [2159] = 2069,
  [2160] = 2160,
  [2161] = 2071,
  [2162] = 2162,
  [2163] = 2119,
  [2164] = 2126,
  [2165] = 2135,
  [2166] = 2141,
  [2167] = 2151,
  [2168] = 2136,
  [2169] = 2025,
  [2170] = 2035,
  [2171] = 2097,
  [2172] = 2100,
  [2173] = 2173,
  [2174] = 2129,
  [2175] = 2130,
  [2176] = 2132,
  [2177] = 2133,
  [2178] = 2081,
  [2179] = 2039,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2141,
  [2186] = 2151,
  [2187] = 2112,
  [2188] = 2188,
  [2189] = 2180,
  [2190] = 2190,
  [2191] = 2026,
  [2192] = 2029,
  [2193] = 2087,
  [2194] = 2032,
  [2195] = 2195,
  [2196] = 2038,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2141,
  [2202] = 2151,
  [2203] = 2180,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2180,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2100,
  [2212] = 2212,
  [2213] = 2052,
  [2214] = 2026,
  [2215] = 2055,
  [2216] = 2032,
  [2217] = 2217,
  [2218] = 2038,
  [2219] = 2064,
  [2220] = 2068,
  [2221] = 2069,
  [2222] = 2052,
  [2223] = 2055,
  [2224] = 2064,
  [2225] = 2068,
  [2226] = 2069,
  [2227] = 2071,
  [2228] = 2071,
  [2229] = 2119,
  [2230] = 2126,
  [2231] = 2231,
  [2232] = 2135,
  [2233] = 2136,
  [2234] = 2025,
  [2235] = 2035,
  [2236] = 2097,
  [2237] = 2100,
  [2238] = 2129,
  [2239] = 2130,
  [2240] = 2132,
  [2241] = 2133,
  [2242] = 2081,
  [2243] = 2039,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2063,
  [2247] = 2145,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2119,
  [2253] = 2126,
  [2254] = 2135,
  [2255] = 2136,
  [2256] = 2025,
  [2257] = 2208,
  [2258] = 2258,
  [2259] = 2173,
  [2260] = 2260,
  [2261] = 2244,
  [2262] = 2035,
  [2263] = 2199,
  [2264] = 2097,
  [2265] = 2125,
  [2266] = 2024,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2268,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2268,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 650,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2281,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2279,
  [2295] = 2292,
  [2296] = 2270,
  [2297] = 2013,
  [2298] = 2278,
  [2299] = 2286,
  [2300] = 2270,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2278,
  [2305] = 2286,
  [2306] = 2207,
  [2307] = 2303,
  [2308] = 2308,
  [2309] = 2292,
  [2310] = 2310,
  [2311] = 2303,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2313,
  [2317] = 2313,
  [2318] = 1997,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2315,
  [2322] = 2315,
  [2323] = 2323,
  [2324] = 2268,
  [2325] = 2209,
  [2326] = 2326,
  [2327] = 2276,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2280,
  [2331] = 2331,
  [2332] = 2283,
  [2333] = 2285,
  [2334] = 2287,
  [2335] = 2288,
  [2336] = 2212,
  [2337] = 2281,
  [2338] = 1607,
  [2339] = 1914,
  [2340] = 2271,
  [2341] = 1930,
  [2342] = 2279,
  [2343] = 651,
  [2344] = 2270,
  [2345] = 2345,
  [2346] = 2278,
  [2347] = 2286,
  [2348] = 1932,
  [2349] = 2013,
  [2350] = 1031,
  [2351] = 2245,
  [2352] = 2352,
  [2353] = 2320,
  [2354] = 2354,
  [2355] = 2301,
  [2356] = 2302,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2276,
  [2360] = 2319,
  [2361] = 2280,
  [2362] = 2362,
  [2363] = 2283,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2285,
  [2367] = 2268,
  [2368] = 2368,
  [2369] = 2287,
  [2370] = 2288,
  [2371] = 2281,
  [2372] = 2276,
  [2373] = 2287,
  [2374] = 2279,
  [2375] = 2270,
  [2376] = 2376,
  [2377] = 2278,
  [2378] = 2286,
  [2379] = 2280,
  [2380] = 2380,
  [2381] = 2283,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2209,
  [2385] = 2285,
  [2386] = 2207,
  [2387] = 2387,
  [2388] = 2288,
  [2389] = 2268,
  [2390] = 2364,
  [2391] = 2287,
  [2392] = 2276,
  [2393] = 2288,
  [2394] = 2281,
  [2395] = 2280,
  [2396] = 2209,
  [2397] = 2397,
  [2398] = 2283,
  [2399] = 2399,
  [2400] = 2279,
  [2401] = 2285,
  [2402] = 2270,
  [2403] = 658,
  [2404] = 2287,
  [2405] = 2288,
  [2406] = 2212,
  [2407] = 2268,
  [2408] = 2281,
  [2409] = 2409,
  [2410] = 2278,
  [2411] = 2286,
  [2412] = 1997,
  [2413] = 1926,
  [2414] = 2270,
  [2415] = 2301,
  [2416] = 2278,
  [2417] = 2286,
  [2418] = 2291,
  [2419] = 2283,
  [2420] = 1957,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2268,
  [2424] = 2424,
  [2425] = 2276,
  [2426] = 1963,
  [2427] = 2271,
  [2428] = 2280,
  [2429] = 2276,
  [2430] = 2283,
  [2431] = 2328,
  [2432] = 2285,
  [2433] = 2210,
  [2434] = 2382,
  [2435] = 2287,
  [2436] = 2288,
  [2437] = 2383,
  [2438] = 2281,
  [2439] = 2217,
  [2440] = 2308,
  [2441] = 2424,
  [2442] = 2279,
  [2443] = 2270,
  [2444] = 2444,
  [2445] = 2278,
  [2446] = 2286,
  [2447] = 2302,
  [2448] = 1647,
  [2449] = 2380,
  [2450] = 2450,
  [2451] = 2281,
  [2452] = 2272,
  [2453] = 2278,
  [2454] = 2286,
  [2455] = 1970,
  [2456] = 2280,
  [2457] = 2281,
  [2458] = 2278,
  [2459] = 2286,
  [2460] = 2329,
  [2461] = 2364,
  [2462] = 2274,
  [2463] = 2463,
  [2464] = 2283,
  [2465] = 1610,
  [2466] = 2466,
  [2467] = 2280,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2376,
  [2471] = 2382,
  [2472] = 2357,
  [2473] = 2383,
  [2474] = 2474,
  [2475] = 2310,
  [2476] = 2312,
  [2477] = 2477,
  [2478] = 2290,
  [2479] = 2362,
  [2480] = 2292,
  [2481] = 2345,
  [2482] = 2276,
  [2483] = 2323,
  [2484] = 649,
  [2485] = 2376,
  [2486] = 2357,
  [2487] = 2468,
  [2488] = 647,
  [2489] = 2489,
  [2490] = 1997,
  [2491] = 1607,
  [2492] = 2285,
  [2493] = 2493,
  [2494] = 2352,
  [2495] = 1607,
  [2496] = 2303,
  [2497] = 1047,
  [2498] = 2287,
  [2499] = 2288,
  [2500] = 2313,
  [2501] = 2308,
  [2502] = 2281,
  [2503] = 2013,
  [2504] = 2469,
  [2505] = 2315,
  [2506] = 2301,
  [2507] = 2421,
  [2508] = 2474,
  [2509] = 2308,
  [2510] = 2477,
  [2511] = 2320,
  [2512] = 2512,
  [2513] = 2200,
  [2514] = 2514,
  [2515] = 2285,
  [2516] = 2205,
  [2517] = 2016,
  [2518] = 2269,
  [2519] = 2320,
  [2520] = 2251,
  [2521] = 2245,
  [2522] = 2245,
  [2523] = 2140,
  [2524] = 2279,
  [2525] = 2358,
  [2526] = 2354,
  [2527] = 2279,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 650,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2037,
  [2550] = 1647,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2528,
  [2554] = 2529,
  [2555] = 2530,
  [2556] = 2556,
  [2557] = 2331,
  [2558] = 2558,
  [2559] = 2528,
  [2560] = 2556,
  [2561] = 2561,
  [2562] = 2556,
  [2563] = 2563,
  [2564] = 2531,
  [2565] = 2529,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2532,
  [2569] = 2569,
  [2570] = 2534,
  [2571] = 2571,
  [2572] = 2572,
  [2573] = 2530,
  [2574] = 2574,
  [2575] = 2528,
  [2576] = 2576,
  [2577] = 2037,
  [2578] = 1644,
  [2579] = 2530,
  [2580] = 2532,
  [2581] = 2581,
  [2582] = 2582,
  [2583] = 651,
  [2584] = 2584,
  [2585] = 2585,
  [2586] = 647,
  [2587] = 2587,
  [2588] = 649,
  [2589] = 2589,
  [2590] = 1644,
  [2591] = 1625,
  [2592] = 2592,
  [2593] = 2572,
  [2594] = 2542,
  [2595] = 2561,
  [2596] = 2582,
  [2597] = 2597,
  [2598] = 658,
  [2599] = 2556,
  [2600] = 2600,
  [2601] = 2037,
  [2602] = 2602,
  [2603] = 1637,
  [2604] = 2597,
  [2605] = 2605,
  [2606] = 1625,
  [2607] = 1637,
  [2608] = 2608,
  [2609] = 2609,
  [2610] = 2529,
  [2611] = 2611,
  [2612] = 2534,
  [2613] = 2613,
  [2614] = 2614,
  [2615] = 2615,
  [2616] = 2616,
  [2617] = 2589,
  [2618] = 2581,
  [2619] = 2584,
  [2620] = 2602,
  [2621] = 2621,
  [2622] = 2622,
  [2623] = 2623,
  [2624] = 2463,
  [2625] = 2275,
  [2626] = 2626,
  [2627] = 2531,
  [2628] = 2592,
  [2629] = 2629,
  [2630] = 2630,
  [2631] = 2631,
  [2632] = 2632,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2635,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2633,
  [2639] = 2639,
  [2640] = 2633,
  [2641] = 2641,
  [2642] = 2642,
  [2643] = 2643,
  [2644] = 2629,
  [2645] = 2645,
  [2646] = 2646,
  [2647] = 2635,
  [2648] = 2636,
  [2649] = 2649,
  [2650] = 2650,
  [2651] = 2651,
  [2652] = 2639,
  [2653] = 2653,
  [2654] = 2654,
  [2655] = 2655,
  [2656] = 2656,
  [2657] = 2642,
  [2658] = 2646,
  [2659] = 2639,
  [2660] = 2660,
  [2661] = 2661,
  [2662] = 2633,
  [2663] = 2649,
  [2664] = 2664,
  [2665] = 2643,
  [2666] = 2629,
  [2667] = 2643,
  [2668] = 2634,
  [2669] = 2629,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2645,
  [2673] = 2645,
  [2674] = 2674,
  [2675] = 2635,
  [2676] = 2653,
  [2677] = 2653,
  [2678] = 2639,
  [2679] = 2650,
  [2680] = 2633,
  [2681] = 2649,
  [2682] = 2635,
  [2683] = 2633,
  [2684] = 2664,
  [2685] = 2650,
  [2686] = 2632,
  [2687] = 2687,
  [2688] = 2651,
  [2689] = 2650,
  [2690] = 2636,
  [2691] = 2687,
  [2692] = 2635,
  [2693] = 2693,
  [2694] = 2654,
  [2695] = 2695,
  [2696] = 2639,
  [2697] = 2633,
  [2698] = 2655,
  [2699] = 2632,
  [2700] = 2643,
  [2701] = 2701,
  [2702] = 2651,
  [2703] = 2643,
  [2704] = 2704,
  [2705] = 2629,
  [2706] = 2634,
  [2707] = 2707,
  [2708] = 2701,
  [2709] = 2709,
  [2710] = 2635,
  [2711] = 2711,
  [2712] = 2649,
  [2713] = 2713,
  [2714] = 2636,
  [2715] = 2715,
  [2716] = 2646,
  [2717] = 2664,
  [2718] = 2635,
  [2719] = 2711,
  [2720] = 2720,
  [2721] = 2653,
  [2722] = 2707,
  [2723] = 2635,
  [2724] = 2724,
  [2725] = 2670,
  [2726] = 2639,
  [2727] = 2727,
  [2728] = 2649,
  [2729] = 2729,
  [2730] = 2650,
  [2731] = 2704,
  [2732] = 2732,
  [2733] = 2674,
  [2734] = 2633,
  [2735] = 2651,
  [2736] = 2650,
  [2737] = 2632,
  [2738] = 2738,
  [2739] = 2664,
  [2740] = 2643,
  [2741] = 2741,
  [2742] = 2654,
  [2743] = 2713,
  [2744] = 2655,
  [2745] = 2635,
  [2746] = 2687,
  [2747] = 2747,
  [2748] = 2649,
  [2749] = 2654,
  [2750] = 2687,
  [2751] = 2643,
  [2752] = 2636,
  [2753] = 2664,
  [2754] = 2650,
  [2755] = 2651,
  [2756] = 2707,
  [2757] = 2649,
  [2758] = 2704,
  [2759] = 2642,
  [2760] = 2713,
  [2761] = 2654,
  [2762] = 2651,
  [2763] = 2655,
  [2764] = 2654,
  [2765] = 2646,
  [2766] = 2766,
  [2767] = 2649,
  [2768] = 2646,
  [2769] = 2655,
  [2770] = 2654,
  [2771] = 2655,
  [2772] = 2650,
  [2773] = 2693,
  [2774] = 2651,
  [2775] = 2775,
  [2776] = 2646,
  [2777] = 2646,
  [2778] = 2729,
  [2779] = 2779,
  [2780] = 2643,
  [2781] = 2629,
  [2782] = 2642,
  [2783] = 2632,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2720,
  [2787] = 2654,
  [2788] = 2655,
  [2789] = 2634,
  [2790] = 2634,
  [2791] = 2651,
  [2792] = 2629,
  [2793] = 2793,
  [2794] = 2794,
  [2795] = 2635,
  [2796] = 2796,
  [2797] = 2794,
  [2798] = 2798,
  [2799] = 2747,
  [2800] = 2800,
  [2801] = 2630,
  [2802] = 2646,
  [2803] = 2715,
  [2804] = 2636,
  [2805] = 2805,
  [2806] = 2632,
  [2807] = 2724,
  [2808] = 2636,
  [2809] = 2732,
  [2810] = 2810,
  [2811] = 2645,
  [2812] = 2796,
  [2813] = 2813,
  [2814] = 2632,
  [2815] = 2653,
  [2816] = 2655,
  [2817] = 2632,
  [2818] = 2639,
  [2819] = 2671,
  [2820] = 2779,
  [2821] = 2821,
  [2822] = 2775,
  [2823] = 2785,
  [2824] = 2641,
  [2825] = 2636,
  [2826] = 2741,
  [2827] = 2641,
  [2828] = 2639,
  [2829] = 2727,
  [2830] = 2629,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xece},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071},
  {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10},
  {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0},
  {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9},
  {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f},
  {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d},
  {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c},
  {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe},
  {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739},
  {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(55);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '&') ADVANCE(99);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(133);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(163);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(168);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(130);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(3);
      if (lookahead == '\r') ADVANCE(135);
      if (lookahead == '#') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '}') ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(135);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '&') ADVANCE(99);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(5);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(94);
      if (lookahead == '&') ADVANCE(98);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(106);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(114);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(100);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(86);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(6);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(21);
      if (lookahead == '&') ADVANCE(22);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(15);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(18);
      if (lookahead == '=') ADVANCE(77);
      if (lookahead == '>') ADVANCE(31);
      if (lookahead == '@') ADVANCE(23);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '^') ADVANCE(24);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(25);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(6);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(7);
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '&') ADVANCE(99);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '}') ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(7);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(8);
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '&') ADVANCE(99);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '|') ADVANCE(87);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '-') ADVANCE(30);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == 'e') ADVANCE(163);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(9);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 10:
      if (lookahead == '\r') ADVANCE(1);
      if ((!eof && lookahead == 00) ||
          lookahead == '\n') ADVANCE(168);
      END_STATE();
    case 11:
      if (lookahead == '\r') SKIP(11);
      if (lookahead == '!') ADVANCE(19);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '&') ADVANCE(99);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(11);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 12:
      if (lookahead == '\r') SKIP(12);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(94);
      if (lookahead == '&') ADVANCE(98);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(106);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(114);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(100);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(86);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(12);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 13:
      if (lookahead == '\r') SKIP(13);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(94);
      if (lookahead == '&') ADVANCE(98);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(106);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(114);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(100);
      if (lookahead == '|') ADVANCE(86);
      if (lookahead == '}') ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(13);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 14:
      if (lookahead == '\r') SKIP(14);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(94);
      if (lookahead == '&') ADVANCE(98);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(106);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(114);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(100);
      if (lookahead == '|') ADVANCE(86);
      if (lookahead == '}') ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(14);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(129);
      END_STATE();
    case 17:
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 18:
      if (lookahead == '<') ADVANCE(28);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(110);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(137);
      END_STATE();
    case 21:
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 22:
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 27:
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 28:
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 29:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 30:
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 31:
      if (lookahead == '>') ADVANCE(29);
      END_STATE();
    case 32:
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(142);
      END_STATE();
    case 33:
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(143);
      END_STATE();
    case 34:
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(50);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(130);
      if (lookahead != 0) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 38:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(142);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(143);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 50:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(36);
      END_STATE();
    case 51:
      if (eof) ADVANCE(55);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(95);
      if (lookahead == '&') ADVANCE(99);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(113);
      if (lookahead == '@') ADVANCE(82);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(163);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 52:
      if (eof) ADVANCE(55);
      if (lookahead == '\r') SKIP(52);
      if (lookahead == '!') ADVANCE(20);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == ')') ADVANCE(60);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(15);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(56);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == '>') ADVANCE(112);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(86);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(52);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 53:
      if (eof) ADVANCE(55);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(15);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == 'e') ADVANCE(164);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(53);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 54:
      if (eof) ADVANCE(55);
      if (lookahead == '\r') SKIP(54);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '(') ADVANCE(59);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(90);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(15);
      if (lookahead == '0') ADVANCE(139);
      if (lookahead == '@') ADVANCE(81);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '~') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(54);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(140);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(166);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(75);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(68);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '*') ADVANCE(73);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_except);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_except_STAR);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(97);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(96);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(103);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(102);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(67);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(66);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(131);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      ADVANCE_MAP(
        0, 168,
        '\n', 130,
        '\r', 2,
        'N', 35,
        'U', 49,
        'u', 45,
        'x', 43,
        '"', 130,
        '\'', 130,
        '\\', 130,
        'a', 130,
        'b', 130,
        'f', 130,
        'n', 130,
        'r', 130,
        't', 130,
        'v', 130,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(132);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if ((!eof && lookahead == 00)) ADVANCE(136);
      if (lookahead == '\r') ADVANCE(136);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(136);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      ADVANCE_MAP(
        '\r', 135,
        '#', 136,
        '\\', 134,
        '\t', 135,
        0x0b, 135,
        '\f', 135,
        ' ', 135,
        0x200b, 135,
        0x2060, 135,
        0xfeff, 135,
      );
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 148,
        '_', 141,
        'B', 32,
        'b', 32,
        'E', 37,
        'e', 37,
        'O', 33,
        'o', 33,
        'X', 34,
        'x', 34,
        'J', 138,
        'L', 138,
        'j', 138,
        'l', 138,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 148,
        '_', 141,
        'E', 37,
        'e', 37,
        'J', 138,
        'L', 138,
        'j', 138,
        'l', 138,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(148);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(138);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(148);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(149);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '*') ADVANCE(73);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(154);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(155);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(156);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(157);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(158);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(159);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(160);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(161);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(162);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(71);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(72);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(150);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(151);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(152);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(153);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_line_continuation);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\r') SKIP(0);
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '_') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'n') ADVANCE(26);
      if (lookahead == 's') ADVANCE(27);
      if (lookahead == 'w') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'r') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 15:
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(52);
      if (lookahead == 'y') ADVANCE(53);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(57);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 24:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(60);
      END_STATE();
    case 26:
      if (lookahead == 'd') ADVANCE(61);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(66);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(67);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(69);
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(71);
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(75);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(78);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(79);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(83);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(84);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 52:
      if (lookahead == 'y') ADVANCE(87);
      END_STATE();
    case 53:
      if (lookahead == 'p') ADVANCE(88);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 57:
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 63:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(99);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 67:
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 71:
      if (lookahead == 'f') ADVANCE(103);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(105);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(106);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 76:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 78:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 79:
      if (lookahead == 'b') ADVANCE(110);
      END_STATE();
    case 80:
      if (lookahead == 'c') ADVANCE(111);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(113);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 86:
      if (lookahead == 'u') ADVANCE(116);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 90:
      if (lookahead == 'h') ADVANCE(119);
      END_STATE();
    case 91:
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 97:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 99:
      if (lookahead == 'k') ADVANCE(126);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 101:
      if (lookahead == 's') ADVANCE(127);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 106:
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 111:
      if (lookahead == 'h') ADVANCE(133);
      END_STATE();
    case 112:
      if (lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 116:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 120:
      if (lookahead == 'd') ADVANCE(139);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 122:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 129:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(144);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(147);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 137:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(149);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 142:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 143:
      if (lookahead == 'y') ADVANCE(151);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 147:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 152:
      if (lookahead == 'l') ADVANCE(155);
      END_STATE();
    case 153:
      if (lookahead == '_') ADVANCE(156);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 156:
      if (lookahead == '_') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 52, .external_lex_state = 2},
  [2] = {.lex_state = 52, .external_lex_state = 3},
  [3] = {.lex_state = 52, .external_lex_state = 3},
  [4] = {.lex_state = 52, .external_lex_state = 3},
  [5] = {.lex_state = 52, .external_lex_state = 3},
  [6] = {.lex_state = 52, .external_lex_state = 3},
  [7] = {.lex_state = 52, .external_lex_state = 3},
  [8] = {.lex_state = 52, .external_lex_state = 3},
  [9] = {.lex_state = 52, .external_lex_state = 3},
  [10] = {.lex_state = 52, .external_lex_state = 3},
  [11] = {.lex_state = 52, .external_lex_state = 3},
  [12] = {.lex_state = 52, .external_lex_state = 3},
  [13] = {.lex_state = 52, .external_lex_state = 3},
  [14] = {.lex_state = 52, .external_lex_state = 3},
  [15] = {.lex_state = 52, .external_lex_state = 3},
  [16] = {.lex_state = 52, .external_lex_state = 3},
  [17] = {.lex_state = 52, .external_lex_state = 3},
  [18] = {.lex_state = 52, .external_lex_state = 3},
  [19] = {.lex_state = 52, .external_lex_state = 3},
  [20] = {.lex_state = 52, .external_lex_state = 3},
  [21] = {.lex_state = 52, .external_lex_state = 3},
  [22] = {.lex_state = 52, .external_lex_state = 3},
  [23] = {.lex_state = 52, .external_lex_state = 3},
  [24] = {.lex_state = 52, .external_lex_state = 3},
  [25] = {.lex_state = 52, .external_lex_state = 3},
  [26] = {.lex_state = 52, .external_lex_state = 3},
  [27] = {.lex_state = 52, .external_lex_state = 3},
  [28] = {.lex_state = 52, .external_lex_state = 3},
  [29] = {.lex_state = 52, .external_lex_state = 3},
  [30] = {.lex_state = 52, .external_lex_state = 3},
  [31] = {.lex_state = 52, .external_lex_state = 3},
  [32] = {.lex_state = 52, .external_lex_state = 3},
  [33] = {.lex_state = 52, .external_lex_state = 3},
  [34] = {.lex_state = 52, .external_lex_state = 3},
  [35] = {.lex_state = 52, .external_lex_state = 3},
  [36] = {.lex_state = 52, .external_lex_state = 3},
  [37] = {.lex_state = 52, .external_lex_state = 3},
  [38] = {.lex_state = 52, .external_lex_state = 3},
  [39] = {.lex_state = 52, .external_lex_state = 3},
  [40] = {.lex_state = 52, .external_lex_state = 3},
  [41] = {.lex_state = 52, .external_lex_state = 3},
  [42] = {.lex_state = 52, .external_lex_state = 3},
  [43] = {.lex_state = 52, .external_lex_state = 3},
  [44] = {.lex_state = 52, .external_lex_state = 3},
  [45] = {.lex_state = 52, .external_lex_state = 3},
  [46] = {.lex_state = 52, .external_lex_state = 3},
  [47] = {.lex_state = 52, .external_lex_state = 3},
  [48] = {.lex_state = 52, .external_lex_state = 3},
  [49] = {.lex_state = 52, .external_lex_state = 3},
  [50] = {.lex_state = 52, .external_lex_state = 3},
  [51] = {.lex_state = 52, .external_lex_state = 3},
  [52] = {.lex_state = 52, .external_lex_state = 3},
  [53] = {.lex_state = 52, .external_lex_state = 3},
  [54] = {.lex_state = 52, .external_lex_state = 3},
  [55] = {.lex_state = 52, .external_lex_state = 3},
  [56] = {.lex_state = 52, .external_lex_state = 3},
  [57] = {.lex_state = 52, .external_lex_state = 3},
  [58] = {.lex_state = 52, .external_lex_state = 3},
  [59] = {.lex_state = 52, .external_lex_state = 3},
  [60] = {.lex_state = 52, .external_lex_state = 3},
  [61] = {.lex_state = 52, .external_lex_state = 3},
  [62] = {.lex_state = 52, .external_lex_state = 3},
  [63] = {.lex_state = 52, .external_lex_state = 2},
  [64] = {.lex_state = 52, .external_lex_state = 2},
  [65] = {.lex_state = 52, .external_lex_state = 3},
  [66] = {.lex_state = 52, .external_lex_state = 3},
  [67] = {.lex_state = 52, .external_lex_state = 3},
  [68] = {.lex_state = 52, .external_lex_state = 3},
  [69] = {.lex_state = 52, .external_lex_state = 3},
  [70] = {.lex_state = 52, .external_lex_state = 3},
  [71] = {.lex_state = 52, .external_lex_state = 3},
  [72] = {.lex_state = 52, .external_lex_state = 3},
  [73] = {.lex_state = 4, .external_lex_state = 4},
  [74] = {.lex_state = 4, .external_lex_state = 4},
  [75] = {.lex_state = 5, .external_lex_state = 5},
  [76] = {.lex_state = 5, .external_lex_state = 5},
  [77] = {.lex_state = 5, .external_lex_state = 5},
  [78] = {.lex_state = 5, .external_lex_state = 5},
  [79] = {.lex_state = 5, .external_lex_state = 5},
  [80] = {.lex_state = 5, .external_lex_state = 5},
  [81] = {.lex_state = 5, .external_lex_state = 5},
  [82] = {.lex_state = 5, .external_lex_state = 5},
  [83] = {.lex_state = 4, .external_lex_state = 4},
  [84] = {.lex_state = 4, .external_lex_state = 4},
  [85] = {.lex_state = 4, .external_lex_state = 4},
  [86] = {.lex_state = 4, .external_lex_state = 4},
  [87] = {.lex_state = 52, .external_lex_state = 5},
  [88] = {.lex_state = 52, .external_lex_state = 5},
  [89] = {.lex_state = 52, .external_lex_state = 5},
  [90] = {.lex_state = 52, .external_lex_state = 5},
  [91] = {.lex_state = 52, .external_lex_state = 5},
  [92] = {.lex_state = 52, .external_lex_state = 5},
  [93] = {.lex_state = 52, .external_lex_state = 5},
  [94] = {.lex_state = 52, .external_lex_state = 5},
  [95] = {.lex_state = 52, .external_lex_state = 5},
  [96] = {.lex_state = 52, .external_lex_state = 5},
  [97] = {.lex_state = 52, .external_lex_state = 5},
  [98] = {.lex_state = 52, .external_lex_state = 5},
  [99] = {.lex_state = 52, .external_lex_state = 5},
  [100] = {.lex_state = 52, .external_lex_state = 5},
  [101] = {.lex_state = 52, .external_lex_state = 5},
  [102] = {.lex_state = 52, .external_lex_state = 5},
  [103] = {.lex_state = 52, .external_lex_state = 5},
  [104] = {.lex_state = 52, .external_lex_state = 5},
  [105] = {.lex_state = 52, .external_lex_state = 5},
  [106] = {.lex_state = 52, .external_lex_state = 5},
  [107] = {.lex_state = 52, .external_lex_state = 5},
  [108] = {.lex_state = 52, .external_lex_state = 5},
  [109] = {.lex_state = 52, .external_lex_state = 5},
  [110] = {.lex_state = 52, .external_lex_state = 5},
  [111] = {.lex_state = 52, .external_lex_state = 5},
  [112] = {.lex_state = 52, .external_lex_state = 5},
  [113] = {.lex_state = 52, .external_lex_state = 5},
  [114] = {.lex_state = 52, .external_lex_state = 5},
  [115] = {.lex_state = 52, .external_lex_state = 5},
  [116] = {.lex_state = 52, .external_lex_state = 5},
  [117] = {.lex_state = 52, .external_lex_state = 5},
  [118] = {.lex_state = 52, .external_lex_state = 5},
  [119] = {.lex_state = 52, .external_lex_state = 5},
  [120] = {.lex_state = 52, .external_lex_state = 5},
  [121] = {.lex_state = 52, .external_lex_state = 5},
  [122] = {.lex_state = 52, .external_lex_state = 5},
  [123] = {.lex_state = 52, .external_lex_state = 5},
  [124] = {.lex_state = 52, .external_lex_state = 5},
  [125] = {.lex_state = 52, .external_lex_state = 5},
  [126] = {.lex_state = 52, .external_lex_state = 5},
  [127] = {.lex_state = 52, .external_lex_state = 5},
  [128] = {.lex_state = 52, .external_lex_state = 5},
  [129] = {.lex_state = 52, .external_lex_state = 5},
  [130] = {.lex_state = 52, .external_lex_state = 5},
  [131] = {.lex_state = 52, .external_lex_state = 5},
  [132] = {.lex_state = 52, .external_lex_state = 5},
  [133] = {.lex_state = 52, .external_lex_state = 5},
  [134] = {.lex_state = 52, .external_lex_state = 5},
  [135] = {.lex_state = 52, .external_lex_state = 5},
  [136] = {.lex_state = 52, .external_lex_state = 5},
  [137] = {.lex_state = 52, .external_lex_state = 4},
  [138] = {.lex_state = 52, .external_lex_state = 4},
  [139] = {.lex_state = 52, .external_lex_state = 4},
  [140] = {.lex_state = 52, .external_lex_state = 4},
  [141] = {.lex_state = 52, .external_lex_state = 4},
  [142] = {.lex_state = 52, .external_lex_state = 4},
  [143] = {.lex_state = 52, .external_lex_state = 4},
  [144] = {.lex_state = 52, .external_lex_state = 4},
  [145] = {.lex_state = 52, .external_lex_state = 4},
  [146] = {.lex_state = 52, .external_lex_state = 4},
  [147] = {.lex_state = 52, .external_lex_state = 4},
  [148] = {.lex_state = 52, .external_lex_state = 4},
  [149] = {.lex_state = 52, .external_lex_state = 4},
  [150] = {.lex_state = 52, .external_lex_state = 4},
  [151] = {.lex_state = 52, .external_lex_state = 4},
  [152] = {.lex_state = 52, .external_lex_state = 4},
  [153] = {.lex_state = 52, .external_lex_state = 2},
  [154] = {.lex_state = 4, .external_lex_state = 4},
  [155] = {.lex_state = 4, .external_lex_state = 4},
  [156] = {.lex_state = 11, .external_lex_state = 4},
  [157] = {.lex_state = 5, .external_lex_state = 4},
  [158] = {.lex_state = 5, .external_lex_state = 6},
  [159] = {.lex_state = 12, .external_lex_state = 4},
  [160] = {.lex_state = 12, .external_lex_state = 6},
  [161] = {.lex_state = 12, .external_lex_state = 4},
  [162] = {.lex_state = 5, .external_lex_state = 6},
  [163] = {.lex_state = 5, .external_lex_state = 2},
  [164] = {.lex_state = 5, .external_lex_state = 7},
  [165] = {.lex_state = 5, .external_lex_state = 6},
  [166] = {.lex_state = 5, .external_lex_state = 6},
  [167] = {.lex_state = 5, .external_lex_state = 7},
  [168] = {.lex_state = 12, .external_lex_state = 7},
  [169] = {.lex_state = 12, .external_lex_state = 6},
  [170] = {.lex_state = 5, .external_lex_state = 8},
  [171] = {.lex_state = 5, .external_lex_state = 7},
  [172] = {.lex_state = 5, .external_lex_state = 7},
  [173] = {.lex_state = 5, .external_lex_state = 8},
  [174] = {.lex_state = 12, .external_lex_state = 6},
  [175] = {.lex_state = 5, .external_lex_state = 8},
  [176] = {.lex_state = 11, .external_lex_state = 4},
  [177] = {.lex_state = 12, .external_lex_state = 8},
  [178] = {.lex_state = 5, .external_lex_state = 8},
  [179] = {.lex_state = 12, .external_lex_state = 7},
  [180] = {.lex_state = 5, .external_lex_state = 7},
  [181] = {.lex_state = 12, .external_lex_state = 2},
  [182] = {.lex_state = 5, .external_lex_state = 7},
  [183] = {.lex_state = 12, .external_lex_state = 2},
  [184] = {.lex_state = 5, .external_lex_state = 8},
  [185] = {.lex_state = 5, .external_lex_state = 7},
  [186] = {.lex_state = 12, .external_lex_state = 8},
  [187] = {.lex_state = 11, .external_lex_state = 2},
  [188] = {.lex_state = 11, .external_lex_state = 2},
  [189] = {.lex_state = 52, .external_lex_state = 7},
  [190] = {.lex_state = 52, .external_lex_state = 8},
  [191] = {.lex_state = 5, .external_lex_state = 6},
  [192] = {.lex_state = 52, .external_lex_state = 7},
  [193] = {.lex_state = 52, .external_lex_state = 7},
  [194] = {.lex_state = 52, .external_lex_state = 7},
  [195] = {.lex_state = 52, .external_lex_state = 8},
  [196] = {.lex_state = 52, .external_lex_state = 2},
  [197] = {.lex_state = 52, .external_lex_state = 2},
  [198] = {.lex_state = 52, .external_lex_state = 2},
  [199] = {.lex_state = 52, .external_lex_state = 8},
  [200] = {.lex_state = 5, .external_lex_state = 6},
  [201] = {.lex_state = 52, .external_lex_state = 7},
  [202] = {.lex_state = 52, .external_lex_state = 8},
  [203] = {.lex_state = 5, .external_lex_state = 6},
  [204] = {.lex_state = 52, .external_lex_state = 7},
  [205] = {.lex_state = 52, .external_lex_state = 8},
  [206] = {.lex_state = 5, .external_lex_state = 6},
  [207] = {.lex_state = 5, .external_lex_state = 6},
  [208] = {.lex_state = 52, .external_lex_state = 7},
  [209] = {.lex_state = 52, .external_lex_state = 8},
  [210] = {.lex_state = 5, .external_lex_state = 6},
  [211] = {.lex_state = 52, .external_lex_state = 7},
  [212] = {.lex_state = 52, .external_lex_state = 8},
  [213] = {.lex_state = 5, .external_lex_state = 6},
  [214] = {.lex_state = 52, .external_lex_state = 7},
  [215] = {.lex_state = 52, .external_lex_state = 8},
  [216] = {.lex_state = 5, .external_lex_state = 6},
  [217] = {.lex_state = 52, .external_lex_state = 7},
  [218] = {.lex_state = 52, .external_lex_state = 8},
  [219] = {.lex_state = 52, .external_lex_state = 8},
  [220] = {.lex_state = 52, .external_lex_state = 8},
  [221] = {.lex_state = 52, .external_lex_state = 7},
  [222] = {.lex_state = 6, .external_lex_state = 4},
  [223] = {.lex_state = 6, .external_lex_state = 4},
  [224] = {.lex_state = 5, .external_lex_state = 8},
  [225] = {.lex_state = 5, .external_lex_state = 8},
  [226] = {.lex_state = 5, .external_lex_state = 8},
  [227] = {.lex_state = 5, .external_lex_state = 8},
  [228] = {.lex_state = 5, .external_lex_state = 8},
  [229] = {.lex_state = 5, .external_lex_state = 8},
  [230] = {.lex_state = 5, .external_lex_state = 8},
  [231] = {.lex_state = 52, .external_lex_state = 2},
  [232] = {.lex_state = 5, .external_lex_state = 8},
  [233] = {.lex_state = 52, .external_lex_state = 2},
  [234] = {.lex_state = 5, .external_lex_state = 2},
  [235] = {.lex_state = 5, .external_lex_state = 2},
  [236] = {.lex_state = 5, .external_lex_state = 2},
  [237] = {.lex_state = 5, .external_lex_state = 2},
  [238] = {.lex_state = 5, .external_lex_state = 7},
  [239] = {.lex_state = 5, .external_lex_state = 2},
  [240] = {.lex_state = 5, .external_lex_state = 2},
  [241] = {.lex_state = 5, .external_lex_state = 2},
  [242] = {.lex_state = 5, .external_lex_state = 2},
  [243] = {.lex_state = 5, .external_lex_state = 7},
  [244] = {.lex_state = 5, .external_lex_state = 2},
  [245] = {.lex_state = 5, .external_lex_state = 7},
  [246] = {.lex_state = 5, .external_lex_state = 7},
  [247] = {.lex_state = 5, .external_lex_state = 2},
  [248] = {.lex_state = 5, .external_lex_state = 7},
  [249] = {.lex_state = 6, .external_lex_state = 2},
  [250] = {.lex_state = 5, .external_lex_state = 2},
  [251] = {.lex_state = 5, .external_lex_state = 7},
  [252] = {.lex_state = 5, .external_lex_state = 2},
  [253] = {.lex_state = 52, .external_lex_state = 7},
  [254] = {.lex_state = 5, .external_lex_state = 7},
  [255] = {.lex_state = 5, .external_lex_state = 2},
  [256] = {.lex_state = 52, .external_lex_state = 6},
  [257] = {.lex_state = 5, .external_lex_state = 7},
  [258] = {.lex_state = 5, .external_lex_state = 2},
  [259] = {.lex_state = 5, .external_lex_state = 2},
  [260] = {.lex_state = 6, .external_lex_state = 2},
  [261] = {.lex_state = 5, .external_lex_state = 2},
  [262] = {.lex_state = 5, .external_lex_state = 7},
  [263] = {.lex_state = 5, .external_lex_state = 2},
  [264] = {.lex_state = 5, .external_lex_state = 2},
  [265] = {.lex_state = 5, .external_lex_state = 2},
  [266] = {.lex_state = 5, .external_lex_state = 2},
  [267] = {.lex_state = 5, .external_lex_state = 2},
  [268] = {.lex_state = 5, .external_lex_state = 2},
  [269] = {.lex_state = 5, .external_lex_state = 2},
  [270] = {.lex_state = 5, .external_lex_state = 2},
  [271] = {.lex_state = 5, .external_lex_state = 2},
  [272] = {.lex_state = 52, .external_lex_state = 7},
  [273] = {.lex_state = 52, .external_lex_state = 8},
  [274] = {.lex_state = 52, .external_lex_state = 7},
  [275] = {.lex_state = 5, .external_lex_state = 7},
  [276] = {.lex_state = 5, .external_lex_state = 7},
  [277] = {.lex_state = 5, .external_lex_state = 7},
  [278] = {.lex_state = 5, .external_lex_state = 7},
  [279] = {.lex_state = 5, .external_lex_state = 7},
  [280] = {.lex_state = 52, .external_lex_state = 8},
  [281] = {.lex_state = 52, .external_lex_state = 7},
  [282] = {.lex_state = 52, .external_lex_state = 7},
  [283] = {.lex_state = 52, .external_lex_state = 7},
  [284] = {.lex_state = 52, .external_lex_state = 8},
  [285] = {.lex_state = 52, .external_lex_state = 7},
  [286] = {.lex_state = 52, .external_lex_state = 8},
  [287] = {.lex_state = 5, .external_lex_state = 7},
  [288] = {.lex_state = 5, .external_lex_state = 7},
  [289] = {.lex_state = 5, .external_lex_state = 7},
  [290] = {.lex_state = 5, .external_lex_state = 7},
  [291] = {.lex_state = 5, .external_lex_state = 7},
  [292] = {.lex_state = 52, .external_lex_state = 7},
  [293] = {.lex_state = 5, .external_lex_state = 7},
  [294] = {.lex_state = 52, .external_lex_state = 7},
  [295] = {.lex_state = 52, .external_lex_state = 8},
  [296] = {.lex_state = 52, .external_lex_state = 8},
  [297] = {.lex_state = 52, .external_lex_state = 7},
  [298] = {.lex_state = 5, .external_lex_state = 7},
  [299] = {.lex_state = 5, .external_lex_state = 7},
  [300] = {.lex_state = 5, .external_lex_state = 7},
  [301] = {.lex_state = 5, .external_lex_state = 7},
  [302] = {.lex_state = 52, .external_lex_state = 7},
  [303] = {.lex_state = 5, .external_lex_state = 7},
  [304] = {.lex_state = 5, .external_lex_state = 7},
  [305] = {.lex_state = 52, .external_lex_state = 7},
  [306] = {.lex_state = 52, .external_lex_state = 8},
  [307] = {.lex_state = 5, .external_lex_state = 7},
  [308] = {.lex_state = 5, .external_lex_state = 7},
  [309] = {.lex_state = 5, .external_lex_state = 7},
  [310] = {.lex_state = 5, .external_lex_state = 7},
  [311] = {.lex_state = 5, .external_lex_state = 7},
  [312] = {.lex_state = 5, .external_lex_state = 7},
  [313] = {.lex_state = 5, .external_lex_state = 7},
  [314] = {.lex_state = 5, .external_lex_state = 7},
  [315] = {.lex_state = 5, .external_lex_state = 7},
  [316] = {.lex_state = 5, .external_lex_state = 7},
  [317] = {.lex_state = 5, .external_lex_state = 7},
  [318] = {.lex_state = 5, .external_lex_state = 7},
  [319] = {.lex_state = 52, .external_lex_state = 7},
  [320] = {.lex_state = 5, .external_lex_state = 7},
  [321] = {.lex_state = 5, .external_lex_state = 7},
  [322] = {.lex_state = 52, .external_lex_state = 7},
  [323] = {.lex_state = 52, .external_lex_state = 8},
  [324] = {.lex_state = 52, .external_lex_state = 7},
  [325] = {.lex_state = 5, .external_lex_state = 7},
  [326] = {.lex_state = 52, .external_lex_state = 6},
  [327] = {.lex_state = 52, .external_lex_state = 6},
  [328] = {.lex_state = 52, .external_lex_state = 8},
  [329] = {.lex_state = 12, .external_lex_state = 6},
  [330] = {.lex_state = 52, .external_lex_state = 8},
  [331] = {.lex_state = 52, .external_lex_state = 7},
  [332] = {.lex_state = 52, .external_lex_state = 7},
  [333] = {.lex_state = 52, .external_lex_state = 8},
  [334] = {.lex_state = 52, .external_lex_state = 6},
  [335] = {.lex_state = 52, .external_lex_state = 6},
  [336] = {.lex_state = 5, .external_lex_state = 2},
  [337] = {.lex_state = 52, .external_lex_state = 7},
  [338] = {.lex_state = 52, .external_lex_state = 6},
  [339] = {.lex_state = 52, .external_lex_state = 8},
  [340] = {.lex_state = 52, .external_lex_state = 7},
  [341] = {.lex_state = 52, .external_lex_state = 8},
  [342] = {.lex_state = 52, .external_lex_state = 7},
  [343] = {.lex_state = 52, .external_lex_state = 7},
  [344] = {.lex_state = 52, .external_lex_state = 6},
  [345] = {.lex_state = 52, .external_lex_state = 6},
  [346] = {.lex_state = 52, .external_lex_state = 8},
  [347] = {.lex_state = 52, .external_lex_state = 6},
  [348] = {.lex_state = 5, .external_lex_state = 6},
  [349] = {.lex_state = 5, .external_lex_state = 6},
  [350] = {.lex_state = 52, .external_lex_state = 2},
  [351] = {.lex_state = 5, .external_lex_state = 6},
  [352] = {.lex_state = 5, .external_lex_state = 6},
  [353] = {.lex_state = 5, .external_lex_state = 6},
  [354] = {.lex_state = 52, .external_lex_state = 2},
  [355] = {.lex_state = 5, .external_lex_state = 6},
  [356] = {.lex_state = 5, .external_lex_state = 6},
  [357] = {.lex_state = 52, .external_lex_state = 4},
  [358] = {.lex_state = 5, .external_lex_state = 6},
  [359] = {.lex_state = 5, .external_lex_state = 6},
  [360] = {.lex_state = 5, .external_lex_state = 6},
  [361] = {.lex_state = 52, .external_lex_state = 4},
  [362] = {.lex_state = 52, .external_lex_state = 2},
  [363] = {.lex_state = 52, .external_lex_state = 7},
  [364] = {.lex_state = 5, .external_lex_state = 6},
  [365] = {.lex_state = 52, .external_lex_state = 8},
  [366] = {.lex_state = 5, .external_lex_state = 6},
  [367] = {.lex_state = 5, .external_lex_state = 6},
  [368] = {.lex_state = 5, .external_lex_state = 6},
  [369] = {.lex_state = 5, .external_lex_state = 6},
  [370] = {.lex_state = 5, .external_lex_state = 6},
  [371] = {.lex_state = 52, .external_lex_state = 8},
  [372] = {.lex_state = 52, .external_lex_state = 8},
  [373] = {.lex_state = 52, .external_lex_state = 8},
  [374] = {.lex_state = 52, .external_lex_state = 8},
  [375] = {.lex_state = 52, .external_lex_state = 8},
  [376] = {.lex_state = 52, .external_lex_state = 8},
  [377] = {.lex_state = 52, .external_lex_state = 8},
  [378] = {.lex_state = 12, .external_lex_state = 7},
  [379] = {.lex_state = 52, .external_lex_state = 8},
  [380] = {.lex_state = 52, .external_lex_state = 8},
  [381] = {.lex_state = 52, .external_lex_state = 8},
  [382] = {.lex_state = 52, .external_lex_state = 8},
  [383] = {.lex_state = 52, .external_lex_state = 4},
  [384] = {.lex_state = 52, .external_lex_state = 8},
  [385] = {.lex_state = 52, .external_lex_state = 8},
  [386] = {.lex_state = 52, .external_lex_state = 8},
  [387] = {.lex_state = 52, .external_lex_state = 8},
  [388] = {.lex_state = 52, .external_lex_state = 4},
  [389] = {.lex_state = 52, .external_lex_state = 8},
  [390] = {.lex_state = 52, .external_lex_state = 8},
  [391] = {.lex_state = 52, .external_lex_state = 8},
  [392] = {.lex_state = 52, .external_lex_state = 8},
  [393] = {.lex_state = 52, .external_lex_state = 8},
  [394] = {.lex_state = 52, .external_lex_state = 8},
  [395] = {.lex_state = 52, .external_lex_state = 8},
  [396] = {.lex_state = 52, .external_lex_state = 8},
  [397] = {.lex_state = 52, .external_lex_state = 4},
  [398] = {.lex_state = 52, .external_lex_state = 8},
  [399] = {.lex_state = 52, .external_lex_state = 8},
  [400] = {.lex_state = 5, .external_lex_state = 2},
  [401] = {.lex_state = 52, .external_lex_state = 8},
  [402] = {.lex_state = 52, .external_lex_state = 8},
  [403] = {.lex_state = 52, .external_lex_state = 8},
  [404] = {.lex_state = 52, .external_lex_state = 8},
  [405] = {.lex_state = 12, .external_lex_state = 7},
  [406] = {.lex_state = 52, .external_lex_state = 8},
  [407] = {.lex_state = 52, .external_lex_state = 8},
  [408] = {.lex_state = 52, .external_lex_state = 8},
  [409] = {.lex_state = 52, .external_lex_state = 2},
  [410] = {.lex_state = 52, .external_lex_state = 2},
  [411] = {.lex_state = 52, .external_lex_state = 4},
  [412] = {.lex_state = 52, .external_lex_state = 7},
  [413] = {.lex_state = 52, .external_lex_state = 2},
  [414] = {.lex_state = 52, .external_lex_state = 2},
  [415] = {.lex_state = 52, .external_lex_state = 2},
  [416] = {.lex_state = 52, .external_lex_state = 2},
  [417] = {.lex_state = 52, .external_lex_state = 2},
  [418] = {.lex_state = 52, .external_lex_state = 4},
  [419] = {.lex_state = 52, .external_lex_state = 4},
  [420] = {.lex_state = 52, .external_lex_state = 8},
  [421] = {.lex_state = 52, .external_lex_state = 2},
  [422] = {.lex_state = 52, .external_lex_state = 2},
  [423] = {.lex_state = 5, .external_lex_state = 7},
  [424] = {.lex_state = 52, .external_lex_state = 2},
  [425] = {.lex_state = 52, .external_lex_state = 2},
  [426] = {.lex_state = 52, .external_lex_state = 7},
  [427] = {.lex_state = 52, .external_lex_state = 2},
  [428] = {.lex_state = 52, .external_lex_state = 2},
  [429] = {.lex_state = 52, .external_lex_state = 2},
  [430] = {.lex_state = 5, .external_lex_state = 2},
  [431] = {.lex_state = 52, .external_lex_state = 2},
  [432] = {.lex_state = 52, .external_lex_state = 2},
  [433] = {.lex_state = 52, .external_lex_state = 2},
  [434] = {.lex_state = 52, .external_lex_state = 8},
  [435] = {.lex_state = 12, .external_lex_state = 2},
  [436] = {.lex_state = 52, .external_lex_state = 7},
  [437] = {.lex_state = 52, .external_lex_state = 7},
  [438] = {.lex_state = 52, .external_lex_state = 2},
  [439] = {.lex_state = 12, .external_lex_state = 2},
  [440] = {.lex_state = 5, .external_lex_state = 8},
  [441] = {.lex_state = 52, .external_lex_state = 4},
  [442] = {.lex_state = 52, .external_lex_state = 8},
  [443] = {.lex_state = 52, .external_lex_state = 8},
  [444] = {.lex_state = 52, .external_lex_state = 4},
  [445] = {.lex_state = 52, .external_lex_state = 4},
  [446] = {.lex_state = 52, .external_lex_state = 2},
  [447] = {.lex_state = 52, .external_lex_state = 8},
  [448] = {.lex_state = 52, .external_lex_state = 2},
  [449] = {.lex_state = 52, .external_lex_state = 2},
  [450] = {.lex_state = 52, .external_lex_state = 2},
  [451] = {.lex_state = 52, .external_lex_state = 2},
  [452] = {.lex_state = 52, .external_lex_state = 2},
  [453] = {.lex_state = 52, .external_lex_state = 2},
  [454] = {.lex_state = 52, .external_lex_state = 2},
  [455] = {.lex_state = 52, .external_lex_state = 2},
  [456] = {.lex_state = 52, .external_lex_state = 2},
  [457] = {.lex_state = 52, .external_lex_state = 2},
  [458] = {.lex_state = 52, .external_lex_state = 2},
  [459] = {.lex_state = 52, .external_lex_state = 2},
  [460] = {.lex_state = 52, .external_lex_state = 2},
  [461] = {.lex_state = 7, .external_lex_state = 9},
  [462] = {.lex_state = 52, .external_lex_state = 2},
  [463] = {.lex_state = 52, .external_lex_state = 2},
  [464] = {.lex_state = 52, .external_lex_state = 2},
  [465] = {.lex_state = 52, .external_lex_state = 2},
  [466] = {.lex_state = 52, .external_lex_state = 2},
  [467] = {.lex_state = 52, .external_lex_state = 2},
  [468] = {.lex_state = 52, .external_lex_state = 2},
  [469] = {.lex_state = 52, .external_lex_state = 2},
  [470] = {.lex_state = 7, .external_lex_state = 4},
  [471] = {.lex_state = 7, .external_lex_state = 4},
  [472] = {.lex_state = 52, .external_lex_state = 2},
  [473] = {.lex_state = 7, .external_lex_state = 9},
  [474] = {.lex_state = 52, .external_lex_state = 2},
  [475] = {.lex_state = 52, .external_lex_state = 2},
  [476] = {.lex_state = 52, .external_lex_state = 2},
  [477] = {.lex_state = 52, .external_lex_state = 2},
  [478] = {.lex_state = 52, .external_lex_state = 2},
  [479] = {.lex_state = 52, .external_lex_state = 2},
  [480] = {.lex_state = 52, .external_lex_state = 2},
  [481] = {.lex_state = 53, .external_lex_state = 10},
  [482] = {.lex_state = 52, .external_lex_state = 2},
  [483] = {.lex_state = 52, .external_lex_state = 2},
  [484] = {.lex_state = 52, .external_lex_state = 2},
  [485] = {.lex_state = 54, .external_lex_state = 2},
  [486] = {.lex_state = 52, .external_lex_state = 2},
  [487] = {.lex_state = 52, .external_lex_state = 2},
  [488] = {.lex_state = 52, .external_lex_state = 2},
  [489] = {.lex_state = 52, .external_lex_state = 2},
  [490] = {.lex_state = 52, .external_lex_state = 2},
  [491] = {.lex_state = 52, .external_lex_state = 2},
  [492] = {.lex_state = 53, .external_lex_state = 10},
  [493] = {.lex_state = 54, .external_lex_state = 2},
  [494] = {.lex_state = 52, .external_lex_state = 2},
  [495] = {.lex_state = 52, .external_lex_state = 2},
  [496] = {.lex_state = 52, .external_lex_state = 2},
  [497] = {.lex_state = 52, .external_lex_state = 2},
  [498] = {.lex_state = 52, .external_lex_state = 2},
  [499] = {.lex_state = 52, .external_lex_state = 2},
  [500] = {.lex_state = 52, .external_lex_state = 2},
  [501] = {.lex_state = 53, .external_lex_state = 11},
  [502] = {.lex_state = 54, .external_lex_state = 3},
  [503] = {.lex_state = 52, .external_lex_state = 2},
  [504] = {.lex_state = 52, .external_lex_state = 2},
  [505] = {.lex_state = 52, .external_lex_state = 2},
  [506] = {.lex_state = 53, .external_lex_state = 11},
  [507] = {.lex_state = 54, .external_lex_state = 3},
  [508] = {.lex_state = 52, .external_lex_state = 2},
  [509] = {.lex_state = 52, .external_lex_state = 2},
  [510] = {.lex_state = 52, .external_lex_state = 2},
  [511] = {.lex_state = 52, .external_lex_state = 2},
  [512] = {.lex_state = 52, .external_lex_state = 2},
  [513] = {.lex_state = 52, .external_lex_state = 2},
  [514] = {.lex_state = 52, .external_lex_state = 2},
  [515] = {.lex_state = 52, .external_lex_state = 2},
  [516] = {.lex_state = 52, .external_lex_state = 2},
  [517] = {.lex_state = 52, .external_lex_state = 2},
  [518] = {.lex_state = 52, .external_lex_state = 2},
  [519] = {.lex_state = 52, .external_lex_state = 2},
  [520] = {.lex_state = 52, .external_lex_state = 2},
  [521] = {.lex_state = 52, .external_lex_state = 2},
  [522] = {.lex_state = 52, .external_lex_state = 2},
  [523] = {.lex_state = 52, .external_lex_state = 2},
  [524] = {.lex_state = 52, .external_lex_state = 2},
  [525] = {.lex_state = 52, .external_lex_state = 2},
  [526] = {.lex_state = 52, .external_lex_state = 2},
  [527] = {.lex_state = 52, .external_lex_state = 2},
  [528] = {.lex_state = 52, .external_lex_state = 2},
  [529] = {.lex_state = 52, .external_lex_state = 2},
  [530] = {.lex_state = 52, .external_lex_state = 2},
  [531] = {.lex_state = 52, .external_lex_state = 2},
  [532] = {.lex_state = 52, .external_lex_state = 2},
  [533] = {.lex_state = 52, .external_lex_state = 2},
  [534] = {.lex_state = 52, .external_lex_state = 2},
  [535] = {.lex_state = 52, .external_lex_state = 2},
  [536] = {.lex_state = 52, .external_lex_state = 2},
  [537] = {.lex_state = 52, .external_lex_state = 2},
  [538] = {.lex_state = 52, .external_lex_state = 2},
  [539] = {.lex_state = 52, .external_lex_state = 2},
  [540] = {.lex_state = 52, .external_lex_state = 2},
  [541] = {.lex_state = 52, .external_lex_state = 2},
  [542] = {.lex_state = 52, .external_lex_state = 2},
  [543] = {.lex_state = 52, .external_lex_state = 2},
  [544] = {.lex_state = 52, .external_lex_state = 2},
  [545] = {.lex_state = 52, .external_lex_state = 2},
  [546] = {.lex_state = 52, .external_lex_state = 2},
  [547] = {.lex_state = 52, .external_lex_state = 2},
  [548] = {.lex_state = 52, .external_lex_state = 2},
  [549] = {.lex_state = 52, .external_lex_state = 2},
  [550] = {.lex_state = 52, .external_lex_state = 2},
  [551] = {.lex_state = 52, .external_lex_state = 2},
  [552] = {.lex_state = 52, .external_lex_state = 2},
  [553] = {.lex_state = 52, .external_lex_state = 2},
  [554] = {.lex_state = 52, .external_lex_state = 2},
  [555] = {.lex_state = 52, .external_lex_state = 2},
  [556] = {.lex_state = 52, .external_lex_state = 2},
  [557] = {.lex_state = 52, .external_lex_state = 2},
  [558] = {.lex_state = 52, .external_lex_state = 2},
  [559] = {.lex_state = 52, .external_lex_state = 2},
  [560] = {.lex_state = 52, .external_lex_state = 2},
  [561] = {.lex_state = 52, .external_lex_state = 2},
  [562] = {.lex_state = 52, .external_lex_state = 2},
  [563] = {.lex_state = 52, .external_lex_state = 2},
  [564] = {.lex_state = 52, .external_lex_state = 2},
  [565] = {.lex_state = 52, .external_lex_state = 2},
  [566] = {.lex_state = 52, .external_lex_state = 2},
  [567] = {.lex_state = 52, .external_lex_state = 2},
  [568] = {.lex_state = 52, .external_lex_state = 2},
  [569] = {.lex_state = 52, .external_lex_state = 2},
  [570] = {.lex_state = 52, .external_lex_state = 2},
  [571] = {.lex_state = 52, .external_lex_state = 2},
  [572] = {.lex_state = 52, .external_lex_state = 2},
  [573] = {.lex_state = 52, .external_lex_state = 2},
  [574] = {.lex_state = 52, .external_lex_state = 2},
  [575] = {.lex_state = 52, .external_lex_state = 2},
  [576] = {.lex_state = 52, .external_lex_state = 2},
  [577] = {.lex_state = 52, .external_lex_state = 2},
  [578] = {.lex_state = 52, .external_lex_state = 2},
  [579] = {.lex_state = 52, .external_lex_state = 2},
  [580] = {.lex_state = 52, .external_lex_state = 2},
  [581] = {.lex_state = 52, .external_lex_state = 2},
  [582] = {.lex_state = 52, .external_lex_state = 2},
  [583] = {.lex_state = 52, .external_lex_state = 2},
  [584] = {.lex_state = 52, .external_lex_state = 2},
  [585] = {.lex_state = 52, .external_lex_state = 2},
  [586] = {.lex_state = 52, .external_lex_state = 2},
  [587] = {.lex_state = 52, .external_lex_state = 2},
  [588] = {.lex_state = 52, .external_lex_state = 2},
  [589] = {.lex_state = 52, .external_lex_state = 2},
  [590] = {.lex_state = 52, .external_lex_state = 2},
  [591] = {.lex_state = 52, .external_lex_state = 2},
  [592] = {.lex_state = 52, .external_lex_state = 2},
  [593] = {.lex_state = 52, .external_lex_state = 2},
  [594] = {.lex_state = 52, .external_lex_state = 2},
  [595] = {.lex_state = 52, .external_lex_state = 2},
  [596] = {.lex_state = 52, .external_lex_state = 2},
  [597] = {.lex_state = 52, .external_lex_state = 2},
  [598] = {.lex_state = 52, .external_lex_state = 2},
  [599] = {.lex_state = 52, .external_lex_state = 2},
  [600] = {.lex_state = 52, .external_lex_state = 2},
  [601] = {.lex_state = 52, .external_lex_state = 2},
  [602] = {.lex_state = 52, .external_lex_state = 2},
  [603] = {.lex_state = 52, .external_lex_state = 2},
  [604] = {.lex_state = 52, .external_lex_state = 2},
  [605] = {.lex_state = 52, .external_lex_state = 2},
  [606] = {.lex_state = 52, .external_lex_state = 2},
  [607] = {.lex_state = 52, .external_lex_state = 2},
  [608] = {.lex_state = 52, .external_lex_state = 2},
  [609] = {.lex_state = 7, .external_lex_state = 9},
  [610] = {.lex_state = 7, .external_lex_state = 9},
  [611] = {.lex_state = 52, .external_lex_state = 2},
  [612] = {.lex_state = 7, .external_lex_state = 9},
  [613] = {.lex_state = 52, .external_lex_state = 3},
  [614] = {.lex_state = 53, .external_lex_state = 10},
  [615] = {.lex_state = 52, .external_lex_state = 2},
  [616] = {.lex_state = 7, .external_lex_state = 9},
  [617] = {.lex_state = 52, .external_lex_state = 2},
  [618] = {.lex_state = 7, .external_lex_state = 9},
  [619] = {.lex_state = 54, .external_lex_state = 2},
  [620] = {.lex_state = 52, .external_lex_state = 3},
  [621] = {.lex_state = 52, .external_lex_state = 3},
  [622] = {.lex_state = 53, .external_lex_state = 11},
  [623] = {.lex_state = 52, .external_lex_state = 2},
  [624] = {.lex_state = 54, .external_lex_state = 3},
  [625] = {.lex_state = 52, .external_lex_state = 3},
  [626] = {.lex_state = 8, .external_lex_state = 9},
  [627] = {.lex_state = 8, .external_lex_state = 9},
  [628] = {.lex_state = 8, .external_lex_state = 9},
  [629] = {.lex_state = 8, .external_lex_state = 9},
  [630] = {.lex_state = 52, .external_lex_state = 2},
  [631] = {.lex_state = 8, .external_lex_state = 9},
  [632] = {.lex_state = 8, .external_lex_state = 9},
  [633] = {.lex_state = 8, .external_lex_state = 9},
  [634] = {.lex_state = 8, .external_lex_state = 9},
  [635] = {.lex_state = 8, .external_lex_state = 9},
  [636] = {.lex_state = 8, .external_lex_state = 9},
  [637] = {.lex_state = 8, .external_lex_state = 9},
  [638] = {.lex_state = 8, .external_lex_state = 9},
  [639] = {.lex_state = 8, .external_lex_state = 9},
  [640] = {.lex_state = 8, .external_lex_state = 9},
  [641] = {.lex_state = 8, .external_lex_state = 9},
  [642] = {.lex_state = 52, .external_lex_state = 3},
  [643] = {.lex_state = 8, .external_lex_state = 9},
  [644] = {.lex_state = 8, .external_lex_state = 9},
  [645] = {.lex_state = 8, .external_lex_state = 9},
  [646] = {.lex_state = 8, .external_lex_state = 9},
  [647] = {.lex_state = 52, .external_lex_state = 2},
  [648] = {.lex_state = 53, .external_lex_state = 10},
  [649] = {.lex_state = 54, .external_lex_state = 2},
  [650] = {.lex_state = 52, .external_lex_state = 3},
  [651] = {.lex_state = 53, .external_lex_state = 11},
  [652] = {.lex_state = 54, .external_lex_state = 3},
  [653] = {.lex_state = 53, .external_lex_state = 10},
  [654] = {.lex_state = 53, .external_lex_state = 11},
  [655] = {.lex_state = 54, .external_lex_state = 2},
  [656] = {.lex_state = 54, .external_lex_state = 2},
  [657] = {.lex_state = 53, .external_lex_state = 11},
  [658] = {.lex_state = 53, .external_lex_state = 11},
  [659] = {.lex_state = 53, .external_lex_state = 11},
  [660] = {.lex_state = 52, .external_lex_state = 3},
  [661] = {.lex_state = 53, .external_lex_state = 10},
  [662] = {.lex_state = 54, .external_lex_state = 3},
  [663] = {.lex_state = 53, .external_lex_state = 10},
  [664] = {.lex_state = 53, .external_lex_state = 11},
  [665] = {.lex_state = 52, .external_lex_state = 2},
  [666] = {.lex_state = 54, .external_lex_state = 2},
  [667] = {.lex_state = 53, .external_lex_state = 11},
  [668] = {.lex_state = 54, .external_lex_state = 3},
  [669] = {.lex_state = 54, .external_lex_state = 2},
  [670] = {.lex_state = 53, .external_lex_state = 10},
  [671] = {.lex_state = 53, .external_lex_state = 10},
  [672] = {.lex_state = 52, .external_lex_state = 3},
  [673] = {.lex_state = 54, .external_lex_state = 2},
  [674] = {.lex_state = 54, .external_lex_state = 3},
  [675] = {.lex_state = 54, .external_lex_state = 2},
  [676] = {.lex_state = 52, .external_lex_state = 3},
  [677] = {.lex_state = 52, .external_lex_state = 2},
  [678] = {.lex_state = 53, .external_lex_state = 10},
  [679] = {.lex_state = 53, .external_lex_state = 11},
  [680] = {.lex_state = 53, .external_lex_state = 10},
  [681] = {.lex_state = 54, .external_lex_state = 2},
  [682] = {.lex_state = 52, .external_lex_state = 6},
  [683] = {.lex_state = 54, .external_lex_state = 3},
  [684] = {.lex_state = 54, .external_lex_state = 3},
  [685] = {.lex_state = 53, .external_lex_state = 11},
  [686] = {.lex_state = 53, .external_lex_state = 11},
  [687] = {.lex_state = 54, .external_lex_state = 3},
  [688] = {.lex_state = 53, .external_lex_state = 10},
  [689] = {.lex_state = 52, .external_lex_state = 3},
  [690] = {.lex_state = 53, .external_lex_state = 10},
  [691] = {.lex_state = 54, .external_lex_state = 3},
  [692] = {.lex_state = 52, .external_lex_state = 6},
  [693] = {.lex_state = 53, .external_lex_state = 10},
  [694] = {.lex_state = 53, .external_lex_state = 11},
  [695] = {.lex_state = 54, .external_lex_state = 3},
  [696] = {.lex_state = 54, .external_lex_state = 2},
  [697] = {.lex_state = 52, .external_lex_state = 2},
  [698] = {.lex_state = 52, .external_lex_state = 2},
  [699] = {.lex_state = 52, .external_lex_state = 2},
  [700] = {.lex_state = 52, .external_lex_state = 3},
  [701] = {.lex_state = 52, .external_lex_state = 2},
  [702] = {.lex_state = 52, .external_lex_state = 2},
  [703] = {.lex_state = 52, .external_lex_state = 2},
  [704] = {.lex_state = 52, .external_lex_state = 2},
  [705] = {.lex_state = 52, .external_lex_state = 2},
  [706] = {.lex_state = 52, .external_lex_state = 2},
  [707] = {.lex_state = 52, .external_lex_state = 2},
  [708] = {.lex_state = 52, .external_lex_state = 2},
  [709] = {.lex_state = 52, .external_lex_state = 2},
  [710] = {.lex_state = 52, .external_lex_state = 2},
  [711] = {.lex_state = 52, .external_lex_state = 3},
  [712] = {.lex_state = 52, .external_lex_state = 3},
  [713] = {.lex_state = 52, .external_lex_state = 3},
  [714] = {.lex_state = 52, .external_lex_state = 3},
  [715] = {.lex_state = 52, .external_lex_state = 3},
  [716] = {.lex_state = 52, .external_lex_state = 3},
  [717] = {.lex_state = 52, .external_lex_state = 3},
  [718] = {.lex_state = 52, .external_lex_state = 3},
  [719] = {.lex_state = 52, .external_lex_state = 3},
  [720] = {.lex_state = 52, .external_lex_state = 3},
  [721] = {.lex_state = 52, .external_lex_state = 2},
  [722] = {.lex_state = 52, .external_lex_state = 7},
  [723] = {.lex_state = 52, .external_lex_state = 2},
  [724] = {.lex_state = 52, .external_lex_state = 7},
  [725] = {.lex_state = 52, .external_lex_state = 3},
  [726] = {.lex_state = 52, .external_lex_state = 3},
  [727] = {.lex_state = 52, .external_lex_state = 3},
  [728] = {.lex_state = 52, .external_lex_state = 2},
  [729] = {.lex_state = 52, .external_lex_state = 2},
  [730] = {.lex_state = 52, .external_lex_state = 2},
  [731] = {.lex_state = 52, .external_lex_state = 2},
  [732] = {.lex_state = 52, .external_lex_state = 2},
  [733] = {.lex_state = 52, .external_lex_state = 2},
  [734] = {.lex_state = 52, .external_lex_state = 2},
  [735] = {.lex_state = 52, .external_lex_state = 2},
  [736] = {.lex_state = 52, .external_lex_state = 2},
  [737] = {.lex_state = 52, .external_lex_state = 2},
  [738] = {.lex_state = 52, .external_lex_state = 2},
  [739] = {.lex_state = 52, .external_lex_state = 2},
  [740] = {.lex_state = 52, .external_lex_state = 2},
  [741] = {.lex_state = 52, .external_lex_state = 2},
  [742] = {.lex_state = 52, .external_lex_state = 7},
  [743] = {.lex_state = 52, .external_lex_state = 2},
  [744] = {.lex_state = 52, .external_lex_state = 2},
  [745] = {.lex_state = 52, .external_lex_state = 2},
  [746] = {.lex_state = 52, .external_lex_state = 2},
  [747] = {.lex_state = 52, .external_lex_state = 2},
  [748] = {.lex_state = 52, .external_lex_state = 2},
  [749] = {.lex_state = 52, .external_lex_state = 2},
  [750] = {.lex_state = 52, .external_lex_state = 2},
  [751] = {.lex_state = 52, .external_lex_state = 2},
  [752] = {.lex_state = 52, .external_lex_state = 2},
  [753] = {.lex_state = 52, .external_lex_state = 2},
  [754] = {.lex_state = 52, .external_lex_state = 2},
  [755] = {.lex_state = 52, .external_lex_state = 2},
  [756] = {.lex_state = 52, .external_lex_state = 2},
  [757] = {.lex_state = 52, .external_lex_state = 2},
  [758] = {.lex_state = 52, .external_lex_state = 2},
  [759] = {.lex_state = 52, .external_lex_state = 2},
  [760] = {.lex_state = 52, .external_lex_state = 2},
  [761] = {.lex_state = 52, .external_lex_state = 2},
  [762] = {.lex_state = 52, .external_lex_state = 2},
  [763] = {.lex_state = 52, .external_lex_state = 2},
  [764] = {.lex_state = 52, .external_lex_state = 2},
  [765] = {.lex_state = 52, .external_lex_state = 3},
  [766] = {.lex_state = 52, .external_lex_state = 2},
  [767] = {.lex_state = 52, .external_lex_state = 8},
  [768] = {.lex_state = 52, .external_lex_state = 2},
  [769] = {.lex_state = 52, .external_lex_state = 2},
  [770] = {.lex_state = 52, .external_lex_state = 2},
  [771] = {.lex_state = 52, .external_lex_state = 2},
  [772] = {.lex_state = 52, .external_lex_state = 2},
  [773] = {.lex_state = 52, .external_lex_state = 8},
  [774] = {.lex_state = 52, .external_lex_state = 3},
  [775] = {.lex_state = 52, .external_lex_state = 3},
  [776] = {.lex_state = 52, .external_lex_state = 2},
  [777] = {.lex_state = 52, .external_lex_state = 3},
  [778] = {.lex_state = 52, .external_lex_state = 2},
  [779] = {.lex_state = 52, .external_lex_state = 3},
  [780] = {.lex_state = 52, .external_lex_state = 3},
  [781] = {.lex_state = 52, .external_lex_state = 2},
  [782] = {.lex_state = 52, .external_lex_state = 3},
  [783] = {.lex_state = 52, .external_lex_state = 2},
  [784] = {.lex_state = 52, .external_lex_state = 3},
  [785] = {.lex_state = 52, .external_lex_state = 3},
  [786] = {.lex_state = 52, .external_lex_state = 3},
  [787] = {.lex_state = 52, .external_lex_state = 3},
  [788] = {.lex_state = 52, .external_lex_state = 3},
  [789] = {.lex_state = 52, .external_lex_state = 7},
  [790] = {.lex_state = 52, .external_lex_state = 2},
  [791] = {.lex_state = 52, .external_lex_state = 3},
  [792] = {.lex_state = 52, .external_lex_state = 2},
  [793] = {.lex_state = 52, .external_lex_state = 3},
  [794] = {.lex_state = 52, .external_lex_state = 3},
  [795] = {.lex_state = 52, .external_lex_state = 3},
  [796] = {.lex_state = 52, .external_lex_state = 3},
  [797] = {.lex_state = 52, .external_lex_state = 3},
  [798] = {.lex_state = 52, .external_lex_state = 3},
  [799] = {.lex_state = 52, .external_lex_state = 3},
  [800] = {.lex_state = 52, .external_lex_state = 2},
  [801] = {.lex_state = 52, .external_lex_state = 3},
  [802] = {.lex_state = 52, .external_lex_state = 2},
  [803] = {.lex_state = 52, .external_lex_state = 3},
  [804] = {.lex_state = 52, .external_lex_state = 3},
  [805] = {.lex_state = 52, .external_lex_state = 3},
  [806] = {.lex_state = 52, .external_lex_state = 3},
  [807] = {.lex_state = 52, .external_lex_state = 3},
  [808] = {.lex_state = 52, .external_lex_state = 3},
  [809] = {.lex_state = 52, .external_lex_state = 3},
  [810] = {.lex_state = 52, .external_lex_state = 2},
  [811] = {.lex_state = 52, .external_lex_state = 3},
  [812] = {.lex_state = 52, .external_lex_state = 3},
  [813] = {.lex_state = 52, .external_lex_state = 3},
  [814] = {.lex_state = 52, .external_lex_state = 3},
  [815] = {.lex_state = 52, .external_lex_state = 3},
  [816] = {.lex_state = 52, .external_lex_state = 3},
  [817] = {.lex_state = 52, .external_lex_state = 2},
  [818] = {.lex_state = 52, .external_lex_state = 3},
  [819] = {.lex_state = 52, .external_lex_state = 2},
  [820] = {.lex_state = 52, .external_lex_state = 3},
  [821] = {.lex_state = 52, .external_lex_state = 3},
  [822] = {.lex_state = 52, .external_lex_state = 3},
  [823] = {.lex_state = 52, .external_lex_state = 2},
  [824] = {.lex_state = 52, .external_lex_state = 2},
  [825] = {.lex_state = 52, .external_lex_state = 3},
  [826] = {.lex_state = 52, .external_lex_state = 3},
  [827] = {.lex_state = 52, .external_lex_state = 3},
  [828] = {.lex_state = 52, .external_lex_state = 3},
  [829] = {.lex_state = 52, .external_lex_state = 3},
  [830] = {.lex_state = 52, .external_lex_state = 2},
  [831] = {.lex_state = 52, .external_lex_state = 2},
  [832] = {.lex_state = 52, .external_lex_state = 2},
  [833] = {.lex_state = 52, .external_lex_state = 2},
  [834] = {.lex_state = 52, .external_lex_state = 3},
  [835] = {.lex_state = 52, .external_lex_state = 3},
  [836] = {.lex_state = 52, .external_lex_state = 3},
  [837] = {.lex_state = 52, .external_lex_state = 3},
  [838] = {.lex_state = 52, .external_lex_state = 3},
  [839] = {.lex_state = 52, .external_lex_state = 2},
  [840] = {.lex_state = 52, .external_lex_state = 3},
  [841] = {.lex_state = 52, .external_lex_state = 3},
  [842] = {.lex_state = 52, .external_lex_state = 3},
  [843] = {.lex_state = 52, .external_lex_state = 3},
  [844] = {.lex_state = 52, .external_lex_state = 3},
  [845] = {.lex_state = 52, .external_lex_state = 2},
  [846] = {.lex_state = 52, .external_lex_state = 2},
  [847] = {.lex_state = 52, .external_lex_state = 2},
  [848] = {.lex_state = 52, .external_lex_state = 2},
  [849] = {.lex_state = 52, .external_lex_state = 2},
  [850] = {.lex_state = 52, .external_lex_state = 2},
  [851] = {.lex_state = 52, .external_lex_state = 2},
  [852] = {.lex_state = 52, .external_lex_state = 2},
  [853] = {.lex_state = 52, .external_lex_state = 2},
  [854] = {.lex_state = 52, .external_lex_state = 2},
  [855] = {.lex_state = 52, .external_lex_state = 2},
  [856] = {.lex_state = 52, .external_lex_state = 2},
  [857] = {.lex_state = 52, .external_lex_state = 2},
  [858] = {.lex_state = 52, .external_lex_state = 7},
  [859] = {.lex_state = 52, .external_lex_state = 2},
  [860] = {.lex_state = 52, .external_lex_state = 2},
  [861] = {.lex_state = 52, .external_lex_state = 2},
  [862] = {.lex_state = 52, .external_lex_state = 2},
  [863] = {.lex_state = 52, .external_lex_state = 2},
  [864] = {.lex_state = 52, .external_lex_state = 2},
  [865] = {.lex_state = 52, .external_lex_state = 2},
  [866] = {.lex_state = 52, .external_lex_state = 2},
  [867] = {.lex_state = 52, .external_lex_state = 2},
  [868] = {.lex_state = 52, .external_lex_state = 2},
  [869] = {.lex_state = 52, .external_lex_state = 2},
  [870] = {.lex_state = 52, .external_lex_state = 2},
  [871] = {.lex_state = 52, .external_lex_state = 2},
  [872] = {.lex_state = 52, .external_lex_state = 2},
  [873] = {.lex_state = 52, .external_lex_state = 2},
  [874] = {.lex_state = 52, .external_lex_state = 2},
  [875] = {.lex_state = 52, .external_lex_state = 2},
  [876] = {.lex_state = 52, .external_lex_state = 2},
  [877] = {.lex_state = 52, .external_lex_state = 2},
  [878] = {.lex_state = 52, .external_lex_state = 2},
  [879] = {.lex_state = 52, .external_lex_state = 2},
  [880] = {.lex_state = 52, .external_lex_state = 2},
  [881] = {.lex_state = 52, .external_lex_state = 2},
  [882] = {.lex_state = 52, .external_lex_state = 2},
  [883] = {.lex_state = 52, .external_lex_state = 2},
  [884] = {.lex_state = 52, .external_lex_state = 2},
  [885] = {.lex_state = 52, .external_lex_state = 2},
  [886] = {.lex_state = 52, .external_lex_state = 2},
  [887] = {.lex_state = 52, .external_lex_state = 2},
  [888] = {.lex_state = 52, .external_lex_state = 2},
  [889] = {.lex_state = 52, .external_lex_state = 2},
  [890] = {.lex_state = 52, .external_lex_state = 2},
  [891] = {.lex_state = 52, .external_lex_state = 2},
  [892] = {.lex_state = 52, .external_lex_state = 2},
  [893] = {.lex_state = 52, .external_lex_state = 2},
  [894] = {.lex_state = 52, .external_lex_state = 2},
  [895] = {.lex_state = 52, .external_lex_state = 2},
  [896] = {.lex_state = 52, .external_lex_state = 2},
  [897] = {.lex_state = 52, .external_lex_state = 2},
  [898] = {.lex_state = 52, .external_lex_state = 2},
  [899] = {.lex_state = 52, .external_lex_state = 2},
  [900] = {.lex_state = 52, .external_lex_state = 2},
  [901] = {.lex_state = 52, .external_lex_state = 2},
  [902] = {.lex_state = 52, .external_lex_state = 2},
  [903] = {.lex_state = 52, .external_lex_state = 2},
  [904] = {.lex_state = 52, .external_lex_state = 2},
  [905] = {.lex_state = 52, .external_lex_state = 2},
  [906] = {.lex_state = 52, .external_lex_state = 2},
  [907] = {.lex_state = 52, .external_lex_state = 2},
  [908] = {.lex_state = 52, .external_lex_state = 2},
  [909] = {.lex_state = 52, .external_lex_state = 2},
  [910] = {.lex_state = 52, .external_lex_state = 2},
  [911] = {.lex_state = 52, .external_lex_state = 2},
  [912] = {.lex_state = 52, .external_lex_state = 2},
  [913] = {.lex_state = 52, .external_lex_state = 2},
  [914] = {.lex_state = 52, .external_lex_state = 2},
  [915] = {.lex_state = 52, .external_lex_state = 2},
  [916] = {.lex_state = 52, .external_lex_state = 2},
  [917] = {.lex_state = 52, .external_lex_state = 2},
  [918] = {.lex_state = 52, .external_lex_state = 2},
  [919] = {.lex_state = 52, .external_lex_state = 2},
  [920] = {.lex_state = 52, .external_lex_state = 2},
  [921] = {.lex_state = 52, .external_lex_state = 2},
  [922] = {.lex_state = 52, .external_lex_state = 2},
  [923] = {.lex_state = 52, .external_lex_state = 2},
  [924] = {.lex_state = 52, .external_lex_state = 2},
  [925] = {.lex_state = 52, .external_lex_state = 2},
  [926] = {.lex_state = 52, .external_lex_state = 2},
  [927] = {.lex_state = 52, .external_lex_state = 2},
  [928] = {.lex_state = 52, .external_lex_state = 2},
  [929] = {.lex_state = 52, .external_lex_state = 2},
  [930] = {.lex_state = 52, .external_lex_state = 2},
  [931] = {.lex_state = 52, .external_lex_state = 2},
  [932] = {.lex_state = 52, .external_lex_state = 2},
  [933] = {.lex_state = 52, .external_lex_state = 2},
  [934] = {.lex_state = 52, .external_lex_state = 2},
  [935] = {.lex_state = 52, .external_lex_state = 2},
  [936] = {.lex_state = 52, .external_lex_state = 2},
  [937] = {.lex_state = 52, .external_lex_state = 2},
  [938] = {.lex_state = 52, .external_lex_state = 2},
  [939] = {.lex_state = 52, .external_lex_state = 2},
  [940] = {.lex_state = 52, .external_lex_state = 2},
  [941] = {.lex_state = 52, .external_lex_state = 2},
  [942] = {.lex_state = 52, .external_lex_state = 2},
  [943] = {.lex_state = 52, .external_lex_state = 2},
  [944] = {.lex_state = 52, .external_lex_state = 2},
  [945] = {.lex_state = 52, .external_lex_state = 2},
  [946] = {.lex_state = 52, .external_lex_state = 2},
  [947] = {.lex_state = 52, .external_lex_state = 2},
  [948] = {.lex_state = 52, .external_lex_state = 2},
  [949] = {.lex_state = 52, .external_lex_state = 2},
  [950] = {.lex_state = 52, .external_lex_state = 2},
  [951] = {.lex_state = 52, .external_lex_state = 2},
  [952] = {.lex_state = 52, .external_lex_state = 2},
  [953] = {.lex_state = 52, .external_lex_state = 2},
  [954] = {.lex_state = 52, .external_lex_state = 2},
  [955] = {.lex_state = 52, .external_lex_state = 2},
  [956] = {.lex_state = 52, .external_lex_state = 2},
  [957] = {.lex_state = 52, .external_lex_state = 2},
  [958] = {.lex_state = 52, .external_lex_state = 2},
  [959] = {.lex_state = 52, .external_lex_state = 2},
  [960] = {.lex_state = 52, .external_lex_state = 2},
  [961] = {.lex_state = 52, .external_lex_state = 2},
  [962] = {.lex_state = 52, .external_lex_state = 2},
  [963] = {.lex_state = 52, .external_lex_state = 2},
  [964] = {.lex_state = 52, .external_lex_state = 2},
  [965] = {.lex_state = 52, .external_lex_state = 2},
  [966] = {.lex_state = 52, .external_lex_state = 2},
  [967] = {.lex_state = 52, .external_lex_state = 2},
  [968] = {.lex_state = 52, .external_lex_state = 2},
  [969] = {.lex_state = 52, .external_lex_state = 2},
  [970] = {.lex_state = 52, .external_lex_state = 2},
  [971] = {.lex_state = 52, .external_lex_state = 2},
  [972] = {.lex_state = 52, .external_lex_state = 2},
  [973] = {.lex_state = 52, .external_lex_state = 2},
  [974] = {.lex_state = 52, .external_lex_state = 2},
  [975] = {.lex_state = 13, .external_lex_state = 9},
  [976] = {.lex_state = 13, .external_lex_state = 4},
  [977] = {.lex_state = 13, .external_lex_state = 4},
  [978] = {.lex_state = 13, .external_lex_state = 4},
  [979] = {.lex_state = 13, .external_lex_state = 9},
  [980] = {.lex_state = 13, .external_lex_state = 9},
  [981] = {.lex_state = 13, .external_lex_state = 6},
  [982] = {.lex_state = 13, .external_lex_state = 9},
  [983] = {.lex_state = 13, .external_lex_state = 9},
  [984] = {.lex_state = 13, .external_lex_state = 6},
  [985] = {.lex_state = 13, .external_lex_state = 9},
  [986] = {.lex_state = 13, .external_lex_state = 9},
  [987] = {.lex_state = 13, .external_lex_state = 6},
  [988] = {.lex_state = 13, .external_lex_state = 12},
  [989] = {.lex_state = 13, .external_lex_state = 6},
  [990] = {.lex_state = 13, .external_lex_state = 9},
  [991] = {.lex_state = 13, .external_lex_state = 9},
  [992] = {.lex_state = 13, .external_lex_state = 9},
  [993] = {.lex_state = 13, .external_lex_state = 9},
  [994] = {.lex_state = 13, .external_lex_state = 9},
  [995] = {.lex_state = 13, .external_lex_state = 9},
  [996] = {.lex_state = 13, .external_lex_state = 12},
  [997] = {.lex_state = 13, .external_lex_state = 6},
  [998] = {.lex_state = 13, .external_lex_state = 6},
  [999] = {.lex_state = 13, .external_lex_state = 12},
  [1000] = {.lex_state = 13, .external_lex_state = 12},
  [1001] = {.lex_state = 13, .external_lex_state = 12},
  [1002] = {.lex_state = 13, .external_lex_state = 12},
  [1003] = {.lex_state = 13, .external_lex_state = 12},
  [1004] = {.lex_state = 13, .external_lex_state = 8},
  [1005] = {.lex_state = 13, .external_lex_state = 13},
  [1006] = {.lex_state = 14, .external_lex_state = 9},
  [1007] = {.lex_state = 13, .external_lex_state = 8},
  [1008] = {.lex_state = 13, .external_lex_state = 12},
  [1009] = {.lex_state = 13, .external_lex_state = 12},
  [1010] = {.lex_state = 13, .external_lex_state = 12},
  [1011] = {.lex_state = 13, .external_lex_state = 12},
  [1012] = {.lex_state = 13, .external_lex_state = 7},
  [1013] = {.lex_state = 13, .external_lex_state = 12},
  [1014] = {.lex_state = 14, .external_lex_state = 9},
  [1015] = {.lex_state = 13, .external_lex_state = 12},
  [1016] = {.lex_state = 13, .external_lex_state = 9},
  [1017] = {.lex_state = 13, .external_lex_state = 12},
  [1018] = {.lex_state = 13, .external_lex_state = 12},
  [1019] = {.lex_state = 13, .external_lex_state = 12},
  [1020] = {.lex_state = 13, .external_lex_state = 12},
  [1021] = {.lex_state = 13, .external_lex_state = 12},
  [1022] = {.lex_state = 13, .external_lex_state = 14},
  [1023] = {.lex_state = 13, .external_lex_state = 12},
  [1024] = {.lex_state = 13, .external_lex_state = 7},
  [1025] = {.lex_state = 13, .external_lex_state = 12},
  [1026] = {.lex_state = 13, .external_lex_state = 7},
  [1027] = {.lex_state = 13, .external_lex_state = 12},
  [1028] = {.lex_state = 13, .external_lex_state = 7},
  [1029] = {.lex_state = 13, .external_lex_state = 12},
  [1030] = {.lex_state = 13, .external_lex_state = 7},
  [1031] = {.lex_state = 13, .external_lex_state = 4},
  [1032] = {.lex_state = 13, .external_lex_state = 12},
  [1033] = {.lex_state = 13, .external_lex_state = 12},
  [1034] = {.lex_state = 13, .external_lex_state = 8},
  [1035] = {.lex_state = 14, .external_lex_state = 9},
  [1036] = {.lex_state = 13, .external_lex_state = 12},
  [1037] = {.lex_state = 13, .external_lex_state = 2},
  [1038] = {.lex_state = 13, .external_lex_state = 14},
  [1039] = {.lex_state = 13, .external_lex_state = 12},
  [1040] = {.lex_state = 13, .external_lex_state = 15},
  [1041] = {.lex_state = 13, .external_lex_state = 2},
  [1042] = {.lex_state = 13, .external_lex_state = 12},
  [1043] = {.lex_state = 13, .external_lex_state = 12},
  [1044] = {.lex_state = 13, .external_lex_state = 12},
  [1045] = {.lex_state = 13, .external_lex_state = 2},
  [1046] = {.lex_state = 13, .external_lex_state = 7},
  [1047] = {.lex_state = 13, .external_lex_state = 4},
  [1048] = {.lex_state = 13, .external_lex_state = 12},
  [1049] = {.lex_state = 13, .external_lex_state = 12},
  [1050] = {.lex_state = 13, .external_lex_state = 12},
  [1051] = {.lex_state = 13, .external_lex_state = 12},
  [1052] = {.lex_state = 14, .external_lex_state = 14},
  [1053] = {.lex_state = 13, .external_lex_state = 8},
  [1054] = {.lex_state = 14, .external_lex_state = 12},
  [1055] = {.lex_state = 13, .external_lex_state = 9},
  [1056] = {.lex_state = 13, .external_lex_state = 9},
  [1057] = {.lex_state = 13, .external_lex_state = 9},
  [1058] = {.lex_state = 13, .external_lex_state = 9},
  [1059] = {.lex_state = 13, .external_lex_state = 9},
  [1060] = {.lex_state = 13, .external_lex_state = 9},
  [1061] = {.lex_state = 13, .external_lex_state = 15},
  [1062] = {.lex_state = 13, .external_lex_state = 9},
  [1063] = {.lex_state = 14, .external_lex_state = 9},
  [1064] = {.lex_state = 13, .external_lex_state = 14},
  [1065] = {.lex_state = 13, .external_lex_state = 15},
  [1066] = {.lex_state = 13, .external_lex_state = 14},
  [1067] = {.lex_state = 14, .external_lex_state = 14},
  [1068] = {.lex_state = 13, .external_lex_state = 13},
  [1069] = {.lex_state = 13, .external_lex_state = 13},
  [1070] = {.lex_state = 13, .external_lex_state = 6},
  [1071] = {.lex_state = 13, .external_lex_state = 14},
  [1072] = {.lex_state = 13, .external_lex_state = 14},
  [1073] = {.lex_state = 13, .external_lex_state = 6},
  [1074] = {.lex_state = 13, .external_lex_state = 6},
  [1075] = {.lex_state = 14, .external_lex_state = 12},
  [1076] = {.lex_state = 13, .external_lex_state = 9},
  [1077] = {.lex_state = 13, .external_lex_state = 9},
  [1078] = {.lex_state = 14, .external_lex_state = 12},
  [1079] = {.lex_state = 13, .external_lex_state = 6},
  [1080] = {.lex_state = 14, .external_lex_state = 12},
  [1081] = {.lex_state = 13, .external_lex_state = 9},
  [1082] = {.lex_state = 13, .external_lex_state = 9},
  [1083] = {.lex_state = 13, .external_lex_state = 15},
  [1084] = {.lex_state = 13, .external_lex_state = 14},
  [1085] = {.lex_state = 13, .external_lex_state = 14},
  [1086] = {.lex_state = 13, .external_lex_state = 14},
  [1087] = {.lex_state = 13, .external_lex_state = 14},
  [1088] = {.lex_state = 13, .external_lex_state = 14},
  [1089] = {.lex_state = 13, .external_lex_state = 14},
  [1090] = {.lex_state = 13, .external_lex_state = 14},
  [1091] = {.lex_state = 13, .external_lex_state = 14},
  [1092] = {.lex_state = 13, .external_lex_state = 14},
  [1093] = {.lex_state = 13, .external_lex_state = 14},
  [1094] = {.lex_state = 13, .external_lex_state = 14},
  [1095] = {.lex_state = 13, .external_lex_state = 14},
  [1096] = {.lex_state = 13, .external_lex_state = 14},
  [1097] = {.lex_state = 13, .external_lex_state = 14},
  [1098] = {.lex_state = 13, .external_lex_state = 9},
  [1099] = {.lex_state = 13, .external_lex_state = 14},
  [1100] = {.lex_state = 13, .external_lex_state = 14},
  [1101] = {.lex_state = 13, .external_lex_state = 15},
  [1102] = {.lex_state = 13, .external_lex_state = 9},
  [1103] = {.lex_state = 13, .external_lex_state = 9},
  [1104] = {.lex_state = 13, .external_lex_state = 9},
  [1105] = {.lex_state = 13, .external_lex_state = 9},
  [1106] = {.lex_state = 13, .external_lex_state = 9},
  [1107] = {.lex_state = 13, .external_lex_state = 9},
  [1108] = {.lex_state = 13, .external_lex_state = 9},
  [1109] = {.lex_state = 13, .external_lex_state = 14},
  [1110] = {.lex_state = 13, .external_lex_state = 14},
  [1111] = {.lex_state = 13, .external_lex_state = 14},
  [1112] = {.lex_state = 13, .external_lex_state = 9},
  [1113] = {.lex_state = 13, .external_lex_state = 13},
  [1114] = {.lex_state = 13, .external_lex_state = 13},
  [1115] = {.lex_state = 13, .external_lex_state = 13},
  [1116] = {.lex_state = 13, .external_lex_state = 13},
  [1117] = {.lex_state = 13, .external_lex_state = 13},
  [1118] = {.lex_state = 13, .external_lex_state = 13},
  [1119] = {.lex_state = 13, .external_lex_state = 13},
  [1120] = {.lex_state = 13, .external_lex_state = 13},
  [1121] = {.lex_state = 13, .external_lex_state = 9},
  [1122] = {.lex_state = 13, .external_lex_state = 8},
  [1123] = {.lex_state = 13, .external_lex_state = 13},
  [1124] = {.lex_state = 13, .external_lex_state = 13},
  [1125] = {.lex_state = 13, .external_lex_state = 9},
  [1126] = {.lex_state = 14, .external_lex_state = 14},
  [1127] = {.lex_state = 13, .external_lex_state = 9},
  [1128] = {.lex_state = 14, .external_lex_state = 14},
  [1129] = {.lex_state = 14, .external_lex_state = 12},
  [1130] = {.lex_state = 14, .external_lex_state = 12},
  [1131] = {.lex_state = 14, .external_lex_state = 12},
  [1132] = {.lex_state = 13, .external_lex_state = 9},
  [1133] = {.lex_state = 13, .external_lex_state = 9},
  [1134] = {.lex_state = 13, .external_lex_state = 9},
  [1135] = {.lex_state = 13, .external_lex_state = 9},
  [1136] = {.lex_state = 13, .external_lex_state = 9},
  [1137] = {.lex_state = 13, .external_lex_state = 9},
  [1138] = {.lex_state = 13, .external_lex_state = 9},
  [1139] = {.lex_state = 13, .external_lex_state = 15},
  [1140] = {.lex_state = 13, .external_lex_state = 15},
  [1141] = {.lex_state = 13, .external_lex_state = 15},
  [1142] = {.lex_state = 13, .external_lex_state = 15},
  [1143] = {.lex_state = 13, .external_lex_state = 8},
  [1144] = {.lex_state = 13, .external_lex_state = 15},
  [1145] = {.lex_state = 13, .external_lex_state = 9},
  [1146] = {.lex_state = 13, .external_lex_state = 15},
  [1147] = {.lex_state = 13, .external_lex_state = 9},
  [1148] = {.lex_state = 13, .external_lex_state = 15},
  [1149] = {.lex_state = 13, .external_lex_state = 9},
  [1150] = {.lex_state = 13, .external_lex_state = 13},
  [1151] = {.lex_state = 13, .external_lex_state = 9},
  [1152] = {.lex_state = 14, .external_lex_state = 12},
  [1153] = {.lex_state = 14, .external_lex_state = 12},
  [1154] = {.lex_state = 13, .external_lex_state = 9},
  [1155] = {.lex_state = 13, .external_lex_state = 9},
  [1156] = {.lex_state = 14, .external_lex_state = 12},
  [1157] = {.lex_state = 14, .external_lex_state = 12},
  [1158] = {.lex_state = 14, .external_lex_state = 12},
  [1159] = {.lex_state = 13, .external_lex_state = 15},
  [1160] = {.lex_state = 13, .external_lex_state = 14},
  [1161] = {.lex_state = 13, .external_lex_state = 12},
  [1162] = {.lex_state = 13, .external_lex_state = 12},
  [1163] = {.lex_state = 13, .external_lex_state = 12},
  [1164] = {.lex_state = 14, .external_lex_state = 14},
  [1165] = {.lex_state = 13, .external_lex_state = 12},
  [1166] = {.lex_state = 13, .external_lex_state = 14},
  [1167] = {.lex_state = 13, .external_lex_state = 12},
  [1168] = {.lex_state = 13, .external_lex_state = 12},
  [1169] = {.lex_state = 13, .external_lex_state = 12},
  [1170] = {.lex_state = 13, .external_lex_state = 12},
  [1171] = {.lex_state = 13, .external_lex_state = 12},
  [1172] = {.lex_state = 13, .external_lex_state = 12},
  [1173] = {.lex_state = 13, .external_lex_state = 12},
  [1174] = {.lex_state = 13, .external_lex_state = 12},
  [1175] = {.lex_state = 13, .external_lex_state = 12},
  [1176] = {.lex_state = 13, .external_lex_state = 12},
  [1177] = {.lex_state = 13, .external_lex_state = 7},
  [1178] = {.lex_state = 14, .external_lex_state = 13},
  [1179] = {.lex_state = 13, .external_lex_state = 12},
  [1180] = {.lex_state = 14, .external_lex_state = 13},
  [1181] = {.lex_state = 14, .external_lex_state = 13},
  [1182] = {.lex_state = 13, .external_lex_state = 12},
  [1183] = {.lex_state = 13, .external_lex_state = 12},
  [1184] = {.lex_state = 13, .external_lex_state = 12},
  [1185] = {.lex_state = 13, .external_lex_state = 2},
  [1186] = {.lex_state = 13, .external_lex_state = 12},
  [1187] = {.lex_state = 13, .external_lex_state = 13},
  [1188] = {.lex_state = 13, .external_lex_state = 12},
  [1189] = {.lex_state = 13, .external_lex_state = 7},
  [1190] = {.lex_state = 13, .external_lex_state = 12},
  [1191] = {.lex_state = 13, .external_lex_state = 12},
  [1192] = {.lex_state = 13, .external_lex_state = 12},
  [1193] = {.lex_state = 13, .external_lex_state = 12},
  [1194] = {.lex_state = 13, .external_lex_state = 14},
  [1195] = {.lex_state = 13, .external_lex_state = 14},
  [1196] = {.lex_state = 13, .external_lex_state = 14},
  [1197] = {.lex_state = 13, .external_lex_state = 12},
  [1198] = {.lex_state = 13, .external_lex_state = 12},
  [1199] = {.lex_state = 13, .external_lex_state = 12},
  [1200] = {.lex_state = 13, .external_lex_state = 12},
  [1201] = {.lex_state = 13, .external_lex_state = 12},
  [1202] = {.lex_state = 13, .external_lex_state = 12},
  [1203] = {.lex_state = 13, .external_lex_state = 8},
  [1204] = {.lex_state = 13, .external_lex_state = 12},
  [1205] = {.lex_state = 13, .external_lex_state = 12},
  [1206] = {.lex_state = 13, .external_lex_state = 12},
  [1207] = {.lex_state = 13, .external_lex_state = 12},
  [1208] = {.lex_state = 13, .external_lex_state = 12},
  [1209] = {.lex_state = 13, .external_lex_state = 12},
  [1210] = {.lex_state = 13, .external_lex_state = 12},
  [1211] = {.lex_state = 14, .external_lex_state = 14},
  [1212] = {.lex_state = 14, .external_lex_state = 14},
  [1213] = {.lex_state = 14, .external_lex_state = 14},
  [1214] = {.lex_state = 13, .external_lex_state = 12},
  [1215] = {.lex_state = 13, .external_lex_state = 12},
  [1216] = {.lex_state = 13, .external_lex_state = 12},
  [1217] = {.lex_state = 14, .external_lex_state = 15},
  [1218] = {.lex_state = 13, .external_lex_state = 13},
  [1219] = {.lex_state = 13, .external_lex_state = 14},
  [1220] = {.lex_state = 13, .external_lex_state = 14},
  [1221] = {.lex_state = 13, .external_lex_state = 12},
  [1222] = {.lex_state = 14, .external_lex_state = 14},
  [1223] = {.lex_state = 13, .external_lex_state = 13},
  [1224] = {.lex_state = 13, .external_lex_state = 12},
  [1225] = {.lex_state = 13, .external_lex_state = 12},
  [1226] = {.lex_state = 13, .external_lex_state = 12},
  [1227] = {.lex_state = 13, .external_lex_state = 12},
  [1228] = {.lex_state = 14, .external_lex_state = 13},
  [1229] = {.lex_state = 13, .external_lex_state = 14},
  [1230] = {.lex_state = 14, .external_lex_state = 13},
  [1231] = {.lex_state = 13, .external_lex_state = 12},
  [1232] = {.lex_state = 14, .external_lex_state = 13},
  [1233] = {.lex_state = 14, .external_lex_state = 14},
  [1234] = {.lex_state = 13, .external_lex_state = 7},
  [1235] = {.lex_state = 13, .external_lex_state = 12},
  [1236] = {.lex_state = 13, .external_lex_state = 12},
  [1237] = {.lex_state = 14, .external_lex_state = 13},
  [1238] = {.lex_state = 13, .external_lex_state = 12},
  [1239] = {.lex_state = 13, .external_lex_state = 12},
  [1240] = {.lex_state = 14, .external_lex_state = 13},
  [1241] = {.lex_state = 13, .external_lex_state = 12},
  [1242] = {.lex_state = 13, .external_lex_state = 13},
  [1243] = {.lex_state = 13, .external_lex_state = 7},
  [1244] = {.lex_state = 13, .external_lex_state = 8},
  [1245] = {.lex_state = 13, .external_lex_state = 12},
  [1246] = {.lex_state = 13, .external_lex_state = 12},
  [1247] = {.lex_state = 13, .external_lex_state = 12},
  [1248] = {.lex_state = 14, .external_lex_state = 15},
  [1249] = {.lex_state = 14, .external_lex_state = 15},
  [1250] = {.lex_state = 14, .external_lex_state = 15},
  [1251] = {.lex_state = 13, .external_lex_state = 12},
  [1252] = {.lex_state = 13, .external_lex_state = 12},
  [1253] = {.lex_state = 13, .external_lex_state = 12},
  [1254] = {.lex_state = 13, .external_lex_state = 12},
  [1255] = {.lex_state = 14, .external_lex_state = 14},
  [1256] = {.lex_state = 14, .external_lex_state = 14},
  [1257] = {.lex_state = 13, .external_lex_state = 12},
  [1258] = {.lex_state = 13, .external_lex_state = 12},
  [1259] = {.lex_state = 14, .external_lex_state = 14},
  [1260] = {.lex_state = 14, .external_lex_state = 14},
  [1261] = {.lex_state = 13, .external_lex_state = 12},
  [1262] = {.lex_state = 14, .external_lex_state = 13},
  [1263] = {.lex_state = 13, .external_lex_state = 13},
  [1264] = {.lex_state = 13, .external_lex_state = 13},
  [1265] = {.lex_state = 13, .external_lex_state = 2},
  [1266] = {.lex_state = 14, .external_lex_state = 14},
  [1267] = {.lex_state = 13, .external_lex_state = 12},
  [1268] = {.lex_state = 13, .external_lex_state = 12},
  [1269] = {.lex_state = 13, .external_lex_state = 12},
  [1270] = {.lex_state = 13, .external_lex_state = 12},
  [1271] = {.lex_state = 14, .external_lex_state = 14},
  [1272] = {.lex_state = 13, .external_lex_state = 12},
  [1273] = {.lex_state = 13, .external_lex_state = 12},
  [1274] = {.lex_state = 13, .external_lex_state = 12},
  [1275] = {.lex_state = 13, .external_lex_state = 13},
  [1276] = {.lex_state = 13, .external_lex_state = 13},
  [1277] = {.lex_state = 14, .external_lex_state = 13},
  [1278] = {.lex_state = 13, .external_lex_state = 13},
  [1279] = {.lex_state = 13, .external_lex_state = 13},
  [1280] = {.lex_state = 13, .external_lex_state = 12},
  [1281] = {.lex_state = 13, .external_lex_state = 13},
  [1282] = {.lex_state = 13, .external_lex_state = 13},
  [1283] = {.lex_state = 13, .external_lex_state = 12},
  [1284] = {.lex_state = 13, .external_lex_state = 13},
  [1285] = {.lex_state = 13, .external_lex_state = 14},
  [1286] = {.lex_state = 13, .external_lex_state = 12},
  [1287] = {.lex_state = 13, .external_lex_state = 14},
  [1288] = {.lex_state = 8, .external_lex_state = 9},
  [1289] = {.lex_state = 13, .external_lex_state = 14},
  [1290] = {.lex_state = 8, .external_lex_state = 9},
  [1291] = {.lex_state = 13, .external_lex_state = 13},
  [1292] = {.lex_state = 13, .external_lex_state = 13},
  [1293] = {.lex_state = 13, .external_lex_state = 15},
  [1294] = {.lex_state = 13, .external_lex_state = 13},
  [1295] = {.lex_state = 13, .external_lex_state = 15},
  [1296] = {.lex_state = 13, .external_lex_state = 14},
  [1297] = {.lex_state = 13, .external_lex_state = 14},
  [1298] = {.lex_state = 13, .external_lex_state = 15},
  [1299] = {.lex_state = 13, .external_lex_state = 14},
  [1300] = {.lex_state = 13, .external_lex_state = 13},
  [1301] = {.lex_state = 13, .external_lex_state = 15},
  [1302] = {.lex_state = 13, .external_lex_state = 13},
  [1303] = {.lex_state = 13, .external_lex_state = 13},
  [1304] = {.lex_state = 13, .external_lex_state = 13},
  [1305] = {.lex_state = 13, .external_lex_state = 13},
  [1306] = {.lex_state = 13, .external_lex_state = 15},
  [1307] = {.lex_state = 13, .external_lex_state = 14},
  [1308] = {.lex_state = 13, .external_lex_state = 14},
  [1309] = {.lex_state = 13, .external_lex_state = 13},
  [1310] = {.lex_state = 13, .external_lex_state = 15},
  [1311] = {.lex_state = 13, .external_lex_state = 14},
  [1312] = {.lex_state = 13, .external_lex_state = 13},
  [1313] = {.lex_state = 13, .external_lex_state = 14},
  [1314] = {.lex_state = 13, .external_lex_state = 15},
  [1315] = {.lex_state = 13, .external_lex_state = 14},
  [1316] = {.lex_state = 13, .external_lex_state = 15},
  [1317] = {.lex_state = 13, .external_lex_state = 14},
  [1318] = {.lex_state = 13, .external_lex_state = 15},
  [1319] = {.lex_state = 13, .external_lex_state = 15},
  [1320] = {.lex_state = 13, .external_lex_state = 14},
  [1321] = {.lex_state = 13, .external_lex_state = 13},
  [1322] = {.lex_state = 13, .external_lex_state = 14},
  [1323] = {.lex_state = 13, .external_lex_state = 15},
  [1324] = {.lex_state = 13, .external_lex_state = 15},
  [1325] = {.lex_state = 13, .external_lex_state = 15},
  [1326] = {.lex_state = 13, .external_lex_state = 14},
  [1327] = {.lex_state = 13, .external_lex_state = 14},
  [1328] = {.lex_state = 13, .external_lex_state = 14},
  [1329] = {.lex_state = 13, .external_lex_state = 14},
  [1330] = {.lex_state = 13, .external_lex_state = 14},
  [1331] = {.lex_state = 13, .external_lex_state = 14},
  [1332] = {.lex_state = 14, .external_lex_state = 13},
  [1333] = {.lex_state = 14, .external_lex_state = 13},
  [1334] = {.lex_state = 14, .external_lex_state = 13},
  [1335] = {.lex_state = 13, .external_lex_state = 14},
  [1336] = {.lex_state = 13, .external_lex_state = 14},
  [1337] = {.lex_state = 13, .external_lex_state = 14},
  [1338] = {.lex_state = 13, .external_lex_state = 14},
  [1339] = {.lex_state = 13, .external_lex_state = 13},
  [1340] = {.lex_state = 13, .external_lex_state = 13},
  [1341] = {.lex_state = 13, .external_lex_state = 14},
  [1342] = {.lex_state = 13, .external_lex_state = 14},
  [1343] = {.lex_state = 13, .external_lex_state = 13},
  [1344] = {.lex_state = 13, .external_lex_state = 13},
  [1345] = {.lex_state = 13, .external_lex_state = 13},
  [1346] = {.lex_state = 13, .external_lex_state = 9},
  [1347] = {.lex_state = 13, .external_lex_state = 14},
  [1348] = {.lex_state = 13, .external_lex_state = 15},
  [1349] = {.lex_state = 13, .external_lex_state = 14},
  [1350] = {.lex_state = 13, .external_lex_state = 14},
  [1351] = {.lex_state = 13, .external_lex_state = 14},
  [1352] = {.lex_state = 13, .external_lex_state = 13},
  [1353] = {.lex_state = 13, .external_lex_state = 14},
  [1354] = {.lex_state = 13, .external_lex_state = 14},
  [1355] = {.lex_state = 13, .external_lex_state = 14},
  [1356] = {.lex_state = 13, .external_lex_state = 14},
  [1357] = {.lex_state = 14, .external_lex_state = 14},
  [1358] = {.lex_state = 14, .external_lex_state = 14},
  [1359] = {.lex_state = 14, .external_lex_state = 14},
  [1360] = {.lex_state = 13, .external_lex_state = 14},
  [1361] = {.lex_state = 13, .external_lex_state = 14},
  [1362] = {.lex_state = 13, .external_lex_state = 13},
  [1363] = {.lex_state = 13, .external_lex_state = 15},
  [1364] = {.lex_state = 13, .external_lex_state = 14},
  [1365] = {.lex_state = 13, .external_lex_state = 13},
  [1366] = {.lex_state = 13, .external_lex_state = 13},
  [1367] = {.lex_state = 13, .external_lex_state = 13},
  [1368] = {.lex_state = 13, .external_lex_state = 13},
  [1369] = {.lex_state = 13, .external_lex_state = 13},
  [1370] = {.lex_state = 13, .external_lex_state = 13},
  [1371] = {.lex_state = 13, .external_lex_state = 15},
  [1372] = {.lex_state = 13, .external_lex_state = 13},
  [1373] = {.lex_state = 13, .external_lex_state = 14},
  [1374] = {.lex_state = 13, .external_lex_state = 13},
  [1375] = {.lex_state = 13, .external_lex_state = 13},
  [1376] = {.lex_state = 13, .external_lex_state = 14},
  [1377] = {.lex_state = 13, .external_lex_state = 14},
  [1378] = {.lex_state = 13, .external_lex_state = 14},
  [1379] = {.lex_state = 13, .external_lex_state = 14},
  [1380] = {.lex_state = 13, .external_lex_state = 14},
  [1381] = {.lex_state = 13, .external_lex_state = 15},
  [1382] = {.lex_state = 13, .external_lex_state = 15},
  [1383] = {.lex_state = 13, .external_lex_state = 14},
  [1384] = {.lex_state = 13, .external_lex_state = 14},
  [1385] = {.lex_state = 13, .external_lex_state = 14},
  [1386] = {.lex_state = 13, .external_lex_state = 14},
  [1387] = {.lex_state = 13, .external_lex_state = 14},
  [1388] = {.lex_state = 13, .external_lex_state = 14},
  [1389] = {.lex_state = 13, .external_lex_state = 14},
  [1390] = {.lex_state = 13, .external_lex_state = 14},
  [1391] = {.lex_state = 13, .external_lex_state = 13},
  [1392] = {.lex_state = 13, .external_lex_state = 13},
  [1393] = {.lex_state = 13, .external_lex_state = 13},
  [1394] = {.lex_state = 13, .external_lex_state = 14},
  [1395] = {.lex_state = 13, .external_lex_state = 14},
  [1396] = {.lex_state = 13, .external_lex_state = 14},
  [1397] = {.lex_state = 13, .external_lex_state = 13},
  [1398] = {.lex_state = 13, .external_lex_state = 15},
  [1399] = {.lex_state = 13, .external_lex_state = 14},
  [1400] = {.lex_state = 13, .external_lex_state = 14},
  [1401] = {.lex_state = 13, .external_lex_state = 15},
  [1402] = {.lex_state = 13, .external_lex_state = 14},
  [1403] = {.lex_state = 13, .external_lex_state = 14},
  [1404] = {.lex_state = 13, .external_lex_state = 13},
  [1405] = {.lex_state = 13, .external_lex_state = 13},
  [1406] = {.lex_state = 13, .external_lex_state = 15},
  [1407] = {.lex_state = 13, .external_lex_state = 14},
  [1408] = {.lex_state = 13, .external_lex_state = 14},
  [1409] = {.lex_state = 13, .external_lex_state = 14},
  [1410] = {.lex_state = 13, .external_lex_state = 15},
  [1411] = {.lex_state = 8, .external_lex_state = 9},
  [1412] = {.lex_state = 8, .external_lex_state = 9},
  [1413] = {.lex_state = 13, .external_lex_state = 13},
  [1414] = {.lex_state = 13, .external_lex_state = 15},
  [1415] = {.lex_state = 13, .external_lex_state = 15},
  [1416] = {.lex_state = 13, .external_lex_state = 15},
  [1417] = {.lex_state = 13, .external_lex_state = 15},
  [1418] = {.lex_state = 13, .external_lex_state = 15},
  [1419] = {.lex_state = 13, .external_lex_state = 15},
  [1420] = {.lex_state = 13, .external_lex_state = 13},
  [1421] = {.lex_state = 13, .external_lex_state = 14},
  [1422] = {.lex_state = 13, .external_lex_state = 15},
  [1423] = {.lex_state = 13, .external_lex_state = 14},
  [1424] = {.lex_state = 13, .external_lex_state = 14},
  [1425] = {.lex_state = 13, .external_lex_state = 15},
  [1426] = {.lex_state = 13, .external_lex_state = 14},
  [1427] = {.lex_state = 13, .external_lex_state = 15},
  [1428] = {.lex_state = 13, .external_lex_state = 13},
  [1429] = {.lex_state = 13, .external_lex_state = 13},
  [1430] = {.lex_state = 13, .external_lex_state = 13},
  [1431] = {.lex_state = 13, .external_lex_state = 13},
  [1432] = {.lex_state = 13, .external_lex_state = 14},
  [1433] = {.lex_state = 13, .external_lex_state = 15},
  [1434] = {.lex_state = 13, .external_lex_state = 14},
  [1435] = {.lex_state = 13, .external_lex_state = 15},
  [1436] = {.lex_state = 13, .external_lex_state = 14},
  [1437] = {.lex_state = 13, .external_lex_state = 14},
  [1438] = {.lex_state = 13, .external_lex_state = 14},
  [1439] = {.lex_state = 13, .external_lex_state = 14},
  [1440] = {.lex_state = 13, .external_lex_state = 15},
  [1441] = {.lex_state = 13, .external_lex_state = 8},
  [1442] = {.lex_state = 13, .external_lex_state = 13},
  [1443] = {.lex_state = 13, .external_lex_state = 13},
  [1444] = {.lex_state = 13, .external_lex_state = 14},
  [1445] = {.lex_state = 13, .external_lex_state = 8},
  [1446] = {.lex_state = 13, .external_lex_state = 15},
  [1447] = {.lex_state = 13, .external_lex_state = 15},
  [1448] = {.lex_state = 8, .external_lex_state = 9},
  [1449] = {.lex_state = 8, .external_lex_state = 9},
  [1450] = {.lex_state = 13, .external_lex_state = 13},
  [1451] = {.lex_state = 13, .external_lex_state = 13},
  [1452] = {.lex_state = 13, .external_lex_state = 13},
  [1453] = {.lex_state = 13, .external_lex_state = 13},
  [1454] = {.lex_state = 14, .external_lex_state = 13},
  [1455] = {.lex_state = 14, .external_lex_state = 13},
  [1456] = {.lex_state = 14, .external_lex_state = 13},
  [1457] = {.lex_state = 13, .external_lex_state = 13},
  [1458] = {.lex_state = 13, .external_lex_state = 13},
  [1459] = {.lex_state = 13, .external_lex_state = 13},
  [1460] = {.lex_state = 13, .external_lex_state = 13},
  [1461] = {.lex_state = 13, .external_lex_state = 13},
  [1462] = {.lex_state = 14, .external_lex_state = 14},
  [1463] = {.lex_state = 13, .external_lex_state = 15},
  [1464] = {.lex_state = 13, .external_lex_state = 13},
  [1465] = {.lex_state = 13, .external_lex_state = 13},
  [1466] = {.lex_state = 13, .external_lex_state = 13},
  [1467] = {.lex_state = 13, .external_lex_state = 13},
  [1468] = {.lex_state = 13, .external_lex_state = 13},
  [1469] = {.lex_state = 13, .external_lex_state = 13},
  [1470] = {.lex_state = 13, .external_lex_state = 13},
  [1471] = {.lex_state = 13, .external_lex_state = 13},
  [1472] = {.lex_state = 14, .external_lex_state = 12},
  [1473] = {.lex_state = 14, .external_lex_state = 12},
  [1474] = {.lex_state = 14, .external_lex_state = 12},
  [1475] = {.lex_state = 13, .external_lex_state = 13},
  [1476] = {.lex_state = 13, .external_lex_state = 13},
  [1477] = {.lex_state = 13, .external_lex_state = 13},
  [1478] = {.lex_state = 13, .external_lex_state = 13},
  [1479] = {.lex_state = 13, .external_lex_state = 13},
  [1480] = {.lex_state = 13, .external_lex_state = 13},
  [1481] = {.lex_state = 13, .external_lex_state = 13},
  [1482] = {.lex_state = 14, .external_lex_state = 14},
  [1483] = {.lex_state = 13, .external_lex_state = 13},
  [1484] = {.lex_state = 13, .external_lex_state = 13},
  [1485] = {.lex_state = 13, .external_lex_state = 13},
  [1486] = {.lex_state = 13, .external_lex_state = 13},
  [1487] = {.lex_state = 13, .external_lex_state = 13},
  [1488] = {.lex_state = 13, .external_lex_state = 13},
  [1489] = {.lex_state = 14, .external_lex_state = 14},
  [1490] = {.lex_state = 13, .external_lex_state = 13},
  [1491] = {.lex_state = 13, .external_lex_state = 13},
  [1492] = {.lex_state = 13, .external_lex_state = 13},
  [1493] = {.lex_state = 13, .external_lex_state = 13},
  [1494] = {.lex_state = 13, .external_lex_state = 13},
  [1495] = {.lex_state = 13, .external_lex_state = 13},
  [1496] = {.lex_state = 13, .external_lex_state = 13},
  [1497] = {.lex_state = 8, .external_lex_state = 15},
  [1498] = {.lex_state = 8, .external_lex_state = 15},
  [1499] = {.lex_state = 8, .external_lex_state = 15},
  [1500] = {.lex_state = 8, .external_lex_state = 15},
  [1501] = {.lex_state = 8, .external_lex_state = 15},
  [1502] = {.lex_state = 13, .external_lex_state = 14},
  [1503] = {.lex_state = 8, .external_lex_state = 15},
  [1504] = {.lex_state = 8, .external_lex_state = 15},
  [1505] = {.lex_state = 8, .external_lex_state = 15},
  [1506] = {.lex_state = 8, .external_lex_state = 15},
  [1507] = {.lex_state = 8, .external_lex_state = 15},
  [1508] = {.lex_state = 13, .external_lex_state = 13},
  [1509] = {.lex_state = 13, .external_lex_state = 12},
  [1510] = {.lex_state = 8, .external_lex_state = 15},
  [1511] = {.lex_state = 8, .external_lex_state = 15},
  [1512] = {.lex_state = 8, .external_lex_state = 15},
  [1513] = {.lex_state = 8, .external_lex_state = 15},
  [1514] = {.lex_state = 8, .external_lex_state = 15},
  [1515] = {.lex_state = 8, .external_lex_state = 15},
  [1516] = {.lex_state = 12, .external_lex_state = 2},
  [1517] = {.lex_state = 12, .external_lex_state = 2},
  [1518] = {.lex_state = 5, .external_lex_state = 7},
  [1519] = {.lex_state = 5, .external_lex_state = 8},
  [1520] = {.lex_state = 5, .external_lex_state = 7},
  [1521] = {.lex_state = 5, .external_lex_state = 7},
  [1522] = {.lex_state = 5, .external_lex_state = 8},
  [1523] = {.lex_state = 5, .external_lex_state = 7},
  [1524] = {.lex_state = 5, .external_lex_state = 7},
  [1525] = {.lex_state = 5, .external_lex_state = 8},
  [1526] = {.lex_state = 5, .external_lex_state = 8},
  [1527] = {.lex_state = 5, .external_lex_state = 7},
  [1528] = {.lex_state = 5, .external_lex_state = 7},
  [1529] = {.lex_state = 5, .external_lex_state = 8},
  [1530] = {.lex_state = 5, .external_lex_state = 7},
  [1531] = {.lex_state = 5, .external_lex_state = 7},
  [1532] = {.lex_state = 5, .external_lex_state = 7},
  [1533] = {.lex_state = 5, .external_lex_state = 8},
  [1534] = {.lex_state = 5, .external_lex_state = 7},
  [1535] = {.lex_state = 5, .external_lex_state = 7},
  [1536] = {.lex_state = 5, .external_lex_state = 7},
  [1537] = {.lex_state = 5, .external_lex_state = 8},
  [1538] = {.lex_state = 5, .external_lex_state = 7},
  [1539] = {.lex_state = 5, .external_lex_state = 7},
  [1540] = {.lex_state = 5, .external_lex_state = 8},
  [1541] = {.lex_state = 5, .external_lex_state = 7},
  [1542] = {.lex_state = 5, .external_lex_state = 7},
  [1543] = {.lex_state = 5, .external_lex_state = 7},
  [1544] = {.lex_state = 5, .external_lex_state = 8},
  [1545] = {.lex_state = 5, .external_lex_state = 7},
  [1546] = {.lex_state = 5, .external_lex_state = 8},
  [1547] = {.lex_state = 5, .external_lex_state = 8},
  [1548] = {.lex_state = 5, .external_lex_state = 7},
  [1549] = {.lex_state = 5, .external_lex_state = 7},
  [1550] = {.lex_state = 5, .external_lex_state = 7},
  [1551] = {.lex_state = 5, .external_lex_state = 8},
  [1552] = {.lex_state = 5, .external_lex_state = 7},
  [1553] = {.lex_state = 5, .external_lex_state = 7},
  [1554] = {.lex_state = 5, .external_lex_state = 2},
  [1555] = {.lex_state = 5, .external_lex_state = 2},
  [1556] = {.lex_state = 5, .external_lex_state = 2},
  [1557] = {.lex_state = 5, .external_lex_state = 2},
  [1558] = {.lex_state = 5, .external_lex_state = 2},
  [1559] = {.lex_state = 5, .external_lex_state = 6},
  [1560] = {.lex_state = 5, .external_lex_state = 6},
  [1561] = {.lex_state = 5, .external_lex_state = 6},
  [1562] = {.lex_state = 5, .external_lex_state = 6},
  [1563] = {.lex_state = 5, .external_lex_state = 6},
  [1564] = {.lex_state = 5, .external_lex_state = 6},
  [1565] = {.lex_state = 5, .external_lex_state = 6},
  [1566] = {.lex_state = 5, .external_lex_state = 6},
  [1567] = {.lex_state = 5, .external_lex_state = 6},
  [1568] = {.lex_state = 5, .external_lex_state = 6},
  [1569] = {.lex_state = 5, .external_lex_state = 6},
  [1570] = {.lex_state = 5, .external_lex_state = 6},
  [1571] = {.lex_state = 5, .external_lex_state = 6},
  [1572] = {.lex_state = 5, .external_lex_state = 6},
  [1573] = {.lex_state = 5, .external_lex_state = 6},
  [1574] = {.lex_state = 5, .external_lex_state = 6},
  [1575] = {.lex_state = 5, .external_lex_state = 6},
  [1576] = {.lex_state = 5, .external_lex_state = 6},
  [1577] = {.lex_state = 5, .external_lex_state = 6},
  [1578] = {.lex_state = 5, .external_lex_state = 6},
  [1579] = {.lex_state = 5, .external_lex_state = 2},
  [1580] = {.lex_state = 5, .external_lex_state = 2},
  [1581] = {.lex_state = 5, .external_lex_state = 2},
  [1582] = {.lex_state = 5, .external_lex_state = 2},
  [1583] = {.lex_state = 5, .external_lex_state = 2},
  [1584] = {.lex_state = 5, .external_lex_state = 2},
  [1585] = {.lex_state = 5, .external_lex_state = 2},
  [1586] = {.lex_state = 5, .external_lex_state = 2},
  [1587] = {.lex_state = 5, .external_lex_state = 2},
  [1588] = {.lex_state = 8, .external_lex_state = 9},
  [1589] = {.lex_state = 8, .external_lex_state = 9},
  [1590] = {.lex_state = 13, .external_lex_state = 12},
  [1591] = {.lex_state = 13, .external_lex_state = 12},
  [1592] = {.lex_state = 8, .external_lex_state = 14},
  [1593] = {.lex_state = 13, .external_lex_state = 12},
  [1594] = {.lex_state = 13, .external_lex_state = 12},
  [1595] = {.lex_state = 8, .external_lex_state = 15},
  [1596] = {.lex_state = 8, .external_lex_state = 15},
  [1597] = {.lex_state = 13, .external_lex_state = 12},
  [1598] = {.lex_state = 13, .external_lex_state = 12},
  [1599] = {.lex_state = 8, .external_lex_state = 14},
  [1600] = {.lex_state = 52, .external_lex_state = 12},
  [1601] = {.lex_state = 8, .external_lex_state = 13},
  [1602] = {.lex_state = 8, .external_lex_state = 13},
  [1603] = {.lex_state = 52, .external_lex_state = 12},
  [1604] = {.lex_state = 52, .external_lex_state = 12},
  [1605] = {.lex_state = 52, .external_lex_state = 12},
  [1606] = {.lex_state = 13, .external_lex_state = 14},
  [1607] = {.lex_state = 11, .external_lex_state = 9},
  [1608] = {.lex_state = 13, .external_lex_state = 14},
  [1609] = {.lex_state = 13, .external_lex_state = 14},
  [1610] = {.lex_state = 11, .external_lex_state = 9},
  [1611] = {.lex_state = 52, .external_lex_state = 14},
  [1612] = {.lex_state = 13, .external_lex_state = 14},
  [1613] = {.lex_state = 13, .external_lex_state = 14},
  [1614] = {.lex_state = 13, .external_lex_state = 14},
  [1615] = {.lex_state = 52, .external_lex_state = 13},
  [1616] = {.lex_state = 52, .external_lex_state = 13},
  [1617] = {.lex_state = 52, .external_lex_state = 14},
  [1618] = {.lex_state = 13, .external_lex_state = 14},
  [1619] = {.lex_state = 13, .external_lex_state = 15},
  [1620] = {.lex_state = 13, .external_lex_state = 14},
  [1621] = {.lex_state = 13, .external_lex_state = 13},
  [1622] = {.lex_state = 13, .external_lex_state = 15},
  [1623] = {.lex_state = 13, .external_lex_state = 13},
  [1624] = {.lex_state = 13, .external_lex_state = 15},
  [1625] = {.lex_state = 11, .external_lex_state = 9},
  [1626] = {.lex_state = 13, .external_lex_state = 15},
  [1627] = {.lex_state = 13, .external_lex_state = 13},
  [1628] = {.lex_state = 13, .external_lex_state = 15},
  [1629] = {.lex_state = 13, .external_lex_state = 15},
  [1630] = {.lex_state = 13, .external_lex_state = 15},
  [1631] = {.lex_state = 13, .external_lex_state = 15},
  [1632] = {.lex_state = 13, .external_lex_state = 15},
  [1633] = {.lex_state = 13, .external_lex_state = 15},
  [1634] = {.lex_state = 13, .external_lex_state = 15},
  [1635] = {.lex_state = 13, .external_lex_state = 15},
  [1636] = {.lex_state = 13, .external_lex_state = 14},
  [1637] = {.lex_state = 11, .external_lex_state = 9},
  [1638] = {.lex_state = 13, .external_lex_state = 15},
  [1639] = {.lex_state = 13, .external_lex_state = 15},
  [1640] = {.lex_state = 13, .external_lex_state = 14},
  [1641] = {.lex_state = 13, .external_lex_state = 14},
  [1642] = {.lex_state = 13, .external_lex_state = 15},
  [1643] = {.lex_state = 13, .external_lex_state = 15},
  [1644] = {.lex_state = 11, .external_lex_state = 9},
  [1645] = {.lex_state = 13, .external_lex_state = 14},
  [1646] = {.lex_state = 13, .external_lex_state = 15},
  [1647] = {.lex_state = 11, .external_lex_state = 9},
  [1648] = {.lex_state = 13, .external_lex_state = 13},
  [1649] = {.lex_state = 13, .external_lex_state = 15},
  [1650] = {.lex_state = 13, .external_lex_state = 13},
  [1651] = {.lex_state = 13, .external_lex_state = 15},
  [1652] = {.lex_state = 13, .external_lex_state = 15},
  [1653] = {.lex_state = 13, .external_lex_state = 13},
  [1654] = {.lex_state = 13, .external_lex_state = 15},
  [1655] = {.lex_state = 13, .external_lex_state = 15},
  [1656] = {.lex_state = 11, .external_lex_state = 15},
  [1657] = {.lex_state = 12, .external_lex_state = 15},
  [1658] = {.lex_state = 11, .external_lex_state = 15},
  [1659] = {.lex_state = 11, .external_lex_state = 15},
  [1660] = {.lex_state = 11, .external_lex_state = 9},
  [1661] = {.lex_state = 12, .external_lex_state = 15},
  [1662] = {.lex_state = 11, .external_lex_state = 15},
  [1663] = {.lex_state = 11, .external_lex_state = 15},
  [1664] = {.lex_state = 12, .external_lex_state = 15},
  [1665] = {.lex_state = 12, .external_lex_state = 15},
  [1666] = {.lex_state = 12, .external_lex_state = 15},
  [1667] = {.lex_state = 12, .external_lex_state = 15},
  [1668] = {.lex_state = 11, .external_lex_state = 15},
  [1669] = {.lex_state = 12, .external_lex_state = 15},
  [1670] = {.lex_state = 11, .external_lex_state = 15},
  [1671] = {.lex_state = 12, .external_lex_state = 15},
  [1672] = {.lex_state = 12, .external_lex_state = 15},
  [1673] = {.lex_state = 11, .external_lex_state = 15},
  [1674] = {.lex_state = 12, .external_lex_state = 15},
  [1675] = {.lex_state = 12, .external_lex_state = 15},
  [1676] = {.lex_state = 5, .external_lex_state = 14},
  [1677] = {.lex_state = 12, .external_lex_state = 15},
  [1678] = {.lex_state = 5, .external_lex_state = 14},
  [1679] = {.lex_state = 5, .external_lex_state = 14},
  [1680] = {.lex_state = 11, .external_lex_state = 15},
  [1681] = {.lex_state = 12, .external_lex_state = 15},
  [1682] = {.lex_state = 5, .external_lex_state = 15},
  [1683] = {.lex_state = 5, .external_lex_state = 15},
  [1684] = {.lex_state = 52, .external_lex_state = 12},
  [1685] = {.lex_state = 8, .external_lex_state = 9},
  [1686] = {.lex_state = 8, .external_lex_state = 9},
  [1687] = {.lex_state = 8, .external_lex_state = 9},
  [1688] = {.lex_state = 52, .external_lex_state = 12},
  [1689] = {.lex_state = 52, .external_lex_state = 12},
  [1690] = {.lex_state = 52, .external_lex_state = 12},
  [1691] = {.lex_state = 8, .external_lex_state = 9},
  [1692] = {.lex_state = 52, .external_lex_state = 12},
  [1693] = {.lex_state = 8, .external_lex_state = 9},
  [1694] = {.lex_state = 52, .external_lex_state = 12},
  [1695] = {.lex_state = 52, .external_lex_state = 12},
  [1696] = {.lex_state = 8, .external_lex_state = 9},
  [1697] = {.lex_state = 8, .external_lex_state = 9},
  [1698] = {.lex_state = 8, .external_lex_state = 9},
  [1699] = {.lex_state = 8, .external_lex_state = 9},
  [1700] = {.lex_state = 52, .external_lex_state = 12},
  [1701] = {.lex_state = 0, .external_lex_state = 16},
  [1702] = {.lex_state = 0, .external_lex_state = 16},
  [1703] = {.lex_state = 52, .external_lex_state = 14},
  [1704] = {.lex_state = 8, .external_lex_state = 9},
  [1705] = {.lex_state = 0, .external_lex_state = 16},
  [1706] = {.lex_state = 0, .external_lex_state = 16},
  [1707] = {.lex_state = 0, .external_lex_state = 16},
  [1708] = {.lex_state = 52, .external_lex_state = 14},
  [1709] = {.lex_state = 52, .external_lex_state = 14},
  [1710] = {.lex_state = 0, .external_lex_state = 16},
  [1711] = {.lex_state = 0, .external_lex_state = 16},
  [1712] = {.lex_state = 52, .external_lex_state = 14},
  [1713] = {.lex_state = 52, .external_lex_state = 13},
  [1714] = {.lex_state = 0, .external_lex_state = 16},
  [1715] = {.lex_state = 0, .external_lex_state = 16},
  [1716] = {.lex_state = 52, .external_lex_state = 14},
  [1717] = {.lex_state = 52, .external_lex_state = 14},
  [1718] = {.lex_state = 52, .external_lex_state = 13},
  [1719] = {.lex_state = 0, .external_lex_state = 16},
  [1720] = {.lex_state = 0, .external_lex_state = 16},
  [1721] = {.lex_state = 52, .external_lex_state = 14},
  [1722] = {.lex_state = 52, .external_lex_state = 14},
  [1723] = {.lex_state = 0, .external_lex_state = 16},
  [1724] = {.lex_state = 0, .external_lex_state = 16},
  [1725] = {.lex_state = 52, .external_lex_state = 14},
  [1726] = {.lex_state = 52, .external_lex_state = 14},
  [1727] = {.lex_state = 0, .external_lex_state = 16},
  [1728] = {.lex_state = 0, .external_lex_state = 16},
  [1729] = {.lex_state = 52, .external_lex_state = 14},
  [1730] = {.lex_state = 52, .external_lex_state = 14},
  [1731] = {.lex_state = 0, .external_lex_state = 16},
  [1732] = {.lex_state = 0, .external_lex_state = 16},
  [1733] = {.lex_state = 0, .external_lex_state = 16},
  [1734] = {.lex_state = 52, .external_lex_state = 14},
  [1735] = {.lex_state = 52, .external_lex_state = 14},
  [1736] = {.lex_state = 52, .external_lex_state = 14},
  [1737] = {.lex_state = 0, .external_lex_state = 16},
  [1738] = {.lex_state = 52, .external_lex_state = 14},
  [1739] = {.lex_state = 52, .external_lex_state = 13},
  [1740] = {.lex_state = 52, .external_lex_state = 13},
  [1741] = {.lex_state = 52, .external_lex_state = 13},
  [1742] = {.lex_state = 52, .external_lex_state = 13},
  [1743] = {.lex_state = 52, .external_lex_state = 13},
  [1744] = {.lex_state = 52, .external_lex_state = 13},
  [1745] = {.lex_state = 52, .external_lex_state = 14},
  [1746] = {.lex_state = 8, .external_lex_state = 14},
  [1747] = {.lex_state = 8, .external_lex_state = 14},
  [1748] = {.lex_state = 8, .external_lex_state = 14},
  [1749] = {.lex_state = 8, .external_lex_state = 15},
  [1750] = {.lex_state = 8, .external_lex_state = 15},
  [1751] = {.lex_state = 8, .external_lex_state = 14},
  [1752] = {.lex_state = 8, .external_lex_state = 14},
  [1753] = {.lex_state = 8, .external_lex_state = 14},
  [1754] = {.lex_state = 8, .external_lex_state = 14},
  [1755] = {.lex_state = 8, .external_lex_state = 14},
  [1756] = {.lex_state = 8, .external_lex_state = 15},
  [1757] = {.lex_state = 52, .external_lex_state = 12},
  [1758] = {.lex_state = 8, .external_lex_state = 15},
  [1759] = {.lex_state = 52, .external_lex_state = 12},
  [1760] = {.lex_state = 8, .external_lex_state = 14},
  [1761] = {.lex_state = 8, .external_lex_state = 14},
  [1762] = {.lex_state = 8, .external_lex_state = 15},
  [1763] = {.lex_state = 8, .external_lex_state = 9},
  [1764] = {.lex_state = 8, .external_lex_state = 15},
  [1765] = {.lex_state = 8, .external_lex_state = 15},
  [1766] = {.lex_state = 8, .external_lex_state = 15},
  [1767] = {.lex_state = 8, .external_lex_state = 15},
  [1768] = {.lex_state = 52, .external_lex_state = 12},
  [1769] = {.lex_state = 8, .external_lex_state = 13},
  [1770] = {.lex_state = 8, .external_lex_state = 15},
  [1771] = {.lex_state = 52, .external_lex_state = 12},
  [1772] = {.lex_state = 52, .external_lex_state = 12},
  [1773] = {.lex_state = 52, .external_lex_state = 12},
  [1774] = {.lex_state = 52, .external_lex_state = 12},
  [1775] = {.lex_state = 8, .external_lex_state = 15},
  [1776] = {.lex_state = 8, .external_lex_state = 15},
  [1777] = {.lex_state = 52, .external_lex_state = 9},
  [1778] = {.lex_state = 52, .external_lex_state = 12},
  [1779] = {.lex_state = 8, .external_lex_state = 13},
  [1780] = {.lex_state = 52, .external_lex_state = 12},
  [1781] = {.lex_state = 52, .external_lex_state = 12},
  [1782] = {.lex_state = 8, .external_lex_state = 13},
  [1783] = {.lex_state = 52, .external_lex_state = 12},
  [1784] = {.lex_state = 52, .external_lex_state = 12},
  [1785] = {.lex_state = 8, .external_lex_state = 13},
  [1786] = {.lex_state = 8, .external_lex_state = 13},
  [1787] = {.lex_state = 8, .external_lex_state = 13},
  [1788] = {.lex_state = 8, .external_lex_state = 13},
  [1789] = {.lex_state = 8, .external_lex_state = 15},
  [1790] = {.lex_state = 8, .external_lex_state = 13},
  [1791] = {.lex_state = 8, .external_lex_state = 13},
  [1792] = {.lex_state = 52, .external_lex_state = 12},
  [1793] = {.lex_state = 8, .external_lex_state = 13},
  [1794] = {.lex_state = 52, .external_lex_state = 12},
  [1795] = {.lex_state = 52, .external_lex_state = 12},
  [1796] = {.lex_state = 52, .external_lex_state = 12},
  [1797] = {.lex_state = 52, .external_lex_state = 12},
  [1798] = {.lex_state = 52, .external_lex_state = 12},
  [1799] = {.lex_state = 52, .external_lex_state = 12},
  [1800] = {.lex_state = 52, .external_lex_state = 12},
  [1801] = {.lex_state = 52, .external_lex_state = 12},
  [1802] = {.lex_state = 8, .external_lex_state = 15},
  [1803] = {.lex_state = 52, .external_lex_state = 12},
  [1804] = {.lex_state = 52, .external_lex_state = 14},
  [1805] = {.lex_state = 0, .external_lex_state = 16},
  [1806] = {.lex_state = 52, .external_lex_state = 15},
  [1807] = {.lex_state = 52, .external_lex_state = 13},
  [1808] = {.lex_state = 52, .external_lex_state = 9},
  [1809] = {.lex_state = 52, .external_lex_state = 13},
  [1810] = {.lex_state = 52, .external_lex_state = 9},
  [1811] = {.lex_state = 52, .external_lex_state = 13},
  [1812] = {.lex_state = 52, .external_lex_state = 13},
  [1813] = {.lex_state = 52, .external_lex_state = 13},
  [1814] = {.lex_state = 52, .external_lex_state = 13},
  [1815] = {.lex_state = 52, .external_lex_state = 13},
  [1816] = {.lex_state = 0, .external_lex_state = 16},
  [1817] = {.lex_state = 52, .external_lex_state = 13},
  [1818] = {.lex_state = 52, .external_lex_state = 13},
  [1819] = {.lex_state = 52, .external_lex_state = 13},
  [1820] = {.lex_state = 52, .external_lex_state = 13},
  [1821] = {.lex_state = 7, .external_lex_state = 12},
  [1822] = {.lex_state = 52, .external_lex_state = 14},
  [1823] = {.lex_state = 7, .external_lex_state = 14},
  [1824] = {.lex_state = 52, .external_lex_state = 13},
  [1825] = {.lex_state = 52, .external_lex_state = 13},
  [1826] = {.lex_state = 52, .external_lex_state = 14},
  [1827] = {.lex_state = 9, .external_lex_state = 17},
  [1828] = {.lex_state = 52, .external_lex_state = 13},
  [1829] = {.lex_state = 52, .external_lex_state = 13},
  [1830] = {.lex_state = 9, .external_lex_state = 17},
  [1831] = {.lex_state = 52, .external_lex_state = 12},
  [1832] = {.lex_state = 52, .external_lex_state = 15},
  [1833] = {.lex_state = 7, .external_lex_state = 13},
  [1834] = {.lex_state = 52, .external_lex_state = 12},
  [1835] = {.lex_state = 52, .external_lex_state = 12},
  [1836] = {.lex_state = 52, .external_lex_state = 13},
  [1837] = {.lex_state = 52, .external_lex_state = 9},
  [1838] = {.lex_state = 52, .external_lex_state = 13},
  [1839] = {.lex_state = 52, .external_lex_state = 14},
  [1840] = {.lex_state = 52, .external_lex_state = 13},
  [1841] = {.lex_state = 52, .external_lex_state = 9},
  [1842] = {.lex_state = 52, .external_lex_state = 13},
  [1843] = {.lex_state = 52, .external_lex_state = 14},
  [1844] = {.lex_state = 52, .external_lex_state = 14},
  [1845] = {.lex_state = 52, .external_lex_state = 9},
  [1846] = {.lex_state = 52, .external_lex_state = 14},
  [1847] = {.lex_state = 52, .external_lex_state = 9},
  [1848] = {.lex_state = 52, .external_lex_state = 14},
  [1849] = {.lex_state = 52, .external_lex_state = 13},
  [1850] = {.lex_state = 52, .external_lex_state = 14},
  [1851] = {.lex_state = 52, .external_lex_state = 13},
  [1852] = {.lex_state = 52, .external_lex_state = 14},
  [1853] = {.lex_state = 52, .external_lex_state = 13},
  [1854] = {.lex_state = 52, .external_lex_state = 9},
  [1855] = {.lex_state = 52, .external_lex_state = 12},
  [1856] = {.lex_state = 52, .external_lex_state = 14},
  [1857] = {.lex_state = 52, .external_lex_state = 2},
  [1858] = {.lex_state = 52, .external_lex_state = 14},
  [1859] = {.lex_state = 52, .external_lex_state = 9},
  [1860] = {.lex_state = 8, .external_lex_state = 15},
  [1861] = {.lex_state = 9, .external_lex_state = 17},
  [1862] = {.lex_state = 52, .external_lex_state = 9},
  [1863] = {.lex_state = 9, .external_lex_state = 17},
  [1864] = {.lex_state = 52, .external_lex_state = 14},
  [1865] = {.lex_state = 52, .external_lex_state = 7},
  [1866] = {.lex_state = 7, .external_lex_state = 15},
  [1867] = {.lex_state = 52, .external_lex_state = 12},
  [1868] = {.lex_state = 7, .external_lex_state = 14},
  [1869] = {.lex_state = 7, .external_lex_state = 14},
  [1870] = {.lex_state = 7, .external_lex_state = 12},
  [1871] = {.lex_state = 52, .external_lex_state = 15},
  [1872] = {.lex_state = 52, .external_lex_state = 15},
  [1873] = {.lex_state = 52, .external_lex_state = 13},
  [1874] = {.lex_state = 52, .external_lex_state = 12},
  [1875] = {.lex_state = 7, .external_lex_state = 14},
  [1876] = {.lex_state = 52, .external_lex_state = 15},
  [1877] = {.lex_state = 7, .external_lex_state = 13},
  [1878] = {.lex_state = 52, .external_lex_state = 13},
  [1879] = {.lex_state = 52, .external_lex_state = 15},
  [1880] = {.lex_state = 52, .external_lex_state = 13},
  [1881] = {.lex_state = 52, .external_lex_state = 8},
  [1882] = {.lex_state = 52, .external_lex_state = 14},
  [1883] = {.lex_state = 52, .external_lex_state = 12},
  [1884] = {.lex_state = 52, .external_lex_state = 13},
  [1885] = {.lex_state = 52, .external_lex_state = 15},
  [1886] = {.lex_state = 52, .external_lex_state = 14},
  [1887] = {.lex_state = 52, .external_lex_state = 12},
  [1888] = {.lex_state = 52, .external_lex_state = 12},
  [1889] = {.lex_state = 52, .external_lex_state = 15},
  [1890] = {.lex_state = 7, .external_lex_state = 12},
  [1891] = {.lex_state = 52, .external_lex_state = 12},
  [1892] = {.lex_state = 52, .external_lex_state = 13},
  [1893] = {.lex_state = 52, .external_lex_state = 9},
  [1894] = {.lex_state = 7, .external_lex_state = 13},
  [1895] = {.lex_state = 52, .external_lex_state = 13},
  [1896] = {.lex_state = 52, .external_lex_state = 13},
  [1897] = {.lex_state = 52, .external_lex_state = 12},
  [1898] = {.lex_state = 52, .external_lex_state = 13},
  [1899] = {.lex_state = 52, .external_lex_state = 9},
  [1900] = {.lex_state = 52, .external_lex_state = 6},
  [1901] = {.lex_state = 52, .external_lex_state = 15},
  [1902] = {.lex_state = 52, .external_lex_state = 12},
  [1903] = {.lex_state = 52, .external_lex_state = 12},
  [1904] = {.lex_state = 7, .external_lex_state = 13},
  [1905] = {.lex_state = 52, .external_lex_state = 14},
  [1906] = {.lex_state = 52, .external_lex_state = 14},
  [1907] = {.lex_state = 52, .external_lex_state = 14},
  [1908] = {.lex_state = 52, .external_lex_state = 12},
  [1909] = {.lex_state = 7, .external_lex_state = 12},
  [1910] = {.lex_state = 52, .external_lex_state = 12},
  [1911] = {.lex_state = 52, .external_lex_state = 15},
  [1912] = {.lex_state = 52, .external_lex_state = 12},
  [1913] = {.lex_state = 52, .external_lex_state = 15},
  [1914] = {.lex_state = 0, .external_lex_state = 16},
  [1915] = {.lex_state = 7, .external_lex_state = 12},
  [1916] = {.lex_state = 8, .external_lex_state = 13},
  [1917] = {.lex_state = 52, .external_lex_state = 13},
  [1918] = {.lex_state = 7, .external_lex_state = 9},
  [1919] = {.lex_state = 52, .external_lex_state = 12},
  [1920] = {.lex_state = 52, .external_lex_state = 12},
  [1921] = {.lex_state = 52, .external_lex_state = 13},
  [1922] = {.lex_state = 8, .external_lex_state = 13},
  [1923] = {.lex_state = 52, .external_lex_state = 12},
  [1924] = {.lex_state = 52, .external_lex_state = 13},
  [1925] = {.lex_state = 52, .external_lex_state = 12},
  [1926] = {.lex_state = 0, .external_lex_state = 16},
  [1927] = {.lex_state = 52, .external_lex_state = 14},
  [1928] = {.lex_state = 52, .external_lex_state = 14},
  [1929] = {.lex_state = 52, .external_lex_state = 14},
  [1930] = {.lex_state = 0, .external_lex_state = 16},
  [1931] = {.lex_state = 52, .external_lex_state = 14},
  [1932] = {.lex_state = 0, .external_lex_state = 16},
  [1933] = {.lex_state = 8, .external_lex_state = 14},
  [1934] = {.lex_state = 52, .external_lex_state = 14},
  [1935] = {.lex_state = 8, .external_lex_state = 13},
  [1936] = {.lex_state = 52, .external_lex_state = 15},
  [1937] = {.lex_state = 8, .external_lex_state = 14},
  [1938] = {.lex_state = 52, .external_lex_state = 15},
  [1939] = {.lex_state = 52, .external_lex_state = 14},
  [1940] = {.lex_state = 8, .external_lex_state = 14},
  [1941] = {.lex_state = 8, .external_lex_state = 14},
  [1942] = {.lex_state = 52, .external_lex_state = 15},
  [1943] = {.lex_state = 52, .external_lex_state = 14},
  [1944] = {.lex_state = 52, .external_lex_state = 14},
  [1945] = {.lex_state = 52, .external_lex_state = 12},
  [1946] = {.lex_state = 8, .external_lex_state = 13},
  [1947] = {.lex_state = 52, .external_lex_state = 13},
  [1948] = {.lex_state = 52, .external_lex_state = 13},
  [1949] = {.lex_state = 52, .external_lex_state = 9},
  [1950] = {.lex_state = 52, .external_lex_state = 14},
  [1951] = {.lex_state = 8, .external_lex_state = 9},
  [1952] = {.lex_state = 52, .external_lex_state = 14},
  [1953] = {.lex_state = 52, .external_lex_state = 14},
  [1954] = {.lex_state = 8, .external_lex_state = 9},
  [1955] = {.lex_state = 7, .external_lex_state = 13},
  [1956] = {.lex_state = 8, .external_lex_state = 15},
  [1957] = {.lex_state = 0, .external_lex_state = 16},
  [1958] = {.lex_state = 8, .external_lex_state = 14},
  [1959] = {.lex_state = 52, .external_lex_state = 15},
  [1960] = {.lex_state = 8, .external_lex_state = 14},
  [1961] = {.lex_state = 8, .external_lex_state = 14},
  [1962] = {.lex_state = 8, .external_lex_state = 9},
  [1963] = {.lex_state = 0, .external_lex_state = 16},
  [1964] = {.lex_state = 8, .external_lex_state = 9},
  [1965] = {.lex_state = 52, .external_lex_state = 9},
  [1966] = {.lex_state = 52, .external_lex_state = 13},
  [1967] = {.lex_state = 52, .external_lex_state = 14},
  [1968] = {.lex_state = 8, .external_lex_state = 9},
  [1969] = {.lex_state = 8, .external_lex_state = 14},
  [1970] = {.lex_state = 0, .external_lex_state = 16},
  [1971] = {.lex_state = 52, .external_lex_state = 13},
  [1972] = {.lex_state = 52, .external_lex_state = 12},
  [1973] = {.lex_state = 52, .external_lex_state = 12},
  [1974] = {.lex_state = 52, .external_lex_state = 15},
  [1975] = {.lex_state = 8, .external_lex_state = 9},
  [1976] = {.lex_state = 8, .external_lex_state = 14},
  [1977] = {.lex_state = 52, .external_lex_state = 14},
  [1978] = {.lex_state = 52, .external_lex_state = 13},
  [1979] = {.lex_state = 8, .external_lex_state = 9},
  [1980] = {.lex_state = 52, .external_lex_state = 12},
  [1981] = {.lex_state = 52, .external_lex_state = 12},
  [1982] = {.lex_state = 8, .external_lex_state = 14},
  [1983] = {.lex_state = 52, .external_lex_state = 9},
  [1984] = {.lex_state = 7, .external_lex_state = 9},
  [1985] = {.lex_state = 52, .external_lex_state = 15},
  [1986] = {.lex_state = 52, .external_lex_state = 14},
  [1987] = {.lex_state = 52, .external_lex_state = 13},
  [1988] = {.lex_state = 8, .external_lex_state = 15},
  [1989] = {.lex_state = 52, .external_lex_state = 14},
  [1990] = {.lex_state = 52, .external_lex_state = 14},
  [1991] = {.lex_state = 7, .external_lex_state = 9},
  [1992] = {.lex_state = 52, .external_lex_state = 13},
  [1993] = {.lex_state = 52, .external_lex_state = 15},
  [1994] = {.lex_state = 52, .external_lex_state = 15},
  [1995] = {.lex_state = 7, .external_lex_state = 14},
  [1996] = {.lex_state = 8, .external_lex_state = 9},
  [1997] = {.lex_state = 52, .external_lex_state = 12},
  [1998] = {.lex_state = 8, .external_lex_state = 9},
  [1999] = {.lex_state = 8, .external_lex_state = 9},
  [2000] = {.lex_state = 52, .external_lex_state = 12},
  [2001] = {.lex_state = 52, .external_lex_state = 15},
  [2002] = {.lex_state = 52, .external_lex_state = 15},
  [2003] = {.lex_state = 52, .external_lex_state = 14},
  [2004] = {.lex_state = 52, .external_lex_state = 13},
  [2005] = {.lex_state = 52, .external_lex_state = 15},
  [2006] = {.lex_state = 52, .external_lex_state = 15},
  [2007] = {.lex_state = 52, .external_lex_state = 14},
  [2008] = {.lex_state = 52, .external_lex_state = 15},
  [2009] = {.lex_state = 52, .external_lex_state = 15},
  [2010] = {.lex_state = 52, .external_lex_state = 12},
  [2011] = {.lex_state = 52, .external_lex_state = 13},
  [2012] = {.lex_state = 52, .external_lex_state = 15},
  [2013] = {.lex_state = 52, .external_lex_state = 12},
  [2014] = {.lex_state = 52, .external_lex_state = 13},
  [2015] = {.lex_state = 52, .external_lex_state = 15},
  [2016] = {.lex_state = 0, .external_lex_state = 16},
  [2017] = {.lex_state = 8, .external_lex_state = 15},
  [2018] = {.lex_state = 52, .external_lex_state = 13},
  [2019] = {.lex_state = 52, .external_lex_state = 12},
  [2020] = {.lex_state = 52, .external_lex_state = 12},
  [2021] = {.lex_state = 52, .external_lex_state = 15},
  [2022] = {.lex_state = 8, .external_lex_state = 13},
  [2023] = {.lex_state = 8, .external_lex_state = 13},
  [2024] = {.lex_state = 52, .external_lex_state = 9},
  [2025] = {.lex_state = 52, .external_lex_state = 15},
  [2026] = {.lex_state = 52, .external_lex_state = 15},
  [2027] = {.lex_state = 52, .external_lex_state = 15},
  [2028] = {.lex_state = 52, .external_lex_state = 12},
  [2029] = {.lex_state = 52, .external_lex_state = 15},
  [2030] = {.lex_state = 52, .external_lex_state = 15},
  [2031] = {.lex_state = 52, .external_lex_state = 15},
  [2032] = {.lex_state = 52, .external_lex_state = 15},
  [2033] = {.lex_state = 52, .external_lex_state = 14},
  [2034] = {.lex_state = 52, .external_lex_state = 12},
  [2035] = {.lex_state = 52, .external_lex_state = 15},
  [2036] = {.lex_state = 52, .external_lex_state = 15},
  [2037] = {.lex_state = 52, .external_lex_state = 12},
  [2038] = {.lex_state = 52, .external_lex_state = 15},
  [2039] = {.lex_state = 52, .external_lex_state = 15},
  [2040] = {.lex_state = 52, .external_lex_state = 12},
  [2041] = {.lex_state = 52, .external_lex_state = 14},
  [2042] = {.lex_state = 52, .external_lex_state = 12},
  [2043] = {.lex_state = 52, .external_lex_state = 12},
  [2044] = {.lex_state = 8, .external_lex_state = 15},
  [2045] = {.lex_state = 52, .external_lex_state = 12},
  [2046] = {.lex_state = 52, .external_lex_state = 14},
  [2047] = {.lex_state = 52, .external_lex_state = 12},
  [2048] = {.lex_state = 52, .external_lex_state = 14},
  [2049] = {.lex_state = 52, .external_lex_state = 12},
  [2050] = {.lex_state = 52, .external_lex_state = 13},
  [2051] = {.lex_state = 52, .external_lex_state = 15},
  [2052] = {.lex_state = 52, .external_lex_state = 15},
  [2053] = {.lex_state = 52, .external_lex_state = 15},
  [2054] = {.lex_state = 52, .external_lex_state = 15},
  [2055] = {.lex_state = 52, .external_lex_state = 15},
  [2056] = {.lex_state = 52, .external_lex_state = 12},
  [2057] = {.lex_state = 52, .external_lex_state = 13},
  [2058] = {.lex_state = 52, .external_lex_state = 12},
  [2059] = {.lex_state = 52, .external_lex_state = 12},
  [2060] = {.lex_state = 52, .external_lex_state = 12},
  [2061] = {.lex_state = 52, .external_lex_state = 12},
  [2062] = {.lex_state = 52, .external_lex_state = 13},
  [2063] = {.lex_state = 52, .external_lex_state = 9},
  [2064] = {.lex_state = 52, .external_lex_state = 15},
  [2065] = {.lex_state = 52, .external_lex_state = 15},
  [2066] = {.lex_state = 8, .external_lex_state = 13},
  [2067] = {.lex_state = 8, .external_lex_state = 13},
  [2068] = {.lex_state = 52, .external_lex_state = 15},
  [2069] = {.lex_state = 52, .external_lex_state = 15},
  [2070] = {.lex_state = 8, .external_lex_state = 15},
  [2071] = {.lex_state = 52, .external_lex_state = 15},
  [2072] = {.lex_state = 52, .external_lex_state = 15},
  [2073] = {.lex_state = 52, .external_lex_state = 15},
  [2074] = {.lex_state = 52, .external_lex_state = 13},
  [2075] = {.lex_state = 52, .external_lex_state = 12},
  [2076] = {.lex_state = 52, .external_lex_state = 14},
  [2077] = {.lex_state = 8, .external_lex_state = 13},
  [2078] = {.lex_state = 52, .external_lex_state = 15},
  [2079] = {.lex_state = 52, .external_lex_state = 12},
  [2080] = {.lex_state = 52, .external_lex_state = 14},
  [2081] = {.lex_state = 52, .external_lex_state = 15},
  [2082] = {.lex_state = 52, .external_lex_state = 15},
  [2083] = {.lex_state = 8, .external_lex_state = 13},
  [2084] = {.lex_state = 52, .external_lex_state = 15},
  [2085] = {.lex_state = 52, .external_lex_state = 15},
  [2086] = {.lex_state = 52, .external_lex_state = 15},
  [2087] = {.lex_state = 52, .external_lex_state = 9},
  [2088] = {.lex_state = 52, .external_lex_state = 12},
  [2089] = {.lex_state = 52, .external_lex_state = 15},
  [2090] = {.lex_state = 52, .external_lex_state = 12},
  [2091] = {.lex_state = 7, .external_lex_state = 9},
  [2092] = {.lex_state = 52, .external_lex_state = 15},
  [2093] = {.lex_state = 52, .external_lex_state = 9},
  [2094] = {.lex_state = 52, .external_lex_state = 15},
  [2095] = {.lex_state = 52, .external_lex_state = 15},
  [2096] = {.lex_state = 3, .external_lex_state = 12},
  [2097] = {.lex_state = 52, .external_lex_state = 15},
  [2098] = {.lex_state = 52, .external_lex_state = 15},
  [2099] = {.lex_state = 52, .external_lex_state = 12},
  [2100] = {.lex_state = 52, .external_lex_state = 15},
  [2101] = {.lex_state = 8, .external_lex_state = 13},
  [2102] = {.lex_state = 8, .external_lex_state = 15},
  [2103] = {.lex_state = 52, .external_lex_state = 13},
  [2104] = {.lex_state = 52, .external_lex_state = 13},
  [2105] = {.lex_state = 52, .external_lex_state = 15},
  [2106] = {.lex_state = 8, .external_lex_state = 15},
  [2107] = {.lex_state = 52, .external_lex_state = 15},
  [2108] = {.lex_state = 52, .external_lex_state = 15},
  [2109] = {.lex_state = 52, .external_lex_state = 9},
  [2110] = {.lex_state = 8, .external_lex_state = 13},
  [2111] = {.lex_state = 8, .external_lex_state = 13},
  [2112] = {.lex_state = 8, .external_lex_state = 14},
  [2113] = {.lex_state = 8, .external_lex_state = 15},
  [2114] = {.lex_state = 52, .external_lex_state = 13},
  [2115] = {.lex_state = 8, .external_lex_state = 15},
  [2116] = {.lex_state = 52, .external_lex_state = 14},
  [2117] = {.lex_state = 8, .external_lex_state = 9},
  [2118] = {.lex_state = 52, .external_lex_state = 12},
  [2119] = {.lex_state = 52, .external_lex_state = 15},
  [2120] = {.lex_state = 52, .external_lex_state = 9},
  [2121] = {.lex_state = 8, .external_lex_state = 15},
  [2122] = {.lex_state = 3, .external_lex_state = 12},
  [2123] = {.lex_state = 52, .external_lex_state = 12},
  [2124] = {.lex_state = 52, .external_lex_state = 13},
  [2125] = {.lex_state = 52, .external_lex_state = 9},
  [2126] = {.lex_state = 52, .external_lex_state = 15},
  [2127] = {.lex_state = 8, .external_lex_state = 13},
  [2128] = {.lex_state = 52, .external_lex_state = 15},
  [2129] = {.lex_state = 52, .external_lex_state = 15},
  [2130] = {.lex_state = 52, .external_lex_state = 15},
  [2131] = {.lex_state = 3, .external_lex_state = 12},
  [2132] = {.lex_state = 52, .external_lex_state = 15},
  [2133] = {.lex_state = 52, .external_lex_state = 15},
  [2134] = {.lex_state = 52, .external_lex_state = 14},
  [2135] = {.lex_state = 52, .external_lex_state = 15},
  [2136] = {.lex_state = 52, .external_lex_state = 15},
  [2137] = {.lex_state = 52, .external_lex_state = 14},
  [2138] = {.lex_state = 52, .external_lex_state = 13},
  [2139] = {.lex_state = 52, .external_lex_state = 9},
  [2140] = {.lex_state = 52, .external_lex_state = 9},
  [2141] = {.lex_state = 52, .external_lex_state = 14},
  [2142] = {.lex_state = 52, .external_lex_state = 14},
  [2143] = {.lex_state = 52, .external_lex_state = 14},
  [2144] = {.lex_state = 52, .external_lex_state = 14},
  [2145] = {.lex_state = 52, .external_lex_state = 18},
  [2146] = {.lex_state = 52, .external_lex_state = 14},
  [2147] = {.lex_state = 52, .external_lex_state = 14},
  [2148] = {.lex_state = 52, .external_lex_state = 13},
  [2149] = {.lex_state = 52, .external_lex_state = 13},
  [2150] = {.lex_state = 52, .external_lex_state = 13},
  [2151] = {.lex_state = 52, .external_lex_state = 13},
  [2152] = {.lex_state = 52, .external_lex_state = 13},
  [2153] = {.lex_state = 52, .external_lex_state = 9},
  [2154] = {.lex_state = 52, .external_lex_state = 14},
  [2155] = {.lex_state = 52, .external_lex_state = 13},
  [2156] = {.lex_state = 52, .external_lex_state = 13},
  [2157] = {.lex_state = 52, .external_lex_state = 13},
  [2158] = {.lex_state = 52, .external_lex_state = 13},
  [2159] = {.lex_state = 52, .external_lex_state = 13},
  [2160] = {.lex_state = 52, .external_lex_state = 15},
  [2161] = {.lex_state = 52, .external_lex_state = 13},
  [2162] = {.lex_state = 52, .external_lex_state = 15},
  [2163] = {.lex_state = 52, .external_lex_state = 13},
  [2164] = {.lex_state = 52, .external_lex_state = 13},
  [2165] = {.lex_state = 52, .external_lex_state = 13},
  [2166] = {.lex_state = 52, .external_lex_state = 14},
  [2167] = {.lex_state = 52, .external_lex_state = 13},
  [2168] = {.lex_state = 52, .external_lex_state = 13},
  [2169] = {.lex_state = 52, .external_lex_state = 13},
  [2170] = {.lex_state = 52, .external_lex_state = 13},
  [2171] = {.lex_state = 52, .external_lex_state = 13},
  [2172] = {.lex_state = 52, .external_lex_state = 13},
  [2173] = {.lex_state = 52, .external_lex_state = 15},
  [2174] = {.lex_state = 52, .external_lex_state = 13},
  [2175] = {.lex_state = 52, .external_lex_state = 13},
  [2176] = {.lex_state = 52, .external_lex_state = 13},
  [2177] = {.lex_state = 52, .external_lex_state = 13},
  [2178] = {.lex_state = 52, .external_lex_state = 13},
  [2179] = {.lex_state = 52, .external_lex_state = 13},
  [2180] = {.lex_state = 52, .external_lex_state = 14},
  [2181] = {.lex_state = 52, .external_lex_state = 9},
  [2182] = {.lex_state = 52, .external_lex_state = 9},
  [2183] = {.lex_state = 52, .external_lex_state = 9},
  [2184] = {.lex_state = 7, .external_lex_state = 15},
  [2185] = {.lex_state = 52, .external_lex_state = 14},
  [2186] = {.lex_state = 52, .external_lex_state = 13},
  [2187] = {.lex_state = 8, .external_lex_state = 15},
  [2188] = {.lex_state = 52, .external_lex_state = 9},
  [2189] = {.lex_state = 52, .external_lex_state = 14},
  [2190] = {.lex_state = 8, .external_lex_state = 15},
  [2191] = {.lex_state = 52, .external_lex_state = 14},
  [2192] = {.lex_state = 52, .external_lex_state = 14},
  [2193] = {.lex_state = 52, .external_lex_state = 14},
  [2194] = {.lex_state = 52, .external_lex_state = 14},
  [2195] = {.lex_state = 52, .external_lex_state = 9},
  [2196] = {.lex_state = 52, .external_lex_state = 14},
  [2197] = {.lex_state = 52, .external_lex_state = 9},
  [2198] = {.lex_state = 52, .external_lex_state = 9},
  [2199] = {.lex_state = 52, .external_lex_state = 18},
  [2200] = {.lex_state = 52, .external_lex_state = 9},
  [2201] = {.lex_state = 52, .external_lex_state = 14},
  [2202] = {.lex_state = 52, .external_lex_state = 13},
  [2203] = {.lex_state = 52, .external_lex_state = 14},
  [2204] = {.lex_state = 52, .external_lex_state = 15},
  [2205] = {.lex_state = 52, .external_lex_state = 14},
  [2206] = {.lex_state = 52, .external_lex_state = 14},
  [2207] = {.lex_state = 52, .external_lex_state = 15},
  [2208] = {.lex_state = 52, .external_lex_state = 12},
  [2209] = {.lex_state = 52, .external_lex_state = 15},
  [2210] = {.lex_state = 52, .external_lex_state = 9},
  [2211] = {.lex_state = 52, .external_lex_state = 14},
  [2212] = {.lex_state = 52, .external_lex_state = 15},
  [2213] = {.lex_state = 52, .external_lex_state = 14},
  [2214] = {.lex_state = 52, .external_lex_state = 12},
  [2215] = {.lex_state = 52, .external_lex_state = 14},
  [2216] = {.lex_state = 52, .external_lex_state = 12},
  [2217] = {.lex_state = 52, .external_lex_state = 9},
  [2218] = {.lex_state = 52, .external_lex_state = 12},
  [2219] = {.lex_state = 52, .external_lex_state = 14},
  [2220] = {.lex_state = 52, .external_lex_state = 14},
  [2221] = {.lex_state = 52, .external_lex_state = 14},
  [2222] = {.lex_state = 52, .external_lex_state = 12},
  [2223] = {.lex_state = 52, .external_lex_state = 12},
  [2224] = {.lex_state = 52, .external_lex_state = 12},
  [2225] = {.lex_state = 52, .external_lex_state = 12},
  [2226] = {.lex_state = 52, .external_lex_state = 12},
  [2227] = {.lex_state = 52, .external_lex_state = 12},
  [2228] = {.lex_state = 52, .external_lex_state = 14},
  [2229] = {.lex_state = 52, .external_lex_state = 12},
  [2230] = {.lex_state = 52, .external_lex_state = 12},
  [2231] = {.lex_state = 7, .external_lex_state = 15},
  [2232] = {.lex_state = 52, .external_lex_state = 12},
  [2233] = {.lex_state = 52, .external_lex_state = 12},
  [2234] = {.lex_state = 52, .external_lex_state = 12},
  [2235] = {.lex_state = 52, .external_lex_state = 12},
  [2236] = {.lex_state = 52, .external_lex_state = 12},
  [2237] = {.lex_state = 52, .external_lex_state = 12},
  [2238] = {.lex_state = 52, .external_lex_state = 12},
  [2239] = {.lex_state = 52, .external_lex_state = 12},
  [2240] = {.lex_state = 52, .external_lex_state = 12},
  [2241] = {.lex_state = 52, .external_lex_state = 12},
  [2242] = {.lex_state = 52, .external_lex_state = 12},
  [2243] = {.lex_state = 52, .external_lex_state = 12},
  [2244] = {.lex_state = 52, .external_lex_state = 15},
  [2245] = {.lex_state = 52, .external_lex_state = 15},
  [2246] = {.lex_state = 52, .external_lex_state = 14},
  [2247] = {.lex_state = 52, .external_lex_state = 18},
  [2248] = {.lex_state = 52, .external_lex_state = 18},
  [2249] = {.lex_state = 52, .external_lex_state = 9},
  [2250] = {.lex_state = 52, .external_lex_state = 9},
  [2251] = {.lex_state = 52, .external_lex_state = 9},
  [2252] = {.lex_state = 52, .external_lex_state = 14},
  [2253] = {.lex_state = 52, .external_lex_state = 14},
  [2254] = {.lex_state = 52, .external_lex_state = 14},
  [2255] = {.lex_state = 52, .external_lex_state = 14},
  [2256] = {.lex_state = 52, .external_lex_state = 14},
  [2257] = {.lex_state = 52, .external_lex_state = 12},
  [2258] = {.lex_state = 52, .external_lex_state = 15},
  [2259] = {.lex_state = 52, .external_lex_state = 15},
  [2260] = {.lex_state = 52, .external_lex_state = 9},
  [2261] = {.lex_state = 52, .external_lex_state = 15},
  [2262] = {.lex_state = 52, .external_lex_state = 14},
  [2263] = {.lex_state = 52, .external_lex_state = 18},
  [2264] = {.lex_state = 52, .external_lex_state = 14},
  [2265] = {.lex_state = 52, .external_lex_state = 14},
  [2266] = {.lex_state = 52, .external_lex_state = 14},
  [2267] = {.lex_state = 52, .external_lex_state = 12},
  [2268] = {.lex_state = 52, .external_lex_state = 9},
  [2269] = {.lex_state = 52, .external_lex_state = 19},
  [2270] = {.lex_state = 52, .external_lex_state = 14},
  [2271] = {.lex_state = 52, .external_lex_state = 13},
  [2272] = {.lex_state = 52, .external_lex_state = 13},
  [2273] = {.lex_state = 52, .external_lex_state = 9},
  [2274] = {.lex_state = 52, .external_lex_state = 14},
  [2275] = {.lex_state = 52, .external_lex_state = 9},
  [2276] = {.lex_state = 52, .external_lex_state = 14},
  [2277] = {.lex_state = 52, .external_lex_state = 9},
  [2278] = {.lex_state = 52, .external_lex_state = 13},
  [2279] = {.lex_state = 52, .external_lex_state = 14},
  [2280] = {.lex_state = 52, .external_lex_state = 12},
  [2281] = {.lex_state = 52, .external_lex_state = 13},
  [2282] = {.lex_state = 52, .external_lex_state = 13},
  [2283] = {.lex_state = 52, .external_lex_state = 9},
  [2284] = {.lex_state = 9, .external_lex_state = 17},
  [2285] = {.lex_state = 52, .external_lex_state = 12},
  [2286] = {.lex_state = 52, .external_lex_state = 13},
  [2287] = {.lex_state = 52, .external_lex_state = 14},
  [2288] = {.lex_state = 52, .external_lex_state = 14},
  [2289] = {.lex_state = 52, .external_lex_state = 13},
  [2290] = {.lex_state = 8, .external_lex_state = 15},
  [2291] = {.lex_state = 52, .external_lex_state = 19},
  [2292] = {.lex_state = 52, .external_lex_state = 14},
  [2293] = {.lex_state = 52, .external_lex_state = 15},
  [2294] = {.lex_state = 52, .external_lex_state = 14},
  [2295] = {.lex_state = 52, .external_lex_state = 14},
  [2296] = {.lex_state = 52, .external_lex_state = 14},
  [2297] = {.lex_state = 52, .external_lex_state = 13},
  [2298] = {.lex_state = 52, .external_lex_state = 13},
  [2299] = {.lex_state = 52, .external_lex_state = 13},
  [2300] = {.lex_state = 52, .external_lex_state = 14},
  [2301] = {.lex_state = 52, .external_lex_state = 13},
  [2302] = {.lex_state = 52, .external_lex_state = 12},
  [2303] = {.lex_state = 52, .external_lex_state = 13},
  [2304] = {.lex_state = 52, .external_lex_state = 13},
  [2305] = {.lex_state = 52, .external_lex_state = 13},
  [2306] = {.lex_state = 52, .external_lex_state = 13},
  [2307] = {.lex_state = 52, .external_lex_state = 13},
  [2308] = {.lex_state = 52, .external_lex_state = 12},
  [2309] = {.lex_state = 52, .external_lex_state = 14},
  [2310] = {.lex_state = 52, .external_lex_state = 19},
  [2311] = {.lex_state = 52, .external_lex_state = 13},
  [2312] = {.lex_state = 52, .external_lex_state = 15},
  [2313] = {.lex_state = 52, .external_lex_state = 12},
  [2314] = {.lex_state = 3, .external_lex_state = 12},
  [2315] = {.lex_state = 52, .external_lex_state = 12},
  [2316] = {.lex_state = 52, .external_lex_state = 12},
  [2317] = {.lex_state = 52, .external_lex_state = 12},
  [2318] = {.lex_state = 52, .external_lex_state = 14},
  [2319] = {.lex_state = 52, .external_lex_state = 12},
  [2320] = {.lex_state = 52, .external_lex_state = 14},
  [2321] = {.lex_state = 52, .external_lex_state = 12},
  [2322] = {.lex_state = 52, .external_lex_state = 12},
  [2323] = {.lex_state = 52, .external_lex_state = 15},
  [2324] = {.lex_state = 52, .external_lex_state = 9},
  [2325] = {.lex_state = 52, .external_lex_state = 13},
  [2326] = {.lex_state = 52, .external_lex_state = 9},
  [2327] = {.lex_state = 52, .external_lex_state = 14},
  [2328] = {.lex_state = 52, .external_lex_state = 14},
  [2329] = {.lex_state = 52, .external_lex_state = 14},
  [2330] = {.lex_state = 52, .external_lex_state = 12},
  [2331] = {.lex_state = 52, .external_lex_state = 14},
  [2332] = {.lex_state = 52, .external_lex_state = 9},
  [2333] = {.lex_state = 52, .external_lex_state = 12},
  [2334] = {.lex_state = 52, .external_lex_state = 14},
  [2335] = {.lex_state = 52, .external_lex_state = 14},
  [2336] = {.lex_state = 52, .external_lex_state = 13},
  [2337] = {.lex_state = 52, .external_lex_state = 13},
  [2338] = {.lex_state = 52, .external_lex_state = 13},
  [2339] = {.lex_state = 3, .external_lex_state = 12},
  [2340] = {.lex_state = 52, .external_lex_state = 12},
  [2341] = {.lex_state = 3, .external_lex_state = 12},
  [2342] = {.lex_state = 52, .external_lex_state = 14},
  [2343] = {.lex_state = 9, .external_lex_state = 17},
  [2344] = {.lex_state = 52, .external_lex_state = 14},
  [2345] = {.lex_state = 52, .external_lex_state = 15},
  [2346] = {.lex_state = 52, .external_lex_state = 13},
  [2347] = {.lex_state = 52, .external_lex_state = 13},
  [2348] = {.lex_state = 3, .external_lex_state = 12},
  [2349] = {.lex_state = 52, .external_lex_state = 14},
  [2350] = {.lex_state = 52, .external_lex_state = 9},
  [2351] = {.lex_state = 52, .external_lex_state = 12},
  [2352] = {.lex_state = 52, .external_lex_state = 14},
  [2353] = {.lex_state = 52, .external_lex_state = 14},
  [2354] = {.lex_state = 52, .external_lex_state = 15},
  [2355] = {.lex_state = 52, .external_lex_state = 13},
  [2356] = {.lex_state = 52, .external_lex_state = 14},
  [2357] = {.lex_state = 52, .external_lex_state = 15},
  [2358] = {.lex_state = 52, .external_lex_state = 15},
  [2359] = {.lex_state = 52, .external_lex_state = 14},
  [2360] = {.lex_state = 52, .external_lex_state = 12},
  [2361] = {.lex_state = 52, .external_lex_state = 12},
  [2362] = {.lex_state = 8, .external_lex_state = 15},
  [2363] = {.lex_state = 52, .external_lex_state = 9},
  [2364] = {.lex_state = 52, .external_lex_state = 14},
  [2365] = {.lex_state = 52, .external_lex_state = 9},
  [2366] = {.lex_state = 52, .external_lex_state = 12},
  [2367] = {.lex_state = 52, .external_lex_state = 9},
  [2368] = {.lex_state = 52, .external_lex_state = 9},
  [2369] = {.lex_state = 52, .external_lex_state = 14},
  [2370] = {.lex_state = 52, .external_lex_state = 14},
  [2371] = {.lex_state = 52, .external_lex_state = 13},
  [2372] = {.lex_state = 52, .external_lex_state = 14},
  [2373] = {.lex_state = 52, .external_lex_state = 14},
  [2374] = {.lex_state = 52, .external_lex_state = 14},
  [2375] = {.lex_state = 52, .external_lex_state = 14},
  [2376] = {.lex_state = 52, .external_lex_state = 15},
  [2377] = {.lex_state = 52, .external_lex_state = 13},
  [2378] = {.lex_state = 52, .external_lex_state = 13},
  [2379] = {.lex_state = 52, .external_lex_state = 12},
  [2380] = {.lex_state = 52, .external_lex_state = 14},
  [2381] = {.lex_state = 52, .external_lex_state = 9},
  [2382] = {.lex_state = 52, .external_lex_state = 14},
  [2383] = {.lex_state = 52, .external_lex_state = 14},
  [2384] = {.lex_state = 52, .external_lex_state = 12},
  [2385] = {.lex_state = 52, .external_lex_state = 12},
  [2386] = {.lex_state = 52, .external_lex_state = 14},
  [2387] = {.lex_state = 52, .external_lex_state = 12},
  [2388] = {.lex_state = 52, .external_lex_state = 14},
  [2389] = {.lex_state = 52, .external_lex_state = 9},
  [2390] = {.lex_state = 52, .external_lex_state = 12},
  [2391] = {.lex_state = 52, .external_lex_state = 14},
  [2392] = {.lex_state = 52, .external_lex_state = 14},
  [2393] = {.lex_state = 52, .external_lex_state = 14},
  [2394] = {.lex_state = 52, .external_lex_state = 13},
  [2395] = {.lex_state = 52, .external_lex_state = 12},
  [2396] = {.lex_state = 52, .external_lex_state = 14},
  [2397] = {.lex_state = 52, .external_lex_state = 9},
  [2398] = {.lex_state = 52, .external_lex_state = 9},
  [2399] = {.lex_state = 52, .external_lex_state = 15},
  [2400] = {.lex_state = 52, .external_lex_state = 14},
  [2401] = {.lex_state = 52, .external_lex_state = 12},
  [2402] = {.lex_state = 52, .external_lex_state = 14},
  [2403] = {.lex_state = 9, .external_lex_state = 17},
  [2404] = {.lex_state = 52, .external_lex_state = 14},
  [2405] = {.lex_state = 52, .external_lex_state = 14},
  [2406] = {.lex_state = 52, .external_lex_state = 14},
  [2407] = {.lex_state = 52, .external_lex_state = 9},
  [2408] = {.lex_state = 52, .external_lex_state = 13},
  [2409] = {.lex_state = 52, .external_lex_state = 12},
  [2410] = {.lex_state = 52, .external_lex_state = 13},
  [2411] = {.lex_state = 52, .external_lex_state = 13},
  [2412] = {.lex_state = 52, .external_lex_state = 13},
  [2413] = {.lex_state = 3, .external_lex_state = 12},
  [2414] = {.lex_state = 52, .external_lex_state = 14},
  [2415] = {.lex_state = 52, .external_lex_state = 13},
  [2416] = {.lex_state = 52, .external_lex_state = 13},
  [2417] = {.lex_state = 52, .external_lex_state = 13},
  [2418] = {.lex_state = 52, .external_lex_state = 19},
  [2419] = {.lex_state = 52, .external_lex_state = 9},
  [2420] = {.lex_state = 3, .external_lex_state = 12},
  [2421] = {.lex_state = 52, .external_lex_state = 12},
  [2422] = {.lex_state = 52, .external_lex_state = 14},
  [2423] = {.lex_state = 52, .external_lex_state = 9},
  [2424] = {.lex_state = 52, .external_lex_state = 19},
  [2425] = {.lex_state = 52, .external_lex_state = 14},
  [2426] = {.lex_state = 3, .external_lex_state = 12},
  [2427] = {.lex_state = 52, .external_lex_state = 14},
  [2428] = {.lex_state = 52, .external_lex_state = 12},
  [2429] = {.lex_state = 52, .external_lex_state = 14},
  [2430] = {.lex_state = 52, .external_lex_state = 9},
  [2431] = {.lex_state = 52, .external_lex_state = 15},
  [2432] = {.lex_state = 52, .external_lex_state = 12},
  [2433] = {.lex_state = 52, .external_lex_state = 14},
  [2434] = {.lex_state = 52, .external_lex_state = 14},
  [2435] = {.lex_state = 52, .external_lex_state = 14},
  [2436] = {.lex_state = 52, .external_lex_state = 14},
  [2437] = {.lex_state = 52, .external_lex_state = 14},
  [2438] = {.lex_state = 52, .external_lex_state = 13},
  [2439] = {.lex_state = 52, .external_lex_state = 14},
  [2440] = {.lex_state = 52, .external_lex_state = 12},
  [2441] = {.lex_state = 52, .external_lex_state = 19},
  [2442] = {.lex_state = 52, .external_lex_state = 14},
  [2443] = {.lex_state = 52, .external_lex_state = 14},
  [2444] = {.lex_state = 52, .external_lex_state = 15},
  [2445] = {.lex_state = 52, .external_lex_state = 13},
  [2446] = {.lex_state = 52, .external_lex_state = 13},
  [2447] = {.lex_state = 52, .external_lex_state = 13},
  [2448] = {.lex_state = 52, .external_lex_state = 14},
  [2449] = {.lex_state = 52, .external_lex_state = 13},
  [2450] = {.lex_state = 52, .external_lex_state = 14},
  [2451] = {.lex_state = 52, .external_lex_state = 13},
  [2452] = {.lex_state = 52, .external_lex_state = 14},
  [2453] = {.lex_state = 52, .external_lex_state = 13},
  [2454] = {.lex_state = 52, .external_lex_state = 13},
  [2455] = {.lex_state = 3, .external_lex_state = 12},
  [2456] = {.lex_state = 52, .external_lex_state = 12},
  [2457] = {.lex_state = 52, .external_lex_state = 13},
  [2458] = {.lex_state = 52, .external_lex_state = 13},
  [2459] = {.lex_state = 52, .external_lex_state = 13},
  [2460] = {.lex_state = 52, .external_lex_state = 15},
  [2461] = {.lex_state = 52, .external_lex_state = 13},
  [2462] = {.lex_state = 52, .external_lex_state = 15},
  [2463] = {.lex_state = 52, .external_lex_state = 9},
  [2464] = {.lex_state = 52, .external_lex_state = 9},
  [2465] = {.lex_state = 52, .external_lex_state = 15},
  [2466] = {.lex_state = 52, .external_lex_state = 15},
  [2467] = {.lex_state = 52, .external_lex_state = 12},
  [2468] = {.lex_state = 52, .external_lex_state = 14},
  [2469] = {.lex_state = 52, .external_lex_state = 15},
  [2470] = {.lex_state = 52, .external_lex_state = 15},
  [2471] = {.lex_state = 52, .external_lex_state = 14},
  [2472] = {.lex_state = 52, .external_lex_state = 15},
  [2473] = {.lex_state = 52, .external_lex_state = 14},
  [2474] = {.lex_state = 8, .external_lex_state = 15},
  [2475] = {.lex_state = 52, .external_lex_state = 19},
  [2476] = {.lex_state = 52, .external_lex_state = 15},
  [2477] = {.lex_state = 8, .external_lex_state = 15},
  [2478] = {.lex_state = 8, .external_lex_state = 15},
  [2479] = {.lex_state = 8, .external_lex_state = 15},
  [2480] = {.lex_state = 52, .external_lex_state = 14},
  [2481] = {.lex_state = 52, .external_lex_state = 15},
  [2482] = {.lex_state = 52, .external_lex_state = 14},
  [2483] = {.lex_state = 52, .external_lex_state = 14},
  [2484] = {.lex_state = 9, .external_lex_state = 17},
  [2485] = {.lex_state = 52, .external_lex_state = 15},
  [2486] = {.lex_state = 52, .external_lex_state = 15},
  [2487] = {.lex_state = 52, .external_lex_state = 15},
  [2488] = {.lex_state = 9, .external_lex_state = 17},
  [2489] = {.lex_state = 52, .external_lex_state = 13},
  [2490] = {.lex_state = 52, .external_lex_state = 15},
  [2491] = {.lex_state = 52, .external_lex_state = 14},
  [2492] = {.lex_state = 52, .external_lex_state = 12},
  [2493] = {.lex_state = 52, .external_lex_state = 15},
  [2494] = {.lex_state = 52, .external_lex_state = 15},
  [2495] = {.lex_state = 52, .external_lex_state = 15},
  [2496] = {.lex_state = 52, .external_lex_state = 13},
  [2497] = {.lex_state = 52, .external_lex_state = 9},
  [2498] = {.lex_state = 52, .external_lex_state = 14},
  [2499] = {.lex_state = 52, .external_lex_state = 14},
  [2500] = {.lex_state = 52, .external_lex_state = 12},
  [2501] = {.lex_state = 52, .external_lex_state = 12},
  [2502] = {.lex_state = 52, .external_lex_state = 13},
  [2503] = {.lex_state = 52, .external_lex_state = 15},
  [2504] = {.lex_state = 52, .external_lex_state = 15},
  [2505] = {.lex_state = 52, .external_lex_state = 12},
  [2506] = {.lex_state = 52, .external_lex_state = 13},
  [2507] = {.lex_state = 52, .external_lex_state = 12},
  [2508] = {.lex_state = 8, .external_lex_state = 15},
  [2509] = {.lex_state = 52, .external_lex_state = 12},
  [2510] = {.lex_state = 8, .external_lex_state = 15},
  [2511] = {.lex_state = 52, .external_lex_state = 14},
  [2512] = {.lex_state = 52, .external_lex_state = 14},
  [2513] = {.lex_state = 52, .external_lex_state = 14},
  [2514] = {.lex_state = 52, .external_lex_state = 12},
  [2515] = {.lex_state = 52, .external_lex_state = 12},
  [2516] = {.lex_state = 52, .external_lex_state = 15},
  [2517] = {.lex_state = 3, .external_lex_state = 12},
  [2518] = {.lex_state = 52, .external_lex_state = 19},
  [2519] = {.lex_state = 52, .external_lex_state = 14},
  [2520] = {.lex_state = 52, .external_lex_state = 14},
  [2521] = {.lex_state = 52, .external_lex_state = 13},
  [2522] = {.lex_state = 52, .external_lex_state = 14},
  [2523] = {.lex_state = 52, .external_lex_state = 14},
  [2524] = {.lex_state = 52, .external_lex_state = 14},
  [2525] = {.lex_state = 52, .external_lex_state = 15},
  [2526] = {.lex_state = 52, .external_lex_state = 15},
  [2527] = {.lex_state = 52, .external_lex_state = 14},
  [2528] = {.lex_state = 52, .external_lex_state = 15},
  [2529] = {.lex_state = 52, .external_lex_state = 15},
  [2530] = {.lex_state = 52, .external_lex_state = 15},
  [2531] = {.lex_state = 52, .external_lex_state = 12},
  [2532] = {.lex_state = 52, .external_lex_state = 12},
  [2533] = {.lex_state = 52, .external_lex_state = 18},
  [2534] = {.lex_state = 52, .external_lex_state = 12},
  [2535] = {.lex_state = 52, .external_lex_state = 18},
  [2536] = {.lex_state = 52, .external_lex_state = 18},
  [2537] = {.lex_state = 52, .external_lex_state = 9},
  [2538] = {.lex_state = 52, .external_lex_state = 18},
  [2539] = {.lex_state = 9, .external_lex_state = 15},
  [2540] = {.lex_state = 52, .external_lex_state = 9},
  [2541] = {.lex_state = 52, .external_lex_state = 18},
  [2542] = {.lex_state = 9, .external_lex_state = 15},
  [2543] = {.lex_state = 52, .external_lex_state = 9},
  [2544] = {.lex_state = 52, .external_lex_state = 9},
  [2545] = {.lex_state = 52, .external_lex_state = 9},
  [2546] = {.lex_state = 52, .external_lex_state = 12},
  [2547] = {.lex_state = 52, .external_lex_state = 9},
  [2548] = {.lex_state = 52, .external_lex_state = 9},
  [2549] = {.lex_state = 52, .external_lex_state = 9},
  [2550] = {.lex_state = 52, .external_lex_state = 13},
  [2551] = {.lex_state = 52, .external_lex_state = 9},
  [2552] = {.lex_state = 52, .external_lex_state = 9},
  [2553] = {.lex_state = 52, .external_lex_state = 15},
  [2554] = {.lex_state = 52, .external_lex_state = 15},
  [2555] = {.lex_state = 52, .external_lex_state = 15},
  [2556] = {.lex_state = 52, .external_lex_state = 15},
  [2557] = {.lex_state = 52, .external_lex_state = 15},
  [2558] = {.lex_state = 52, .external_lex_state = 18},
  [2559] = {.lex_state = 52, .external_lex_state = 15},
  [2560] = {.lex_state = 52, .external_lex_state = 15},
  [2561] = {.lex_state = 52, .external_lex_state = 15},
  [2562] = {.lex_state = 52, .external_lex_state = 15},
  [2563] = {.lex_state = 52, .external_lex_state = 9},
  [2564] = {.lex_state = 52, .external_lex_state = 14},
  [2565] = {.lex_state = 52, .external_lex_state = 15},
  [2566] = {.lex_state = 52, .external_lex_state = 18},
  [2567] = {.lex_state = 52, .external_lex_state = 18},
  [2568] = {.lex_state = 52, .external_lex_state = 14},
  [2569] = {.lex_state = 52, .external_lex_state = 18},
  [2570] = {.lex_state = 52, .external_lex_state = 14},
  [2571] = {.lex_state = 52, .external_lex_state = 18},
  [2572] = {.lex_state = 9, .external_lex_state = 15},
  [2573] = {.lex_state = 52, .external_lex_state = 15},
  [2574] = {.lex_state = 52, .external_lex_state = 9},
  [2575] = {.lex_state = 52, .external_lex_state = 15},
  [2576] = {.lex_state = 52, .external_lex_state = 14},
  [2577] = {.lex_state = 52, .external_lex_state = 13},
  [2578] = {.lex_state = 52, .external_lex_state = 13},
  [2579] = {.lex_state = 52, .external_lex_state = 15},
  [2580] = {.lex_state = 52, .external_lex_state = 13},
  [2581] = {.lex_state = 52, .external_lex_state = 15},
  [2582] = {.lex_state = 9, .external_lex_state = 15},
  [2583] = {.lex_state = 52, .external_lex_state = 18},
  [2584] = {.lex_state = 52, .external_lex_state = 14},
  [2585] = {.lex_state = 52, .external_lex_state = 14},
  [2586] = {.lex_state = 52, .external_lex_state = 18},
  [2587] = {.lex_state = 52, .external_lex_state = 13},
  [2588] = {.lex_state = 52, .external_lex_state = 18},
  [2589] = {.lex_state = 52, .external_lex_state = 15},
  [2590] = {.lex_state = 52, .external_lex_state = 14},
  [2591] = {.lex_state = 52, .external_lex_state = 13},
  [2592] = {.lex_state = 9, .external_lex_state = 15},
  [2593] = {.lex_state = 9, .external_lex_state = 15},
  [2594] = {.lex_state = 9, .external_lex_state = 15},
  [2595] = {.lex_state = 52, .external_lex_state = 14},
  [2596] = {.lex_state = 9, .external_lex_state = 15},
  [2597] = {.lex_state = 52, .external_lex_state = 15},
  [2598] = {.lex_state = 52, .external_lex_state = 18},
  [2599] = {.lex_state = 52, .external_lex_state = 15},
  [2600] = {.lex_state = 52, .external_lex_state = 9},
  [2601] = {.lex_state = 52, .external_lex_state = 14},
  [2602] = {.lex_state = 52, .external_lex_state = 15},
  [2603] = {.lex_state = 52, .external_lex_state = 14},
  [2604] = {.lex_state = 52, .external_lex_state = 14},
  [2605] = {.lex_state = 52, .external_lex_state = 9},
  [2606] = {.lex_state = 52, .external_lex_state = 14},
  [2607] = {.lex_state = 52, .external_lex_state = 13},
  [2608] = {.lex_state = 52, .external_lex_state = 9},
  [2609] = {.lex_state = 52, .external_lex_state = 18},
  [2610] = {.lex_state = 52, .external_lex_state = 15},
  [2611] = {.lex_state = 52, .external_lex_state = 9},
  [2612] = {.lex_state = 52, .external_lex_state = 13},
  [2613] = {.lex_state = 52, .external_lex_state = 9},
  [2614] = {.lex_state = 9, .external_lex_state = 15},
  [2615] = {.lex_state = 52, .external_lex_state = 9},
  [2616] = {.lex_state = 52, .external_lex_state = 15},
  [2617] = {.lex_state = 52, .external_lex_state = 14},
  [2618] = {.lex_state = 52, .external_lex_state = 15},
  [2619] = {.lex_state = 52, .external_lex_state = 15},
  [2620] = {.lex_state = 52, .external_lex_state = 15},
  [2621] = {.lex_state = 52, .external_lex_state = 18},
  [2622] = {.lex_state = 52, .external_lex_state = 18},
  [2623] = {.lex_state = 52, .external_lex_state = 12},
  [2624] = {.lex_state = 52, .external_lex_state = 14},
  [2625] = {.lex_state = 52, .external_lex_state = 14},
  [2626] = {.lex_state = 52, .external_lex_state = 18},
  [2627] = {.lex_state = 52, .external_lex_state = 13},
  [2628] = {.lex_state = 9, .external_lex_state = 15},
  [2629] = {.lex_state = 52, .external_lex_state = 15},
  [2630] = {.lex_state = 52, .external_lex_state = 12},
  [2631] = {.lex_state = 52, .external_lex_state = 15},
  [2632] = {.lex_state = 4, .external_lex_state = 15},
  [2633] = {.lex_state = 52, .external_lex_state = 12},
  [2634] = {.lex_state = 52, .external_lex_state = 14},
  [2635] = {.lex_state = 52, .external_lex_state = 15},
  [2636] = {.lex_state = 52, .external_lex_state = 14},
  [2637] = {.lex_state = 52, .external_lex_state = 15},
  [2638] = {.lex_state = 52, .external_lex_state = 12},
  [2639] = {.lex_state = 52, .external_lex_state = 13},
  [2640] = {.lex_state = 52, .external_lex_state = 12},
  [2641] = {.lex_state = 52, .external_lex_state = 15},
  [2642] = {.lex_state = 52, .external_lex_state = 15},
  [2643] = {.lex_state = 52, .external_lex_state = 12},
  [2644] = {.lex_state = 52, .external_lex_state = 15},
  [2645] = {.lex_state = 52, .external_lex_state = 15},
  [2646] = {.lex_state = 52, .external_lex_state = 14},
  [2647] = {.lex_state = 52, .external_lex_state = 15},
  [2648] = {.lex_state = 52, .external_lex_state = 14},
  [2649] = {.lex_state = 52, .external_lex_state = 15},
  [2650] = {.lex_state = 52, .external_lex_state = 14},
  [2651] = {.lex_state = 52, .external_lex_state = 13},
  [2652] = {.lex_state = 52, .external_lex_state = 13},
  [2653] = {.lex_state = 52, .external_lex_state = 13},
  [2654] = {.lex_state = 52, .external_lex_state = 12},
  [2655] = {.lex_state = 52, .external_lex_state = 12},
  [2656] = {.lex_state = 52, .external_lex_state = 15},
  [2657] = {.lex_state = 52, .external_lex_state = 15},
  [2658] = {.lex_state = 52, .external_lex_state = 14},
  [2659] = {.lex_state = 52, .external_lex_state = 13},
  [2660] = {.lex_state = 52, .external_lex_state = 15},
  [2661] = {.lex_state = 52, .external_lex_state = 15},
  [2662] = {.lex_state = 52, .external_lex_state = 12},
  [2663] = {.lex_state = 52, .external_lex_state = 15},
  [2664] = {.lex_state = 52, .external_lex_state = 15},
  [2665] = {.lex_state = 52, .external_lex_state = 12},
  [2666] = {.lex_state = 52, .external_lex_state = 15},
  [2667] = {.lex_state = 52, .external_lex_state = 12},
  [2668] = {.lex_state = 52, .external_lex_state = 14},
  [2669] = {.lex_state = 52, .external_lex_state = 15},
  [2670] = {.lex_state = 52, .external_lex_state = 15},
  [2671] = {.lex_state = 52, .external_lex_state = 15},
  [2672] = {.lex_state = 52, .external_lex_state = 15},
  [2673] = {.lex_state = 52, .external_lex_state = 15},
  [2674] = {.lex_state = 52, .external_lex_state = 15},
  [2675] = {.lex_state = 52, .external_lex_state = 15},
  [2676] = {.lex_state = 52, .external_lex_state = 13},
  [2677] = {.lex_state = 52, .external_lex_state = 13},
  [2678] = {.lex_state = 52, .external_lex_state = 13},
  [2679] = {.lex_state = 52, .external_lex_state = 14},
  [2680] = {.lex_state = 52, .external_lex_state = 12},
  [2681] = {.lex_state = 52, .external_lex_state = 15},
  [2682] = {.lex_state = 52, .external_lex_state = 15},
  [2683] = {.lex_state = 52, .external_lex_state = 12},
  [2684] = {.lex_state = 52, .external_lex_state = 15},
  [2685] = {.lex_state = 52, .external_lex_state = 14},
  [2686] = {.lex_state = 4, .external_lex_state = 15},
  [2687] = {.lex_state = 52, .external_lex_state = 15},
  [2688] = {.lex_state = 52, .external_lex_state = 13},
  [2689] = {.lex_state = 52, .external_lex_state = 14},
  [2690] = {.lex_state = 52, .external_lex_state = 14},
  [2691] = {.lex_state = 52, .external_lex_state = 15},
  [2692] = {.lex_state = 52, .external_lex_state = 15},
  [2693] = {.lex_state = 52, .external_lex_state = 12},
  [2694] = {.lex_state = 52, .external_lex_state = 12},
  [2695] = {.lex_state = 52, .external_lex_state = 15},
  [2696] = {.lex_state = 52, .external_lex_state = 13},
  [2697] = {.lex_state = 52, .external_lex_state = 12},
  [2698] = {.lex_state = 52, .external_lex_state = 12},
  [2699] = {.lex_state = 4, .external_lex_state = 15},
  [2700] = {.lex_state = 52, .external_lex_state = 12},
  [2701] = {.lex_state = 52, .external_lex_state = 15},
  [2702] = {.lex_state = 52, .external_lex_state = 13},
  [2703] = {.lex_state = 52, .external_lex_state = 12},
  [2704] = {.lex_state = 52, .external_lex_state = 15},
  [2705] = {.lex_state = 52, .external_lex_state = 15},
  [2706] = {.lex_state = 52, .external_lex_state = 14},
  [2707] = {.lex_state = 52, .external_lex_state = 15},
  [2708] = {.lex_state = 52, .external_lex_state = 15},
  [2709] = {.lex_state = 52, .external_lex_state = 15},
  [2710] = {.lex_state = 52, .external_lex_state = 15},
  [2711] = {.lex_state = 52, .external_lex_state = 12},
  [2712] = {.lex_state = 52, .external_lex_state = 15},
  [2713] = {.lex_state = 52, .external_lex_state = 15},
  [2714] = {.lex_state = 52, .external_lex_state = 14},
  [2715] = {.lex_state = 52, .external_lex_state = 15},
  [2716] = {.lex_state = 52, .external_lex_state = 14},
  [2717] = {.lex_state = 52, .external_lex_state = 15},
  [2718] = {.lex_state = 52, .external_lex_state = 15},
  [2719] = {.lex_state = 52, .external_lex_state = 12},
  [2720] = {.lex_state = 52, .external_lex_state = 15},
  [2721] = {.lex_state = 52, .external_lex_state = 13},
  [2722] = {.lex_state = 52, .external_lex_state = 15},
  [2723] = {.lex_state = 52, .external_lex_state = 15},
  [2724] = {.lex_state = 52, .external_lex_state = 15},
  [2725] = {.lex_state = 52, .external_lex_state = 15},
  [2726] = {.lex_state = 52, .external_lex_state = 13},
  [2727] = {.lex_state = 52, .external_lex_state = 15},
  [2728] = {.lex_state = 52, .external_lex_state = 15},
  [2729] = {.lex_state = 52, .external_lex_state = 15},
  [2730] = {.lex_state = 52, .external_lex_state = 14},
  [2731] = {.lex_state = 52, .external_lex_state = 15},
  [2732] = {.lex_state = 52, .external_lex_state = 15},
  [2733] = {.lex_state = 52, .external_lex_state = 15},
  [2734] = {.lex_state = 52, .external_lex_state = 12},
  [2735] = {.lex_state = 52, .external_lex_state = 13},
  [2736] = {.lex_state = 52, .external_lex_state = 14},
  [2737] = {.lex_state = 4, .external_lex_state = 15},
  [2738] = {.lex_state = 52, .external_lex_state = 14},
  [2739] = {.lex_state = 52, .external_lex_state = 15},
  [2740] = {.lex_state = 52, .external_lex_state = 12},
  [2741] = {.lex_state = 52, .external_lex_state = 15},
  [2742] = {.lex_state = 52, .external_lex_state = 12},
  [2743] = {.lex_state = 52, .external_lex_state = 15},
  [2744] = {.lex_state = 52, .external_lex_state = 12},
  [2745] = {.lex_state = 52, .external_lex_state = 15},
  [2746] = {.lex_state = 52, .external_lex_state = 15},
  [2747] = {.lex_state = 52, .external_lex_state = 12},
  [2748] = {.lex_state = 52, .external_lex_state = 15},
  [2749] = {.lex_state = 52, .external_lex_state = 12},
  [2750] = {.lex_state = 52, .external_lex_state = 15},
  [2751] = {.lex_state = 52, .external_lex_state = 12},
  [2752] = {.lex_state = 52, .external_lex_state = 14},
  [2753] = {.lex_state = 52, .external_lex_state = 15},
  [2754] = {.lex_state = 52, .external_lex_state = 14},
  [2755] = {.lex_state = 52, .external_lex_state = 13},
  [2756] = {.lex_state = 52, .external_lex_state = 15},
  [2757] = {.lex_state = 52, .external_lex_state = 15},
  [2758] = {.lex_state = 52, .external_lex_state = 15},
  [2759] = {.lex_state = 52, .external_lex_state = 15},
  [2760] = {.lex_state = 52, .external_lex_state = 15},
  [2761] = {.lex_state = 52, .external_lex_state = 12},
  [2762] = {.lex_state = 52, .external_lex_state = 13},
  [2763] = {.lex_state = 52, .external_lex_state = 12},
  [2764] = {.lex_state = 52, .external_lex_state = 12},
  [2765] = {.lex_state = 52, .external_lex_state = 14},
  [2766] = {.lex_state = 52, .external_lex_state = 15},
  [2767] = {.lex_state = 52, .external_lex_state = 15},
  [2768] = {.lex_state = 52, .external_lex_state = 14},
  [2769] = {.lex_state = 52, .external_lex_state = 12},
  [2770] = {.lex_state = 52, .external_lex_state = 12},
  [2771] = {.lex_state = 52, .external_lex_state = 12},
  [2772] = {.lex_state = 52, .external_lex_state = 14},
  [2773] = {.lex_state = 52, .external_lex_state = 12},
  [2774] = {.lex_state = 52, .external_lex_state = 13},
  [2775] = {.lex_state = 52, .external_lex_state = 15},
  [2776] = {.lex_state = 52, .external_lex_state = 14},
  [2777] = {.lex_state = 52, .external_lex_state = 14},
  [2778] = {.lex_state = 52, .external_lex_state = 15},
  [2779] = {.lex_state = 52, .external_lex_state = 15},
  [2780] = {.lex_state = 52, .external_lex_state = 12},
  [2781] = {.lex_state = 52, .external_lex_state = 15},
  [2782] = {.lex_state = 52, .external_lex_state = 15},
  [2783] = {.lex_state = 4, .external_lex_state = 15},
  [2784] = {.lex_state = 52, .external_lex_state = 15},
  [2785] = {.lex_state = 52, .external_lex_state = 15},
  [2786] = {.lex_state = 52, .external_lex_state = 15},
  [2787] = {.lex_state = 52, .external_lex_state = 12},
  [2788] = {.lex_state = 52, .external_lex_state = 12},
  [2789] = {.lex_state = 52, .external_lex_state = 14},
  [2790] = {.lex_state = 52, .external_lex_state = 14},
  [2791] = {.lex_state = 52, .external_lex_state = 13},
  [2792] = {.lex_state = 52, .external_lex_state = 15},
  [2793] = {.lex_state = 52, .external_lex_state = 14},
  [2794] = {.lex_state = 52, .external_lex_state = 15},
  [2795] = {.lex_state = 52, .external_lex_state = 15},
  [2796] = {.lex_state = 52, .external_lex_state = 15},
  [2797] = {.lex_state = 52, .external_lex_state = 15},
  [2798] = {.lex_state = 52, .external_lex_state = 14},
  [2799] = {.lex_state = 52, .external_lex_state = 12},
  [2800] = {.lex_state = 52, .external_lex_state = 15},
  [2801] = {.lex_state = 52, .external_lex_state = 12},
  [2802] = {.lex_state = 52, .external_lex_state = 14},
  [2803] = {.lex_state = 52, .external_lex_state = 15},
  [2804] = {.lex_state = 52, .external_lex_state = 14},
  [2805] = {.lex_state = 52, .external_lex_state = 15},
  [2806] = {.lex_state = 4, .external_lex_state = 15},
  [2807] = {.lex_state = 52, .external_lex_state = 15},
  [2808] = {.lex_state = 52, .external_lex_state = 14},
  [2809] = {.lex_state = 52, .external_lex_state = 15},
  [2810] = {.lex_state = 52, .external_lex_state = 15},
  [2811] = {.lex_state = 52, .external_lex_state = 15},
  [2812] = {.lex_state = 52, .external_lex_state = 15},
  [2813] = {.lex_state = 52, .external_lex_state = 15},
  [2814] = {.lex_state = 4, .external_lex_state = 15},
  [2815] = {.lex_state = 52, .external_lex_state = 13},
  [2816] = {.lex_state = 52, .external_lex_state = 12},
  [2817] = {.lex_state = 4, .external_lex_state = 15},
  [2818] = {.lex_state = 52, .external_lex_state = 13},
  [2819] = {.lex_state = 52, .external_lex_state = 15},
  [2820] = {.lex_state = 52, .external_lex_state = 15},
  [2821] = {.lex_state = 52, .external_lex_state = 15},
  [2822] = {.lex_state = 52, .external_lex_state = 15},
  [2823] = {.lex_state = 52, .external_lex_state = 15},
  [2824] = {.lex_state = 52, .external_lex_state = 15},
  [2825] = {.lex_state = 52, .external_lex_state = 14},
  [2826] = {.lex_state = 52, .external_lex_state = 15},
  [2827] = {.lex_state = 52, .external_lex_state = 15},
  [2828] = {.lex_state = 52, .external_lex_state = 13},
  [2829] = {.lex_state = 52, .external_lex_state = 15},
  [2830] = {.lex_state = 52, .external_lex_state = 15},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_except_STAR] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(5),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym_string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_escape_interpolation] = ACTIONS(1),
    [sym_string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(2709),
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1832),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1832),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_match] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_def] = ACTIONS(49),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(81),
  },
  [2] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(1861),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym_string_start] = ACTIONS(81),
  },
  [3] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(611),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [4] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(709),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [5] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(783),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [6] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(800),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [7] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(730),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [8] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(769),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [9] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(776),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [10] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(850),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [11] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(833),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [12] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(705),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [13] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(688),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [14] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(732),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [15] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(736),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [16] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(737),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [17] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(721),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [18] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(708),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [19] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(747),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [20] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(670),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [21] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(673),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [22] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(750),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [23] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(707),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [24] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(2536),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [25] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(754),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [26] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(757),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [27] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(2622),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [28] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(2533),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [29] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(758),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [30] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(1830),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym_string_start] = ACTIONS(81),
  },
  [31] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(681),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [32] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(2566),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [33] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(2567),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [34] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(2571),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [35] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(621),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [36] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(713),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [37] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(794),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [38] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(796),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [39] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(805),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [40] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(812),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [41] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(814),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [42] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(816),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [43] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(820),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [44] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(717),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [45] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(654),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym_string_start] = ACTIONS(81),
  },
  [46] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(825),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [47] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(828),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [48] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(829),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [49] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(726),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [50] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(720),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [51] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(835),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [52] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(686),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym_string_start] = ACTIONS(81),
  },
  [53] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(687),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(81),
  },
  [54] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(837),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [55] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(700),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [56] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(841),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [57] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(843),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [58] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(844),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [59] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(685),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym_string_start] = ACTIONS(81),
  },
  [60] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(691),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(81),
  },
  [61] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(1806),
    [sym_block] = STATE(680),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [62] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(117),
    [anon_sym_import] = ACTIONS(120),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(126),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_print] = ACTIONS(132),
    [anon_sym_assert] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(138),
    [anon_sym_del] = ACTIONS(141),
    [anon_sym_raise] = ACTIONS(144),
    [anon_sym_pass] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(150),
    [anon_sym_continue] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(156),
    [anon_sym_match] = ACTIONS(159),
    [anon_sym_async] = ACTIONS(162),
    [anon_sym_for] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(168),
    [anon_sym_try] = ACTIONS(171),
    [anon_sym_with] = ACTIONS(174),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_nonlocal] = ACTIONS(183),
    [anon_sym_exec] = ACTIONS(186),
    [anon_sym_type] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_AT] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_LBRACE] = ACTIONS(204),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_not] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(201),
    [anon_sym_lambda] = ACTIONS(210),
    [anon_sym_yield] = ACTIONS(213),
    [sym_ellipsis] = ACTIONS(216),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(222),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [sym_none] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(225),
    [sym_string_start] = ACTIONS(227),
  },
  [63] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1832),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1832),
    [ts_builtin_sym_end] = ACTIONS(230),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_match] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_def] = ACTIONS(49),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(81),
  },
  [64] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1832),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1832),
    [ts_builtin_sym_end] = ACTIONS(225),
    [sym_identifier] = ACTIONS(117),
    [anon_sym_import] = ACTIONS(120),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(126),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_print] = ACTIONS(132),
    [anon_sym_assert] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(138),
    [anon_sym_del] = ACTIONS(141),
    [anon_sym_raise] = ACTIONS(144),
    [anon_sym_pass] = ACTIONS(147),
    [anon_sym_break] = ACTIONS(150),
    [anon_sym_continue] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(232),
    [anon_sym_match] = ACTIONS(235),
    [anon_sym_async] = ACTIONS(238),
    [anon_sym_for] = ACTIONS(241),
    [anon_sym_while] = ACTIONS(244),
    [anon_sym_try] = ACTIONS(247),
    [anon_sym_with] = ACTIONS(250),
    [anon_sym_def] = ACTIONS(253),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_nonlocal] = ACTIONS(183),
    [anon_sym_exec] = ACTIONS(186),
    [anon_sym_type] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(256),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_AT] = ACTIONS(198),
    [anon_sym_DASH] = ACTIONS(201),
    [anon_sym_LBRACE] = ACTIONS(204),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_not] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(201),
    [anon_sym_lambda] = ACTIONS(210),
    [anon_sym_yield] = ACTIONS(213),
    [sym_ellipsis] = ACTIONS(216),
    [sym_integer] = ACTIONS(219),
    [sym_float] = ACTIONS(216),
    [anon_sym_await] = ACTIONS(222),
    [sym_true] = ACTIONS(219),
    [sym_false] = ACTIONS(219),
    [sym_none] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(227),
  },
  [65] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(259),
    [sym_string_start] = ACTIONS(81),
  },
  [66] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(261),
    [sym_string_start] = ACTIONS(81),
  },
  [67] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(263),
    [sym_string_start] = ACTIONS(81),
  },
  [68] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(265),
    [sym_string_start] = ACTIONS(81),
  },
  [69] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(267),
    [sym_string_start] = ACTIONS(81),
  },
  [70] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(269),
    [sym_string_start] = ACTIONS(81),
  },
  [71] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(271),
    [sym_string_start] = ACTIONS(81),
  },
  [72] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1806),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1806),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(273),
    [sym_string_start] = ACTIONS(81),
  },
  [73] = {
    [sym_named_expression] = STATE(1756),
    [sym__named_expression_lhs] = STATE(2783),
    [sym_list_splat_pattern] = STATE(1348),
    [sym_as_pattern] = STATE(1756),
    [sym_expression] = STATE(1775),
    [sym_primary_expression] = STATE(1040),
    [sym_not_operator] = STATE(1756),
    [sym_boolean_operator] = STATE(1756),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_comparison_operator] = STATE(1756),
    [sym_lambda] = STATE(1756),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_type] = STATE(2190),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_conditional_expression] = STATE(1756),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(296),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(304),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_not] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [74] = {
    [sym_named_expression] = STATE(1756),
    [sym__named_expression_lhs] = STATE(2783),
    [sym_list_splat_pattern] = STATE(1348),
    [sym_as_pattern] = STATE(1756),
    [sym_expression] = STATE(1775),
    [sym_primary_expression] = STATE(1040),
    [sym_not_operator] = STATE(1756),
    [sym_boolean_operator] = STATE(1756),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_comparison_operator] = STATE(1756),
    [sym_lambda] = STATE(1756),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_type] = STATE(2190),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_conditional_expression] = STATE(1756),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(296),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(304),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_not] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [75] = {
    [sym__simple_statements] = STATE(735),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(349),
    [sym__indent] = ACTIONS(351),
    [sym_string_start] = ACTIONS(81),
  },
  [76] = {
    [sym__simple_statements] = STATE(746),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(353),
    [sym__indent] = ACTIONS(355),
    [sym_string_start] = ACTIONS(81),
  },
  [77] = {
    [sym__simple_statements] = STATE(827),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(357),
    [sym__indent] = ACTIONS(359),
    [sym_string_start] = ACTIONS(81),
  },
  [78] = {
    [sym__simple_statements] = STATE(842),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym__indent] = ACTIONS(363),
    [sym_string_start] = ACTIONS(81),
  },
  [79] = {
    [sym__simple_statements] = STATE(834),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(365),
    [sym__indent] = ACTIONS(367),
    [sym_string_start] = ACTIONS(81),
  },
  [80] = {
    [sym__simple_statements] = STATE(838),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__indent] = ACTIONS(371),
    [sym_string_start] = ACTIONS(81),
  },
  [81] = {
    [sym__simple_statements] = STATE(755),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(373),
    [sym__indent] = ACTIONS(375),
    [sym_string_start] = ACTIONS(81),
  },
  [82] = {
    [sym__simple_statements] = STATE(751),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(637),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(636),
    [sym_subscript] = STATE(636),
    [sym_call] = STATE(1121),
    [sym_type] = STATE(2115),
    [sym_splat_type] = STATE(2070),
    [sym_generic_type] = STATE(2070),
    [sym_union_type] = STATE(2070),
    [sym_constrained_type] = STATE(2070),
    [sym_member_type] = STATE(2070),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(377),
    [sym__indent] = ACTIONS(379),
    [sym_string_start] = ACTIONS(81),
  },
  [83] = {
    [sym_chevron] = STATE(2153),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_list_splat_pattern] = STATE(1062),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1841),
    [sym_primary_expression] = STATE(975),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_attribute] = STATE(1121),
    [sym_subscript] = STATE(1121),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_async] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(404),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [84] = {
    [sym_chevron] = STATE(2153),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_list_splat_pattern] = STATE(1062),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1841),
    [sym_primary_expression] = STATE(975),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_attribute] = STATE(1121),
    [sym_subscript] = STATE(1121),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_async] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(404),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [85] = {
    [sym_named_expression] = STATE(1756),
    [sym__named_expression_lhs] = STATE(2783),
    [sym_list_splat_pattern] = STATE(1348),
    [sym_as_pattern] = STATE(1756),
    [sym_expression] = STATE(1876),
    [sym_primary_expression] = STATE(1040),
    [sym_not_operator] = STATE(1756),
    [sym_boolean_operator] = STATE(1756),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_comparison_operator] = STATE(1756),
    [sym_lambda] = STATE(1756),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_conditional_expression] = STATE(1756),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_not] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [86] = {
    [sym_named_expression] = STATE(1756),
    [sym__named_expression_lhs] = STATE(2783),
    [sym_list_splat_pattern] = STATE(1348),
    [sym_as_pattern] = STATE(1756),
    [sym_expression] = STATE(1885),
    [sym_primary_expression] = STATE(1040),
    [sym_not_operator] = STATE(1756),
    [sym_boolean_operator] = STATE(1756),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_comparison_operator] = STATE(1756),
    [sym_lambda] = STATE(1756),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_conditional_expression] = STATE(1756),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_not] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [87] = {
    [sym__simple_statements] = STATE(2621),
    [sym_import_statement] = STATE(2268),
    [sym_future_import_statement] = STATE(2268),
    [sym_import_from_statement] = STATE(2268),
    [sym_print_statement] = STATE(2268),
    [sym_assert_statement] = STATE(2268),
    [sym_expression_statement] = STATE(2268),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2268),
    [sym_delete_statement] = STATE(2268),
    [sym_raise_statement] = STATE(2268),
    [sym_pass_statement] = STATE(2268),
    [sym_break_statement] = STATE(2268),
    [sym_continue_statement] = STATE(2268),
    [sym_global_statement] = STATE(2268),
    [sym_nonlocal_statement] = STATE(2268),
    [sym_exec_statement] = STATE(2268),
    [sym_type_alias_statement] = STATE(2268),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(420),
    [sym__indent] = ACTIONS(422),
    [sym_string_start] = ACTIONS(81),
  },
  [88] = {
    [sym__simple_statements] = STATE(2538),
    [sym_import_statement] = STATE(2268),
    [sym_future_import_statement] = STATE(2268),
    [sym_import_from_statement] = STATE(2268),
    [sym_print_statement] = STATE(2268),
    [sym_assert_statement] = STATE(2268),
    [sym_expression_statement] = STATE(2268),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2268),
    [sym_delete_statement] = STATE(2268),
    [sym_raise_statement] = STATE(2268),
    [sym_pass_statement] = STATE(2268),
    [sym_break_statement] = STATE(2268),
    [sym_continue_statement] = STATE(2268),
    [sym_global_statement] = STATE(2268),
    [sym_nonlocal_statement] = STATE(2268),
    [sym_exec_statement] = STATE(2268),
    [sym_type_alias_statement] = STATE(2268),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(424),
    [sym__indent] = ACTIONS(426),
    [sym_string_start] = ACTIONS(81),
  },
  [89] = {
    [sym__simple_statements] = STATE(806),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(428),
    [sym__indent] = ACTIONS(430),
    [sym_string_start] = ACTIONS(81),
  },
  [90] = {
    [sym__simple_statements] = STATE(715),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(432),
    [sym__indent] = ACTIONS(434),
    [sym_string_start] = ACTIONS(81),
  },
  [91] = {
    [sym__simple_statements] = STATE(694),
    [sym_import_statement] = STATE(2389),
    [sym_future_import_statement] = STATE(2389),
    [sym_import_from_statement] = STATE(2389),
    [sym_print_statement] = STATE(2389),
    [sym_assert_statement] = STATE(2389),
    [sym_expression_statement] = STATE(2389),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2389),
    [sym_delete_statement] = STATE(2389),
    [sym_raise_statement] = STATE(2389),
    [sym_pass_statement] = STATE(2389),
    [sym_break_statement] = STATE(2389),
    [sym_continue_statement] = STATE(2389),
    [sym_global_statement] = STATE(2389),
    [sym_nonlocal_statement] = STATE(2389),
    [sym_exec_statement] = STATE(2389),
    [sym_type_alias_statement] = STATE(2389),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(436),
    [sym__indent] = ACTIONS(438),
    [sym_string_start] = ACTIONS(81),
  },
  [92] = {
    [sym__simple_statements] = STATE(808),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(440),
    [sym__indent] = ACTIONS(442),
    [sym_string_start] = ACTIONS(81),
  },
  [93] = {
    [sym__simple_statements] = STATE(699),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(444),
    [sym__indent] = ACTIONS(446),
    [sym_string_start] = ACTIONS(81),
  },
  [94] = {
    [sym__simple_statements] = STATE(813),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(448),
    [sym__indent] = ACTIONS(450),
    [sym_string_start] = ACTIONS(81),
  },
  [95] = {
    [sym__simple_statements] = STATE(792),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(452),
    [sym__indent] = ACTIONS(454),
    [sym_string_start] = ACTIONS(81),
  },
  [96] = {
    [sym__simple_statements] = STATE(815),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(456),
    [sym__indent] = ACTIONS(458),
    [sym_string_start] = ACTIONS(81),
  },
  [97] = {
    [sym__simple_statements] = STATE(703),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(460),
    [sym__indent] = ACTIONS(462),
    [sym_string_start] = ACTIONS(81),
  },
  [98] = {
    [sym__simple_statements] = STATE(725),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(464),
    [sym__indent] = ACTIONS(466),
    [sym_string_start] = ACTIONS(81),
  },
  [99] = {
    [sym__simple_statements] = STATE(718),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(468),
    [sym__indent] = ACTIONS(470),
    [sym_string_start] = ACTIONS(81),
  },
  [100] = {
    [sym__simple_statements] = STATE(723),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(472),
    [sym__indent] = ACTIONS(474),
    [sym_string_start] = ACTIONS(81),
  },
  [101] = {
    [sym__simple_statements] = STATE(821),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(476),
    [sym__indent] = ACTIONS(478),
    [sym_string_start] = ACTIONS(81),
  },
  [102] = {
    [sym__simple_statements] = STATE(1863),
    [sym_import_statement] = STATE(2407),
    [sym_future_import_statement] = STATE(2407),
    [sym_import_from_statement] = STATE(2407),
    [sym_print_statement] = STATE(2407),
    [sym_assert_statement] = STATE(2407),
    [sym_expression_statement] = STATE(2407),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2407),
    [sym_delete_statement] = STATE(2407),
    [sym_raise_statement] = STATE(2407),
    [sym_pass_statement] = STATE(2407),
    [sym_break_statement] = STATE(2407),
    [sym_continue_statement] = STATE(2407),
    [sym_global_statement] = STATE(2407),
    [sym_nonlocal_statement] = STATE(2407),
    [sym_exec_statement] = STATE(2407),
    [sym_type_alias_statement] = STATE(2407),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(480),
    [sym__indent] = ACTIONS(482),
    [sym_string_start] = ACTIONS(81),
  },
  [103] = {
    [sym__simple_statements] = STATE(802),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(484),
    [sym__indent] = ACTIONS(486),
    [sym_string_start] = ACTIONS(81),
  },
  [104] = {
    [sym__simple_statements] = STATE(667),
    [sym_import_statement] = STATE(2389),
    [sym_future_import_statement] = STATE(2389),
    [sym_import_from_statement] = STATE(2389),
    [sym_print_statement] = STATE(2389),
    [sym_assert_statement] = STATE(2389),
    [sym_expression_statement] = STATE(2389),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2389),
    [sym_delete_statement] = STATE(2389),
    [sym_raise_statement] = STATE(2389),
    [sym_pass_statement] = STATE(2389),
    [sym_break_statement] = STATE(2389),
    [sym_continue_statement] = STATE(2389),
    [sym_global_statement] = STATE(2389),
    [sym_nonlocal_statement] = STATE(2389),
    [sym_exec_statement] = STATE(2389),
    [sym_type_alias_statement] = STATE(2389),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(488),
    [sym__indent] = ACTIONS(490),
    [sym_string_start] = ACTIONS(81),
  },
  [105] = {
    [sym__simple_statements] = STATE(674),
    [sym_import_statement] = STATE(2423),
    [sym_future_import_statement] = STATE(2423),
    [sym_import_from_statement] = STATE(2423),
    [sym_print_statement] = STATE(2423),
    [sym_assert_statement] = STATE(2423),
    [sym_expression_statement] = STATE(2423),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2423),
    [sym_delete_statement] = STATE(2423),
    [sym_raise_statement] = STATE(2423),
    [sym_pass_statement] = STATE(2423),
    [sym_break_statement] = STATE(2423),
    [sym_continue_statement] = STATE(2423),
    [sym_global_statement] = STATE(2423),
    [sym_nonlocal_statement] = STATE(2423),
    [sym_exec_statement] = STATE(2423),
    [sym_type_alias_statement] = STATE(2423),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(492),
    [sym__indent] = ACTIONS(494),
    [sym_string_start] = ACTIONS(81),
  },
  [106] = {
    [sym__simple_statements] = STATE(704),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(496),
    [sym__indent] = ACTIONS(498),
    [sym_string_start] = ACTIONS(81),
  },
  [107] = {
    [sym__simple_statements] = STATE(766),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(500),
    [sym__indent] = ACTIONS(502),
    [sym_string_start] = ACTIONS(81),
  },
  [108] = {
    [sym__simple_statements] = STATE(824),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(504),
    [sym__indent] = ACTIONS(506),
    [sym_string_start] = ACTIONS(81),
  },
  [109] = {
    [sym__simple_statements] = STATE(738),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(508),
    [sym__indent] = ACTIONS(510),
    [sym_string_start] = ACTIONS(81),
  },
  [110] = {
    [sym__simple_statements] = STATE(719),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(512),
    [sym__indent] = ACTIONS(514),
    [sym_string_start] = ACTIONS(81),
  },
  [111] = {
    [sym__simple_statements] = STATE(781),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(516),
    [sym__indent] = ACTIONS(518),
    [sym_string_start] = ACTIONS(81),
  },
  [112] = {
    [sym__simple_statements] = STATE(701),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(520),
    [sym__indent] = ACTIONS(522),
    [sym_string_start] = ACTIONS(81),
  },
  [113] = {
    [sym__simple_statements] = STATE(625),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(524),
    [sym__indent] = ACTIONS(526),
    [sym_string_start] = ACTIONS(81),
  },
  [114] = {
    [sym__simple_statements] = STATE(711),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(528),
    [sym__indent] = ACTIONS(530),
    [sym_string_start] = ACTIONS(81),
  },
  [115] = {
    [sym__simple_statements] = STATE(690),
    [sym_import_statement] = STATE(2273),
    [sym_future_import_statement] = STATE(2273),
    [sym_import_from_statement] = STATE(2273),
    [sym_print_statement] = STATE(2273),
    [sym_assert_statement] = STATE(2273),
    [sym_expression_statement] = STATE(2273),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2273),
    [sym_delete_statement] = STATE(2273),
    [sym_raise_statement] = STATE(2273),
    [sym_pass_statement] = STATE(2273),
    [sym_break_statement] = STATE(2273),
    [sym_continue_statement] = STATE(2273),
    [sym_global_statement] = STATE(2273),
    [sym_nonlocal_statement] = STATE(2273),
    [sym_exec_statement] = STATE(2273),
    [sym_type_alias_statement] = STATE(2273),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(532),
    [sym__indent] = ACTIONS(534),
    [sym_string_start] = ACTIONS(81),
  },
  [116] = {
    [sym__simple_statements] = STATE(2609),
    [sym_import_statement] = STATE(2268),
    [sym_future_import_statement] = STATE(2268),
    [sym_import_from_statement] = STATE(2268),
    [sym_print_statement] = STATE(2268),
    [sym_assert_statement] = STATE(2268),
    [sym_expression_statement] = STATE(2268),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2268),
    [sym_delete_statement] = STATE(2268),
    [sym_raise_statement] = STATE(2268),
    [sym_pass_statement] = STATE(2268),
    [sym_break_statement] = STATE(2268),
    [sym_continue_statement] = STATE(2268),
    [sym_global_statement] = STATE(2268),
    [sym_nonlocal_statement] = STATE(2268),
    [sym_exec_statement] = STATE(2268),
    [sym_type_alias_statement] = STATE(2268),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(536),
    [sym__indent] = ACTIONS(538),
    [sym_string_start] = ACTIONS(81),
  },
  [117] = {
    [sym__simple_statements] = STATE(752),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(540),
    [sym__indent] = ACTIONS(542),
    [sym_string_start] = ACTIONS(81),
  },
  [118] = {
    [sym__simple_statements] = STATE(779),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(544),
    [sym__indent] = ACTIONS(546),
    [sym_string_start] = ACTIONS(81),
  },
  [119] = {
    [sym__simple_statements] = STATE(2541),
    [sym_import_statement] = STATE(2268),
    [sym_future_import_statement] = STATE(2268),
    [sym_import_from_statement] = STATE(2268),
    [sym_print_statement] = STATE(2268),
    [sym_assert_statement] = STATE(2268),
    [sym_expression_statement] = STATE(2268),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2268),
    [sym_delete_statement] = STATE(2268),
    [sym_raise_statement] = STATE(2268),
    [sym_pass_statement] = STATE(2268),
    [sym_break_statement] = STATE(2268),
    [sym_continue_statement] = STATE(2268),
    [sym_global_statement] = STATE(2268),
    [sym_nonlocal_statement] = STATE(2268),
    [sym_exec_statement] = STATE(2268),
    [sym_type_alias_statement] = STATE(2268),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(548),
    [sym__indent] = ACTIONS(550),
    [sym_string_start] = ACTIONS(81),
  },
  [120] = {
    [sym__simple_statements] = STATE(741),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(552),
    [sym__indent] = ACTIONS(554),
    [sym_string_start] = ACTIONS(81),
  },
  [121] = {
    [sym__simple_statements] = STATE(780),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(556),
    [sym__indent] = ACTIONS(558),
    [sym_string_start] = ACTIONS(81),
  },
  [122] = {
    [sym__simple_statements] = STATE(679),
    [sym_import_statement] = STATE(2389),
    [sym_future_import_statement] = STATE(2389),
    [sym_import_from_statement] = STATE(2389),
    [sym_print_statement] = STATE(2389),
    [sym_assert_statement] = STATE(2389),
    [sym_expression_statement] = STATE(2389),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2389),
    [sym_delete_statement] = STATE(2389),
    [sym_raise_statement] = STATE(2389),
    [sym_pass_statement] = STATE(2389),
    [sym_break_statement] = STATE(2389),
    [sym_continue_statement] = STATE(2389),
    [sym_global_statement] = STATE(2389),
    [sym_nonlocal_statement] = STATE(2389),
    [sym_exec_statement] = STATE(2389),
    [sym_type_alias_statement] = STATE(2389),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(560),
    [sym__indent] = ACTIONS(562),
    [sym_string_start] = ACTIONS(81),
  },
  [123] = {
    [sym__simple_statements] = STATE(615),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(564),
    [sym__indent] = ACTIONS(566),
    [sym_string_start] = ACTIONS(81),
  },
  [124] = {
    [sym__simple_statements] = STATE(663),
    [sym_import_statement] = STATE(2273),
    [sym_future_import_statement] = STATE(2273),
    [sym_import_from_statement] = STATE(2273),
    [sym_print_statement] = STATE(2273),
    [sym_assert_statement] = STATE(2273),
    [sym_expression_statement] = STATE(2273),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2273),
    [sym_delete_statement] = STATE(2273),
    [sym_raise_statement] = STATE(2273),
    [sym_pass_statement] = STATE(2273),
    [sym_break_statement] = STATE(2273),
    [sym_continue_statement] = STATE(2273),
    [sym_global_statement] = STATE(2273),
    [sym_nonlocal_statement] = STATE(2273),
    [sym_exec_statement] = STATE(2273),
    [sym_type_alias_statement] = STATE(2273),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(568),
    [sym__indent] = ACTIONS(570),
    [sym_string_start] = ACTIONS(81),
  },
  [125] = {
    [sym__simple_statements] = STATE(770),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(572),
    [sym__indent] = ACTIONS(574),
    [sym_string_start] = ACTIONS(81),
  },
  [126] = {
    [sym__simple_statements] = STATE(787),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(576),
    [sym__indent] = ACTIONS(578),
    [sym_string_start] = ACTIONS(81),
  },
  [127] = {
    [sym__simple_statements] = STATE(648),
    [sym_import_statement] = STATE(2273),
    [sym_future_import_statement] = STATE(2273),
    [sym_import_from_statement] = STATE(2273),
    [sym_print_statement] = STATE(2273),
    [sym_assert_statement] = STATE(2273),
    [sym_expression_statement] = STATE(2273),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2273),
    [sym_delete_statement] = STATE(2273),
    [sym_raise_statement] = STATE(2273),
    [sym_pass_statement] = STATE(2273),
    [sym_break_statement] = STATE(2273),
    [sym_continue_statement] = STATE(2273),
    [sym_global_statement] = STATE(2273),
    [sym_nonlocal_statement] = STATE(2273),
    [sym_exec_statement] = STATE(2273),
    [sym_type_alias_statement] = STATE(2273),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(580),
    [sym__indent] = ACTIONS(582),
    [sym_string_start] = ACTIONS(81),
  },
  [128] = {
    [sym__simple_statements] = STATE(839),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(584),
    [sym__indent] = ACTIONS(586),
    [sym_string_start] = ACTIONS(81),
  },
  [129] = {
    [sym__simple_statements] = STATE(656),
    [sym_import_statement] = STATE(2324),
    [sym_future_import_statement] = STATE(2324),
    [sym_import_from_statement] = STATE(2324),
    [sym_print_statement] = STATE(2324),
    [sym_assert_statement] = STATE(2324),
    [sym_expression_statement] = STATE(2324),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2324),
    [sym_delete_statement] = STATE(2324),
    [sym_raise_statement] = STATE(2324),
    [sym_pass_statement] = STATE(2324),
    [sym_break_statement] = STATE(2324),
    [sym_continue_statement] = STATE(2324),
    [sym_global_statement] = STATE(2324),
    [sym_nonlocal_statement] = STATE(2324),
    [sym_exec_statement] = STATE(2324),
    [sym_type_alias_statement] = STATE(2324),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(588),
    [sym__indent] = ACTIONS(590),
    [sym_string_start] = ACTIONS(81),
  },
  [130] = {
    [sym__simple_statements] = STATE(795),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(592),
    [sym__indent] = ACTIONS(594),
    [sym_string_start] = ACTIONS(81),
  },
  [131] = {
    [sym__simple_statements] = STATE(2569),
    [sym_import_statement] = STATE(2268),
    [sym_future_import_statement] = STATE(2268),
    [sym_import_from_statement] = STATE(2268),
    [sym_print_statement] = STATE(2268),
    [sym_assert_statement] = STATE(2268),
    [sym_expression_statement] = STATE(2268),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2268),
    [sym_delete_statement] = STATE(2268),
    [sym_raise_statement] = STATE(2268),
    [sym_pass_statement] = STATE(2268),
    [sym_break_statement] = STATE(2268),
    [sym_continue_statement] = STATE(2268),
    [sym_global_statement] = STATE(2268),
    [sym_nonlocal_statement] = STATE(2268),
    [sym_exec_statement] = STATE(2268),
    [sym_type_alias_statement] = STATE(2268),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(596),
    [sym__indent] = ACTIONS(598),
    [sym_string_start] = ACTIONS(81),
  },
  [132] = {
    [sym__simple_statements] = STATE(797),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(600),
    [sym__indent] = ACTIONS(602),
    [sym_string_start] = ACTIONS(81),
  },
  [133] = {
    [sym__simple_statements] = STATE(798),
    [sym_import_statement] = STATE(2367),
    [sym_future_import_statement] = STATE(2367),
    [sym_import_from_statement] = STATE(2367),
    [sym_print_statement] = STATE(2367),
    [sym_assert_statement] = STATE(2367),
    [sym_expression_statement] = STATE(2367),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2367),
    [sym_delete_statement] = STATE(2367),
    [sym_raise_statement] = STATE(2367),
    [sym_pass_statement] = STATE(2367),
    [sym_break_statement] = STATE(2367),
    [sym_continue_statement] = STATE(2367),
    [sym_global_statement] = STATE(2367),
    [sym_nonlocal_statement] = STATE(2367),
    [sym_exec_statement] = STATE(2367),
    [sym_type_alias_statement] = STATE(2367),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(604),
    [sym__indent] = ACTIONS(606),
    [sym_string_start] = ACTIONS(81),
  },
  [134] = {
    [sym__simple_statements] = STATE(1827),
    [sym_import_statement] = STATE(2407),
    [sym_future_import_statement] = STATE(2407),
    [sym_import_from_statement] = STATE(2407),
    [sym_print_statement] = STATE(2407),
    [sym_assert_statement] = STATE(2407),
    [sym_expression_statement] = STATE(2407),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2407),
    [sym_delete_statement] = STATE(2407),
    [sym_raise_statement] = STATE(2407),
    [sym_pass_statement] = STATE(2407),
    [sym_break_statement] = STATE(2407),
    [sym_continue_statement] = STATE(2407),
    [sym_global_statement] = STATE(2407),
    [sym_nonlocal_statement] = STATE(2407),
    [sym_exec_statement] = STATE(2407),
    [sym_type_alias_statement] = STATE(2407),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(608),
    [sym__indent] = ACTIONS(610),
    [sym_string_start] = ACTIONS(81),
  },
  [135] = {
    [sym__simple_statements] = STATE(2626),
    [sym_import_statement] = STATE(2268),
    [sym_future_import_statement] = STATE(2268),
    [sym_import_from_statement] = STATE(2268),
    [sym_print_statement] = STATE(2268),
    [sym_assert_statement] = STATE(2268),
    [sym_expression_statement] = STATE(2268),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2268),
    [sym_delete_statement] = STATE(2268),
    [sym_raise_statement] = STATE(2268),
    [sym_pass_statement] = STATE(2268),
    [sym_break_statement] = STATE(2268),
    [sym_continue_statement] = STATE(2268),
    [sym_global_statement] = STATE(2268),
    [sym_nonlocal_statement] = STATE(2268),
    [sym_exec_statement] = STATE(2268),
    [sym_type_alias_statement] = STATE(2268),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(612),
    [sym__indent] = ACTIONS(614),
    [sym_string_start] = ACTIONS(81),
  },
  [136] = {
    [sym__simple_statements] = STATE(739),
    [sym_import_statement] = STATE(2277),
    [sym_future_import_statement] = STATE(2277),
    [sym_import_from_statement] = STATE(2277),
    [sym_print_statement] = STATE(2277),
    [sym_assert_statement] = STATE(2277),
    [sym_expression_statement] = STATE(2277),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2277),
    [sym_delete_statement] = STATE(2277),
    [sym_raise_statement] = STATE(2277),
    [sym_pass_statement] = STATE(2277),
    [sym_break_statement] = STATE(2277),
    [sym_continue_statement] = STATE(2277),
    [sym_global_statement] = STATE(2277),
    [sym_nonlocal_statement] = STATE(2277),
    [sym_exec_statement] = STATE(2277),
    [sym_type_alias_statement] = STATE(2277),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(616),
    [sym__indent] = ACTIONS(618),
    [sym_string_start] = ACTIONS(81),
  },
  [137] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(620),
    [sym_string_start] = ACTIONS(81),
  },
  [138] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(622),
    [sym_string_start] = ACTIONS(81),
  },
  [139] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(624),
    [sym_string_start] = ACTIONS(81),
  },
  [140] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(626),
    [sym_string_start] = ACTIONS(81),
  },
  [141] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(628),
    [sym_string_start] = ACTIONS(81),
  },
  [142] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(630),
    [sym_string_start] = ACTIONS(81),
  },
  [143] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(632),
    [sym_string_start] = ACTIONS(81),
  },
  [144] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(634),
    [sym_string_start] = ACTIONS(81),
  },
  [145] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(636),
    [sym_string_start] = ACTIONS(81),
  },
  [146] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(638),
    [sym_string_start] = ACTIONS(81),
  },
  [147] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(640),
    [sym_string_start] = ACTIONS(81),
  },
  [148] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(642),
    [sym_string_start] = ACTIONS(81),
  },
  [149] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(644),
    [sym_string_start] = ACTIONS(81),
  },
  [150] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(646),
    [sym_string_start] = ACTIONS(81),
  },
  [151] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(648),
    [sym_string_start] = ACTIONS(81),
  },
  [152] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(650),
    [sym_string_start] = ACTIONS(81),
  },
  [153] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1697),
    [sym__named_expression_lhs] = STATE(2817),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1662),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1697),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1016),
    [sym_not_operator] = STATE(1697),
    [sym_boolean_operator] = STATE(1697),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_comparison_operator] = STATE(1697),
    [sym_lambda] = STATE(1697),
    [sym_assignment] = STATE(2548),
    [sym_augmented_assignment] = STATE(2548),
    [sym_pattern_list] = STATE(1680),
    [sym_yield] = STATE(2548),
    [sym_attribute] = STATE(635),
    [sym_subscript] = STATE(635),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_conditional_expression] = STATE(1697),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(81),
  },
  [154] = {
    [sym_list_splat_pattern] = STATE(1062),
    [sym_primary_expression] = STATE(979),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_attribute] = STATE(1121),
    [sym_subscript] = STATE(1121),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [155] = {
    [sym_list_splat_pattern] = STATE(1062),
    [sym_primary_expression] = STATE(979),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_attribute] = STATE(1121),
    [sym_subscript] = STATE(1121),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [156] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_SLASH_SLASH] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_AT_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(666),
    [sym_string_start] = ACTIONS(324),
  },
  [157] = {
    [sym_list_splat_pattern] = STATE(1062),
    [sym_primary_expression] = STATE(979),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_attribute] = STATE(1121),
    [sym_subscript] = STATE(1121),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_from] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [158] = {
    [sym_list_splat_pattern] = STATE(1202),
    [sym_primary_expression] = STATE(1000),
    [sym_binary_operator] = STATE(1168),
    [sym_unary_operator] = STATE(1168),
    [sym_attribute] = STATE(1168),
    [sym_subscript] = STATE(1168),
    [sym_call] = STATE(1168),
    [sym_list] = STATE(1168),
    [sym_set] = STATE(1168),
    [sym_tuple] = STATE(1168),
    [sym_dictionary] = STATE(1168),
    [sym_list_comprehension] = STATE(1168),
    [sym_dictionary_comprehension] = STATE(1168),
    [sym_set_comprehension] = STATE(1168),
    [sym_generator_expression] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_concatenated_string] = STATE(1168),
    [sym_string] = STATE(998),
    [sym_await] = STATE(1168),
    [sym_identifier] = ACTIONS(679),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_print] = ACTIONS(685),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_async] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(695),
    [sym_type_conversion] = ACTIONS(277),
    [sym_integer] = ACTIONS(679),
    [sym_float] = ACTIONS(695),
    [anon_sym_await] = ACTIONS(697),
    [sym_true] = ACTIONS(679),
    [sym_false] = ACTIONS(679),
    [sym_none] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(699),
  },
  [159] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_from] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(666),
    [sym_string_start] = ACTIONS(324),
  },
  [160] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_type_conversion] = ACTIONS(666),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [161] = {
    [sym_list_splat_pattern] = STATE(1062),
    [sym_primary_expression] = STATE(979),
    [sym_binary_operator] = STATE(1121),
    [sym_unary_operator] = STATE(1121),
    [sym_attribute] = STATE(1121),
    [sym_subscript] = STATE(1121),
    [sym_call] = STATE(1121),
    [sym_list] = STATE(1121),
    [sym_set] = STATE(1121),
    [sym_tuple] = STATE(1121),
    [sym_dictionary] = STATE(1121),
    [sym_list_comprehension] = STATE(1121),
    [sym_dictionary_comprehension] = STATE(1121),
    [sym_set_comprehension] = STATE(1121),
    [sym_generator_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_concatenated_string] = STATE(1121),
    [sym_string] = STATE(976),
    [sym_await] = STATE(1121),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_from] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [162] = {
    [sym_list_splat_pattern] = STATE(1202),
    [sym_primary_expression] = STATE(1000),
    [sym_binary_operator] = STATE(1168),
    [sym_unary_operator] = STATE(1168),
    [sym_attribute] = STATE(1168),
    [sym_subscript] = STATE(1168),
    [sym_call] = STATE(1168),
    [sym_list] = STATE(1168),
    [sym_set] = STATE(1168),
    [sym_tuple] = STATE(1168),
    [sym_dictionary] = STATE(1168),
    [sym_list_comprehension] = STATE(1168),
    [sym_dictionary_comprehension] = STATE(1168),
    [sym_set_comprehension] = STATE(1168),
    [sym_generator_expression] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_concatenated_string] = STATE(1168),
    [sym_string] = STATE(998),
    [sym_await] = STATE(1168),
    [sym_identifier] = ACTIONS(679),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_print] = ACTIONS(685),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_async] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(695),
    [sym_type_conversion] = ACTIONS(277),
    [sym_integer] = ACTIONS(679),
    [sym_float] = ACTIONS(695),
    [anon_sym_await] = ACTIONS(697),
    [sym_true] = ACTIONS(679),
    [sym_false] = ACTIONS(679),
    [sym_none] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(699),
  },
  [163] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_else] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [164] = {
    [sym_list_splat_pattern] = STATE(1421),
    [sym_primary_expression] = STATE(1066),
    [sym_binary_operator] = STATE(1311),
    [sym_unary_operator] = STATE(1311),
    [sym_attribute] = STATE(1311),
    [sym_subscript] = STATE(1311),
    [sym_call] = STATE(1311),
    [sym_list] = STATE(1311),
    [sym_set] = STATE(1311),
    [sym_tuple] = STATE(1311),
    [sym_dictionary] = STATE(1311),
    [sym_list_comprehension] = STATE(1311),
    [sym_dictionary_comprehension] = STATE(1311),
    [sym_set_comprehension] = STATE(1311),
    [sym_generator_expression] = STATE(1311),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_concatenated_string] = STATE(1311),
    [sym_string] = STATE(1024),
    [sym_await] = STATE(1311),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_print] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(722),
    [sym_integer] = ACTIONS(704),
    [sym_float] = ACTIONS(722),
    [anon_sym_await] = ACTIONS(724),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_none] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(726),
  },
  [165] = {
    [sym_list_splat_pattern] = STATE(1202),
    [sym_primary_expression] = STATE(1000),
    [sym_binary_operator] = STATE(1168),
    [sym_unary_operator] = STATE(1168),
    [sym_attribute] = STATE(1168),
    [sym_subscript] = STATE(1168),
    [sym_call] = STATE(1168),
    [sym_list] = STATE(1168),
    [sym_set] = STATE(1168),
    [sym_tuple] = STATE(1168),
    [sym_dictionary] = STATE(1168),
    [sym_list_comprehension] = STATE(1168),
    [sym_dictionary_comprehension] = STATE(1168),
    [sym_set_comprehension] = STATE(1168),
    [sym_generator_expression] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_concatenated_string] = STATE(1168),
    [sym_string] = STATE(998),
    [sym_await] = STATE(1168),
    [sym_identifier] = ACTIONS(679),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_print] = ACTIONS(685),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_COLON] = ACTIONS(671),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_async] = ACTIONS(685),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_not] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(701),
    [anon_sym_is] = ACTIONS(668),
    [sym_ellipsis] = ACTIONS(695),
    [sym_integer] = ACTIONS(679),
    [sym_float] = ACTIONS(695),
    [anon_sym_await] = ACTIONS(697),
    [sym_true] = ACTIONS(679),
    [sym_false] = ACTIONS(679),
    [sym_none] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(699),
  },
  [166] = {
    [sym_list_splat_pattern] = STATE(1270),
    [sym_primary_expression] = STATE(1018),
    [sym_binary_operator] = STATE(1197),
    [sym_unary_operator] = STATE(1197),
    [sym_attribute] = STATE(1197),
    [sym_subscript] = STATE(1197),
    [sym_call] = STATE(1197),
    [sym_list] = STATE(1197),
    [sym_set] = STATE(1197),
    [sym_tuple] = STATE(1197),
    [sym_dictionary] = STATE(1197),
    [sym_list_comprehension] = STATE(1197),
    [sym_dictionary_comprehension] = STATE(1197),
    [sym_set_comprehension] = STATE(1197),
    [sym_generator_expression] = STATE(1197),
    [sym_parenthesized_expression] = STATE(1197),
    [sym_concatenated_string] = STATE(1197),
    [sym_string] = STATE(989),
    [sym_await] = STATE(1197),
    [sym_identifier] = ACTIONS(728),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_print] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(734),
    [anon_sym_async] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(734),
    [anon_sym_type] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(744),
    [sym_integer] = ACTIONS(728),
    [sym_float] = ACTIONS(744),
    [anon_sym_await] = ACTIONS(746),
    [sym_true] = ACTIONS(728),
    [sym_false] = ACTIONS(728),
    [sym_none] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(748),
  },
  [167] = {
    [sym_list_splat_pattern] = STATE(1287),
    [sym_primary_expression] = STATE(1072),
    [sym_binary_operator] = STATE(1322),
    [sym_unary_operator] = STATE(1322),
    [sym_attribute] = STATE(1322),
    [sym_subscript] = STATE(1322),
    [sym_call] = STATE(1322),
    [sym_list] = STATE(1322),
    [sym_set] = STATE(1322),
    [sym_tuple] = STATE(1322),
    [sym_dictionary] = STATE(1322),
    [sym_list_comprehension] = STATE(1322),
    [sym_dictionary_comprehension] = STATE(1322),
    [sym_set_comprehension] = STATE(1322),
    [sym_generator_expression] = STATE(1322),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_concatenated_string] = STATE(1322),
    [sym_string] = STATE(1026),
    [sym_await] = STATE(1322),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [168] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [169] = {
    [sym_list_splat_pattern] = STATE(1202),
    [sym_primary_expression] = STATE(1000),
    [sym_binary_operator] = STATE(1168),
    [sym_unary_operator] = STATE(1168),
    [sym_attribute] = STATE(1168),
    [sym_subscript] = STATE(1168),
    [sym_call] = STATE(1168),
    [sym_list] = STATE(1168),
    [sym_set] = STATE(1168),
    [sym_tuple] = STATE(1168),
    [sym_dictionary] = STATE(1168),
    [sym_list_comprehension] = STATE(1168),
    [sym_dictionary_comprehension] = STATE(1168),
    [sym_set_comprehension] = STATE(1168),
    [sym_generator_expression] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_concatenated_string] = STATE(1168),
    [sym_string] = STATE(998),
    [sym_await] = STATE(1168),
    [sym_identifier] = ACTIONS(679),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_print] = ACTIONS(685),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(685),
    [anon_sym_async] = ACTIONS(685),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(691),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(695),
    [sym_type_conversion] = ACTIONS(277),
    [sym_integer] = ACTIONS(679),
    [sym_float] = ACTIONS(695),
    [anon_sym_await] = ACTIONS(697),
    [sym_true] = ACTIONS(679),
    [sym_false] = ACTIONS(679),
    [sym_none] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(699),
  },
  [170] = {
    [sym_list_splat_pattern] = STATE(1404),
    [sym_primary_expression] = STATE(1069),
    [sym_binary_operator] = STATE(1428),
    [sym_unary_operator] = STATE(1428),
    [sym_attribute] = STATE(1428),
    [sym_subscript] = STATE(1428),
    [sym_call] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_set] = STATE(1428),
    [sym_tuple] = STATE(1428),
    [sym_dictionary] = STATE(1428),
    [sym_list_comprehension] = STATE(1428),
    [sym_dictionary_comprehension] = STATE(1428),
    [sym_set_comprehension] = STATE(1428),
    [sym_generator_expression] = STATE(1428),
    [sym_parenthesized_expression] = STATE(1428),
    [sym_concatenated_string] = STATE(1428),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1428),
    [sym_identifier] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(284),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(788),
    [sym_integer] = ACTIONS(772),
    [sym_float] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(790),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_none] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(792),
  },
  [171] = {
    [sym_list_splat_pattern] = STATE(1287),
    [sym_primary_expression] = STATE(1072),
    [sym_binary_operator] = STATE(1322),
    [sym_unary_operator] = STATE(1322),
    [sym_attribute] = STATE(1322),
    [sym_subscript] = STATE(1322),
    [sym_call] = STATE(1322),
    [sym_list] = STATE(1322),
    [sym_set] = STATE(1322),
    [sym_tuple] = STATE(1322),
    [sym_dictionary] = STATE(1322),
    [sym_list_comprehension] = STATE(1322),
    [sym_dictionary_comprehension] = STATE(1322),
    [sym_set_comprehension] = STATE(1322),
    [sym_generator_expression] = STATE(1322),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_concatenated_string] = STATE(1322),
    [sym_string] = STATE(1026),
    [sym_await] = STATE(1322),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [172] = {
    [sym_list_splat_pattern] = STATE(1421),
    [sym_primary_expression] = STATE(1066),
    [sym_binary_operator] = STATE(1311),
    [sym_unary_operator] = STATE(1311),
    [sym_attribute] = STATE(1311),
    [sym_subscript] = STATE(1311),
    [sym_call] = STATE(1311),
    [sym_list] = STATE(1311),
    [sym_set] = STATE(1311),
    [sym_tuple] = STATE(1311),
    [sym_dictionary] = STATE(1311),
    [sym_list_comprehension] = STATE(1311),
    [sym_dictionary_comprehension] = STATE(1311),
    [sym_set_comprehension] = STATE(1311),
    [sym_generator_expression] = STATE(1311),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_concatenated_string] = STATE(1311),
    [sym_string] = STATE(1024),
    [sym_await] = STATE(1311),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_print] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(722),
    [sym_integer] = ACTIONS(704),
    [sym_float] = ACTIONS(722),
    [anon_sym_await] = ACTIONS(724),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_none] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(726),
  },
  [173] = {
    [sym_list_splat_pattern] = STATE(1465),
    [sym_primary_expression] = STATE(1223),
    [sym_binary_operator] = STATE(1470),
    [sym_unary_operator] = STATE(1470),
    [sym_attribute] = STATE(1470),
    [sym_subscript] = STATE(1470),
    [sym_call] = STATE(1470),
    [sym_list] = STATE(1470),
    [sym_set] = STATE(1470),
    [sym_tuple] = STATE(1470),
    [sym_dictionary] = STATE(1470),
    [sym_list_comprehension] = STATE(1470),
    [sym_dictionary_comprehension] = STATE(1470),
    [sym_set_comprehension] = STATE(1470),
    [sym_generator_expression] = STATE(1470),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_concatenated_string] = STATE(1470),
    [sym_string] = STATE(1122),
    [sym_await] = STATE(1470),
    [sym_identifier] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(800),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(800),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(701),
    [anon_sym_is] = ACTIONS(668),
    [sym_ellipsis] = ACTIONS(810),
    [sym_integer] = ACTIONS(794),
    [sym_float] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(812),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_none] = ACTIONS(794),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(814),
  },
  [174] = {
    [sym_list_splat_pattern] = STATE(1270),
    [sym_primary_expression] = STATE(1018),
    [sym_binary_operator] = STATE(1197),
    [sym_unary_operator] = STATE(1197),
    [sym_attribute] = STATE(1197),
    [sym_subscript] = STATE(1197),
    [sym_call] = STATE(1197),
    [sym_list] = STATE(1197),
    [sym_set] = STATE(1197),
    [sym_tuple] = STATE(1197),
    [sym_dictionary] = STATE(1197),
    [sym_list_comprehension] = STATE(1197),
    [sym_dictionary_comprehension] = STATE(1197),
    [sym_set_comprehension] = STATE(1197),
    [sym_generator_expression] = STATE(1197),
    [sym_parenthesized_expression] = STATE(1197),
    [sym_concatenated_string] = STATE(1197),
    [sym_string] = STATE(989),
    [sym_await] = STATE(1197),
    [sym_identifier] = ACTIONS(728),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(732),
    [anon_sym_print] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(734),
    [anon_sym_async] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(734),
    [anon_sym_type] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(744),
    [sym_integer] = ACTIONS(728),
    [sym_float] = ACTIONS(744),
    [anon_sym_await] = ACTIONS(746),
    [sym_true] = ACTIONS(728),
    [sym_false] = ACTIONS(728),
    [sym_none] = ACTIONS(728),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(748),
  },
  [175] = {
    [sym_list_splat_pattern] = STATE(1404),
    [sym_primary_expression] = STATE(1069),
    [sym_binary_operator] = STATE(1428),
    [sym_unary_operator] = STATE(1428),
    [sym_attribute] = STATE(1428),
    [sym_subscript] = STATE(1428),
    [sym_call] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_set] = STATE(1428),
    [sym_tuple] = STATE(1428),
    [sym_dictionary] = STATE(1428),
    [sym_list_comprehension] = STATE(1428),
    [sym_dictionary_comprehension] = STATE(1428),
    [sym_set_comprehension] = STATE(1428),
    [sym_generator_expression] = STATE(1428),
    [sym_parenthesized_expression] = STATE(1428),
    [sym_concatenated_string] = STATE(1428),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1428),
    [sym_identifier] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(788),
    [sym_integer] = ACTIONS(772),
    [sym_float] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(790),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_none] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(792),
  },
  [176] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(316),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(316),
    [sym_string_start] = ACTIONS(324),
  },
  [177] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [178] = {
    [sym_list_splat_pattern] = STATE(1465),
    [sym_primary_expression] = STATE(1223),
    [sym_binary_operator] = STATE(1470),
    [sym_unary_operator] = STATE(1470),
    [sym_attribute] = STATE(1470),
    [sym_subscript] = STATE(1470),
    [sym_call] = STATE(1470),
    [sym_list] = STATE(1470),
    [sym_set] = STATE(1470),
    [sym_tuple] = STATE(1470),
    [sym_dictionary] = STATE(1470),
    [sym_list_comprehension] = STATE(1470),
    [sym_dictionary_comprehension] = STATE(1470),
    [sym_set_comprehension] = STATE(1470),
    [sym_generator_expression] = STATE(1470),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_concatenated_string] = STATE(1470),
    [sym_string] = STATE(1122),
    [sym_await] = STATE(1470),
    [sym_identifier] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(800),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(800),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(810),
    [sym_integer] = ACTIONS(794),
    [sym_float] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(812),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_none] = ACTIONS(794),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(814),
  },
  [179] = {
    [sym_list_splat_pattern] = STATE(1287),
    [sym_primary_expression] = STATE(1072),
    [sym_binary_operator] = STATE(1322),
    [sym_unary_operator] = STATE(1322),
    [sym_attribute] = STATE(1322),
    [sym_subscript] = STATE(1322),
    [sym_call] = STATE(1322),
    [sym_list] = STATE(1322),
    [sym_set] = STATE(1322),
    [sym_tuple] = STATE(1322),
    [sym_dictionary] = STATE(1322),
    [sym_list_comprehension] = STATE(1322),
    [sym_dictionary_comprehension] = STATE(1322),
    [sym_set_comprehension] = STATE(1322),
    [sym_generator_expression] = STATE(1322),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_concatenated_string] = STATE(1322),
    [sym_string] = STATE(1026),
    [sym_await] = STATE(1322),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [180] = {
    [sym_list_splat_pattern] = STATE(1287),
    [sym_primary_expression] = STATE(1072),
    [sym_binary_operator] = STATE(1322),
    [sym_unary_operator] = STATE(1322),
    [sym_attribute] = STATE(1322),
    [sym_subscript] = STATE(1322),
    [sym_call] = STATE(1322),
    [sym_list] = STATE(1322),
    [sym_set] = STATE(1322),
    [sym_tuple] = STATE(1322),
    [sym_dictionary] = STATE(1322),
    [sym_list_comprehension] = STATE(1322),
    [sym_dictionary_comprehension] = STATE(1322),
    [sym_set_comprehension] = STATE(1322),
    [sym_generator_expression] = STATE(1322),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_concatenated_string] = STATE(1322),
    [sym_string] = STATE(1026),
    [sym_await] = STATE(1322),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(701),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(701),
    [anon_sym_EQ_EQ] = ACTIONS(701),
    [anon_sym_BANG_EQ] = ACTIONS(701),
    [anon_sym_GT_EQ] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(701),
    [anon_sym_is] = ACTIONS(668),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [181] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_else] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [182] = {
    [sym_list_splat_pattern] = STATE(1421),
    [sym_primary_expression] = STATE(1066),
    [sym_binary_operator] = STATE(1311),
    [sym_unary_operator] = STATE(1311),
    [sym_attribute] = STATE(1311),
    [sym_subscript] = STATE(1311),
    [sym_call] = STATE(1311),
    [sym_list] = STATE(1311),
    [sym_set] = STATE(1311),
    [sym_tuple] = STATE(1311),
    [sym_dictionary] = STATE(1311),
    [sym_list_comprehension] = STATE(1311),
    [sym_dictionary_comprehension] = STATE(1311),
    [sym_set_comprehension] = STATE(1311),
    [sym_generator_expression] = STATE(1311),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_concatenated_string] = STATE(1311),
    [sym_string] = STATE(1024),
    [sym_await] = STATE(1311),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(284),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_print] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(722),
    [sym_integer] = ACTIONS(704),
    [sym_float] = ACTIONS(722),
    [anon_sym_await] = ACTIONS(724),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_none] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(726),
  },
  [183] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(671),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(701),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(701),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(701),
    [anon_sym_SLASH_SLASH] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_CARET] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [184] = {
    [sym_list_splat_pattern] = STATE(1404),
    [sym_primary_expression] = STATE(1069),
    [sym_binary_operator] = STATE(1428),
    [sym_unary_operator] = STATE(1428),
    [sym_attribute] = STATE(1428),
    [sym_subscript] = STATE(1428),
    [sym_call] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_set] = STATE(1428),
    [sym_tuple] = STATE(1428),
    [sym_dictionary] = STATE(1428),
    [sym_list_comprehension] = STATE(1428),
    [sym_dictionary_comprehension] = STATE(1428),
    [sym_set_comprehension] = STATE(1428),
    [sym_generator_expression] = STATE(1428),
    [sym_parenthesized_expression] = STATE(1428),
    [sym_concatenated_string] = STATE(1428),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1428),
    [sym_identifier] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(788),
    [sym_integer] = ACTIONS(772),
    [sym_float] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(790),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_none] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(792),
  },
  [185] = {
    [sym_list_splat_pattern] = STATE(1421),
    [sym_primary_expression] = STATE(1066),
    [sym_binary_operator] = STATE(1311),
    [sym_unary_operator] = STATE(1311),
    [sym_attribute] = STATE(1311),
    [sym_subscript] = STATE(1311),
    [sym_call] = STATE(1311),
    [sym_list] = STATE(1311),
    [sym_set] = STATE(1311),
    [sym_tuple] = STATE(1311),
    [sym_dictionary] = STATE(1311),
    [sym_list_comprehension] = STATE(1311),
    [sym_dictionary_comprehension] = STATE(1311),
    [sym_set_comprehension] = STATE(1311),
    [sym_generator_expression] = STATE(1311),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_concatenated_string] = STATE(1311),
    [sym_string] = STATE(1024),
    [sym_await] = STATE(1311),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_print] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(722),
    [sym_integer] = ACTIONS(704),
    [sym_float] = ACTIONS(722),
    [anon_sym_await] = ACTIONS(724),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_none] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(726),
  },
  [186] = {
    [sym_list_splat_pattern] = STATE(1465),
    [sym_primary_expression] = STATE(1223),
    [sym_binary_operator] = STATE(1470),
    [sym_unary_operator] = STATE(1470),
    [sym_attribute] = STATE(1470),
    [sym_subscript] = STATE(1470),
    [sym_call] = STATE(1470),
    [sym_list] = STATE(1470),
    [sym_set] = STATE(1470),
    [sym_tuple] = STATE(1470),
    [sym_dictionary] = STATE(1470),
    [sym_list_comprehension] = STATE(1470),
    [sym_dictionary_comprehension] = STATE(1470),
    [sym_set_comprehension] = STATE(1470),
    [sym_generator_expression] = STATE(1470),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_concatenated_string] = STATE(1470),
    [sym_string] = STATE(1122),
    [sym_await] = STATE(1470),
    [sym_identifier] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(800),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(800),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(810),
    [sym_integer] = ACTIONS(794),
    [sym_float] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(812),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_none] = ACTIONS(794),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(814),
  },
  [187] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_SLASH_SLASH] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_AT_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [188] = {
    [sym_list_splat_pattern] = STATE(1348),
    [sym_primary_expression] = STATE(1065),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(1041),
    [sym_await] = STATE(1435),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(316),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(820), 1,
      anon_sym_RPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1725), 1,
      sym_expression,
    STATE(2359), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2668), 1,
      sym__patterns,
    STATE(2806), 1,
      sym__named_expression_lhs,
    STATE(2825), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [126] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(850), 1,
      anon_sym_RBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2677), 1,
      sym__patterns,
    STATE(2678), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [250] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(864), 1,
      anon_sym_COMMA,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(874), 1,
      anon_sym_RBRACE,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1695), 1,
      sym_expression,
    STATE(1897), 1,
      sym_pair,
    STATE(2456), 1,
      sym_dictionary_splat,
    STATE(2699), 1,
      sym__named_expression_lhs,
    STATE(2700), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [374] = 32,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(884), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1716), 1,
      sym_expression,
    STATE(2276), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2471), 1,
      sym_list_splat,
    STATE(2473), 1,
      sym_parenthesized_list_splat,
    STATE(2790), 1,
      sym__patterns,
    STATE(2806), 1,
      sym__named_expression_lhs,
    STATE(2808), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [502] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(886), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1738), 1,
      sym_expression,
    STATE(2452), 1,
      sym_pattern,
    STATE(2482), 1,
      sym_yield,
    STATE(2668), 1,
      sym__patterns,
    STATE(2752), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [628] = 32,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(888), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1708), 1,
      sym_expression,
    STATE(2429), 1,
      sym_yield,
    STATE(2434), 1,
      sym_list_splat,
    STATE(2437), 1,
      sym_parenthesized_list_splat,
    STATE(2452), 1,
      sym_pattern,
    STATE(2634), 1,
      sym__patterns,
    STATE(2648), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [756] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(890), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1718), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2676), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2828), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [880] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(892), 1,
      anon_sym_type,
    STATE(626), 1,
      sym_list_splat_pattern,
    STATE(976), 1,
      sym_string,
    STATE(1016), 1,
      sym_primary_expression,
    STATE(1660), 1,
      sym_pattern_list,
    STATE(1668), 1,
      sym_pattern,
    STATE(1854), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(635), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(418), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2547), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1000] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(892), 1,
      anon_sym_type,
    STATE(626), 1,
      sym_list_splat_pattern,
    STATE(976), 1,
      sym_string,
    STATE(1016), 1,
      sym_primary_expression,
    STATE(1660), 1,
      sym_pattern_list,
    STATE(1668), 1,
      sym_pattern,
    STATE(1854), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(635), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(418), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2537), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1120] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(892), 1,
      anon_sym_type,
    STATE(626), 1,
      sym_list_splat_pattern,
    STATE(976), 1,
      sym_string,
    STATE(1016), 1,
      sym_primary_expression,
    STATE(1660), 1,
      sym_pattern_list,
    STATE(1668), 1,
      sym_pattern,
    STATE(1854), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(635), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(418), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2552), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1240] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2676), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1364] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(896), 1,
      anon_sym_COMMA,
    ACTIONS(898), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1684), 1,
      sym_expression,
    STATE(1867), 1,
      sym_pair,
    STATE(2379), 1,
      sym_dictionary_splat,
    STATE(2699), 1,
      sym__named_expression_lhs,
    STATE(2780), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1488] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(900), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2634), 1,
      sym__patterns,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1614] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(902), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1741), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2659), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2815), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1738] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(904), 1,
      anon_sym_COMMA,
    ACTIONS(906), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1694), 1,
      sym_expression,
    STATE(1910), 1,
      sym_pair,
    STATE(2280), 1,
      sym_dictionary_splat,
    STATE(2665), 1,
      sym__collection_elements,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1862] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(908), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2668), 1,
      sym__patterns,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1988] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(910), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1743), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2652), 1,
      sym__collection_elements,
    STATE(2676), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2112] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(912), 1,
      anon_sym_COMMA,
    ACTIONS(914), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1700), 1,
      sym_expression,
    STATE(1887), 1,
      sym_pair,
    STATE(2330), 1,
      sym_dictionary_splat,
    STATE(2699), 1,
      sym__named_expression_lhs,
    STATE(2740), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2236] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      anon_sym_COMMA,
    ACTIONS(918), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1690), 1,
      sym_expression,
    STATE(1891), 1,
      sym_pair,
    STATE(2467), 1,
      sym_dictionary_splat,
    STATE(2699), 1,
      sym__named_expression_lhs,
    STATE(2751), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2360] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(920), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2790), 1,
      sym__patterns,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2486] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(922), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2677), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2610] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(924), 1,
      anon_sym_COMMA,
    ACTIONS(926), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1688), 1,
      sym_expression,
    STATE(1903), 1,
      sym_pair,
    STATE(2361), 1,
      sym_dictionary_splat,
    STATE(2667), 1,
      sym__collection_elements,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2734] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(928), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2789), 1,
      sym__patterns,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2860] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(930), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2676), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2984] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(932), 1,
      anon_sym_COMMA,
    ACTIONS(934), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1689), 1,
      sym_expression,
    STATE(1912), 1,
      sym_pair,
    STATE(2395), 1,
      sym_dictionary_splat,
    STATE(2699), 1,
      sym__named_expression_lhs,
    STATE(2703), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3108] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(936), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2706), 1,
      sym__patterns,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3234] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2815), 1,
      sym__patterns,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3358] = 30,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(866), 1,
      anon_sym_STAR,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(940), 1,
      anon_sym_COMMA,
    ACTIONS(942), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(1874), 1,
      sym_pair,
    STATE(2428), 1,
      sym_dictionary_splat,
    STATE(2643), 1,
      sym__collection_elements,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2340), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3482] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(944), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1738), 1,
      sym_expression,
    STATE(2452), 1,
      sym_pattern,
    STATE(2482), 1,
      sym_yield,
    STATE(2668), 1,
      sym__patterns,
    STATE(2752), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3608] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(946), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2653), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3732] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(948), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2721), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3856] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(838), 1,
      sym_identifier,
    ACTIONS(840), 1,
      anon_sym_LPAREN,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(846), 1,
      anon_sym_type,
    ACTIONS(848), 1,
      anon_sym_LBRACK,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(858), 1,
      anon_sym_await,
    ACTIONS(950), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1300), 1,
      sym_list_splat_pattern,
    STATE(1718), 1,
      sym_expression,
    STATE(2272), 1,
      sym_pattern,
    STATE(2676), 1,
      sym__patterns,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2828), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1305), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(844), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3980] = 31,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(952), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1313), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2452), 1,
      sym_pattern,
    STATE(2668), 1,
      sym__patterns,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1315), 2,
      sym_attribute,
      sym_subscript,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4106] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(954), 1,
      sym_identifier,
    ACTIONS(958), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_STAR,
    ACTIONS(964), 1,
      anon_sym_type,
    ACTIONS(966), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1448), 1,
      sym_list_splat_pattern,
    STATE(1637), 1,
      sym_pattern,
    STATE(1646), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1288), 2,
      sym_attribute,
      sym_subscript,
    STATE(1625), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(956), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4213] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(954), 1,
      sym_identifier,
    ACTIONS(958), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_STAR,
    ACTIONS(964), 1,
      anon_sym_type,
    ACTIONS(966), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1448), 1,
      sym_list_splat_pattern,
    STATE(1637), 1,
      sym_pattern,
    STATE(1646), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1288), 2,
      sym_attribute,
      sym_subscript,
    STATE(1625), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(970), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4320] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(982), 1,
      anon_sym_RBRACK,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4434] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(990), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4548] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(992), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4662] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(994), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4776] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(996), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4890] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(998), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5004] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1000), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5118] = 27,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(1002), 1,
      sym_identifier,
    ACTIONS(1004), 1,
      anon_sym_LPAREN,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1010), 1,
      anon_sym_type,
    ACTIONS(1012), 1,
      anon_sym_LBRACK,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1018), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1199), 1,
      sym_list_splat_pattern,
    STATE(1759), 1,
      sym_expression,
    STATE(2616), 1,
      sym_pattern,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    STATE(1201), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1008), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2028), 4,
      sym_expression_list,
      sym_pattern_list,
      sym_yield,
      sym__f_expression,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5234] = 26,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1020), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5348] = 27,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(1002), 1,
      sym_identifier,
    ACTIONS(1004), 1,
      anon_sym_LPAREN,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1010), 1,
      anon_sym_type,
    ACTIONS(1012), 1,
      anon_sym_LBRACK,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1018), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1199), 1,
      sym_list_splat_pattern,
    STATE(1759), 1,
      sym_expression,
    STATE(2616), 1,
      sym_pattern,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    STATE(1201), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1008), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2118), 4,
      sym_expression_list,
      sym_pattern_list,
      sym_yield,
      sym__f_expression,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5464] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2110), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5575] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(1922), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5686] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2115), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5797] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2362), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5908] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1028), 1,
      anon_sym_RPAREN,
    ACTIONS(1030), 1,
      anon_sym_COMMA,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1745), 1,
      sym_expression,
    STATE(2393), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2391), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6023] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1042), 1,
      sym_identifier,
    ACTIONS(1044), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1755), 1,
      sym_expression,
    STATE(1960), 1,
      sym_type,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1933), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6134] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2510), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6245] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1060), 1,
      anon_sym_STAR,
    ACTIONS(1062), 1,
      anon_sym_STAR_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1763), 1,
      sym_expression,
    STATE(2117), 1,
      sym_type,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1954), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6356] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2121), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6467] = 27,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1028), 1,
      anon_sym_RPAREN,
    ACTIONS(1030), 1,
      anon_sym_COMMA,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1905), 1,
      sym_expression,
    STATE(2393), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2391), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6582] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1042), 1,
      sym_identifier,
    ACTIONS(1044), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1755), 1,
      sym_expression,
    STATE(1961), 1,
      sym_type,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1933), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6693] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1076), 1,
      anon_sym_RPAREN,
    ACTIONS(1078), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1717), 1,
      sym_expression,
    STATE(2288), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2287), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6808] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1080), 1,
      anon_sym_RPAREN,
    ACTIONS(1082), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2388), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6923] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2479), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7034] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1084), 1,
      anon_sym_RPAREN,
    ACTIONS(1086), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1709), 1,
      sym_expression,
    STATE(2499), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2498), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7149] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1088), 1,
      sym_identifier,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1092), 1,
      anon_sym_STAR,
    ACTIONS(1096), 1,
      anon_sym_type,
    ACTIONS(1098), 1,
      anon_sym_LBRACK,
    ACTIONS(1100), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1507), 1,
      sym_list_splat_pattern,
    STATE(1630), 1,
      sym_primary_expression,
    STATE(1656), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1514), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1094), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(956), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7254] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2478), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7365] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1102), 1,
      anon_sym_RPAREN,
    ACTIONS(1104), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1722), 1,
      sym_expression,
    STATE(2335), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2334), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7480] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2111), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7591] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1108), 1,
      anon_sym_RPAREN,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1735), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2422), 1,
      sym_with_item,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7708] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1116), 1,
      anon_sym_RPAREN,
    ACTIONS(1118), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1726), 1,
      sym_expression,
    STATE(2370), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2369), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7823] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2077), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7934] = 25,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1122), 1,
      anon_sym_from,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1757), 1,
      sym_expression,
    STATE(2037), 1,
      sym_expression_list,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1124), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8045] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1132), 1,
      anon_sym_RPAREN,
    ACTIONS(1134), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1730), 1,
      sym_expression,
    STATE(2405), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2404), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8160] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2508), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8271] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1042), 1,
      sym_identifier,
    ACTIONS(1044), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1755), 1,
      sym_expression,
    STATE(1937), 1,
      sym_type,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1933), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8382] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1088), 1,
      sym_identifier,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1092), 1,
      anon_sym_STAR,
    ACTIONS(1096), 1,
      anon_sym_type,
    ACTIONS(1098), 1,
      anon_sym_LBRACK,
    ACTIONS(1100), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1507), 1,
      sym_list_splat_pattern,
    STATE(1630), 1,
      sym_primary_expression,
    STATE(1656), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1514), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1094), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(970), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8487] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2290), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8598] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1024), 1,
      sym_identifier,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1032), 1,
      anon_sym_STAR,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1038), 1,
      anon_sym_type,
    ACTIONS(1040), 1,
      anon_sym_await,
    ACTIONS(1136), 1,
      anon_sym_RPAREN,
    ACTIONS(1138), 1,
      anon_sym_COMMA,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1736), 1,
      sym_expression,
    STATE(2436), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2435), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1034), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8713] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1060), 1,
      anon_sym_STAR,
    ACTIONS(1062), 1,
      anon_sym_STAR_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1763), 1,
      sym_expression,
    STATE(1962), 1,
      sym_type,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1954), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8824] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1042), 1,
      sym_identifier,
    ACTIONS(1044), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1755), 1,
      sym_expression,
    STATE(2112), 1,
      sym_type,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1933), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8935] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(1916), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9046] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(1935), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9157] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_STAR,
    ACTIONS(978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(1946), 1,
      sym_type,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2083), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9268] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1060), 1,
      anon_sym_STAR,
    ACTIONS(1062), 1,
      anon_sym_STAR_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1763), 1,
      sym_expression,
    STATE(1975), 1,
      sym_type,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1954), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9379] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2474), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9490] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1022), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2477), 1,
      sym_type,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2070), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9601] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1058), 1,
      sym_identifier,
    ACTIONS(1060), 1,
      anon_sym_STAR,
    ACTIONS(1062), 1,
      anon_sym_STAR_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1763), 1,
      sym_expression,
    STATE(1979), 1,
      sym_type,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1954), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9712] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1725), 1,
      sym_expression,
    STATE(2359), 1,
      sym_yield,
    STATE(2382), 1,
      sym_list_splat,
    STATE(2383), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    STATE(2825), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9828] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1150), 1,
      anon_sym_RBRACK,
    ACTIONS(1152), 1,
      anon_sym_await,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1742), 1,
      sym_expression,
    STATE(2726), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9940] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1716), 1,
      sym_expression,
    STATE(2276), 1,
      sym_yield,
    STATE(2471), 1,
      sym_list_splat,
    STATE(2473), 1,
      sym_parenthesized_list_splat,
    STATE(2806), 1,
      sym__named_expression_lhs,
    STATE(2808), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10056] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1156), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10168] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10280] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1160), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10392] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10504] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10616] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1166), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10728] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2392), 1,
      sym_yield,
    STATE(2690), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10842] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1708), 1,
      sym_expression,
    STATE(2429), 1,
      sym_yield,
    STATE(2648), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10956] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1716), 1,
      sym_expression,
    STATE(2276), 1,
      sym_yield,
    STATE(2806), 1,
      sym__named_expression_lhs,
    STATE(2808), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11070] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1172), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1741), 1,
      sym_expression,
    STATE(2659), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11182] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1174), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1738), 1,
      sym_expression,
    STATE(2482), 1,
      sym_yield,
    STATE(2752), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11296] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1176), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1744), 1,
      sym_expression,
    STATE(2696), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11408] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11520] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1180), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11632] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11744] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1184), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11856] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1186), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11968] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2392), 1,
      sym_yield,
    STATE(2434), 1,
      sym_list_splat,
    STATE(2437), 1,
      sym_parenthesized_list_splat,
    STATE(2690), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12084] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1188), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12196] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1725), 1,
      sym_expression,
    STATE(2359), 1,
      sym_yield,
    STATE(2806), 1,
      sym__named_expression_lhs,
    STATE(2825), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12310] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1190), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1713), 1,
      sym_expression,
    STATE(2639), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12422] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1192), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1718), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    STATE(2828), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12534] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1721), 1,
      sym_expression,
    STATE(2327), 1,
      sym_yield,
    STATE(2382), 1,
      sym_list_splat,
    STATE(2383), 1,
      sym_parenthesized_list_splat,
    STATE(2714), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12650] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1196), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12762] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12874] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1200), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12986] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13098] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1708), 1,
      sym_expression,
    STATE(2429), 1,
      sym_yield,
    STATE(2434), 1,
      sym_list_splat,
    STATE(2437), 1,
      sym_parenthesized_list_splat,
    STATE(2648), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13214] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1204), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13326] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1206), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13438] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1721), 1,
      sym_expression,
    STATE(2327), 1,
      sym_yield,
    STATE(2714), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13552] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1208), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1743), 1,
      sym_expression,
    STATE(2652), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13664] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13776] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1212), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13888] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1214), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14000] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1216), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14112] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1218), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14224] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1220), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14336] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1222), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14448] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1224), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14560] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1226), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14672] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14784] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1230), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14896] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1232), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15008] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1108), 1,
      anon_sym_RPAREN,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2372), 1,
      sym_yield,
    STATE(2804), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15122] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1234), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15234] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1236), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15346] = 27,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1238), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1734), 1,
      sym_expression,
    STATE(2425), 1,
      sym_yield,
    STATE(2636), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2427), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15460] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(842), 1,
      anon_sym_STAR,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1144), 1,
      anon_sym_LPAREN,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2678), 1,
      sym__collection_elements,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2271), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15572] = 28,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1026), 1,
      anon_sym_LPAREN,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1238), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1734), 1,
      sym_expression,
    STATE(2425), 1,
      sym_yield,
    STATE(2471), 1,
      sym_list_splat,
    STATE(2473), 1,
      sym_parenthesized_list_splat,
    STATE(2636), 1,
      sym__collection_elements,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15688] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    ACTIONS(1242), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15800] = 23,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1795), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1244), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15905] = 25,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_RBRACE,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2045), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(868), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1248), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16014] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1258), 1,
      anon_sym_RBRACK,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2114), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1146), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1256), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16123] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(316), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16220] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1250), 1,
      anon_sym_RBRACK,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2114), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1146), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1248), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16329] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1258), 1,
      anon_sym_RPAREN,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2041), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1110), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1256), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16438] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1250), 1,
      anon_sym_RPAREN,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2041), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1110), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1248), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16547] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    ACTIONS(1268), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2114), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1146), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1266), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16656] = 25,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    ACTIONS(1270), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_STAR,
    ACTIONS(1274), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(2000), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2534), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16765] = 25,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    ACTIONS(1268), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2045), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(868), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1266), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16874] = 25,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1036), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_STAR,
    ACTIONS(1072), 1,
      anon_sym_type,
    ACTIONS(1074), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1990), 1,
      sym_expression,
    STATE(2585), 1,
      sym_parenthesized_list_splat,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2576), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1070), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16983] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    ACTIONS(1268), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2041), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1110), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1266), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17092] = 25,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    ACTIONS(1278), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2045), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(868), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1276), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17201] = 25,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1282), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_STAR,
    ACTIONS(1286), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1924), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2612), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17310] = 25,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1286), 1,
      anon_sym_RPAREN,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1290), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1939), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2570), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17419] = 25,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1274), 1,
      anon_sym_RBRACK,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1282), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1924), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2612), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17528] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    ACTIONS(1278), 1,
      anon_sym_RPAREN,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2041), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1110), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1276), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17637] = 25,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1274), 1,
      anon_sym_RPAREN,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1290), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1939), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2570), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17746] = 23,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1795), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1292), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17851] = 25,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    ACTIONS(1270), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_STAR,
    ACTIONS(1286), 1,
      anon_sym_RBRACE,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(2000), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2534), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17960] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    ACTIONS(1278), 1,
      anon_sym_RBRACK,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2114), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1146), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1276), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18069] = 25,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    ACTIONS(1258), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2045), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(868), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1256), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18178] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1294), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18286] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1296), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18394] = 24,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(856), 1,
      anon_sym_yield,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1282), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1924), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2612), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18500] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1298), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18608] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1300), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18716] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1302), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18824] = 24,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1290), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1939), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2570), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18930] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19038] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1306), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19146] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1310), 1,
      anon_sym_from,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1777), 1,
      sym_expression,
    STATE(2397), 1,
      sym_expression_list,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1308), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19254] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1314), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19362] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1316), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19470] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1318), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19578] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1320), 1,
      anon_sym_from,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1810), 1,
      sym_expression,
    STATE(2549), 1,
      sym_expression_list,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1124), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19686] = 24,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(880), 1,
      anon_sym_yield,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    ACTIONS(1270), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_STAR,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(2000), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2534), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19792] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1322), 1,
      anon_sym_from,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1864), 1,
      sym_expression,
    STATE(2601), 1,
      sym_expression_list,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1124), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19900] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1326), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20008] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_from,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1895), 1,
      sym_expression,
    STATE(2577), 1,
      sym_expression_list,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1124), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20116] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1332), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20224] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1334), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20332] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1336), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20440] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1338), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20548] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1340), 1,
      anon_sym_RBRACE,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20656] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1344), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20763] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1346), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20870] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1348), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20977] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1350), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21084] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1352), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21191] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1354), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21298] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1356), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21405] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(666), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21500] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1358), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21607] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1360), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21714] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1362), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21821] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1364), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21928] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1847), 1,
      sym_expression,
    STATE(2543), 1,
      sym_expression_list,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1366), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22033] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1368), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22140] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1370), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22247] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1372), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22354] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1374), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22461] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1376), 1,
      anon_sym_from,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1808), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1292), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22566] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1378), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22673] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1380), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22780] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1382), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22887] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1386), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1873), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1384), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22992] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1388), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23099] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1390), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23206] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1392), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23313] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1394), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23420] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1396), 1,
      anon_sym_from,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1808), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1244), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23525] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1398), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23632] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1400), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23739] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(870), 1,
      anon_sym_STAR_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2036), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2546), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23844] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1402), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23951] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1404), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24058] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1406), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24165] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1408), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24272] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1410), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24367] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1414), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1884), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24472] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1416), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24579] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    ACTIONS(1418), 1,
      anon_sym_RBRACK,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24686] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1422), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2597), 1,
      sym_with_item,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24790] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1858), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2033), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24892] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1808), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1424), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24994] = 24,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    ACTIONS(1426), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1952), 1,
      sym_expression,
    STATE(2604), 1,
      sym_with_item,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25098] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1428), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2597), 1,
      sym_with_item,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25202] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1826), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2116), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25304] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1815), 1,
      sym_expression,
    STATE(2281), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25408] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2011), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25510] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(2041), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25612] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1893), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1430), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25714] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1893), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1432), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25816] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1948), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25918] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1934), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26020] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1971), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26122] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26216] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1818), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2103), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26318] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1824), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2104), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26420] = 24,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    ACTIONS(1434), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1952), 1,
      sym_expression,
    STATE(2604), 1,
      sym_with_item,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26524] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_lambda,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2114), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26626] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1436), 1,
      anon_sym_LPAREN,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2466), 1,
      sym_with_item,
    STATE(2783), 1,
      sym__named_expression_lhs,
    STATE(2803), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26730] = 23,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1920), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26832] = 20,
    ACTIONS(294), 1,
      anon_sym_in,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(316), 1,
      anon_sym_COMMA,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26928] = 23,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1919), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27030] = 23,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1834), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2034), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27132] = 23,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2045), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27234] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(2018), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27336] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1410), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27430] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1989), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1292), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27532] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1989), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1244), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27634] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(1264), 1,
      anon_sym_lambda,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    STATE(1928), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27736] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(666), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27830] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1065), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27924] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1808), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1440), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28026] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1947), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1292), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28128] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1947), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1244), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28230] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1893), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1442), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28332] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1893), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1444), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28434] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1436), 1,
      anon_sym_LPAREN,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2466), 1,
      sym_with_item,
    STATE(2701), 1,
      sym_with_clause,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28538] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1966), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1446), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28640] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1828), 1,
      sym_expression,
    STATE(2502), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28744] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1878), 1,
      sym_expression,
    STATE(2587), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28848] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1849), 1,
      sym_expression,
    STATE(2394), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28952] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1811), 1,
      sym_expression,
    STATE(2289), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29056] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1819), 1,
      sym_expression,
    STATE(2337), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29160] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1825), 1,
      sym_expression,
    STATE(2371), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29264] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2408), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29368] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1838), 1,
      sym_expression,
    STATE(2438), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29472] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1840), 1,
      sym_expression,
    STATE(2451), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29576] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_COLON,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1842), 1,
      sym_expression,
    STATE(2457), 1,
      sym_slice,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29680] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1436), 1,
      anon_sym_LPAREN,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2466), 1,
      sym_with_item,
    STATE(2708), 1,
      sym_with_clause,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29784] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1436), 1,
      anon_sym_LPAREN,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2466), 1,
      sym_with_item,
    STATE(2715), 1,
      sym_with_clause,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29888] = 23,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(1252), 1,
      anon_sym_lambda,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1835), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2075), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29990] = 10,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1448), 1,
      anon_sym_for,
    ACTIONS(1450), 1,
      anon_sym_with,
    ACTIONS(1452), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [30065] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1454), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2002), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30166] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1862), 1,
      sym_expression,
    STATE(2611), 1,
      sym_expression_list,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30267] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1952), 1,
      sym_expression,
    STATE(2604), 1,
      sym_with_item,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30368] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1456), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1974), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30469] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1458), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1974), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30570] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1460), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2005), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30671] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2012), 1,
      sym_expression,
    STATE(2597), 1,
      sym_with_item,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30772] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2674), 1,
      sym_expression_list,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30873] = 10,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1462), 1,
      sym_identifier,
    ACTIONS(1464), 1,
      sym_string_start,
    STATE(2368), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(277), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [30948] = 11,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(294), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(1462), 1,
      sym_identifier,
    ACTIONS(1464), 1,
      sym_string_start,
    STATE(2368), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [31025] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1466), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1974), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31126] = 10,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1468), 1,
      anon_sym_for,
    ACTIONS(1470), 1,
      anon_sym_with,
    ACTIONS(1472), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [31201] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1474), 1,
      anon_sym_COLON,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1974), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31302] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1292), 1,
      anon_sym_COLON,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2015), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31403] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1244), 1,
      anon_sym_COLON,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2015), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31504] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1872), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    STATE(2807), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31605] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1913), 1,
      sym_expression,
    STATE(2724), 1,
      sym_expression_list,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31706] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1889), 1,
      sym_expression,
    STATE(2733), 1,
      sym_expression_list,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31807] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1936), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31905] = 9,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1482), 1,
      anon_sym_except,
    ACTIONS(1484), 1,
      anon_sym_finally,
    STATE(710), 1,
      sym_else_clause,
    STATE(772), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(614), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1476), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1478), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31977] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1844), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32075] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(2007), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32173] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1846), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32271] = 9,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1484), 1,
      anon_sym_finally,
    ACTIONS(1486), 1,
      anon_sym_except_STAR,
    STATE(710), 1,
      sym_else_clause,
    STATE(772), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(619), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1476), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1478), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32343] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1848), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32441] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1850), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32539] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1852), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32637] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1899), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32735] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1686), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32833] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1795), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32931] = 9,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1482), 1,
      anon_sym_except,
    ACTIONS(1484), 1,
      anon_sym_finally,
    STATE(702), 1,
      sym_else_clause,
    STATE(759), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(614), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1488), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [33003] = 9,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1484), 1,
      anon_sym_finally,
    ACTIONS(1486), 1,
      anon_sym_except_STAR,
    STATE(702), 1,
      sym_else_clause,
    STATE(759), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(619), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1488), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [33075] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(2010), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33173] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1843), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33271] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33369] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1949), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33467] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33565] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1987), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33663] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1989), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33761] = 9,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1494), 1,
      anon_sym_except,
    ACTIONS(1496), 1,
      anon_sym_finally,
    STATE(714), 1,
      sym_else_clause,
    STATE(791), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(622), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1476), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1478), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [33833] = 9,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1496), 1,
      anon_sym_finally,
    ACTIONS(1498), 1,
      anon_sym_except_STAR,
    STATE(714), 1,
      sym_else_clause,
    STATE(791), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(624), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1476), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1478), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [33905] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1839), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34003] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1758), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34101] = 23,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1500), 1,
      sym_identifier,
    ACTIONS(1504), 1,
      anon_sym_type,
    ACTIONS(1506), 1,
      anon_sym_await,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1258), 1,
      sym_primary_expression,
    STATE(1981), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    STATE(1175), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1502), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34201] = 9,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1494), 1,
      anon_sym_except,
    ACTIONS(1496), 1,
      anon_sym_finally,
    STATE(716), 1,
      sym_else_clause,
    STATE(811), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(622), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1488), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [34273] = 9,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1496), 1,
      anon_sym_finally,
    ACTIONS(1498), 1,
      anon_sym_except_STAR,
    STATE(716), 1,
      sym_else_clause,
    STATE(811), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(624), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1488), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [34345] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34443] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1837), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34541] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1892), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34639] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2085), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34737] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1699), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34835] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1685), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34933] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1778), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35031] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1947), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35129] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1851), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35227] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    ACTIONS(1508), 1,
      sym_identifier,
    ACTIONS(1512), 1,
      anon_sym_type,
    ACTIONS(1514), 1,
      anon_sym_await,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1927), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    STATE(1502), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1510), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35327] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2072), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35425] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2001), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35523] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1855), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35621] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    ACTIONS(1514), 1,
      anon_sym_await,
    ACTIONS(1516), 1,
      sym_identifier,
    ACTIONS(1520), 1,
      anon_sym_type,
    STATE(1026), 1,
      sym_string,
    STATE(1285), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1927), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    STATE(1320), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1518), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35721] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2030), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35819] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1762), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35917] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1764), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36015] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1765), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36113] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1766), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36211] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1767), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36309] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1769), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36407] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2015), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36505] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2053), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36603] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1779), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36701] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36799] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1792), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36897] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1522), 1,
      sym_identifier,
    ACTIONS(1526), 1,
      anon_sym_type,
    ACTIONS(1528), 1,
      anon_sym_await,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1992), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    STATE(1508), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36997] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1750), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37095] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1698), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37193] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(2019), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37291] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1687), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37389] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1774), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37487] = 23,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1506), 1,
      anon_sym_await,
    ACTIONS(1530), 1,
      sym_identifier,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1981), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    STATE(1509), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37587] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1807), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37685] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37783] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1812), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37881] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1813), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37979] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1814), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38077] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1691), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38175] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1983), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38273] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1817), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38371] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2021), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38469] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(852), 1,
      anon_sym_not,
    ACTIONS(854), 1,
      anon_sym_lambda,
    ACTIONS(1142), 1,
      sym_identifier,
    ACTIONS(1148), 1,
      anon_sym_type,
    ACTIONS(1152), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1005), 1,
      sym_primary_expression,
    STATE(1007), 1,
      sym_string,
    STATE(1404), 1,
      sym_list_splat_pattern,
    STATE(1820), 1,
      sym_expression,
    STATE(2737), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1146), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1836), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38567] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1974), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38665] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1942), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38763] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2086), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38861] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1906), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38959] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1796), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39057] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1798), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39155] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1799), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39253] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1800), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39351] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1801), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39449] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1106), 1,
      sym_identifier,
    ACTIONS(1112), 1,
      anon_sym_type,
    ACTIONS(1114), 1,
      anon_sym_await,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1024), 1,
      sym_string,
    STATE(1421), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2806), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1110), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1856), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39547] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1784), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39645] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1944), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39743] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1785), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39841] = 22,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(860), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_type,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(878), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_await,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(988), 1,
      sym_primary_expression,
    STATE(989), 1,
      sym_string,
    STATE(1270), 1,
      sym_list_splat_pattern,
    STATE(1781), 1,
      sym_expression,
    STATE(2699), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(728), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(868), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1803), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39939] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1950), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40037] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1845), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40135] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1693), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40233] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40331] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1768), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40429] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1783), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40527] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1794), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40625] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1797), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40723] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1771), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40821] = 22,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(1014), 1,
      anon_sym_not,
    ACTIONS(1016), 1,
      anon_sym_lambda,
    ACTIONS(1120), 1,
      sym_identifier,
    ACTIONS(1128), 1,
      anon_sym_type,
    ACTIONS(1130), 1,
      anon_sym_await,
    STATE(996), 1,
      sym_primary_expression,
    STATE(998), 1,
      sym_string,
    STATE(1202), 1,
      sym_list_splat_pattern,
    STATE(1772), 1,
      sym_expression,
    STATE(2814), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(679), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1126), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1773), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40919] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(1528), 1,
      anon_sym_await,
    ACTIONS(1536), 1,
      sym_identifier,
    ACTIONS(1540), 1,
      anon_sym_type,
    STATE(1122), 1,
      sym_string,
    STATE(1187), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1992), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    STATE(1420), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1538), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41019] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1746), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41117] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1747), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41215] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1748), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41313] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1751), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41411] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1752), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41509] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1753), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41607] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1754), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41705] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2128), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41803] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1808), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41901] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2027), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41999] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(2120), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42097] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42195] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42293] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2031), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42391] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1953), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42489] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2051), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42587] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1965), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42685] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2065), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42783] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2098), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42881] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42979] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(2003), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43077] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2092), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43175] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2094), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43273] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(975), 1,
      sym_primary_expression,
    STATE(976), 1,
      sym_string,
    STATE(1062), 1,
      sym_list_splat_pattern,
    STATE(1893), 1,
      sym_expression,
    STATE(2817), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1697), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43371] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2082), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43469] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2105), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43567] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1788), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43665] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2107), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43763] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1790), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43861] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1791), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43959] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    ACTIONS(1280), 1,
      sym_identifier,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1150), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    STATE(1793), 1,
      sym_expression,
    STATE(2632), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(976), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1782), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44057] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(2108), 1,
      sym_expression,
    STATE(2783), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1756), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44155] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1050), 1,
      anon_sym_type,
    ACTIONS(1052), 1,
      anon_sym_not,
    ACTIONS(1054), 1,
      anon_sym_lambda,
    ACTIONS(1056), 1,
      anon_sym_await,
    ACTIONS(1288), 1,
      sym_identifier,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    STATE(1761), 1,
      sym_expression,
    STATE(2686), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1760), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44253] = 10,
    ACTIONS(1544), 1,
      anon_sym_COMMA,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1551), 1,
      anon_sym_COLON,
    ACTIONS(1554), 1,
      anon_sym_EQ,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    STATE(2106), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1547), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44326] = 7,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44392] = 8,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1564), 1,
      anon_sym_elif,
    STATE(617), 1,
      aux_sym_if_statement_repeat1,
    STATE(706), 1,
      sym_elif_clause,
    STATE(740), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1560), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1562), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44460] = 8,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(294), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44528] = 8,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1570), 1,
      anon_sym_elif,
    STATE(642), 1,
      aux_sym_if_statement_repeat1,
    STATE(712), 1,
      sym_elif_clause,
    STATE(818), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1568), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1566), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44596] = 5,
    ACTIONS(1576), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(614), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1572), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1574), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44658] = 8,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1564), 1,
      anon_sym_elif,
    STATE(623), 1,
      aux_sym_if_statement_repeat1,
    STATE(706), 1,
      sym_elif_clause,
    STATE(760), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1579), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1581), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44726] = 7,
    ACTIONS(1544), 1,
      anon_sym_COMMA,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1554), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(1558), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1547), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44792] = 8,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1564), 1,
      anon_sym_elif,
    STATE(630), 1,
      aux_sym_if_statement_repeat1,
    STATE(706), 1,
      sym_elif_clause,
    STATE(823), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1568), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1566), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44860] = 7,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44926] = 5,
    ACTIONS(1587), 1,
      anon_sym_except_STAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(619), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1583), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1585), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44988] = 8,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1570), 1,
      anon_sym_elif,
    STATE(642), 1,
      aux_sym_if_statement_repeat1,
    STATE(712), 1,
      sym_elif_clause,
    STATE(799), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1592), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1590), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45056] = 8,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1570), 1,
      anon_sym_elif,
    STATE(613), 1,
      aux_sym_if_statement_repeat1,
    STATE(712), 1,
      sym_elif_clause,
    STATE(801), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1560), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1562), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45124] = 5,
    ACTIONS(1594), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(622), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1572), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1574), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45186] = 8,
    ACTIONS(1480), 1,
      anon_sym_else,
    ACTIONS(1564), 1,
      anon_sym_elif,
    STATE(630), 1,
      aux_sym_if_statement_repeat1,
    STATE(706), 1,
      sym_elif_clause,
    STATE(790), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1592), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1590), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45254] = 5,
    ACTIONS(1597), 1,
      anon_sym_except_STAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(624), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1583), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1585), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45316] = 8,
    ACTIONS(1492), 1,
      anon_sym_else,
    ACTIONS(1570), 1,
      anon_sym_elif,
    STATE(620), 1,
      aux_sym_if_statement_repeat1,
    STATE(712), 1,
      sym_elif_clause,
    STATE(782), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1579), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1581), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45384] = 6,
    ACTIONS(1554), 1,
      anon_sym_EQ,
    ACTIONS(1602), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1605), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45447] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45504] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45565] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1613), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1619), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1616), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45626] = 6,
    ACTIONS(1625), 1,
      anon_sym_elif,
    STATE(630), 1,
      aux_sym_if_statement_repeat1,
    STATE(706), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1621), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1623), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45689] = 7,
    ACTIONS(1630), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1613), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1628), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(1619), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1616), 12,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45754] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45811] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45868] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45925] = 6,
    ACTIONS(1544), 1,
      anon_sym_COMMA,
    ACTIONS(1554), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1547), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45988] = 6,
    ACTIONS(1554), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1544), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1558), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1547), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46051] = 6,
    ACTIONS(1554), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1602), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1558), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1605), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46114] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46175] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46289] = 6,
    ACTIONS(1655), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1650), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1657), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1653), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46352] = 6,
    ACTIONS(1659), 1,
      anon_sym_elif,
    STATE(642), 1,
      aux_sym_if_statement_repeat1,
    STATE(712), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1621), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1623), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46415] = 6,
    ACTIONS(1669), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1671), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1667), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46478] = 6,
    ACTIONS(1664), 1,
      anon_sym_COMMA,
    ACTIONS(1669), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1671), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1667), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46541] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [46598] = 6,
    ACTIONS(1650), 1,
      anon_sym_COMMA,
    ACTIONS(1655), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1657), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1653), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1675), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46717] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1677), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1679), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46829] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1685), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46885] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46941] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1685), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46997] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47109] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1675), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1697), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1699), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47221] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1675), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47277] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1701), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47333] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1685), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47389] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1701), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47445] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1685), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1701), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47557] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1705), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1707), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1701), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47725] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1709), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47781] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1677), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1679), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47837] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1675), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47893] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1685), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1715), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1701), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48061] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1717), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1719), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1697), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1699), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48229] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48285] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48341] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48453] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1705), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1707), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1721), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1723), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48565] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1725), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1727), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48621] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_LPAREN,
    ACTIONS(1733), 1,
      anon_sym_STAR,
    ACTIONS(1737), 1,
      anon_sym_type,
    ACTIONS(1739), 1,
      anon_sym_LBRACK,
    ACTIONS(1741), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1594), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_primary_expression,
    STATE(2088), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1598), 2,
      sym_attribute,
      sym_subscript,
    STATE(2099), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(970), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1735), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48713] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1709), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48769] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48825] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1721), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1723), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48881] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1715), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48937] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1717), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1719), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49049] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1675), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1743), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1745), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49161] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1725), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1727), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49217] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_LPAREN,
    ACTIONS(1733), 1,
      anon_sym_STAR,
    ACTIONS(1737), 1,
      anon_sym_type,
    ACTIONS(1739), 1,
      anon_sym_LBRACK,
    ACTIONS(1741), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1594), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_primary_expression,
    STATE(2088), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1598), 2,
      sym_attribute,
      sym_subscript,
    STATE(2099), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(956), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1735), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49309] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1675), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49365] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1743), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1745), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49421] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49477] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1701), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1685), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49589] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49645] = 5,
    ACTIONS(1480), 1,
      anon_sym_else,
    STATE(768), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1747), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1749), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49704] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1753), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1751), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49759] = 5,
    ACTIONS(1480), 1,
      anon_sym_else,
    STATE(729), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1755), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1757), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49818] = 5,
    ACTIONS(1484), 1,
      anon_sym_finally,
    STATE(733), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1759), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1761), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49877] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1763), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1765), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49932] = 5,
    ACTIONS(1480), 1,
      anon_sym_else,
    STATE(744), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1767), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1769), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49991] = 5,
    ACTIONS(1480), 1,
      anon_sym_else,
    STATE(749), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1771), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1773), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1775), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1777), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1753), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1751), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50160] = 5,
    ACTIONS(1480), 1,
      anon_sym_else,
    STATE(753), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1779), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1781), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50219] = 5,
    ACTIONS(1480), 1,
      anon_sym_else,
    STATE(745), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1783), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1785), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50278] = 5,
    ACTIONS(1484), 1,
      anon_sym_finally,
    STATE(756), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1787), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1789), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50337] = 5,
    ACTIONS(1492), 1,
      anon_sym_else,
    STATE(788), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1747), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1749), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1775), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1777), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50451] = 5,
    ACTIONS(1492), 1,
      anon_sym_else,
    STATE(807), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1783), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1785), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50510] = 5,
    ACTIONS(1496), 1,
      anon_sym_finally,
    STATE(809), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1787), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1789), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50569] = 5,
    ACTIONS(1492), 1,
      anon_sym_else,
    STATE(822), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1755), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1757), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50628] = 5,
    ACTIONS(1496), 1,
      anon_sym_finally,
    STATE(826), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1759), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1761), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50687] = 5,
    ACTIONS(1492), 1,
      anon_sym_else,
    STATE(836), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1771), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1773), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50746] = 5,
    ACTIONS(1492), 1,
      anon_sym_else,
    STATE(727), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1767), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1769), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50805] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1763), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1765), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50860] = 5,
    ACTIONS(1492), 1,
      anon_sym_else,
    STATE(840), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1779), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1781), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50919] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1791), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1793), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50973] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1799), 1,
      anon_sym_RPAREN,
    ACTIONS(1801), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_type,
    ACTIONS(1807), 1,
      anon_sym_LBRACK,
    ACTIONS(1809), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1618), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    STATE(2452), 1,
      sym_pattern,
    STATE(2634), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1803), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51065] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1811), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1813), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51119] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_type,
    ACTIONS(1807), 1,
      anon_sym_LBRACK,
    ACTIONS(1809), 1,
      anon_sym_await,
    ACTIONS(1815), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      sym_string,
    STATE(1618), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    STATE(2452), 1,
      sym_pattern,
    STATE(2668), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1803), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51211] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1811), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1813), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1791), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1793), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51319] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1819), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1817), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51372] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2486), 1,
      sym_pattern,
    STATE(2758), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51461] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1833), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1835), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51514] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1837), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1839), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51567] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1476), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1478), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51620] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1841), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1843), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51673] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1845), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1847), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51726] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1849), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1851), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1853), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1855), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1857), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1859), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51885] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1861), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1863), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51938] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1865), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1867), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51991] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1869), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1871), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52044] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1873), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1875), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52097] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1877), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1879), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52150] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_type,
    ACTIONS(1807), 1,
      anon_sym_LBRACK,
    ACTIONS(1809), 1,
      anon_sym_await,
    ACTIONS(1881), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      sym_string,
    STATE(1618), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    STATE(2603), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1803), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52239] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2526), 1,
      sym_pattern,
    STATE(2826), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1819), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1817), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52381] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1883), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1885), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52434] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1887), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1889), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1891), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1893), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52540] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_pattern,
    STATE(2707), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52629] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1895), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1897), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1899), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1901), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52735] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1903), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1905), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52788] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1907), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1909), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52841] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1911), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1913), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1915), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1917), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52947] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1919), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1921), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53000] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1923), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1925), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1927), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1929), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53106] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1931), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1933), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1759), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1761), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53212] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1935), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1937), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1939), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1941), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53318] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    ACTIONS(1943), 1,
      anon_sym_in,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1945), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1947), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1949), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1951), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1849), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1851), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1953), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1955), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53619] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1881), 1,
      anon_sym_RBRACK,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1959), 1,
      anon_sym_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_STAR,
    ACTIONS(1965), 1,
      anon_sym_type,
    ACTIONS(1967), 1,
      anon_sym_LBRACK,
    ACTIONS(1969), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1638), 1,
      sym_primary_expression,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2607), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1653), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1963), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53708] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1971), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1973), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1975), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1977), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53814] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1979), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1981), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53867] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    ACTIONS(1983), 1,
      anon_sym_in,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1787), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1789), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54009] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1959), 1,
      anon_sym_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_STAR,
    ACTIONS(1965), 1,
      anon_sym_type,
    ACTIONS(1967), 1,
      anon_sym_LBRACK,
    ACTIONS(1969), 1,
      anon_sym_await,
    ACTIONS(1985), 1,
      anon_sym_RBRACK,
    STATE(1041), 1,
      sym_string,
    STATE(1638), 1,
      sym_primary_expression,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2607), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1653), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1963), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [54098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1989), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1987), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54151] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1993), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1991), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54204] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1995), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1997), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1476), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1478), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1488), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54363] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1865), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1867), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54416] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1877), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1879), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1999), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2001), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54522] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1935), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1937), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2003), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2005), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54628] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1939), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1941), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1945), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1947), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1949), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1951), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1953), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1955), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54840] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1971), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1973), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54893] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_type,
    ACTIONS(1807), 1,
      anon_sym_LBRACK,
    ACTIONS(1809), 1,
      anon_sym_await,
    ACTIONS(1985), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      sym_string,
    STATE(1618), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    STATE(2603), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1803), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [54982] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2007), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2009), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55035] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1787), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1789), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55088] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2011), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2013), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55141] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1488), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55194] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2003), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2005), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55247] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2011), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2013), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55300] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2017), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2015), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55353] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2021), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2019), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55406] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2025), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2023), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55459] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2007), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2009), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55512] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2017), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2015), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55565] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1873), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1875), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55618] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2021), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2019), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55671] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2029), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2027), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2033), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2031), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55777] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1837), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1839), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55830] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1869), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1871), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1883), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1885), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55936] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1907), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1909), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55989] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1923), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1925), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56042] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2357), 1,
      sym_pattern,
    STATE(2704), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56131] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1759), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1761), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56184] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1975), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1977), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56237] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1979), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1981), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56290] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1995), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1997), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1999), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2001), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2037), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2035), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2029), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2027), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56502] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2041), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2039), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56555] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1989), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1987), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56608] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2045), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2043), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2049), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2047), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1833), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1835), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56767] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2041), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2039), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56820] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2025), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2023), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1841), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1843), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56926] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1845), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1847), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56979] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1853), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1855), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57032] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1857), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1859), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57085] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1861), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1863), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1993), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1991), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57191] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2033), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2031), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57244] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2525), 1,
      sym_pattern,
    STATE(2822), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57333] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2045), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2043), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57386] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1887), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1889), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57439] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1891), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1893), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1895), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1897), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57545] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1899), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1901), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57598] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1903), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1905), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57651] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2049), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2047), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57704] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1911), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1913), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57757] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1915), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1917), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57810] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1919), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1921), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1927), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1929), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57916] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1931), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1933), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57969] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2470), 1,
      sym_pattern,
    STATE(2722), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58058] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2472), 1,
      sym_pattern,
    STATE(2731), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58147] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2354), 1,
      sym_pattern,
    STATE(2741), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58236] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2358), 1,
      sym_pattern,
    STATE(2775), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58325] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(2485), 1,
      sym_pattern,
    STATE(2756), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2037), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2035), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [58467] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1088), 1,
      sym_identifier,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1096), 1,
      anon_sym_type,
    ACTIONS(1098), 1,
      anon_sym_LBRACK,
    ACTIONS(1100), 1,
      anon_sym_await,
    ACTIONS(2051), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1507), 1,
      sym_list_splat_pattern,
    STATE(1630), 1,
      sym_primary_expression,
    STATE(1656), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1514), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1094), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58553] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_type,
    ACTIONS(1807), 1,
      anon_sym_LBRACK,
    ACTIONS(1809), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1618), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    STATE(2603), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym_attribute,
      sym_subscript,
    STATE(2606), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1803), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58639] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(1821), 1,
      sym_identifier,
    ACTIONS(1823), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 1,
      anon_sym_type,
    ACTIONS(1829), 1,
      anon_sym_LBRACK,
    ACTIONS(1831), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1624), 1,
      sym_primary_expression,
    STATE(1629), 1,
      sym_list_splat_pattern,
    STATE(1656), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1631), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1825), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58725] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1959), 1,
      anon_sym_LPAREN,
    ACTIONS(1961), 1,
      anon_sym_STAR,
    ACTIONS(1965), 1,
      anon_sym_type,
    ACTIONS(1967), 1,
      anon_sym_LBRACK,
    ACTIONS(1969), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1638), 1,
      sym_primary_expression,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2607), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1653), 2,
      sym_attribute,
      sym_subscript,
    STATE(2591), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1963), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58811] = 20,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(954), 1,
      sym_identifier,
    ACTIONS(958), 1,
      anon_sym_LPAREN,
    ACTIONS(964), 1,
      anon_sym_type,
    ACTIONS(966), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1448), 1,
      sym_list_splat_pattern,
    STATE(1637), 1,
      sym_pattern,
    STATE(1646), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1288), 2,
      sym_attribute,
      sym_subscript,
    STATE(1625), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58897] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_LPAREN,
    ACTIONS(1733), 1,
      anon_sym_STAR,
    ACTIONS(1737), 1,
      anon_sym_type,
    ACTIONS(1739), 1,
      anon_sym_LBRACK,
    ACTIONS(1741), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1594), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_primary_expression,
    STATE(2088), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1598), 2,
      sym_attribute,
      sym_subscript,
    STATE(2099), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1735), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58983] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2053), 1,
      sym_identifier,
    ACTIONS(2059), 1,
      anon_sym_type,
    ACTIONS(2061), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2055), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(1622), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2057), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59066] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2063), 1,
      sym_identifier,
    ACTIONS(2067), 1,
      anon_sym_type,
    ACTIONS(2069), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2055), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1614), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2065), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59149] = 17,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    ACTIONS(2071), 1,
      anon_sym_not,
    STATE(1007), 1,
      sym_string,
    STATE(1115), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59227] = 17,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(2073), 1,
      anon_sym_not,
    STATE(976), 1,
      sym_string,
    STATE(993), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59305] = 17,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2075), 1,
      anon_sym_not,
    STATE(1041), 1,
      sym_string,
    STATE(1146), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59383] = 17,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    ACTIONS(2077), 1,
      anon_sym_not,
    STATE(1024), 1,
      sym_string,
    STATE(1086), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59461] = 17,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    ACTIONS(2079), 1,
      anon_sym_not,
    STATE(998), 1,
      sym_string,
    STATE(1019), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59539] = 17,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    ACTIONS(2081), 1,
      anon_sym_not,
    STATE(1122), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59617] = 17,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    ACTIONS(2083), 1,
      anon_sym_not,
    STATE(989), 1,
      sym_string,
    STATE(999), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59695] = 17,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    ACTIONS(2085), 1,
      anon_sym_not,
    STATE(1026), 1,
      sym_string,
    STATE(1094), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59773] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1111), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59848] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2087), 1,
      sym_identifier,
    ACTIONS(2091), 1,
      anon_sym_type,
    ACTIONS(2093), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1638), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1451), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2089), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59927] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1033), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60002] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60077] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1101), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60152] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1011), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60227] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1015), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60302] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1019), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60377] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1020), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60452] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1051), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60527] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1027), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60602] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1029), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60677] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1036), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60752] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1146), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60827] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1003), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60902] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60977] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2095), 1,
      sym_identifier,
    ACTIONS(2099), 1,
      anon_sym_type,
    ACTIONS(2101), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1440), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2097), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61056] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1148), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61131] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1090), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61206] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1093), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61281] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1094), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61356] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1095), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61431] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1096), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61506] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1097), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61581] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1099), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61656] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1100), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61731] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1109), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61806] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1263), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61881] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61956] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62031] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1276), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62106] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1278), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62181] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1279), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62256] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1281), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62331] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1282), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62406] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(992), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62481] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1242), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62556] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1284), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62631] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2099), 1,
      anon_sym_type,
    ACTIONS(2101), 1,
      anon_sym_await,
    ACTIONS(2103), 1,
      sym_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1440), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2097), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62710] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1064), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62785] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1141), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62860] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2105), 1,
      sym_identifier,
    ACTIONS(2109), 1,
      anon_sym_type,
    ACTIONS(2111), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1059), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2107), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62939] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(990), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63014] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2113), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_type,
    ACTIONS(2119), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1612), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2115), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63093] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1061), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63168] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1139), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63243] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_type,
    ACTIONS(2127), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(629), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2123), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63322] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1140), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63397] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1084), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63472] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1085), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63547] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1086), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63622] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1087), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63697] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1088), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63772] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1089), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63847] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1091), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63922] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1092), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63997] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2129), 1,
      sym_identifier,
    ACTIONS(2133), 1,
      anon_sym_type,
    ACTIONS(2135), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1619), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2131), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64076] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(995), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64151] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(991), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64226] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2109), 1,
      anon_sym_type,
    ACTIONS(2111), 1,
      anon_sym_await,
    ACTIONS(2137), 1,
      sym_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1059), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2107), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64305] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1159), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64380] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2091), 1,
      anon_sym_type,
    ACTIONS(2093), 1,
      anon_sym_await,
    ACTIONS(2139), 1,
      sym_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1635), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1451), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2089), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64459] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1113), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64534] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1114), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64609] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1115), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64684] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1160), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64759] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(716), 1,
      anon_sym_LBRACK,
    ACTIONS(720), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      anon_sym_await,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(1262), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym_string,
    STATE(1110), 1,
      sym_primary_expression,
    STATE(1421), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(722), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(718), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1311), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64834] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_type,
    ACTIONS(2147), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1632), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1190), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2143), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64913] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1116), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64988] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1068), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65063] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1117), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65138] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1118), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65213] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2149), 1,
      sym_identifier,
    ACTIONS(2153), 1,
      anon_sym_type,
    ACTIONS(2155), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1633), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1444), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2151), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65292] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1119), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65367] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1120), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65442] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2153), 1,
      anon_sym_type,
    ACTIONS(2155), 1,
      anon_sym_await,
    ACTIONS(2157), 1,
      sym_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1633), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1444), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2151), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65521] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1017), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65596] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(994), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65671] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(993), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65746] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1123), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65821] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1254), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1124), 1,
      sym_primary_expression,
    STATE(1404), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1428), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65896] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(980), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65971] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(982), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66046] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2155), 1,
      anon_sym_await,
    ACTIONS(2159), 1,
      sym_identifier,
    ACTIONS(2163), 1,
      anon_sym_type,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1289), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2161), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66125] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(983), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66200] = 16,
    ACTIONS(681), 1,
      anon_sym_LPAREN,
    ACTIONS(687), 1,
      anon_sym_type,
    ACTIONS(689), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_LBRACE,
    ACTIONS(697), 1,
      anon_sym_await,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(1006), 1,
      anon_sym_STAR,
    STATE(998), 1,
      sym_string,
    STATE(1023), 1,
      sym_primary_expression,
    STATE(1202), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(695), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(691), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(685), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(679), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1168), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66275] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2087), 1,
      sym_identifier,
    ACTIONS(2091), 1,
      anon_sym_type,
    ACTIONS(2093), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1635), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1451), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2089), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66354] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1324), 1,
      anon_sym_STAR,
    STATE(1026), 1,
      sym_string,
    STATE(1071), 1,
      sym_primary_expression,
    STATE(1287), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1322), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66429] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1142), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66504] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2093), 1,
      anon_sym_await,
    ACTIONS(2165), 1,
      sym_identifier,
    ACTIONS(2169), 1,
      anon_sym_type,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1638), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1291), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2167), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66583] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    STATE(1041), 1,
      sym_string,
    STATE(1144), 1,
      sym_primary_expression,
    STATE(1348), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1435), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66658] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1330), 1,
      anon_sym_STAR,
    STATE(1122), 1,
      sym_string,
    STATE(1218), 1,
      sym_primary_expression,
    STATE(1465), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1470), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66733] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(985), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66808] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(976), 1,
      sym_string,
    STATE(986), 1,
      sym_primary_expression,
    STATE(1062), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1121), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66883] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1042), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66958] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1043), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67033] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(999), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67108] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1048), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67183] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1049), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67258] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1050), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67333] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1044), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67408] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1039), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67483] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2147), 1,
      anon_sym_await,
    ACTIONS(2171), 1,
      sym_identifier,
    ACTIONS(2175), 1,
      anon_sym_type,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1176), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2173), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67562] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2177), 1,
      sym_identifier,
    ACTIONS(2181), 1,
      anon_sym_type,
    ACTIONS(2183), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1630), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1501), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2179), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67641] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2125), 1,
      anon_sym_type,
    ACTIONS(2127), 1,
      anon_sym_await,
    ACTIONS(2185), 1,
      sym_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1646), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(629), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2123), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67720] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_type,
    ACTIONS(2147), 1,
      anon_sym_await,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1639), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1190), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2143), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67799] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1420), 1,
      anon_sym_STAR,
    ACTIONS(2153), 1,
      anon_sym_type,
    ACTIONS(2155), 1,
      anon_sym_await,
    ACTIONS(2157), 1,
      sym_identifier,
    STATE(1041), 1,
      sym_string,
    STATE(1348), 1,
      sym_list_splat_pattern,
    STATE(1628), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1444), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2151), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1435), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67878] = 16,
    ACTIONS(730), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1246), 1,
      anon_sym_STAR,
    STATE(989), 1,
      sym_string,
    STATE(1032), 1,
      sym_primary_expression,
    STATE(1270), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(734), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(728), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1197), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67953] = 20,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2201), 1,
      anon_sym_EQ,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2209), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_not,
    ACTIONS(2213), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2219), 1,
      anon_sym_is,
    STATE(1588), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2217), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2197), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [68035] = 5,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(978), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68087] = 5,
    ACTIONS(2225), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(977), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68139] = 5,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(977), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68191] = 8,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68248] = 8,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68305] = 5,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(987), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68356] = 10,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 24,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68417] = 14,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2213), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68486] = 5,
    ACTIONS(2240), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(984), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68537] = 13,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 19,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68604] = 12,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 20,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68669] = 5,
    ACTIONS(2243), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(987), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68720] = 20,
    ACTIONS(2201), 1,
      anon_sym_as,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2264), 1,
      anon_sym_PIPE,
    ACTIONS(2266), 1,
      anon_sym_not,
    ACTIONS(2268), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(2274), 1,
      anon_sym_is,
    STATE(1603), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2272), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [68801] = 5,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(997), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68852] = 15,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2209), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2278), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2276), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68923] = 8,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68980] = 15,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2209), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2286), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2284), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69051] = 15,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2209), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2290), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2288), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69122] = 11,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 22,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69185] = 8,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69242] = 20,
    ACTIONS(2201), 1,
      anon_sym_EQ,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2310), 1,
      anon_sym_PIPE,
    ACTIONS(2312), 1,
      anon_sym_not,
    ACTIONS(2314), 1,
      anon_sym_AMP,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(2320), 1,
      anon_sym_is,
    STATE(1600), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2318), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2300), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [69323] = 5,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(984), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69374] = 5,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(981), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69425] = 15,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2264), 1,
      anon_sym_PIPE,
    ACTIONS(2268), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2290), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2288), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69495] = 8,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69551] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69597] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69643] = 15,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2310), 1,
      anon_sym_PIPE,
    ACTIONS(2314), 1,
      anon_sym_AMP,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2286), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2284), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69713] = 5,
    ACTIONS(2322), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1004), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69763] = 20,
    ACTIONS(2201), 1,
      anon_sym_as,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2345), 1,
      anon_sym_not,
    ACTIONS(2347), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_CARET,
    ACTIONS(2353), 1,
      anon_sym_is,
    STATE(1616), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2351), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2333), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [69843] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69891] = 5,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1034), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69941] = 15,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2310), 1,
      anon_sym_PIPE,
    ACTIONS(2314), 1,
      anon_sym_AMP,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2278), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2276), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70011] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70057] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70103] = 8,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70159] = 5,
    ACTIONS(2355), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1012), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70255] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70303] = 11,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 21,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70365] = 19,
    ACTIONS(2191), 1,
      anon_sym_LPAREN,
    ACTIONS(2199), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2209), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_not,
    ACTIONS(2213), 1,
      anon_sym_AMP,
    ACTIONS(2215), 1,
      anon_sym_CARET,
    ACTIONS(2219), 1,
      anon_sym_is,
    ACTIONS(2358), 1,
      anon_sym_DOT,
    ACTIONS(2360), 1,
      anon_sym_LBRACK,
    STATE(1588), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2193), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2195), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2207), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2217), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1149), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2205), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2197), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [70443] = 8,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70499] = 8,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70555] = 15,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2310), 1,
      anon_sym_PIPE,
    ACTIONS(2314), 1,
      anon_sym_AMP,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2290), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2288), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70625] = 8,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70727] = 20,
    ACTIONS(2201), 1,
      anon_sym_as,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_PIPE,
    ACTIONS(2382), 1,
      anon_sym_not,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_CARET,
    ACTIONS(2390), 1,
      anon_sym_is,
    STATE(1617), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2388), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2370), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [70807] = 8,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70863] = 5,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1046), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70913] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70959] = 5,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1030), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71009] = 14,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2314), 1,
      anon_sym_AMP,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71077] = 5,
    ACTIONS(2392), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1028), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71127] = 13,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71193] = 5,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1028), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71243] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 32,
      sym__newline,
      sym_string_start,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71289] = 15,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2264), 1,
      anon_sym_PIPE,
    ACTIONS(2268), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2286), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2284), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71359] = 15,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2264), 1,
      anon_sym_PIPE,
    ACTIONS(2268), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2278), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2276), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71429] = 5,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1004), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71479] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71527] = 12,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71591] = 5,
    ACTIONS(2399), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1037), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71641] = 20,
    ACTIONS(2201), 1,
      anon_sym_EQ,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2420), 1,
      anon_sym_PIPE,
    ACTIONS(2422), 1,
      anon_sym_not,
    ACTIONS(2424), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(2430), 1,
      anon_sym_is,
    STATE(1599), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2428), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2410), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [71721] = 12,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71785] = 20,
    ACTIONS(2201), 1,
      anon_sym_EQ,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2452), 1,
      anon_sym_not,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(2460), 1,
      anon_sym_is,
    STATE(1596), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2458), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2440), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
  [71865] = 5,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1045), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71915] = 8,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71971] = 11,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 21,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72033] = 13,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72099] = 5,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1037), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72149] = 5,
    ACTIONS(726), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1012), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72199] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 32,
      sym__newline,
      sym_string_start,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72245] = 8,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72301] = 10,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 23,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72361] = 14,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2248), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2268), 1,
      anon_sym_AMP,
    ACTIONS(2270), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2250), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2252), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2262), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1241), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2260), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72429] = 10,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 23,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72489] = 6,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2466), 1,
      anon_sym_LBRACK,
    STATE(1941), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72540] = 5,
    ACTIONS(2468), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1053), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2223), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2221), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72589] = 5,
    ACTIONS(1544), 1,
      anon_sym_COMMA,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72638] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72683] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72728] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72818] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72867] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72912] = 14,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72979] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73024] = 6,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2483), 1,
      anon_sym_LBRACK,
    STATE(1999), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73075] = 8,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73130] = 8,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73185] = 8,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73240] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(714), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73289] = 8,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73344] = 8,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [73444] = 8,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73499] = 8,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73599] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73644] = 6,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(671), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73695] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73740] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73785] = 6,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(671), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [73881] = 6,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1619), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1611), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1616), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73977] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74022] = 15,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2286), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2284), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74091] = 8,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74146] = 11,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74207] = 15,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_PIPE,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2290), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2288), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74276] = 8,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74331] = 10,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74390] = 14,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74457] = 8,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74512] = 13,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2386), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74577] = 12,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74640] = 11,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74701] = 15,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2420), 1,
      anon_sym_PIPE,
    ACTIONS(2424), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2290), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2288), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74770] = 8,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74825] = 10,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74884] = 14,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2424), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74951] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74996] = 13,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75061] = 12,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75124] = 15,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2278), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2276), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75193] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75373] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75418] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75463] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75508] = 15,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2420), 1,
      anon_sym_PIPE,
    ACTIONS(2424), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2286), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2284), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75577] = 15,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_PIPE,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2278), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2276), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75646] = 15,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2420), 1,
      anon_sym_PIPE,
    ACTIONS(2424), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2278), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2276), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75715] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75760] = 8,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75815] = 11,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 20,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75876] = 15,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2290), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2288), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75945] = 8,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76000] = 10,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 22,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76059] = 14,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2347), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76126] = 13,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2349), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76191] = 12,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76254] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76299] = 5,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1143), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1547), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76348] = 15,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2286), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2284), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76417] = 15,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_LPAREN,
    ACTIONS(2335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2329), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2331), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2341), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1431), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2278), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2339), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2276), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76486] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76531] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(714), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76580] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76625] = 5,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2521), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76674] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76721] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76768] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76815] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76905] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76950] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76995] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77040] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77085] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77130] = 13,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77195] = 12,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77258] = 10,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77317] = 8,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77372] = 5,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1053), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2230), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77421] = 11,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77482] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77527] = 15,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2290), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2288), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77596] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77641] = 8,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77741] = 19,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PIPE,
    ACTIONS(2571), 1,
      anon_sym_not,
    ACTIONS(2573), 1,
      anon_sym_AMP,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(2579), 1,
      anon_sym_is,
    STATE(1602), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2577), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2559), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2187), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [77818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77863] = 5,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77912] = 5,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77961] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78010] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78059] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78106] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78153] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78200] = 8,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78255] = 15,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2364), 1,
      anon_sym_LPAREN,
    ACTIONS(2372), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_PIPE,
    ACTIONS(2384), 1,
      anon_sym_AMP,
    ACTIONS(2386), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2366), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2368), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2378), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1338), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2286), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2376), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2284), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78324] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78368] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78412] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78456] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78548] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78592] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78636] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78680] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78724] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78772] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78820] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78864] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78908] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78952] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1611), 3,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1616), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78998] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79046] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79090] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79182] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79230] = 5,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1611), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1616), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79322] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79366] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79410] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79454] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79498] = 19,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2569), 1,
      anon_sym_PIPE,
    ACTIONS(2571), 1,
      anon_sym_not,
    ACTIONS(2573), 1,
      anon_sym_AMP,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(2579), 1,
      anon_sym_is,
    STATE(1602), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2577), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2559), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [79574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79618] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79662] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79710] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79754] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79798] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79886] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79930] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79974] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80018] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80062] = 4,
    ACTIONS(1602), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80152] = 4,
    ACTIONS(1544), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80198] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80242] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80286] = 4,
    ACTIONS(1650), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80332] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80376] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80424] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80468] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80512] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80556] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80604] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80650] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80696] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80742] = 4,
    ACTIONS(1664), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80788] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80876] = 6,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    STATE(2106), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80926] = 8,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2282), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2280), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80980] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81024] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81068] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81112] = 5,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1544), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81160] = 8,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2232), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81214] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81258] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81302] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81390] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81436] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81480] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81526] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81570] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81616] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81662] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81706] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81794] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81842] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81886] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81930] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81978] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82022] = 15,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PIPE,
    ACTIONS(2573), 1,
      anon_sym_AMP,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2284), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82090] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82134] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82222] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82310] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82356] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82402] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82536] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82580] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82624] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82670] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82760] = 19,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2294), 1,
      anon_sym_LPAREN,
    ACTIONS(2302), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2310), 1,
      anon_sym_PIPE,
    ACTIONS(2312), 1,
      anon_sym_not,
    ACTIONS(2314), 1,
      anon_sym_AMP,
    ACTIONS(2316), 1,
      anon_sym_CARET,
    ACTIONS(2320), 1,
      anon_sym_is,
    STATE(1600), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2298), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2308), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2318), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1174), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2306), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2300), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [82836] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82884] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82976] = 5,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1544), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83024] = 8,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83078] = 11,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2238), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83182] = 5,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1611), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1616), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83318] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83362] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83406] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83454] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83542] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83586] = 15,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PIPE,
    ACTIONS(2573), 1,
      anon_sym_AMP,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2290), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2288), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83654] = 8,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2238), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2236), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83708] = 6,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2585), 1,
      anon_sym_LBRACK,
    STATE(2067), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83758] = 10,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2238), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83816] = 14,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(2573), 1,
      anon_sym_AMP,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2238), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83882] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83926] = 13,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2238), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83990] = 12,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2238), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2236), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [84096] = 15,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_PIPE,
    ACTIONS(2573), 1,
      anon_sym_AMP,
    ACTIONS(2575), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2555), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2567), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1464), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2565), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2276), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84164] = 19,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2412), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2420), 1,
      anon_sym_PIPE,
    ACTIONS(2422), 1,
      anon_sym_not,
    ACTIONS(2424), 1,
      anon_sym_AMP,
    ACTIONS(2426), 1,
      anon_sym_CARET,
    ACTIONS(2430), 1,
      anon_sym_is,
    STATE(1599), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2406), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2408), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2428), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1347), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2416), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2187), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2410), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [84240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84284] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84327] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1547), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1558), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [84372] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84419] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1662), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1667), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1671), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [84464] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84511] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84597] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84683] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84726] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84769] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84812] = 7,
    ACTIONS(1630), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 5,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1611), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1613), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [84863] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1602), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1605), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84908] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84951] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84994] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85037] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85080] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1544), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85211] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85254] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1650), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1653), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85299] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85342] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85385] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85428] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1602), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1605), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85473] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85516] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1544), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85561] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85604] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1650), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85649] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85696] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85743] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1611), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1616), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85788] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85831] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85874] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85917] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86003] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1667), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86048] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86134] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86181] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86224] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86271] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86316] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86361] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86406] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86535] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86664] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86707] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86879] = 7,
    ACTIONS(1630), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1611), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1613), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [86930] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86973] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87016] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87059] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87102] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87145] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87231] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87360] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(714), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87407] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(714), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87454] = 5,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2521), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87587] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87630] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87673] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87716] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87759] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1667), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87847] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87933] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88062] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88148] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88191] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88234] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88277] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88320] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88363] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88406] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88492] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88535] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88578] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88664] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88707] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88922] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88965] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89051] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89137] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89180] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89223] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89266] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89309] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89356] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89403] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89446] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89489] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89618] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89704] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89749] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89794] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89837] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89880] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89923] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90009] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90095] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1611), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1616), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90140] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90183] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90226] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90269] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90312] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90355] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90398] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90441] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90484] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90527] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90570] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90656] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90871] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90957] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91004] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2397), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2395), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91047] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91094] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91141] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91231] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91317] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1600), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1605), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1558), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [91362] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1648), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1653), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1657), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [91407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2491), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2489), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91449] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91495] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91541] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91587] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91631] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91675] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91719] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1648), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91803] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91845] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1662), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91887] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2479), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91929] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91973] = 7,
    ACTIONS(1630), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 4,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1611), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1613), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [92023] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2549), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2547), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92065] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1600), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92107] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92149] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2533), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2531), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92191] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2487), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2485), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92233] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1542), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2515), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2513), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92359] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92403] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92447] = 4,
    ACTIONS(1549), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92491] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2507), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92533] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92617] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2583), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2581), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92659] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2511), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2509), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92701] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2473), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2471), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92743] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2477), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2475), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92785] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92829] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2537), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2535), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92871] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2541), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2539), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92913] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2545), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2543), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92955] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2499), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2497), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92997] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2503), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2501), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93039] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1619), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    ACTIONS(1611), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1613), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93087] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93131] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1644), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1636), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93215] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1632), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93299] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93341] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1607), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93383] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2495), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2493), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93425] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93468] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1640), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93509] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1648), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1653), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1657), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1646), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1644), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93593] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1613), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1616), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1611), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93636] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1642), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1640), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93718] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1607), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93759] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(701), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93802] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(701), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93845] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1600), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1605), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1558), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93888] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93929] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1616), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93970] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1662), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1667), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1671), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94013] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1636), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94054] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1634), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1632), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94095] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94138] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1547), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1558), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94181] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1607), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94222] = 20,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2587), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2591), 1,
      anon_sym_STAR,
    ACTIONS(2593), 1,
      anon_sym_if,
    ACTIONS(2595), 1,
      anon_sym_COLON,
    ACTIONS(2597), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2207), 1,
      sym_case_pattern,
    STATE(2821), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2245), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2603), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2009), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94296] = 20,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2587), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2591), 1,
      anon_sym_STAR,
    ACTIONS(2593), 1,
      anon_sym_if,
    ACTIONS(2597), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2611), 1,
      anon_sym_COLON,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2207), 1,
      sym_case_pattern,
    STATE(2800), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2245), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2603), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2009), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94370] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2617), 1,
      anon_sym_RPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94438] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2645), 1,
      anon_sym_RBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94506] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2657), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94574] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2659), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94642] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2661), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94710] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2663), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94778] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2665), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94846] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2667), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2202), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94914] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2669), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94982] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2671), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95050] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2673), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95118] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2675), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95186] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2677), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95254] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95322] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2681), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2166), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95390] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2683), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2167), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95458] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95526] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2687), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95594] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2689), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95662] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2691), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95730] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2693), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2141), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95798] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2695), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2185), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95866] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2697), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2186), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95934] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2699), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2206), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96002] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2203), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96070] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2703), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2180), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96138] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2705), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96206] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2707), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96274] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2709), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96342] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2711), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2151), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96410] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2189), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96478] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2715), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96546] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2717), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96614] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2719), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96682] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2721), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2201), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96750] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2723), 1,
      anon_sym_RPAREN,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96818] = 17,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2587), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2591), 1,
      anon_sym_STAR,
    ACTIONS(2597), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2207), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2245), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2603), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2009), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96883] = 17,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2613), 1,
      sym_identifier,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    STATE(2386), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2522), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2627), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2048), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96948] = 17,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    STATE(2306), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2521), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2649), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2138), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97013] = 17,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(2725), 1,
      sym_identifier,
    ACTIONS(2727), 1,
      anon_sym_LPAREN,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2733), 1,
      anon_sym_LBRACK,
    ACTIONS(2735), 1,
      anon_sym_DASH,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(2741), 1,
      sym_integer,
    ACTIONS(2743), 1,
      sym_float,
    STATE(1900), 1,
      sym_string,
    STATE(2042), 1,
      sym_dotted_name,
    STATE(2514), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2351), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2737), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2043), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97078] = 17,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2587), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2591), 1,
      anon_sym_STAR,
    ACTIONS(2597), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2008), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2245), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2603), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2009), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97143] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2749), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97209] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2751), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97275] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2753), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97341] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2755), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97407] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2757), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97473] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2759), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2090), 1,
      sym_splat_pattern,
    STATE(2501), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97539] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2761), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97605] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2763), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97671] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2765), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97737] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2767), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2047), 1,
      sym_splat_pattern,
    STATE(2440), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97803] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2769), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97869] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2771), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97935] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2773), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2123), 1,
      sym_splat_pattern,
    STATE(2308), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98001] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2775), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98067] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2777), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2040), 1,
      sym_splat_pattern,
    STATE(2509), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98133] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2779), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98199] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2781), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98265] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2783), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98331] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2785), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98397] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(2787), 1,
      anon_sym_RBRACE,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98463] = 17,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2745), 1,
      sym_identifier,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    STATE(2267), 1,
      sym_splat_pattern,
    STATE(2623), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2747), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2493), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98526] = 15,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2591), 1,
      anon_sym_STAR,
    ACTIONS(2597), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2745), 1,
      sym_identifier,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2789), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1993), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98584] = 15,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2791), 1,
      sym_identifier,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2793), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2057), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98642] = 15,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2795), 1,
      sym_identifier,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2797), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2134), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98700] = 15,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(2727), 1,
      anon_sym_LPAREN,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2733), 1,
      anon_sym_LBRACK,
    ACTIONS(2735), 1,
      anon_sym_DASH,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(2741), 1,
      sym_integer,
    ACTIONS(2743), 1,
      sym_float,
    ACTIONS(2799), 1,
      sym_identifier,
    STATE(1900), 1,
      sym_string,
    STATE(2042), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2801), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2059), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98758] = 15,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(2727), 1,
      anon_sym_LPAREN,
    ACTIONS(2729), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2733), 1,
      anon_sym_LBRACK,
    ACTIONS(2735), 1,
      anon_sym_DASH,
    ACTIONS(2739), 1,
      anon_sym_LBRACE,
    ACTIONS(2741), 1,
      sym_integer,
    ACTIONS(2743), 1,
      sym_float,
    ACTIONS(2799), 1,
      sym_identifier,
    STATE(1900), 1,
      sym_string,
    STATE(2042), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2803), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2060), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98816] = 15,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    ACTIONS(2591), 1,
      anon_sym_STAR,
    ACTIONS(2597), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2599), 1,
      anon_sym_LBRACK,
    ACTIONS(2601), 1,
      anon_sym_DASH,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
    ACTIONS(2607), 1,
      sym_integer,
    ACTIONS(2609), 1,
      sym_float,
    ACTIONS(2745), 1,
      sym_identifier,
    STATE(1857), 1,
      sym_string,
    STATE(2006), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2805), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1985), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98874] = 15,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2615), 1,
      anon_sym_LPAREN,
    ACTIONS(2619), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2623), 1,
      anon_sym_LBRACK,
    ACTIONS(2625), 1,
      anon_sym_DASH,
    ACTIONS(2629), 1,
      anon_sym_LBRACE,
    ACTIONS(2631), 1,
      sym_integer,
    ACTIONS(2633), 1,
      sym_float,
    ACTIONS(2795), 1,
      sym_identifier,
    STATE(1865), 1,
      sym_string,
    STATE(2046), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2807), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2137), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98932] = 15,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2637), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2643), 1,
      anon_sym_LBRACK,
    ACTIONS(2647), 1,
      anon_sym_DASH,
    ACTIONS(2651), 1,
      anon_sym_LBRACE,
    ACTIONS(2653), 1,
      sym_integer,
    ACTIONS(2655), 1,
      sym_float,
    ACTIONS(2791), 1,
      sym_identifier,
    STATE(1881), 1,
      sym_string,
    STATE(2050), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2809), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2062), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98990] = 8,
    ACTIONS(2211), 1,
      anon_sym_not,
    ACTIONS(2219), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1589), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2217), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2197), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99032] = 8,
    ACTIONS(2820), 1,
      anon_sym_EQ,
    ACTIONS(2822), 1,
      anon_sym_not,
    ACTIONS(2828), 1,
      anon_sym_is,
    STATE(1589), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2817), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99074] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1671), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1662), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99106] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99138] = 8,
    ACTIONS(2820), 1,
      anon_sym_EQ,
    ACTIONS(2834), 1,
      anon_sym_not,
    ACTIONS(2840), 1,
      anon_sym_is,
    STATE(1592), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2837), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2831), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99178] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99210] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1605), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1558), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1600), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99242] = 8,
    ACTIONS(2820), 1,
      anon_sym_EQ,
    ACTIONS(2846), 1,
      anon_sym_not,
    ACTIONS(2852), 1,
      anon_sym_is,
    STATE(1595), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2849), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2843), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99282] = 8,
    ACTIONS(2452), 1,
      anon_sym_not,
    ACTIONS(2460), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1595), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2458), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2440), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99322] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1657), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1648), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99354] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1558), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99386] = 8,
    ACTIONS(2422), 1,
      anon_sym_not,
    ACTIONS(2430), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1592), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2410), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99426] = 8,
    ACTIONS(2312), 1,
      anon_sym_not,
    ACTIONS(2320), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1604), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2318), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2300), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [99465] = 7,
    ACTIONS(2858), 1,
      anon_sym_not,
    ACTIONS(2864), 1,
      anon_sym_is,
    STATE(1601), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2861), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99502] = 7,
    ACTIONS(2571), 1,
      anon_sym_not,
    ACTIONS(2579), 1,
      anon_sym_is,
    STATE(1601), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2577), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2559), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [99539] = 8,
    ACTIONS(2266), 1,
      anon_sym_not,
    ACTIONS(2274), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_as,
    STATE(1605), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2272), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2254), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [99578] = 8,
    ACTIONS(2820), 1,
      anon_sym_EQ,
    ACTIONS(2870), 1,
      anon_sym_not,
    ACTIONS(2876), 1,
      anon_sym_is,
    STATE(1604), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2873), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2867), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [99617] = 8,
    ACTIONS(2820), 1,
      anon_sym_as,
    ACTIONS(2882), 1,
      anon_sym_not,
    ACTIONS(2888), 1,
      anon_sym_is,
    STATE(1605), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2885), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2879), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [99656] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1410), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99686] = 4,
    ACTIONS(2893), 1,
      anon_sym_COMMA,
    STATE(1607), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [99716] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1410), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99746] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99776] = 4,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    STATE(1607), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(970), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [99806] = 8,
    ACTIONS(2820), 1,
      anon_sym_as,
    ACTIONS(2901), 1,
      anon_sym_not,
    ACTIONS(2907), 1,
      anon_sym_is,
    STATE(1611), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2904), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2898), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [99844] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2910), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99874] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99904] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1611), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99934] = 8,
    ACTIONS(2820), 1,
      anon_sym_as,
    ACTIONS(2915), 1,
      anon_sym_not,
    ACTIONS(2921), 1,
      anon_sym_is,
    STATE(1615), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2918), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2912), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2815), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [99972] = 8,
    ACTIONS(2345), 1,
      anon_sym_not,
    ACTIONS(2353), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_as,
    STATE(1615), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2351), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2333), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [100010] = 8,
    ACTIONS(2382), 1,
      anon_sym_not,
    ACTIONS(2390), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_as,
    STATE(1611), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2388), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [100048] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1605), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100077] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2910), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100106] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1558), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100135] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1657), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1648), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100164] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1611), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100193] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100222] = 13,
    ACTIONS(2432), 1,
      anon_sym_DOT,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2444), 1,
      anon_sym_LBRACK,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100269] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100294] = 13,
    ACTIONS(2189), 1,
      anon_sym_DOT,
    ACTIONS(2203), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100341] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1671), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1662), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100370] = 13,
    ACTIONS(2362), 1,
      anon_sym_DOT,
    ACTIONS(2374), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100417] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1605), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100446] = 13,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(2924), 1,
      anon_sym_DOT,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100493] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1558), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100522] = 13,
    ACTIONS(2292), 1,
      anon_sym_DOT,
    ACTIONS(2304), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100569] = 13,
    ACTIONS(2402), 1,
      anon_sym_DOT,
    ACTIONS(2414), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100616] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1657), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1648), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100645] = 13,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(2551), 1,
      anon_sym_DOT,
    ACTIONS(2563), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100692] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1671), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1662), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100721] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100746] = 13,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2337), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100793] = 13,
    ACTIONS(2246), 1,
      anon_sym_DOT,
    ACTIONS(2258), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100840] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100869] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100898] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1410), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100927] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100956] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2928), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100981] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1657), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1648), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101010] = 13,
    ACTIONS(2358), 1,
      anon_sym_DOT,
    ACTIONS(2360), 1,
      anon_sym_LBRACK,
    ACTIONS(2434), 1,
      anon_sym_LPAREN,
    ACTIONS(2442), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2454), 1,
      anon_sym_AMP,
    ACTIONS(2456), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2436), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2438), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2448), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1316), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2446), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [101057] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2930), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101082] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101111] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1667), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1671), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1662), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101140] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1605), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101169] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101198] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1410), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101227] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1547), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1558), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1542), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101256] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101285] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [101314] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101338] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2938), 1,
      anon_sym_COLON,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2666), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101384] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2930), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101408] = 4,
    ACTIONS(2944), 1,
      anon_sym_COMMA,
    STATE(1670), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(970), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101436] = 5,
    ACTIONS(2948), 1,
      anon_sym_COLON,
    ACTIONS(2950), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2946), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2952), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101466] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2954), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2743), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101512] = 6,
    ACTIONS(2948), 1,
      anon_sym_COLON,
    ACTIONS(2950), 1,
      anon_sym_EQ,
    ACTIONS(2956), 1,
      anon_sym_COMMA,
    STATE(1659), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2952), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101544] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101568] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2958), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2713), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101614] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2960), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2629), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101660] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2962), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2810), 1,
      sym__parameters,
    STATE(2830), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101706] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2964), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2705), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101752] = 6,
    ACTIONS(2948), 1,
      anon_sym_COLON,
    ACTIONS(2950), 1,
      anon_sym_EQ,
    ACTIONS(2966), 1,
      anon_sym_COMMA,
    STATE(1610), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2952), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101784] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2968), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2669), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101830] = 4,
    ACTIONS(2970), 1,
      anon_sym_COMMA,
    STATE(1670), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101858] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2973), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2644), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101904] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2975), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2781), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101950] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2928), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101974] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2977), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2792), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102020] = 13,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    STATE(2431), 1,
      sym_parameter,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2760), 1,
      sym_lambda_parameters,
    STATE(2810), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102066] = 12,
    ACTIONS(2981), 1,
      sym_identifier,
    ACTIONS(2983), 1,
      anon_sym_LPAREN,
    ACTIONS(2985), 1,
      anon_sym_RPAREN,
    ACTIONS(2987), 1,
      anon_sym_STAR,
    ACTIONS(2989), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2991), 1,
      anon_sym_SLASH,
    STATE(2328), 1,
      sym_parameter,
    STATE(2329), 1,
      sym_tuple_pattern,
    STATE(2738), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2331), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2595), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102109] = 11,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2993), 1,
      anon_sym_COLON,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2589), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102149] = 11,
    ACTIONS(2981), 1,
      sym_identifier,
    ACTIONS(2983), 1,
      anon_sym_LPAREN,
    ACTIONS(2987), 1,
      anon_sym_STAR,
    ACTIONS(2989), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2991), 1,
      anon_sym_SLASH,
    ACTIONS(2993), 1,
      anon_sym_RPAREN,
    STATE(2329), 1,
      sym_tuple_pattern,
    STATE(2617), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2331), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2595), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102189] = 11,
    ACTIONS(2981), 1,
      sym_identifier,
    ACTIONS(2983), 1,
      anon_sym_LPAREN,
    ACTIONS(2987), 1,
      anon_sym_STAR,
    ACTIONS(2989), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2991), 1,
      anon_sym_SLASH,
    ACTIONS(2995), 1,
      anon_sym_RPAREN,
    STATE(2329), 1,
      sym_tuple_pattern,
    STATE(2617), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2331), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2595), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102229] = 4,
    ACTIONS(2948), 1,
      anon_sym_COLON,
    ACTIONS(2950), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2952), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [102255] = 11,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2589), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102295] = 10,
    ACTIONS(2932), 1,
      sym_identifier,
    ACTIONS(2934), 1,
      anon_sym_LPAREN,
    ACTIONS(2936), 1,
      anon_sym_STAR,
    ACTIONS(2940), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2942), 1,
      anon_sym_SLASH,
    STATE(2460), 1,
      sym_tuple_pattern,
    STATE(2589), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2557), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2561), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102332] = 10,
    ACTIONS(2981), 1,
      sym_identifier,
    ACTIONS(2983), 1,
      anon_sym_LPAREN,
    ACTIONS(2987), 1,
      anon_sym_STAR,
    ACTIONS(2989), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2991), 1,
      anon_sym_SLASH,
    STATE(2329), 1,
      sym_tuple_pattern,
    STATE(2617), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2331), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2595), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [102369] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2764), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102410] = 3,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [102431] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [102450] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [102477] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2787), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102518] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2742), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102559] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2749), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102600] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [102627] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2654), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102668] = 5,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3033), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [102693] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2694), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102734] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2770), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102775] = 4,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [102798] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [102817] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [102844] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [102863] = 13,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_COLON,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2761), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102904] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3046), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [102934] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3048), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [102964] = 12,
    ACTIONS(3050), 1,
      anon_sym_RPAREN,
    ACTIONS(3052), 1,
      anon_sym_COMMA,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2279), 1,
      aux_sym_argument_list_repeat1,
    STATE(2679), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103002] = 9,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3070), 1,
      anon_sym_COMMA,
    STATE(2139), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3066), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3068), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
  [103034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3072), 1,
      anon_sym_LBRACE,
    ACTIONS(3078), 1,
      anon_sym_BSLASH,
    ACTIONS(3081), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3075), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103064] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3083), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1707), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3085), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103124] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3087), 1,
      anon_sym_RPAREN,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2736), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103162] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3091), 1,
      anon_sym_RPAREN,
    ACTIONS(3093), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2524), 1,
      aux_sym_argument_list_repeat1,
    STATE(2736), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103200] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3095), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1711), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3097), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103260] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3099), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2689), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103298] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2651), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103336] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3115), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1715), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103366] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3117), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103396] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2685), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103434] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3121), 1,
      anon_sym_RPAREN,
    ACTIONS(3123), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym_argument_list_repeat1,
    STATE(2685), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103472] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2791), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103510] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3125), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1720), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3127), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103570] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3129), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2754), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103608] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    ACTIONS(3133), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2342), 1,
      aux_sym_argument_list_repeat1,
    STATE(2754), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103646] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3135), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1724), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103676] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3137), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103706] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2772), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103744] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3141), 1,
      anon_sym_RPAREN,
    ACTIONS(3143), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2374), 1,
      aux_sym_argument_list_repeat1,
    STATE(2772), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3145), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1728), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103812] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3147), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103842] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3149), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2730), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103880] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3151), 1,
      anon_sym_RPAREN,
    ACTIONS(3153), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2527), 1,
      aux_sym_argument_list_repeat1,
    STATE(2730), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [103918] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3155), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1733), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3157), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1702), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103978] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3159), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1705), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [104008] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2650), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104046] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3099), 1,
      anon_sym_RPAREN,
    ACTIONS(3163), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2689), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104084] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3166), 1,
      anon_sym_RPAREN,
    ACTIONS(3168), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2442), 1,
      aux_sym_argument_list_repeat1,
    STATE(2650), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3044), 1,
      anon_sym_BSLASH,
    ACTIONS(3170), 1,
      sym_string_end,
    STATE(1805), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3042), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1701), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [104152] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3172), 1,
      anon_sym_RPAREN,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2679), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104190] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2762), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104228] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2702), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104266] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2688), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104304] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2755), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104342] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2774), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104380] = 12,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    STATE(1880), 1,
      sym_for_in_clause,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2735), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104418] = 12,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    ACTIONS(3176), 1,
      anon_sym_COMMA,
    STATE(1882), 1,
      sym_for_in_clause,
    STATE(2400), 1,
      aux_sym_argument_list_repeat1,
    STATE(2689), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [104456] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104481] = 5,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3186), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 7,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104504] = 4,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 8,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104525] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104550] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104575] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104592] = 3,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [104611] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104636] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104661] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104686] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104703] = 8,
    ACTIONS(3197), 1,
      anon_sym_COMMA,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    STATE(1997), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3203), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104749] = 8,
    ACTIONS(3197), 1,
      anon_sym_COMMA,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    STATE(1997), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3209), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104778] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104795] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104812] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104837] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104862] = 5,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3211), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104885] = 4,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104906] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104923] = 3,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [104942] = 5,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3214), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104964] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104988] = 5,
    ACTIONS(3225), 1,
      anon_sym_DOT,
    ACTIONS(3229), 1,
      anon_sym_EQ,
    STATE(1789), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [105010] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105034] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105058] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [105074] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [105090] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [105114] = 4,
    ACTIONS(3225), 1,
      anon_sym_DOT,
    STATE(1789), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [105134] = 9,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3233), 1,
      anon_sym_from,
    ACTIONS(3235), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3231), 2,
      sym__newline,
      anon_sym_SEMI,
  [105164] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3237), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105188] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [105212] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105236] = 6,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105260] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [105276] = 4,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105296] = 6,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105320] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [105336] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [105360] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [105384] = 5,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3239), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [105406] = 4,
    ACTIONS(3225), 1,
      anon_sym_DOT,
    STATE(1802), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [105426] = 4,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [105446] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [105462] = 3,
    ACTIONS(3244), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [105480] = 3,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_or,
  [105498] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [105514] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [105538] = 6,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105562] = 3,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_or,
      sym_type_conversion,
  [105580] = 5,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3248), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105602] = 5,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3251), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105624] = 3,
    ACTIONS(3253), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [105642] = 4,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3253), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_or,
  [105662] = 4,
    ACTIONS(3257), 1,
      anon_sym_DOT,
    STATE(1802), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [105682] = 3,
    ACTIONS(2201), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [105700] = 3,
    ACTIONS(3244), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [105717] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3264), 1,
      anon_sym_BSLASH,
    ACTIONS(3260), 2,
      sym_string_end,
      anon_sym_LBRACE,
    STATE(1816), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3262), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [105740] = 7,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(3266), 1,
      anon_sym_async,
    ACTIONS(3268), 1,
      anon_sym_def,
    ACTIONS(3270), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(765), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(1959), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [105765] = 6,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105788] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [105811] = 5,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3272), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105832] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3235), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3203), 2,
      sym__newline,
      anon_sym_SEMI,
  [105859] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3275), 1,
      anon_sym_COMMA,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3279), 1,
      anon_sym_RBRACK,
    STATE(2298), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105888] = 5,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3251), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105909] = 3,
    ACTIONS(3253), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105926] = 4,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3253), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_or,
  [105945] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3281), 1,
      anon_sym_COMMA,
    ACTIONS(3283), 1,
      anon_sym_RBRACK,
    STATE(2304), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105974] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3290), 1,
      anon_sym_BSLASH,
    ACTIONS(3285), 2,
      sym_string_end,
      anon_sym_LBRACE,
    STATE(1816), 2,
      sym__not_escape_sequence,
      aux_sym_string_content_repeat1,
    ACTIONS(3287), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [105997] = 6,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [106020] = 5,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [106041] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3295), 1,
      anon_sym_COMMA,
    ACTIONS(3297), 1,
      anon_sym_RBRACK,
    STATE(2346), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106070] = 6,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3105), 1,
      anon_sym_if,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [106093] = 5,
    ACTIONS(3299), 1,
      anon_sym_DOT,
    ACTIONS(3301), 1,
      anon_sym_EQ,
    STATE(1890), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [106114] = 5,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106135] = 5,
    ACTIONS(3303), 1,
      anon_sym_DOT,
    ACTIONS(3305), 1,
      anon_sym_EQ,
    STATE(1868), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [106156] = 5,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [106177] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3307), 1,
      anon_sym_COMMA,
    ACTIONS(3309), 1,
      anon_sym_RBRACK,
    STATE(2377), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106206] = 5,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106227] = 7,
    ACTIONS(1494), 1,
      anon_sym_except,
    ACTIONS(1498), 1,
      anon_sym_except_STAR,
    ACTIONS(3311), 1,
      anon_sym_finally,
    STATE(777), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(501), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(502), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [106252] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3313), 1,
      anon_sym_COMMA,
    ACTIONS(3315), 1,
      anon_sym_RBRACK,
    STATE(2278), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106281] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3317), 1,
      anon_sym_COMMA,
    ACTIONS(3319), 1,
      anon_sym_RBRACK,
    STATE(2416), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106310] = 7,
    ACTIONS(1494), 1,
      anon_sym_except,
    ACTIONS(1498), 1,
      anon_sym_except_STAR,
    ACTIONS(3311), 1,
      anon_sym_finally,
    STATE(793), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(506), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(507), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [106335] = 5,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [106356] = 7,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(3321), 1,
      anon_sym_async,
    ACTIONS(3323), 1,
      anon_sym_def,
    ACTIONS(3325), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(734), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(1959), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [106381] = 5,
    ACTIONS(3327), 1,
      anon_sym_DOT,
    ACTIONS(3329), 1,
      anon_sym_EQ,
    STATE(1894), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [106402] = 5,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [106423] = 5,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [106444] = 3,
    ACTIONS(2201), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106461] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3333), 1,
      anon_sym_COMMA,
    STATE(2260), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3331), 2,
      sym__newline,
      anon_sym_SEMI,
  [106488] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3335), 1,
      anon_sym_COMMA,
    ACTIONS(3337), 1,
      anon_sym_RBRACK,
    STATE(2445), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106517] = 6,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [106540] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3339), 1,
      anon_sym_COMMA,
    ACTIONS(3341), 1,
      anon_sym_RBRACK,
    STATE(2453), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106569] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3345), 1,
      anon_sym_COMMA,
    STATE(2197), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3343), 2,
      sym__newline,
      anon_sym_SEMI,
  [106596] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3347), 1,
      anon_sym_COMMA,
    ACTIONS(3349), 1,
      anon_sym_RBRACK,
    STATE(2458), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106625] = 6,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3038), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [106648] = 6,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3056), 1,
      anon_sym_if,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [106671] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3333), 1,
      anon_sym_COMMA,
    STATE(2198), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3351), 2,
      sym__newline,
      anon_sym_SEMI,
  [106698] = 5,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3353), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3031), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106719] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3235), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3356), 2,
      sym__newline,
      anon_sym_SEMI,
  [106746] = 5,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3251), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106767] = 9,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3358), 1,
      anon_sym_COMMA,
    ACTIONS(3360), 1,
      anon_sym_RBRACK,
    STATE(2410), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106796] = 3,
    ACTIONS(3253), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [106813] = 3,
    ACTIONS(3244), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3019), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106830] = 4,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3253), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [106849] = 5,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [106870] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3235), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2946), 2,
      sym__newline,
      anon_sym_SEMI,
  [106897] = 6,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3001), 1,
      anon_sym_if,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3362), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [106920] = 3,
    ACTIONS(2201), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2187), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [106937] = 4,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1045), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3364), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [106956] = 5,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3293), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106977] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3070), 1,
      anon_sym_COMMA,
    STATE(2139), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3066), 2,
      sym__newline,
      anon_sym_SEMI,
  [107004] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 8,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [107019] = 7,
    ACTIONS(1482), 1,
      anon_sym_except,
    ACTIONS(1486), 1,
      anon_sym_except_STAR,
    ACTIONS(3366), 1,
      anon_sym_finally,
    STATE(778), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(492), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(493), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [107044] = 8,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3235), 1,
      anon_sym_COMMA,
    STATE(2093), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3368), 2,
      sym__newline,
      anon_sym_SEMI,
  [107071] = 7,
    ACTIONS(1482), 1,
      anon_sym_except,
    ACTIONS(1486), 1,
      anon_sym_except_STAR,
    ACTIONS(3366), 1,
      anon_sym_finally,
    STATE(731), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(481), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(485), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [107096] = 8,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3203), 1,
      anon_sym_RPAREN,
    ACTIONS(3370), 1,
      anon_sym_COMMA,
    STATE(2318), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107122] = 4,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1030), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3364), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [107140] = 7,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3374), 1,
      anon_sym___future__,
    STATE(2184), 1,
      aux_sym_import_prefix_repeat1,
    STATE(2399), 1,
      sym_import_prefix,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2813), 2,
      sym_relative_import,
      sym_dotted_name,
  [107164] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3376), 1,
      anon_sym_COMMA,
    ACTIONS(3378), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2385), 1,
      aux_sym_dictionary_repeat1,
    STATE(2769), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107190] = 4,
    ACTIONS(3303), 1,
      anon_sym_DOT,
    STATE(1875), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [107208] = 4,
    ACTIONS(3303), 1,
      anon_sym_DOT,
    STATE(1868), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [107226] = 4,
    ACTIONS(3299), 1,
      anon_sym_DOT,
    STATE(1890), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [107244] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3380), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3364), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [107260] = 8,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3382), 1,
      anon_sym_COMMA,
    ACTIONS(3384), 1,
      anon_sym_COLON,
    STATE(2490), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107286] = 7,
    ACTIONS(1414), 1,
      anon_sym_COLON,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107310] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3386), 1,
      anon_sym_COMMA,
    ACTIONS(3388), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2432), 1,
      aux_sym_dictionary_repeat1,
    STATE(2655), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107336] = 4,
    ACTIONS(3390), 1,
      anon_sym_DOT,
    STATE(1875), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [107354] = 8,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3393), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_COLON,
    STATE(2312), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107380] = 4,
    ACTIONS(3397), 1,
      anon_sym_DOT,
    STATE(1877), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [107398] = 7,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3277), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107422] = 8,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3382), 1,
      anon_sym_COMMA,
    ACTIONS(3402), 1,
      anon_sym_COLON,
    STATE(2490), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107448] = 6,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3404), 1,
      anon_sym_if,
    ACTIONS(3406), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1896), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107470] = 4,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1143), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3364), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [107488] = 6,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3406), 1,
      anon_sym_RPAREN,
    ACTIONS(3408), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1886), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107510] = 6,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3406), 1,
      anon_sym_RBRACE,
    ACTIONS(3410), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1902), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107532] = 7,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3412), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107556] = 8,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3414), 1,
      anon_sym_COMMA,
    ACTIONS(3416), 1,
      anon_sym_COLON,
    STATE(2476), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107582] = 6,
    ACTIONS(3058), 1,
      anon_sym_async,
    ACTIONS(3060), 1,
      anon_sym_for,
    ACTIONS(3408), 1,
      anon_sym_if,
    ACTIONS(3418), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1907), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107604] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3420), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2333), 1,
      aux_sym_dictionary_repeat1,
    STATE(2763), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107630] = 6,
    ACTIONS(3424), 1,
      anon_sym_if,
    ACTIONS(3427), 1,
      anon_sym_async,
    ACTIONS(3430), 1,
      anon_sym_for,
    ACTIONS(3433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1888), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107652] = 8,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3382), 1,
      anon_sym_COMMA,
    ACTIONS(3435), 1,
      anon_sym_COLON,
    STATE(2490), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107678] = 4,
    ACTIONS(3299), 1,
      anon_sym_DOT,
    STATE(1909), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [107696] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3439), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2515), 1,
      aux_sym_dictionary_repeat1,
    STATE(2816), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107722] = 5,
    ACTIONS(3103), 1,
      anon_sym_as,
    ACTIONS(3111), 1,
      anon_sym_and,
    ACTIONS(3113), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3441), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [107742] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3443), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [107764] = 4,
    ACTIONS(3327), 1,
      anon_sym_DOT,
    STATE(1877), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [107782] = 8,
    ACTIONS(3203), 1,
      anon_sym_RBRACK,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3445), 1,
      anon_sym_COMMA,
    STATE(2412), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107808] = 6,
    ACTIONS(3107), 1,
      anon_sym_async,
    ACTIONS(3109), 1,
      anon_sym_for,
    ACTIONS(3404), 1,
      anon_sym_if,
    ACTIONS(3418), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1898), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107830] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3447), 1,
      anon_sym_COMMA,
    ACTIONS(3449), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2492), 1,
      aux_sym_dictionary_repeat1,
    STATE(2771), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107856] = 6,
    ACTIONS(3433), 1,
      anon_sym_RBRACK,
    ACTIONS(3451), 1,
      anon_sym_if,
    ACTIONS(3454), 1,
      anon_sym_async,
    ACTIONS(3457), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1898), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107878] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3460), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [107900] = 4,
    ACTIONS(699), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(981), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3364), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [107918] = 8,
    ACTIONS(3462), 1,
      sym_identifier,
    ACTIONS(3464), 1,
      anon_sym_LPAREN,
    ACTIONS(3466), 1,
      anon_sym_STAR,
    STATE(2087), 1,
      sym_dotted_name,
    STATE(2200), 1,
      sym_aliased_import,
    STATE(2544), 1,
      sym__import_list,
    STATE(2563), 1,
      sym_wildcard_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107944] = 6,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3410), 1,
      anon_sym_if,
    ACTIONS(3418), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1888), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107966] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3468), 1,
      anon_sym_COMMA,
    ACTIONS(3470), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2366), 1,
      aux_sym_dictionary_repeat1,
    STATE(2788), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107992] = 4,
    ACTIONS(3327), 1,
      anon_sym_DOT,
    STATE(1894), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [108010] = 8,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    ACTIONS(3176), 1,
      anon_sym_COMMA,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    STATE(2400), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108036] = 5,
    ACTIONS(3054), 1,
      anon_sym_as,
    ACTIONS(3062), 1,
      anon_sym_and,
    ACTIONS(3064), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3441), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108056] = 6,
    ACTIONS(3433), 1,
      anon_sym_RPAREN,
    ACTIONS(3472), 1,
      anon_sym_if,
    ACTIONS(3475), 1,
      anon_sym_async,
    ACTIONS(3478), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1907), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [108078] = 5,
    ACTIONS(2999), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_and,
    ACTIONS(3013), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3441), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108098] = 4,
    ACTIONS(3481), 1,
      anon_sym_DOT,
    STATE(1909), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [108116] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3486), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2285), 1,
      aux_sym_dictionary_repeat1,
    STATE(2698), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3490), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3488), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [108158] = 8,
    ACTIONS(3005), 1,
      anon_sym_async,
    ACTIONS(3007), 1,
      anon_sym_for,
    ACTIONS(3492), 1,
      anon_sym_COMMA,
    ACTIONS(3494), 1,
      anon_sym_RBRACE,
    STATE(1883), 1,
      sym_for_in_clause,
    STATE(2401), 1,
      aux_sym_dictionary_repeat1,
    STATE(2744), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108184] = 8,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3382), 1,
      anon_sym_COMMA,
    ACTIONS(3496), 1,
      anon_sym_COLON,
    STATE(2490), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3500), 1,
      anon_sym_BSLASH,
    ACTIONS(3498), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108227] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [108240] = 7,
    ACTIONS(3502), 1,
      anon_sym_DOT,
    ACTIONS(3504), 1,
      anon_sym_COMMA,
    ACTIONS(3506), 1,
      anon_sym_COLON,
    ACTIONS(3508), 1,
      anon_sym_RBRACK,
    ACTIONS(3510), 1,
      anon_sym_PIPE,
    STATE(2355), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108263] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3512), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3364), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [108278] = 4,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    STATE(1918), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [108295] = 4,
    ACTIONS(3517), 1,
      anon_sym_COMMA,
    STATE(1923), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3519), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108312] = 4,
    ACTIONS(3521), 1,
      anon_sym_COMMA,
    STATE(2020), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3523), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3525), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3488), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [108344] = 7,
    ACTIONS(3502), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_COLON,
    ACTIONS(3510), 1,
      anon_sym_PIPE,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    ACTIONS(3529), 1,
      anon_sym_RBRACK,
    STATE(2506), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108367] = 4,
    ACTIONS(3531), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3533), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108384] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3535), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108405] = 4,
    ACTIONS(3537), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3544), 1,
      anon_sym_BSLASH,
    ACTIONS(3542), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108439] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3546), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108460] = 4,
    ACTIONS(3548), 1,
      anon_sym_COMMA,
    STATE(1967), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3519), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108477] = 4,
    ACTIONS(3552), 1,
      anon_sym_COMMA,
    STATE(1977), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3550), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3556), 1,
      anon_sym_BSLASH,
    ACTIONS(3554), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108511] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3558), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3364), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [108526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3562), 1,
      anon_sym_BSLASH,
    ACTIONS(3560), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108543] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108556] = 4,
    ACTIONS(3564), 1,
      anon_sym_COMMA,
    STATE(1929), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3523), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108573] = 7,
    ACTIONS(3502), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_COLON,
    ACTIONS(3510), 1,
      anon_sym_PIPE,
    ACTIONS(3566), 1,
      anon_sym_COMMA,
    ACTIONS(3568), 1,
      anon_sym_RBRACK,
    STATE(2415), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108596] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3570), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [108617] = 6,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3576), 1,
      anon_sym_COLON,
    ACTIONS(3578), 1,
      anon_sym_EQ,
    ACTIONS(3580), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3574), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108638] = 4,
    ACTIONS(3584), 1,
      anon_sym_PIPE,
    STATE(1994), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3582), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [108655] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3535), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108676] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1628), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3586), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108702] = 4,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [108719] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3570), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108740] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3588), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108761] = 4,
    ACTIONS(3590), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [108778] = 7,
    ACTIONS(3502), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_COLON,
    ACTIONS(3510), 1,
      anon_sym_PIPE,
    ACTIONS(3593), 1,
      anon_sym_COMMA,
    ACTIONS(3595), 1,
      anon_sym_RBRACK,
    STATE(2301), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108801] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108822] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108843] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3597), 2,
      sym__newline,
      anon_sym_SEMI,
  [108864] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3599), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108885] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3601), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108898] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3603), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108919] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3605), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108940] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108953] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [108966] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3607), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3611), 1,
      anon_sym_BSLASH,
    ACTIONS(3609), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108996] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3613), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109009] = 4,
    ACTIONS(3617), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1959), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
    ACTIONS(3615), 3,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
  [109026] = 5,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3576), 1,
      anon_sym_COLON,
    ACTIONS(3580), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3620), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [109045] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3622), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109058] = 6,
    ACTIONS(3626), 1,
      anon_sym_DOT,
    ACTIONS(3628), 1,
      anon_sym_COLON,
    ACTIONS(3630), 1,
      anon_sym_EQ,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3624), 2,
      sym__newline,
      anon_sym_SEMI,
  [109079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3636), 1,
      anon_sym_BSLASH,
    ACTIONS(3634), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [109096] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3613), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109109] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3638), 2,
      sym__newline,
      anon_sym_SEMI,
  [109130] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3640), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [109151] = 4,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    STATE(1977), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3533), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [109168] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3644), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109181] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3644), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3648), 1,
      anon_sym_BSLASH,
    ACTIONS(3646), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [109211] = 4,
    ACTIONS(3650), 1,
      anon_sym_COMMA,
    STATE(2004), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3519), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109228] = 4,
    ACTIONS(3652), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(970), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3654), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3364), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [109260] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3656), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [109281] = 5,
    ACTIONS(3626), 1,
      anon_sym_DOT,
    ACTIONS(3628), 1,
      anon_sym_COLON,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3620), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_EQ,
  [109300] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3601), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109313] = 4,
    ACTIONS(3658), 1,
      anon_sym_COMMA,
    STATE(1977), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [109330] = 4,
    ACTIONS(3661), 1,
      anon_sym_COMMA,
    STATE(2014), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3550), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109347] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3622), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109360] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3663), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3488), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [109375] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3546), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [109396] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3607), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109409] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3237), 2,
      sym__newline,
      anon_sym_SEMI,
  [109430] = 4,
    ACTIONS(3665), 1,
      anon_sym_DOT,
    STATE(1918), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [109447] = 4,
    ACTIONS(3584), 1,
      anon_sym_PIPE,
    STATE(1938), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3667), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [109464] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3669), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3488), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [109479] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3237), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [109500] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3601), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109513] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109534] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3671), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109555] = 4,
    ACTIONS(3665), 1,
      anon_sym_DOT,
    STATE(1984), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3227), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [109572] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3546), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [109593] = 3,
    STATE(1938), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109608] = 4,
    ACTIONS(3675), 1,
      anon_sym_PIPE,
    STATE(1994), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [109625] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [109638] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3607), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109651] = 4,
    ACTIONS(3678), 1,
      anon_sym_COMMA,
    STATE(2013), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1292), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109668] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1628), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109681] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3586), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109694] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3535), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [109715] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3605), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [109736] = 7,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3680), 1,
      anon_sym_COMMA,
    ACTIONS(3682), 1,
      anon_sym_as,
    ACTIONS(3684), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109759] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3686), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109780] = 4,
    ACTIONS(3688), 1,
      anon_sym_COMMA,
    STATE(2014), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3533), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109797] = 7,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3682), 1,
      anon_sym_as,
    ACTIONS(3690), 1,
      anon_sym_COMMA,
    ACTIONS(3692), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109820] = 3,
    ACTIONS(3694), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109835] = 6,
    ACTIONS(3178), 1,
      anon_sym_as,
    ACTIONS(3180), 1,
      anon_sym_if,
    ACTIONS(3182), 1,
      anon_sym_and,
    ACTIONS(3184), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3237), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [109856] = 7,
    ACTIONS(3696), 1,
      anon_sym_COMMA,
    ACTIONS(3698), 1,
      anon_sym_as,
    ACTIONS(3700), 1,
      anon_sym_if,
    ACTIONS(3702), 1,
      anon_sym_COLON,
    STATE(2054), 1,
      aux_sym_case_clause_repeat1,
    STATE(2805), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109879] = 4,
    ACTIONS(3584), 1,
      anon_sym_PIPE,
    STATE(1938), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [109896] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3362), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [109917] = 4,
    ACTIONS(3706), 1,
      anon_sym_COMMA,
    STATE(1978), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3523), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109934] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3603), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [109955] = 4,
    ACTIONS(3708), 1,
      anon_sym_COMMA,
    STATE(2013), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109972] = 4,
    ACTIONS(3711), 1,
      anon_sym_COMMA,
    STATE(2014), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109989] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [110010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3716), 1,
      anon_sym_BSLASH,
    ACTIONS(3714), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [110027] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3644), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110040] = 6,
    ACTIONS(3217), 1,
      anon_sym_as,
    ACTIONS(3219), 1,
      anon_sym_if,
    ACTIONS(3221), 1,
      anon_sym_and,
    ACTIONS(3223), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1446), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [110061] = 6,
    ACTIONS(3199), 1,
      anon_sym_as,
    ACTIONS(3201), 1,
      anon_sym_if,
    ACTIONS(3205), 1,
      anon_sym_and,
    ACTIONS(3207), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3686), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [110082] = 4,
    ACTIONS(3718), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3550), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110099] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3720), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110119] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3607), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110131] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3601), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110143] = 5,
    ACTIONS(3462), 1,
      sym_identifier,
    STATE(2251), 1,
      sym_dotted_name,
    STATE(2463), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3722), 2,
      sym__newline,
      anon_sym_SEMI,
  [110161] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3724), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110173] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3726), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110185] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3728), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110205] = 6,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(3732), 1,
      anon_sym_EQ,
    ACTIONS(3734), 1,
      anon_sym_RBRACE,
    ACTIONS(3736), 1,
      sym_type_conversion,
    STATE(2630), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110225] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3738), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110237] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3441), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110257] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3740), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110277] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3742), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110289] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3744), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [110301] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3744), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110313] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3746), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110325] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3748), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110345] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3203), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110357] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3750), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110369] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3752), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110381] = 5,
    ACTIONS(3754), 1,
      anon_sym_COMMA,
    ACTIONS(3756), 1,
      anon_sym_RBRACE,
    STATE(2322), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110399] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [110411] = 3,
    ACTIONS(3758), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [110425] = 4,
    ACTIONS(3760), 1,
      anon_sym_PIPE,
    STATE(2056), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [110441] = 6,
    ACTIONS(3574), 1,
      anon_sym_COMMA,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3764), 1,
      anon_sym_COLON,
    ACTIONS(3766), 1,
      anon_sym_EQ,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110461] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110473] = 3,
    ACTIONS(3770), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [110487] = 5,
    ACTIONS(3772), 1,
      anon_sym_COMMA,
    ACTIONS(3774), 1,
      anon_sym_RBRACE,
    STATE(2505), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110505] = 4,
    ACTIONS(3776), 1,
      anon_sym_PIPE,
    STATE(2076), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [110521] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3738), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [110533] = 3,
    ACTIONS(3778), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110547] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3780), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110567] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3782), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110579] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3784), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110599] = 6,
    ACTIONS(2611), 1,
      anon_sym_COLON,
    ACTIONS(3700), 1,
      anon_sym_if,
    ACTIONS(3786), 1,
      anon_sym_COMMA,
    STATE(2212), 1,
      aux_sym_case_clause_repeat1,
    STATE(2800), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110619] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3788), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110631] = 4,
    ACTIONS(3760), 1,
      anon_sym_PIPE,
    STATE(2061), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3582), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [110647] = 4,
    ACTIONS(3790), 1,
      anon_sym_PIPE,
    STATE(2124), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3667), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [110663] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2930), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110675] = 4,
    ACTIONS(3760), 1,
      anon_sym_PIPE,
    STATE(2056), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3667), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [110691] = 3,
    STATE(2056), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [110705] = 4,
    ACTIONS(3792), 1,
      anon_sym_PIPE,
    STATE(2061), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [110721] = 3,
    STATE(2124), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110735] = 5,
    ACTIONS(3462), 1,
      sym_identifier,
    STATE(2251), 1,
      sym_dotted_name,
    STATE(2463), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 2,
      sym__newline,
      anon_sym_SEMI,
  [110753] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110765] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3799), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110785] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1628), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110797] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3586), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110809] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3801), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110821] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3803), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110833] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110845] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3805), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110857] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3807), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110877] = 6,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(3809), 1,
      anon_sym_LPAREN,
    ACTIONS(3811), 1,
      anon_sym_COLON,
    STATE(2504), 1,
      sym_type_parameter,
    STATE(2786), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110897] = 4,
    ACTIONS(3813), 1,
      anon_sym_PIPE,
    STATE(2074), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [110913] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3816), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110925] = 4,
    ACTIONS(3776), 1,
      anon_sym_PIPE,
    STATE(2080), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3582), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [110941] = 5,
    ACTIONS(3502), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_COLON,
    ACTIONS(3510), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3818), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [110959] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3820), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110979] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2928), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110991] = 4,
    ACTIONS(3822), 1,
      anon_sym_PIPE,
    STATE(2080), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [111007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3825), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111019] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3827), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111039] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3068), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111051] = 6,
    ACTIONS(3462), 1,
      sym_identifier,
    ACTIONS(3829), 1,
      anon_sym_LPAREN,
    STATE(2087), 1,
      sym_dotted_name,
    STATE(2200), 1,
      sym_aliased_import,
    STATE(2600), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111071] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3831), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111091] = 4,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3036), 3,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [111107] = 5,
    ACTIONS(3835), 1,
      anon_sym_COMMA,
    ACTIONS(3837), 1,
      anon_sym_as,
    STATE(2217), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3833), 2,
      sym__newline,
      anon_sym_SEMI,
  [111125] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [111137] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3839), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111157] = 5,
    ACTIONS(3841), 1,
      anon_sym_COMMA,
    ACTIONS(3843), 1,
      anon_sym_RBRACE,
    STATE(2321), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111175] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [111187] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3845), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111207] = 4,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    STATE(2109), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1292), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [111223] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3849), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111243] = 6,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(3809), 1,
      anon_sym_LPAREN,
    ACTIONS(3851), 1,
      anon_sym_COLON,
    STATE(2469), 1,
      sym_type_parameter,
    STATE(2720), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111263] = 6,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(3855), 1,
      anon_sym_RBRACE,
    ACTIONS(3857), 1,
      aux_sym_format_specifier_token1,
    STATE(2131), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2314), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [111283] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3859), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111295] = 6,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3861), 1,
      anon_sym_as,
    ACTIONS(3863), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [111327] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3865), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111339] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3613), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111351] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1628), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [111363] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3744), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [111375] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3816), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [111387] = 6,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3861), 1,
      anon_sym_as,
    ACTIONS(3867), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111407] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3586), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [111419] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3869), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111439] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3871), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111459] = 4,
    ACTIONS(3873), 1,
      anon_sym_COMMA,
    STATE(2109), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3246), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [111475] = 5,
    ACTIONS(3502), 1,
      anon_sym_DOT,
    ACTIONS(3506), 1,
      anon_sym_COLON,
    ACTIONS(3510), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3620), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [111493] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3622), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111505] = 5,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(3576), 1,
      anon_sym_COLON,
    ACTIONS(3580), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3574), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [111523] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3613), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [111535] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [111547] = 5,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3764), 1,
      anon_sym_COLON,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3620), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
  [111565] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3816), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [111577] = 5,
    ACTIONS(3626), 1,
      anon_sym_DOT,
    ACTIONS(3628), 1,
      anon_sym_COLON,
    ACTIONS(3632), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3876), 2,
      sym__newline,
      anon_sym_SEMI,
  [111595] = 6,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(3878), 1,
      anon_sym_EQ,
    ACTIONS(3880), 1,
      anon_sym_RBRACE,
    ACTIONS(3882), 1,
      sym_type_conversion,
    STATE(2801), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111615] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111627] = 6,
    ACTIONS(3017), 1,
      anon_sym_and,
    ACTIONS(3023), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_if,
    ACTIONS(3027), 1,
      anon_sym_or,
    ACTIONS(3886), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111647] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3622), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [111659] = 6,
    ACTIONS(3888), 1,
      anon_sym_LBRACE,
    ACTIONS(3891), 1,
      anon_sym_RBRACE,
    ACTIONS(3893), 1,
      aux_sym_format_specifier_token1,
    STATE(2122), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2314), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [111679] = 5,
    ACTIONS(3896), 1,
      anon_sym_COMMA,
    ACTIONS(3898), 1,
      anon_sym_RBRACE,
    STATE(2315), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111697] = 4,
    ACTIONS(3790), 1,
      anon_sym_PIPE,
    STATE(2074), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3582), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [111713] = 5,
    ACTIONS(3462), 1,
      sym_identifier,
    STATE(2251), 1,
      sym_dotted_name,
    STATE(2463), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3722), 2,
      sym__newline,
      anon_sym_SEMI,
  [111731] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3900), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111743] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3644), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111755] = 6,
    ACTIONS(3189), 1,
      anon_sym_as,
    ACTIONS(3191), 1,
      anon_sym_if,
    ACTIONS(3193), 1,
      anon_sym_and,
    ACTIONS(3195), 1,
      anon_sym_or,
    ACTIONS(3902), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111775] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3904), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111787] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3906), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111799] = 6,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(3908), 1,
      anon_sym_RBRACE,
    ACTIONS(3910), 1,
      aux_sym_format_specifier_token1,
    STATE(2122), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2314), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [111819] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3912), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111831] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3914), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111843] = 4,
    ACTIONS(3776), 1,
      anon_sym_PIPE,
    STATE(2076), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3667), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [111859] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3916), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111871] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3918), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111883] = 3,
    STATE(2076), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111897] = 4,
    ACTIONS(3790), 1,
      anon_sym_PIPE,
    STATE(2124), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [111913] = 4,
    ACTIONS(3920), 1,
      anon_sym_COMMA,
    STATE(2109), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1424), 2,
      sym__newline,
      anon_sym_SEMI,
  [111928] = 4,
    ACTIONS(3924), 1,
      anon_sym_COMMA,
    STATE(2140), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3922), 2,
      sym__newline,
      anon_sym_SEMI,
  [111943] = 5,
    ACTIONS(3927), 1,
      anon_sym_RPAREN,
    ACTIONS(3929), 1,
      anon_sym_COMMA,
    ACTIONS(3931), 1,
      anon_sym_as,
    STATE(2292), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111960] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3904), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111971] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3906), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111982] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3912), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111993] = 5,
    ACTIONS(3933), 1,
      anon_sym_case,
    ACTIONS(3935), 1,
      sym__dedent,
    STATE(2248), 1,
      aux_sym__match_block_repeat1,
    STATE(2558), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112010] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3914), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112021] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3825), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112032] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3726), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112043] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3738), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112054] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3742), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112065] = 5,
    ACTIONS(3937), 1,
      anon_sym_COMMA,
    ACTIONS(3939), 1,
      anon_sym_as,
    ACTIONS(3941), 1,
      anon_sym_RBRACK,
    STATE(2303), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112082] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3750), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112093] = 4,
    ACTIONS(3945), 1,
      anon_sym_COMMA,
    STATE(2195), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3943), 2,
      sym__newline,
      anon_sym_SEMI,
  [112108] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3752), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112119] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3782), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112130] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3788), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112141] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112152] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3801), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112163] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3803), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112174] = 5,
    ACTIONS(3947), 1,
      sym_identifier,
    STATE(2193), 1,
      sym_dotted_name,
    STATE(2513), 1,
      sym_aliased_import,
    STATE(2793), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112191] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3805), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112202] = 5,
    ACTIONS(3947), 1,
      sym_identifier,
    STATE(2193), 1,
      sym_dotted_name,
    STATE(2513), 1,
      sym_aliased_import,
    STATE(2798), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112219] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112230] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3900), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112241] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3916), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112252] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(3949), 1,
      anon_sym_RPAREN,
    ACTIONS(3951), 1,
      anon_sym_COMMA,
    STATE(2295), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112269] = 5,
    ACTIONS(3939), 1,
      anon_sym_as,
    ACTIONS(3953), 1,
      anon_sym_COMMA,
    ACTIONS(3955), 1,
      anon_sym_RBRACK,
    STATE(2307), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112286] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3918), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112297] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3724), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112308] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3746), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3859), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112330] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3865), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112341] = 5,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2581), 1,
      sym_type_parameter,
    STATE(2628), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112358] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3904), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112369] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3906), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112380] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3912), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112391] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3914), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112402] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3825), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112413] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3752), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112424] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(3959), 1,
      anon_sym_RPAREN,
    ACTIONS(3961), 1,
      anon_sym_COMMA,
    STATE(2353), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112441] = 4,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    STATE(2181), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3963), 2,
      sym__newline,
      anon_sym_SEMI,
  [112456] = 4,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(2249), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3968), 2,
      sym__newline,
      anon_sym_SEMI,
  [112471] = 4,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(2250), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3972), 2,
      sym__newline,
      anon_sym_SEMI,
  [112486] = 4,
    ACTIONS(3976), 1,
      anon_sym_DOT,
    STATE(2231), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3974), 2,
      anon_sym_import,
      sym_identifier,
  [112501] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(3978), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_COMMA,
    STATE(2480), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112518] = 5,
    ACTIONS(3939), 1,
      anon_sym_as,
    ACTIONS(3982), 1,
      anon_sym_COMMA,
    ACTIONS(3984), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112535] = 5,
    ACTIONS(3574), 1,
      anon_sym_COMMA,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3764), 1,
      anon_sym_COLON,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112552] = 4,
    ACTIONS(3988), 1,
      anon_sym_COMMA,
    STATE(2188), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3986), 2,
      sym__newline,
      anon_sym_SEMI,
  [112567] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(3991), 1,
      anon_sym_RPAREN,
    ACTIONS(3993), 1,
      anon_sym_COMMA,
    STATE(2519), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112584] = 5,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3764), 1,
      anon_sym_COLON,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(3995), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112601] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3726), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112612] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3738), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112623] = 5,
    ACTIONS(3833), 1,
      anon_sym_RPAREN,
    ACTIONS(3997), 1,
      anon_sym_COMMA,
    ACTIONS(3999), 1,
      anon_sym_as,
    STATE(2439), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112640] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3742), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112651] = 4,
    ACTIONS(4003), 1,
      anon_sym_COMMA,
    STATE(2188), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4001), 2,
      sym__newline,
      anon_sym_SEMI,
  [112666] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3750), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112677] = 4,
    ACTIONS(4007), 1,
      anon_sym_COMMA,
    STATE(2188), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4005), 2,
      sym__newline,
      anon_sym_SEMI,
  [112692] = 4,
    ACTIONS(3333), 1,
      anon_sym_COMMA,
    STATE(2109), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4009), 2,
      sym__newline,
      anon_sym_SEMI,
  [112707] = 5,
    ACTIONS(3933), 1,
      anon_sym_case,
    ACTIONS(4011), 1,
      sym__dedent,
    STATE(2247), 1,
      aux_sym__match_block_repeat1,
    STATE(2558), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112724] = 4,
    ACTIONS(3835), 1,
      anon_sym_COMMA,
    STATE(2210), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3833), 2,
      sym__newline,
      anon_sym_SEMI,
  [112739] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(4013), 1,
      anon_sym_RPAREN,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    STATE(2309), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112756] = 5,
    ACTIONS(3939), 1,
      anon_sym_as,
    ACTIONS(4017), 1,
      anon_sym_COMMA,
    ACTIONS(4019), 1,
      anon_sym_RBRACK,
    STATE(2311), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112773] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(4021), 1,
      anon_sym_RPAREN,
    ACTIONS(4023), 1,
      anon_sym_COMMA,
    STATE(2320), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112790] = 5,
    ACTIONS(3462), 1,
      sym_identifier,
    STATE(2087), 1,
      sym_dotted_name,
    STATE(2200), 1,
      sym_aliased_import,
    STATE(2540), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112807] = 4,
    ACTIONS(4027), 1,
      anon_sym_COLON,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112822] = 5,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(4031), 1,
      anon_sym_RPAREN,
    ACTIONS(4033), 1,
      anon_sym_COMMA,
    STATE(2511), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112839] = 3,
    ACTIONS(3698), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4035), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
  [112852] = 5,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(4037), 1,
      anon_sym_RBRACE,
    ACTIONS(4039), 1,
      sym_type_conversion,
    STATE(2693), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112869] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4041), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [112880] = 4,
    ACTIONS(4045), 1,
      anon_sym_COMMA,
    STATE(2140), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4043), 2,
      sym__newline,
      anon_sym_SEMI,
  [112895] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3865), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112906] = 4,
    ACTIONS(4047), 1,
      anon_sym_COMMA,
    STATE(2212), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4035), 2,
      anon_sym_if,
      anon_sym_COLON,
  [112921] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3782), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112932] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3726), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112943] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3788), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112954] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3742), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112965] = 4,
    ACTIONS(4050), 1,
      anon_sym_COMMA,
    STATE(2140), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4043), 2,
      sym__newline,
      anon_sym_SEMI,
  [112980] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3750), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112991] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113002] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3801), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113013] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3803), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113024] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3782), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113035] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3788), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113046] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113057] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3801), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113068] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3803), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113079] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3805), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113090] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3805), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113101] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113112] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3900), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113123] = 4,
    ACTIONS(4054), 1,
      anon_sym_DOT,
    STATE(2231), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4052), 2,
      anon_sym_import,
      sym_identifier,
  [113138] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3916), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113149] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3918), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113160] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3724), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113171] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3746), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113182] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3859), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3865), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113204] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3904), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113215] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3906), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113226] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3912), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113237] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3914), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113248] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3825), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3752), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113270] = 5,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2572), 1,
      sym_parameters,
    STATE(2602), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113287] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [113298] = 5,
    ACTIONS(3795), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym_identifier,
    STATE(2520), 1,
      sym_dotted_name,
    STATE(2624), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113315] = 5,
    ACTIONS(3933), 1,
      anon_sym_case,
    ACTIONS(4057), 1,
      sym__dedent,
    STATE(2248), 1,
      aux_sym__match_block_repeat1,
    STATE(2558), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113332] = 5,
    ACTIONS(4059), 1,
      anon_sym_case,
    ACTIONS(4062), 1,
      sym__dedent,
    STATE(2248), 1,
      aux_sym__match_block_repeat1,
    STATE(2558), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113349] = 4,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(2181), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4064), 2,
      sym__newline,
      anon_sym_SEMI,
  [113364] = 4,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(2181), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4066), 2,
      sym__newline,
      anon_sym_SEMI,
  [113379] = 3,
    ACTIONS(3837), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4068), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [113392] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113403] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3900), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113414] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3916), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113425] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3918), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113436] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3724), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113447] = 5,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(4070), 1,
      anon_sym_RBRACE,
    ACTIONS(4072), 1,
      sym_type_conversion,
    STATE(2773), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113464] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4074), 4,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
      anon_sym_AT,
  [113475] = 5,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2592), 1,
      sym_parameters,
    STATE(2618), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113492] = 4,
    ACTIONS(3333), 1,
      anon_sym_COMMA,
    STATE(2109), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4076), 2,
      sym__newline,
      anon_sym_SEMI,
  [113507] = 5,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2593), 1,
      sym_parameters,
    STATE(2620), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113524] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3746), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113535] = 5,
    ACTIONS(3933), 1,
      anon_sym_case,
    ACTIONS(4078), 1,
      sym__dedent,
    STATE(2145), 1,
      aux_sym__match_block_repeat1,
    STATE(2558), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113552] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3859), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113563] = 5,
    ACTIONS(3722), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym_identifier,
    STATE(2520), 1,
      sym_dotted_name,
    STATE(2624), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113580] = 5,
    ACTIONS(3722), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym_identifier,
    STATE(2520), 1,
      sym_dotted_name,
    STATE(2624), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113597] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3364), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4080), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113610] = 4,
    ACTIONS(4082), 1,
      anon_sym_SEMI,
    ACTIONS(4084), 1,
      sym__newline,
    STATE(2363), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113624] = 4,
    ACTIONS(4086), 1,
      sym__newline,
    ACTIONS(4088), 1,
      sym__indent,
    STATE(761), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113638] = 4,
    ACTIONS(1234), 1,
      anon_sym_RPAREN,
    ACTIONS(4090), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113652] = 4,
    ACTIONS(3009), 1,
      anon_sym_RBRACK,
    ACTIONS(3101), 1,
      anon_sym_COMMA,
    STATE(2447), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113666] = 4,
    ACTIONS(4092), 1,
      anon_sym_COMMA,
    ACTIONS(4094), 1,
      anon_sym_RBRACK,
    STATE(2449), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113680] = 4,
    ACTIONS(4096), 1,
      anon_sym_SEMI,
    ACTIONS(4098), 1,
      sym__newline,
    STATE(2283), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113694] = 4,
    ACTIONS(4100), 1,
      anon_sym_RPAREN,
    ACTIONS(4102), 1,
      anon_sym_COMMA,
    STATE(2274), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113708] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4105), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [113718] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3119), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113732] = 4,
    ACTIONS(4107), 1,
      anon_sym_SEMI,
    ACTIONS(4109), 1,
      sym__newline,
    STATE(2419), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113746] = 4,
    ACTIONS(4111), 1,
      anon_sym_COMMA,
    ACTIONS(4113), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113760] = 4,
    ACTIONS(1228), 1,
      anon_sym_RPAREN,
    ACTIONS(4115), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113774] = 4,
    ACTIONS(3484), 1,
      anon_sym_COMMA,
    ACTIONS(3486), 1,
      anon_sym_RBRACE,
    STATE(2285), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113788] = 4,
    ACTIONS(3281), 1,
      anon_sym_COMMA,
    ACTIONS(3283), 1,
      anon_sym_RBRACK,
    STATE(2305), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113802] = 4,
    ACTIONS(3818), 1,
      anon_sym_RBRACK,
    ACTIONS(4117), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113816] = 4,
    ACTIONS(638), 1,
      sym__newline,
    ACTIONS(4120), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113830] = 3,
    ACTIONS(1685), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [113842] = 4,
    ACTIONS(1296), 1,
      anon_sym_RBRACE,
    ACTIONS(4122), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113856] = 4,
    ACTIONS(4124), 1,
      anon_sym_COMMA,
    ACTIONS(4126), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113870] = 4,
    ACTIONS(3121), 1,
      anon_sym_RPAREN,
    ACTIONS(3123), 1,
      anon_sym_COMMA,
    STATE(2294), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113884] = 4,
    ACTIONS(4128), 1,
      anon_sym_RPAREN,
    ACTIONS(4130), 1,
      anon_sym_COMMA,
    STATE(2296), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113898] = 4,
    ACTIONS(3275), 1,
      anon_sym_COMMA,
    ACTIONS(3279), 1,
      anon_sym_RBRACK,
    STATE(2299), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113912] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4132), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113926] = 4,
    ACTIONS(4086), 1,
      sym__newline,
    ACTIONS(4088), 1,
      sym__indent,
    STATE(764), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113940] = 4,
    ACTIONS(2715), 1,
      anon_sym_RPAREN,
    ACTIONS(4134), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113954] = 4,
    ACTIONS(4136), 1,
      anon_sym_COMMA,
    ACTIONS(4139), 1,
      anon_sym_COLON,
    STATE(2293), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113968] = 4,
    ACTIONS(1206), 1,
      anon_sym_RPAREN,
    ACTIONS(4141), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113982] = 4,
    ACTIONS(2717), 1,
      anon_sym_RPAREN,
    ACTIONS(4143), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113996] = 4,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114010] = 4,
    ACTIONS(3246), 1,
      anon_sym_RBRACK,
    ACTIONS(4147), 1,
      anon_sym_COMMA,
    STATE(2297), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114024] = 4,
    ACTIONS(4150), 1,
      anon_sym_COMMA,
    ACTIONS(4152), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114038] = 4,
    ACTIONS(4154), 1,
      anon_sym_COMMA,
    ACTIONS(4156), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114052] = 4,
    ACTIONS(1230), 1,
      anon_sym_RPAREN,
    ACTIONS(4158), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114066] = 4,
    ACTIONS(982), 1,
      anon_sym_RBRACK,
    ACTIONS(4160), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114080] = 4,
    ACTIONS(1286), 1,
      anon_sym_RBRACE,
    ACTIONS(4162), 1,
      anon_sym_COMMA,
    STATE(2390), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114094] = 4,
    ACTIONS(2691), 1,
      anon_sym_RBRACK,
    ACTIONS(4164), 1,
      anon_sym_COMMA,
    STATE(2336), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114108] = 4,
    ACTIONS(4166), 1,
      anon_sym_COMMA,
    ACTIONS(4168), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114122] = 4,
    ACTIONS(4170), 1,
      anon_sym_COMMA,
    ACTIONS(4172), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114136] = 3,
    ACTIONS(3939), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114148] = 4,
    ACTIONS(2719), 1,
      anon_sym_RBRACK,
    ACTIONS(4174), 1,
      anon_sym_COMMA,
    STATE(2336), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114162] = 4,
    ACTIONS(4176), 1,
      anon_sym_COMMA,
    ACTIONS(4178), 1,
      anon_sym_RBRACE,
    STATE(2313), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114176] = 4,
    ACTIONS(2707), 1,
      anon_sym_RPAREN,
    ACTIONS(4180), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114190] = 4,
    ACTIONS(4086), 1,
      sym__newline,
    ACTIONS(4088), 1,
      sym__indent,
    STATE(830), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114204] = 4,
    ACTIONS(2709), 1,
      anon_sym_RBRACK,
    ACTIONS(4182), 1,
      anon_sym_COMMA,
    STATE(2336), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114218] = 4,
    ACTIONS(4184), 1,
      anon_sym_COMMA,
    ACTIONS(4186), 1,
      anon_sym_COLON,
    STATE(2293), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114232] = 4,
    ACTIONS(4188), 1,
      anon_sym_COMMA,
    ACTIONS(4190), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114246] = 3,
    ACTIONS(4194), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4192), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114258] = 4,
    ACTIONS(4196), 1,
      anon_sym_COMMA,
    ACTIONS(4198), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114272] = 4,
    ACTIONS(4200), 1,
      anon_sym_COMMA,
    ACTIONS(4202), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114286] = 4,
    ACTIONS(4204), 1,
      anon_sym_COMMA,
    ACTIONS(4206), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114300] = 4,
    ACTIONS(1292), 1,
      anon_sym_RPAREN,
    ACTIONS(4208), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114314] = 4,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(4210), 1,
      anon_sym_RBRACE,
    STATE(2711), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114328] = 4,
    ACTIONS(2659), 1,
      anon_sym_RPAREN,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114342] = 4,
    ACTIONS(4214), 1,
      anon_sym_COMMA,
    ACTIONS(4216), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114356] = 4,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    ACTIONS(4220), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114370] = 4,
    ACTIONS(2993), 1,
      anon_sym_COLON,
    ACTIONS(4222), 1,
      anon_sym_COMMA,
    STATE(2462), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114384] = 4,
    ACTIONS(4224), 1,
      anon_sym_SEMI,
    ACTIONS(4226), 1,
      sym__newline,
    STATE(2332), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114398] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4041), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [114408] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3963), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [114418] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3129), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114432] = 4,
    ACTIONS(4228), 1,
      anon_sym_RPAREN,
    ACTIONS(4230), 1,
      anon_sym_COMMA,
    STATE(2483), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114446] = 3,
    ACTIONS(4029), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114458] = 4,
    ACTIONS(3420), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 1,
      anon_sym_RBRACE,
    STATE(2333), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114472] = 3,
    ACTIONS(4232), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114484] = 4,
    ACTIONS(642), 1,
      sym__newline,
    ACTIONS(4234), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114498] = 4,
    ACTIONS(1332), 1,
      anon_sym_RBRACE,
    ACTIONS(4236), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114512] = 4,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    ACTIONS(3133), 1,
      anon_sym_COMMA,
    STATE(2342), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114526] = 4,
    ACTIONS(4238), 1,
      anon_sym_RPAREN,
    ACTIONS(4240), 1,
      anon_sym_COMMA,
    STATE(2344), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114540] = 4,
    ACTIONS(4035), 1,
      anon_sym_RBRACK,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    STATE(2336), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114554] = 4,
    ACTIONS(3295), 1,
      anon_sym_COMMA,
    ACTIONS(3297), 1,
      anon_sym_RBRACK,
    STATE(2347), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114568] = 4,
    ACTIONS(2891), 1,
      anon_sym_RBRACK,
    ACTIONS(4245), 1,
      anon_sym_COMMA,
    STATE(2338), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114582] = 3,
    ACTIONS(3498), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3500), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114594] = 4,
    ACTIONS(2997), 1,
      anon_sym_COMMA,
    ACTIONS(3009), 1,
      anon_sym_RBRACE,
    STATE(2302), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114608] = 3,
    ACTIONS(3554), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3556), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114620] = 4,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    ACTIONS(4248), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114634] = 3,
    ACTIONS(1689), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [114646] = 4,
    ACTIONS(1160), 1,
      anon_sym_RPAREN,
    ACTIONS(4250), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114660] = 4,
    ACTIONS(3462), 1,
      sym_identifier,
    STATE(2251), 1,
      sym_dotted_name,
    STATE(2463), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114674] = 4,
    ACTIONS(4252), 1,
      anon_sym_COMMA,
    ACTIONS(4254), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114688] = 4,
    ACTIONS(4256), 1,
      anon_sym_COMMA,
    ACTIONS(4258), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114702] = 3,
    ACTIONS(3560), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3562), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114714] = 4,
    ACTIONS(3246), 1,
      anon_sym_RPAREN,
    ACTIONS(4260), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114728] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2395), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [114738] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [114748] = 4,
    ACTIONS(4263), 1,
      anon_sym_RPAREN,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    STATE(2352), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114762] = 4,
    ACTIONS(2665), 1,
      anon_sym_RPAREN,
    ACTIONS(4268), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114776] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4272), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114790] = 4,
    ACTIONS(992), 1,
      anon_sym_RBRACK,
    ACTIONS(4274), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114804] = 4,
    ACTIONS(1286), 1,
      anon_sym_RPAREN,
    ACTIONS(4276), 1,
      anon_sym_COMMA,
    STATE(2364), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114818] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4278), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114832] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4280), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114846] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114860] = 4,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(4282), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114874] = 4,
    ACTIONS(3468), 1,
      anon_sym_COMMA,
    ACTIONS(3470), 1,
      anon_sym_RBRACE,
    STATE(2366), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114888] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4284), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114902] = 4,
    ACTIONS(646), 1,
      sym__newline,
    ACTIONS(4286), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114916] = 4,
    ACTIONS(3535), 1,
      anon_sym_RPAREN,
    ACTIONS(4288), 1,
      anon_sym_COMMA,
    STATE(2364), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114930] = 4,
    ACTIONS(4291), 1,
      anon_sym_SEMI,
    ACTIONS(4294), 1,
      sym__newline,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114944] = 4,
    ACTIONS(1298), 1,
      anon_sym_RBRACE,
    ACTIONS(4296), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114958] = 4,
    ACTIONS(4298), 1,
      anon_sym_SEMI,
    ACTIONS(4300), 1,
      sym__newline,
    STATE(2381), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114972] = 3,
    ACTIONS(4304), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4302), 2,
      sym__newline,
      anon_sym_SEMI,
  [114984] = 4,
    ACTIONS(3141), 1,
      anon_sym_RPAREN,
    ACTIONS(3143), 1,
      anon_sym_COMMA,
    STATE(2374), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114998] = 4,
    ACTIONS(4306), 1,
      anon_sym_RPAREN,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    STATE(2375), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115012] = 4,
    ACTIONS(3307), 1,
      anon_sym_COMMA,
    ACTIONS(3309), 1,
      anon_sym_RBRACK,
    STATE(2378), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115026] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3099), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115040] = 4,
    ACTIONS(3050), 1,
      anon_sym_RPAREN,
    ACTIONS(3052), 1,
      anon_sym_COMMA,
    STATE(2279), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115054] = 4,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    ACTIONS(4310), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115068] = 4,
    ACTIONS(1180), 1,
      anon_sym_RPAREN,
    ACTIONS(4312), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115082] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115096] = 4,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4318), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115110] = 4,
    ACTIONS(4320), 1,
      anon_sym_COMMA,
    ACTIONS(4322), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115124] = 4,
    ACTIONS(3376), 1,
      anon_sym_COMMA,
    ACTIONS(3378), 1,
      anon_sym_RBRACE,
    STATE(2385), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115138] = 4,
    ACTIONS(1881), 1,
      anon_sym_RPAREN,
    ACTIONS(4324), 1,
      anon_sym_COMMA,
    STATE(2491), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115152] = 4,
    ACTIONS(634), 1,
      sym__newline,
    ACTIONS(4326), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115166] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(4328), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115180] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(4330), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115194] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4041), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [115204] = 4,
    ACTIONS(1340), 1,
      anon_sym_RBRACE,
    ACTIONS(4332), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115218] = 3,
    ACTIONS(3931), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4035), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [115230] = 4,
    ACTIONS(4334), 1,
      anon_sym_COMMA,
    ACTIONS(4337), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115244] = 4,
    ACTIONS(4339), 1,
      anon_sym_RPAREN,
    ACTIONS(4341), 1,
      anon_sym_COMMA,
    STATE(2300), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115258] = 4,
    ACTIONS(4343), 1,
      anon_sym_SEMI,
    ACTIONS(4345), 1,
      sym__newline,
    STATE(2398), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115272] = 4,
    ACTIONS(3535), 1,
      anon_sym_RBRACE,
    ACTIONS(4347), 1,
      anon_sym_COMMA,
    STATE(2390), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115286] = 4,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    ACTIONS(3176), 1,
      anon_sym_COMMA,
    STATE(2400), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115300] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3149), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115314] = 4,
    ACTIONS(4350), 1,
      anon_sym_RPAREN,
    ACTIONS(4352), 1,
      anon_sym_COMMA,
    STATE(2402), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115328] = 4,
    ACTIONS(3358), 1,
      anon_sym_COMMA,
    ACTIONS(3360), 1,
      anon_sym_RBRACK,
    STATE(2411), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115342] = 4,
    ACTIONS(3492), 1,
      anon_sym_COMMA,
    ACTIONS(3494), 1,
      anon_sym_RBRACE,
    STATE(2401), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115356] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4041), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [115366] = 3,
    ACTIONS(3233), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3231), 2,
      sym__newline,
      anon_sym_SEMI,
  [115378] = 4,
    ACTIONS(632), 1,
      sym__newline,
    ACTIONS(4354), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115392] = 4,
    ACTIONS(2745), 1,
      sym_identifier,
    ACTIONS(4356), 1,
      anon_sym_import,
    STATE(2631), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115406] = 4,
    ACTIONS(1188), 1,
      anon_sym_RPAREN,
    ACTIONS(4358), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115420] = 4,
    ACTIONS(1326), 1,
      anon_sym_RBRACE,
    ACTIONS(4360), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115434] = 4,
    ACTIONS(1242), 1,
      anon_sym_RPAREN,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115448] = 3,
    ACTIONS(1701), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [115460] = 4,
    ACTIONS(3151), 1,
      anon_sym_RPAREN,
    ACTIONS(3153), 1,
      anon_sym_COMMA,
    STATE(2527), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115474] = 4,
    ACTIONS(4364), 1,
      anon_sym_RPAREN,
    ACTIONS(4366), 1,
      anon_sym_COMMA,
    STATE(2414), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115488] = 4,
    ACTIONS(4035), 1,
      anon_sym_RPAREN,
    ACTIONS(4368), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115502] = 4,
    ACTIONS(4371), 1,
      anon_sym_SEMI,
    ACTIONS(4373), 1,
      sym__newline,
    STATE(2464), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115516] = 4,
    ACTIONS(3317), 1,
      anon_sym_COMMA,
    ACTIONS(3319), 1,
      anon_sym_RBRACK,
    STATE(2417), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115530] = 4,
    ACTIONS(4375), 1,
      anon_sym_COMMA,
    ACTIONS(4378), 1,
      anon_sym_RBRACE,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115544] = 4,
    ACTIONS(4380), 1,
      anon_sym_COMMA,
    ACTIONS(4382), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115558] = 4,
    ACTIONS(4384), 1,
      anon_sym_COMMA,
    ACTIONS(4386), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115572] = 4,
    ACTIONS(1292), 1,
      anon_sym_RBRACK,
    ACTIONS(4388), 1,
      anon_sym_COMMA,
    STATE(2297), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115586] = 3,
    ACTIONS(3542), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3544), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115598] = 4,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
    ACTIONS(4390), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115612] = 4,
    ACTIONS(996), 1,
      anon_sym_RBRACK,
    ACTIONS(4392), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115626] = 4,
    ACTIONS(4394), 1,
      anon_sym_COMMA,
    ACTIONS(4396), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115640] = 4,
    ACTIONS(4398), 1,
      anon_sym_COMMA,
    ACTIONS(4400), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115654] = 4,
    ACTIONS(4402), 1,
      sym__newline,
    ACTIONS(4404), 1,
      sym__indent,
    STATE(786), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115668] = 4,
    ACTIONS(628), 1,
      sym__newline,
    ACTIONS(4406), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115682] = 3,
    ACTIONS(3609), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3611), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115694] = 4,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(4408), 1,
      anon_sym_RBRACE,
    STATE(2747), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115708] = 4,
    ACTIONS(4410), 1,
      anon_sym_RPAREN,
    ACTIONS(4412), 1,
      anon_sym_COMMA,
    STATE(2450), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115722] = 4,
    ACTIONS(4414), 1,
      anon_sym_SEMI,
    ACTIONS(4416), 1,
      sym__newline,
    STATE(2430), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115736] = 4,
    ACTIONS(4402), 1,
      sym__newline,
    ACTIONS(4404), 1,
      sym__indent,
    STATE(804), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115750] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115764] = 3,
    ACTIONS(3634), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3636), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115776] = 4,
    ACTIONS(3009), 1,
      anon_sym_RPAREN,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115790] = 4,
    ACTIONS(3386), 1,
      anon_sym_COMMA,
    ACTIONS(3388), 1,
      anon_sym_RBRACE,
    STATE(2432), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115804] = 4,
    ACTIONS(3087), 1,
      anon_sym_RPAREN,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115818] = 4,
    ACTIONS(630), 1,
      sym__newline,
    ACTIONS(4418), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115832] = 4,
    ACTIONS(4228), 1,
      anon_sym_COLON,
    ACTIONS(4420), 1,
      anon_sym_COMMA,
    STATE(2323), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115846] = 4,
    ACTIONS(1306), 1,
      anon_sym_RBRACE,
    ACTIONS(4422), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115860] = 4,
    ACTIONS(4043), 1,
      anon_sym_RPAREN,
    ACTIONS(4424), 1,
      anon_sym_COMMA,
    STATE(2523), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115874] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(4426), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115888] = 4,
    ACTIONS(3166), 1,
      anon_sym_RPAREN,
    ACTIONS(3168), 1,
      anon_sym_COMMA,
    STATE(2442), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115902] = 4,
    ACTIONS(4428), 1,
      anon_sym_RPAREN,
    ACTIONS(4430), 1,
      anon_sym_COMMA,
    STATE(2443), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115916] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(4432), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115930] = 4,
    ACTIONS(3335), 1,
      anon_sym_COMMA,
    ACTIONS(3337), 1,
      anon_sym_RBRACK,
    STATE(2446), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115944] = 4,
    ACTIONS(4043), 1,
      anon_sym_RPAREN,
    ACTIONS(4434), 1,
      anon_sym_COMMA,
    STATE(2523), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115958] = 4,
    ACTIONS(4436), 1,
      anon_sym_COMMA,
    ACTIONS(4438), 1,
      anon_sym_RBRACE,
    STATE(2500), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115972] = 4,
    ACTIONS(4086), 1,
      sym__newline,
    ACTIONS(4088), 1,
      sym__indent,
    STATE(831), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115986] = 4,
    ACTIONS(1214), 1,
      anon_sym_RPAREN,
    ACTIONS(4440), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116000] = 4,
    ACTIONS(1216), 1,
      anon_sym_RPAREN,
    ACTIONS(4442), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116014] = 4,
    ACTIONS(1422), 1,
      anon_sym_COLON,
    ACTIONS(4444), 1,
      anon_sym_COMMA,
    STATE(2494), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116028] = 4,
    ACTIONS(4446), 1,
      anon_sym_COMMA,
    ACTIONS(4448), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116042] = 4,
    ACTIONS(4450), 1,
      anon_sym_COMMA,
    ACTIONS(4452), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116056] = 4,
    ACTIONS(1286), 1,
      anon_sym_RBRACK,
    ACTIONS(4454), 1,
      anon_sym_COMMA,
    STATE(2461), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116070] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2930), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [116080] = 4,
    ACTIONS(1881), 1,
      anon_sym_RBRACK,
    ACTIONS(4456), 1,
      anon_sym_COMMA,
    STATE(2338), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116094] = 4,
    ACTIONS(1426), 1,
      anon_sym_RPAREN,
    ACTIONS(4458), 1,
      anon_sym_COMMA,
    STATE(2352), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116108] = 4,
    ACTIONS(3339), 1,
      anon_sym_COMMA,
    ACTIONS(3341), 1,
      anon_sym_RBRACK,
    STATE(2454), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116122] = 4,
    ACTIONS(4094), 1,
      anon_sym_RPAREN,
    ACTIONS(4460), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116136] = 4,
    ACTIONS(4462), 1,
      anon_sym_COMMA,
    ACTIONS(4464), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116150] = 4,
    ACTIONS(4466), 1,
      anon_sym_COMMA,
    ACTIONS(4468), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116164] = 3,
    ACTIONS(3646), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3648), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [116176] = 4,
    ACTIONS(3447), 1,
      anon_sym_COMMA,
    ACTIONS(3449), 1,
      anon_sym_RBRACE,
    STATE(2492), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116190] = 4,
    ACTIONS(3347), 1,
      anon_sym_COMMA,
    ACTIONS(3349), 1,
      anon_sym_RBRACK,
    STATE(2459), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116204] = 4,
    ACTIONS(4470), 1,
      anon_sym_COMMA,
    ACTIONS(4472), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116218] = 4,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4476), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116232] = 3,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [116244] = 4,
    ACTIONS(3535), 1,
      anon_sym_RBRACK,
    ACTIONS(4480), 1,
      anon_sym_COMMA,
    STATE(2461), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116258] = 4,
    ACTIONS(4100), 1,
      anon_sym_COLON,
    ACTIONS(4483), 1,
      anon_sym_COMMA,
    STATE(2462), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116272] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4068), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [116282] = 4,
    ACTIONS(626), 1,
      sym__newline,
    ACTIONS(4486), 1,
      anon_sym_SEMI,
    STATE(2365), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116296] = 4,
    ACTIONS(970), 1,
      anon_sym_in,
    ACTIONS(4488), 1,
      anon_sym_COMMA,
    STATE(2495), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116310] = 4,
    ACTIONS(4490), 1,
      anon_sym_COMMA,
    ACTIONS(4492), 1,
      anon_sym_COLON,
    STATE(2444), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116324] = 4,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3439), 1,
      anon_sym_RBRACE,
    STATE(2515), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116338] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1657), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [116348] = 4,
    ACTIONS(3809), 1,
      anon_sym_LPAREN,
    ACTIONS(4494), 1,
      anon_sym_COLON,
    STATE(2729), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116362] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4496), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116376] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(4498), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116390] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4500), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116404] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(4502), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116418] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4504), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116432] = 4,
    ACTIONS(4402), 1,
      sym__newline,
    ACTIONS(4404), 1,
      sym__indent,
    STATE(775), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116446] = 4,
    ACTIONS(4506), 1,
      anon_sym_COMMA,
    ACTIONS(4508), 1,
      anon_sym_COLON,
    STATE(2293), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116460] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4510), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116474] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116488] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4514), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116502] = 4,
    ACTIONS(2657), 1,
      anon_sym_RPAREN,
    ACTIONS(4516), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116516] = 4,
    ACTIONS(3947), 1,
      sym_identifier,
    STATE(2520), 1,
      sym_dotted_name,
    STATE(2624), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116530] = 4,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    ACTIONS(3172), 1,
      anon_sym_RPAREN,
    STATE(2356), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116544] = 4,
    ACTIONS(2993), 1,
      anon_sym_RPAREN,
    ACTIONS(4518), 1,
      anon_sym_COMMA,
    STATE(2274), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116558] = 3,
    ACTIONS(1683), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [116570] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116584] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4522), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116598] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1657), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [116608] = 3,
    ACTIONS(1675), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [116620] = 4,
    ACTIONS(4524), 1,
      anon_sym_COMMA,
    ACTIONS(4527), 1,
      anon_sym_RBRACK,
    STATE(2489), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116634] = 4,
    ACTIONS(1292), 1,
      anon_sym_COLON,
    ACTIONS(4529), 1,
      anon_sym_COMMA,
    STATE(2503), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116648] = 4,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
    ACTIONS(4531), 1,
      anon_sym_COMMA,
    STATE(2491), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116662] = 4,
    ACTIONS(1314), 1,
      anon_sym_RBRACE,
    ACTIONS(4534), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116676] = 4,
    ACTIONS(3584), 1,
      anon_sym_PIPE,
    ACTIONS(4536), 1,
      anon_sym_COLON,
    STATE(1938), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116690] = 4,
    ACTIONS(4263), 1,
      anon_sym_COLON,
    ACTIONS(4538), 1,
      anon_sym_COMMA,
    STATE(2494), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116704] = 4,
    ACTIONS(2891), 1,
      anon_sym_in,
    ACTIONS(4541), 1,
      anon_sym_COMMA,
    STATE(2495), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116718] = 4,
    ACTIONS(2661), 1,
      anon_sym_RBRACK,
    ACTIONS(4544), 1,
      anon_sym_COMMA,
    STATE(2336), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2462), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [116742] = 4,
    ACTIONS(3091), 1,
      anon_sym_RPAREN,
    ACTIONS(3093), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116756] = 4,
    ACTIONS(4546), 1,
      anon_sym_RPAREN,
    ACTIONS(4548), 1,
      anon_sym_COMMA,
    STATE(2270), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116770] = 4,
    ACTIONS(4550), 1,
      anon_sym_COMMA,
    ACTIONS(4552), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116784] = 4,
    ACTIONS(4554), 1,
      anon_sym_COMMA,
    ACTIONS(4556), 1,
      anon_sym_RBRACE,
    STATE(2316), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116798] = 4,
    ACTIONS(3313), 1,
      anon_sym_COMMA,
    ACTIONS(3315), 1,
      anon_sym_RBRACK,
    STATE(2286), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116812] = 4,
    ACTIONS(3246), 1,
      anon_sym_COLON,
    ACTIONS(4558), 1,
      anon_sym_COMMA,
    STATE(2503), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116826] = 4,
    ACTIONS(3809), 1,
      anon_sym_LPAREN,
    ACTIONS(4561), 1,
      anon_sym_COLON,
    STATE(2778), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116840] = 4,
    ACTIONS(4563), 1,
      anon_sym_COMMA,
    ACTIONS(4565), 1,
      anon_sym_RBRACE,
    STATE(2387), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116854] = 4,
    ACTIONS(990), 1,
      anon_sym_RBRACK,
    ACTIONS(4567), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116868] = 4,
    ACTIONS(3730), 1,
      anon_sym_COLON,
    ACTIONS(4569), 1,
      anon_sym_RBRACE,
    STATE(2799), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116882] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4571), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116896] = 4,
    ACTIONS(4573), 1,
      anon_sym_COMMA,
    ACTIONS(4575), 1,
      anon_sym_RBRACE,
    STATE(2317), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116910] = 4,
    ACTIONS(3762), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_PIPE,
    ACTIONS(4577), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116924] = 4,
    ACTIONS(2617), 1,
      anon_sym_RPAREN,
    ACTIONS(4579), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116938] = 4,
    ACTIONS(3671), 1,
      anon_sym_RPAREN,
    ACTIONS(4581), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116952] = 4,
    ACTIONS(3833), 1,
      anon_sym_RPAREN,
    ACTIONS(3997), 1,
      anon_sym_COMMA,
    STATE(2433), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116966] = 3,
    ACTIONS(4586), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4584), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116978] = 4,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(4588), 1,
      anon_sym_COMMA,
    STATE(2409), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116992] = 3,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117004] = 3,
    ACTIONS(3714), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3716), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [117016] = 4,
    ACTIONS(4402), 1,
      sym__newline,
    ACTIONS(4404), 1,
      sym__indent,
    STATE(784), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117030] = 4,
    ACTIONS(2723), 1,
      anon_sym_RPAREN,
    ACTIONS(4590), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117044] = 3,
    ACTIONS(3999), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4068), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117056] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [117066] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3704), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [117076] = 4,
    ACTIONS(3922), 1,
      anon_sym_RPAREN,
    ACTIONS(4592), 1,
      anon_sym_COMMA,
    STATE(2523), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117090] = 4,
    ACTIONS(1204), 1,
      anon_sym_RPAREN,
    ACTIONS(4595), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117104] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4597), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117118] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4599), 1,
      anon_sym_in,
    STATE(2465), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117132] = 4,
    ACTIONS(1196), 1,
      anon_sym_RPAREN,
    ACTIONS(4601), 1,
      anon_sym_COMMA,
    STATE(2512), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117146] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4603), 2,
      anon_sym__,
      sym_identifier,
  [117155] = 3,
    ACTIONS(4605), 1,
      sym_integer,
    ACTIONS(4607), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117166] = 3,
    ACTIONS(4609), 1,
      sym_integer,
    ACTIONS(4611), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117177] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4613), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117186] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117195] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4617), 2,
      sym__dedent,
      anon_sym_case,
  [117204] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3535), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117213] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1687), 2,
      sym__dedent,
      anon_sym_case,
  [117222] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4619), 2,
      sym__dedent,
      anon_sym_case,
  [117231] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4621), 2,
      sym__newline,
      anon_sym_SEMI,
  [117240] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4623), 2,
      sym__dedent,
      anon_sym_case,
  [117249] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4625), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [117258] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4627), 2,
      sym__newline,
      anon_sym_SEMI,
  [117267] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4629), 2,
      sym__dedent,
      anon_sym_case,
  [117276] = 3,
    ACTIONS(4631), 1,
      anon_sym_COLON,
    ACTIONS(4633), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117287] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3356), 2,
      sym__newline,
      anon_sym_SEMI,
  [117296] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4635), 2,
      sym__newline,
      anon_sym_SEMI,
  [117305] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4637), 2,
      sym__newline,
      anon_sym_SEMI,
  [117314] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117323] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4639), 2,
      sym__newline,
      anon_sym_SEMI,
  [117332] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3066), 2,
      sym__newline,
      anon_sym_SEMI,
  [117341] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3203), 2,
      sym__newline,
      anon_sym_SEMI,
  [117350] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2930), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117359] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4641), 2,
      sym__newline,
      anon_sym_SEMI,
  [117368] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4643), 2,
      sym__newline,
      anon_sym_SEMI,
  [117377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4645), 2,
      anon_sym__,
      sym_identifier,
  [117386] = 3,
    ACTIONS(4647), 1,
      sym_integer,
    ACTIONS(4649), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117397] = 3,
    ACTIONS(4651), 1,
      sym_integer,
    ACTIONS(4653), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117408] = 3,
    ACTIONS(4655), 1,
      sym_integer,
    ACTIONS(4657), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117419] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117428] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4659), 2,
      sym__dedent,
      anon_sym_case,
  [117437] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4661), 2,
      anon_sym__,
      sym_identifier,
  [117446] = 3,
    ACTIONS(4663), 1,
      sym_integer,
    ACTIONS(4665), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117457] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117466] = 3,
    ACTIONS(4667), 1,
      sym_integer,
    ACTIONS(4669), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117477] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4671), 2,
      sym__newline,
      anon_sym_SEMI,
  [117486] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4613), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117495] = 3,
    ACTIONS(4673), 1,
      sym_integer,
    ACTIONS(4675), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117506] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4677), 2,
      sym__dedent,
      anon_sym_case,
  [117515] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4679), 2,
      sym__dedent,
      anon_sym_case,
  [117524] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4615), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117533] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4681), 2,
      sym__dedent,
      anon_sym_case,
  [117542] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3535), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117551] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4683), 2,
      sym__dedent,
      anon_sym_case,
  [117560] = 3,
    ACTIONS(4685), 1,
      anon_sym_COLON,
    ACTIONS(4687), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117571] = 3,
    ACTIONS(4689), 1,
      sym_integer,
    ACTIONS(4691), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117582] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4693), 2,
      sym__newline,
      anon_sym_SEMI,
  [117591] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4695), 2,
      anon_sym__,
      sym_identifier,
  [117600] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3671), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117609] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3203), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117618] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2928), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117627] = 3,
    ACTIONS(4697), 1,
      sym_integer,
    ACTIONS(4699), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117638] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117647] = 3,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2542), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117658] = 3,
    ACTIONS(4701), 1,
      anon_sym_COLON,
    ACTIONS(4703), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117669] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 2,
      sym__dedent,
      anon_sym_case,
  [117678] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4705), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117687] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4707), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117696] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1673), 2,
      sym__dedent,
      anon_sym_case,
  [117705] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117714] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 2,
      sym__dedent,
      anon_sym_case,
  [117723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4100), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2928), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117741] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117750] = 3,
    ACTIONS(4709), 1,
      anon_sym_COLON,
    ACTIONS(4711), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117761] = 3,
    ACTIONS(4713), 1,
      anon_sym_COLON,
    ACTIONS(4715), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117772] = 3,
    ACTIONS(4717), 1,
      anon_sym_COLON,
    ACTIONS(4719), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117783] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4025), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117792] = 3,
    ACTIONS(4721), 1,
      anon_sym_COLON,
    ACTIONS(4723), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117803] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4263), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117812] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1703), 2,
      sym__dedent,
      anon_sym_case,
  [117821] = 3,
    ACTIONS(4725), 1,
      sym_integer,
    ACTIONS(4727), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117832] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4729), 2,
      sym__newline,
      anon_sym_SEMI,
  [117841] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3203), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117850] = 3,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2582), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117861] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117870] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4263), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117879] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4294), 2,
      sym__newline,
      anon_sym_SEMI,
  [117888] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1558), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117897] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2891), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117906] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4731), 2,
      sym__newline,
      anon_sym_SEMI,
  [117915] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4733), 2,
      sym__dedent,
      anon_sym_case,
  [117924] = 3,
    ACTIONS(4735), 1,
      sym_integer,
    ACTIONS(4737), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117935] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3368), 2,
      sym__newline,
      anon_sym_SEMI,
  [117944] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3535), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117953] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4739), 2,
      sym__newline,
      anon_sym_SEMI,
  [117962] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4741), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [117971] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4743), 2,
      sym__newline,
      anon_sym_SEMI,
  [117980] = 3,
    ACTIONS(4745), 1,
      anon_sym_COMMA,
    STATE(1972), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117991] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4100), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [118000] = 3,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2594), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118011] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4705), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [118020] = 3,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    STATE(2596), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118031] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4747), 2,
      sym__dedent,
      anon_sym_case,
  [118040] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4749), 2,
      sym__dedent,
      anon_sym_case,
  [118049] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4751), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [118058] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4068), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [118067] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4105), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [118076] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4753), 2,
      sym__dedent,
      anon_sym_case,
  [118085] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4613), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [118094] = 3,
    ACTIONS(4755), 1,
      anon_sym_COLON,
    ACTIONS(4757), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118105] = 2,
    ACTIONS(4759), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118113] = 2,
    ACTIONS(4761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118121] = 2,
    ACTIONS(4763), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118129] = 2,
    ACTIONS(4765), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118137] = 2,
    ACTIONS(3378), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118145] = 2,
    ACTIONS(4767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118153] = 2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118161] = 2,
    ACTIONS(4771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118169] = 2,
    ACTIONS(4773), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118177] = 2,
    ACTIONS(3470), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118185] = 2,
    ACTIONS(4775), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118193] = 2,
    ACTIONS(3388), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118201] = 2,
    ACTIONS(4777), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118209] = 2,
    ACTIONS(4779), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118217] = 2,
    ACTIONS(4781), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118225] = 2,
    ACTIONS(4783), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118233] = 2,
    ACTIONS(4785), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118241] = 2,
    ACTIONS(3050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118249] = 2,
    ACTIONS(4787), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118257] = 2,
    ACTIONS(4789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118265] = 2,
    ACTIONS(4791), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118273] = 2,
    ACTIONS(4793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118281] = 2,
    ACTIONS(4795), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118289] = 2,
    ACTIONS(4797), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118297] = 2,
    ACTIONS(4799), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118305] = 2,
    ACTIONS(4801), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118313] = 2,
    ACTIONS(4803), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118321] = 2,
    ACTIONS(4805), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118329] = 2,
    ACTIONS(4807), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118337] = 2,
    ACTIONS(3166), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118345] = 2,
    ACTIONS(4809), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118353] = 2,
    ACTIONS(4811), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118361] = 2,
    ACTIONS(1428), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118369] = 2,
    ACTIONS(3486), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118377] = 2,
    ACTIONS(4813), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118385] = 2,
    ACTIONS(4815), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118393] = 2,
    ACTIONS(4817), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118401] = 2,
    ACTIONS(4819), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118409] = 2,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118417] = 2,
    ACTIONS(4823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118425] = 2,
    ACTIONS(4825), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118433] = 2,
    ACTIONS(4827), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118441] = 2,
    ACTIONS(4829), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118449] = 2,
    ACTIONS(4831), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118457] = 2,
    ACTIONS(4833), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118465] = 2,
    ACTIONS(3402), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118473] = 2,
    ACTIONS(4835), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118481] = 2,
    ACTIONS(4837), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118489] = 2,
    ACTIONS(4839), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118497] = 2,
    ACTIONS(4841), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118505] = 2,
    ACTIONS(4843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118513] = 2,
    ACTIONS(3439), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118521] = 2,
    ACTIONS(4845), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118529] = 2,
    ACTIONS(4847), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118537] = 2,
    ACTIONS(3449), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118545] = 2,
    ACTIONS(4849), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118553] = 2,
    ACTIONS(4851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118561] = 2,
    ACTIONS(4853), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118569] = 2,
    ACTIONS(4855), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118577] = 2,
    ACTIONS(4857), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118585] = 2,
    ACTIONS(4859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118593] = 2,
    ACTIONS(4861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118601] = 2,
    ACTIONS(4863), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118609] = 2,
    ACTIONS(4865), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118617] = 2,
    ACTIONS(4867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118625] = 2,
    ACTIONS(4869), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118633] = 2,
    ACTIONS(4871), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118641] = 2,
    ACTIONS(4873), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118649] = 2,
    ACTIONS(3494), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118657] = 2,
    ACTIONS(4875), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118665] = 2,
    ACTIONS(4877), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118673] = 2,
    ACTIONS(4879), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118681] = 2,
    ACTIONS(4881), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118689] = 2,
    ACTIONS(4883), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118697] = 2,
    ACTIONS(4885), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118705] = 2,
    ACTIONS(4278), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118713] = 2,
    ACTIONS(4887), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118721] = 2,
    ACTIONS(4889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118729] = 2,
    ACTIONS(4314), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118737] = 2,
    ACTIONS(4891), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118745] = 2,
    ACTIONS(4893), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118753] = 2,
    ACTIONS(4895), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118761] = 2,
    ACTIONS(4897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118769] = 2,
    ACTIONS(4899), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118777] = 2,
    ACTIONS(4901), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118785] = 2,
    ACTIONS(4903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118793] = 2,
    ACTIONS(4905), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118801] = 2,
    ACTIONS(3121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118809] = 2,
    ACTIONS(4907), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118817] = 2,
    ACTIONS(4909), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118825] = 2,
    ACTIONS(4911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118833] = 2,
    ACTIONS(4913), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118841] = 2,
    ACTIONS(4915), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118849] = 2,
    ACTIONS(4496), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118857] = 2,
    ACTIONS(4917), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118865] = 2,
    ACTIONS(3496), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118873] = 2,
    ACTIONS(4919), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118881] = 2,
    ACTIONS(4921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118889] = 2,
    ACTIONS(4923), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118897] = 2,
    ACTIONS(4925), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118905] = 2,
    ACTIONS(4927), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118913] = 2,
    ACTIONS(4929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118921] = 2,
    ACTIONS(4500), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118929] = 2,
    ACTIONS(4931), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118937] = 2,
    ACTIONS(3435), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118945] = 2,
    ACTIONS(3422), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118953] = 2,
    ACTIONS(4933), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118961] = 2,
    ACTIONS(4935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118969] = 2,
    ACTIONS(4937), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118977] = 2,
    ACTIONS(4939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118985] = 2,
    ACTIONS(4941), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118993] = 2,
    ACTIONS(4943), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119001] = 2,
    ACTIONS(4272), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119009] = 2,
    ACTIONS(4945), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119017] = 2,
    ACTIONS(4947), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119025] = 2,
    ACTIONS(4949), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119033] = 2,
    ACTIONS(4951), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119041] = 2,
    ACTIONS(4953), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119049] = 2,
    ACTIONS(4955), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119057] = 2,
    ACTIONS(4957), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119065] = 2,
    ACTIONS(4959), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119073] = 2,
    ACTIONS(4961), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119081] = 2,
    ACTIONS(4963), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119089] = 2,
    ACTIONS(4965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119097] = 2,
    ACTIONS(4967), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119105] = 2,
    ACTIONS(4969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119113] = 2,
    ACTIONS(4971), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119121] = 2,
    ACTIONS(4520), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119129] = 2,
    ACTIONS(4973), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119137] = 2,
    ACTIONS(4522), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119145] = 2,
    ACTIONS(4975), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119153] = 2,
    ACTIONS(4977), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119161] = 2,
    ACTIONS(4979), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119169] = 2,
    ACTIONS(4981), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119177] = 2,
    ACTIONS(4983), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119185] = 2,
    ACTIONS(4985), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119193] = 2,
    ACTIONS(3151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119201] = 2,
    ACTIONS(4987), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119209] = 2,
    ACTIONS(4989), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119217] = 2,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119225] = 2,
    ACTIONS(4991), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119233] = 2,
    ACTIONS(4993), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119241] = 2,
    ACTIONS(4995), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119249] = 2,
    ACTIONS(4997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119257] = 2,
    ACTIONS(4999), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119265] = 2,
    ACTIONS(5001), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119273] = 2,
    ACTIONS(4280), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119281] = 2,
    ACTIONS(3091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119289] = 2,
    ACTIONS(3174), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119297] = 2,
    ACTIONS(5003), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119305] = 2,
    ACTIONS(5005), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119313] = 2,
    ACTIONS(5007), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119321] = 2,
    ACTIONS(5009), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119329] = 2,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119337] = 2,
    ACTIONS(5013), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119345] = 2,
    ACTIONS(5015), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119353] = 2,
    ACTIONS(1472), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119361] = 2,
    ACTIONS(5017), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119369] = 2,
    ACTIONS(5019), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119377] = 2,
    ACTIONS(5021), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119385] = 2,
    ACTIONS(5023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119393] = 2,
    ACTIONS(5025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119401] = 2,
    ACTIONS(5027), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119409] = 2,
    ACTIONS(5029), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119417] = 2,
    ACTIONS(5031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119425] = 2,
    ACTIONS(5033), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119433] = 2,
    ACTIONS(5035), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119441] = 2,
    ACTIONS(5037), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119449] = 2,
    ACTIONS(5039), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119457] = 2,
    ACTIONS(5041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119465] = 2,
    ACTIONS(5043), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119473] = 2,
    ACTIONS(5045), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119481] = 2,
    ACTIONS(5047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119489] = 2,
    ACTIONS(3141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119497] = 2,
    ACTIONS(5049), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119505] = 2,
    ACTIONS(5051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119513] = 2,
    ACTIONS(5053), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119521] = 2,
    ACTIONS(5055), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119529] = 2,
    ACTIONS(3384), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119537] = 2,
    ACTIONS(5057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119545] = 2,
    ACTIONS(5059), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119553] = 2,
    ACTIONS(5061), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119561] = 2,
    ACTIONS(5063), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119569] = 2,
    ACTIONS(5065), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119577] = 2,
    ACTIONS(5067), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119585] = 2,
    ACTIONS(5069), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119593] = 2,
    ACTIONS(5071), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119601] = 2,
    ACTIONS(5073), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119609] = 2,
    ACTIONS(5075), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119617] = 2,
    ACTIONS(5077), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119625] = 2,
    ACTIONS(5079), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119633] = 2,
    ACTIONS(5081), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119641] = 2,
    ACTIONS(5083), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119649] = 2,
    ACTIONS(4597), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119657] = 2,
    ACTIONS(1452), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119665] = 2,
    ACTIONS(5085), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119673] = 2,
    ACTIONS(5087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119681] = 2,
    ACTIONS(4599), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119689] = 2,
    ACTIONS(5089), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119697] = 2,
    ACTIONS(5091), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119705] = 2,
    ACTIONS(5093), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119713] = 2,
    ACTIONS(5095), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(189)] = 0,
  [SMALL_STATE(190)] = 126,
  [SMALL_STATE(191)] = 250,
  [SMALL_STATE(192)] = 374,
  [SMALL_STATE(193)] = 502,
  [SMALL_STATE(194)] = 628,
  [SMALL_STATE(195)] = 756,
  [SMALL_STATE(196)] = 880,
  [SMALL_STATE(197)] = 1000,
  [SMALL_STATE(198)] = 1120,
  [SMALL_STATE(199)] = 1240,
  [SMALL_STATE(200)] = 1364,
  [SMALL_STATE(201)] = 1488,
  [SMALL_STATE(202)] = 1614,
  [SMALL_STATE(203)] = 1738,
  [SMALL_STATE(204)] = 1862,
  [SMALL_STATE(205)] = 1988,
  [SMALL_STATE(206)] = 2112,
  [SMALL_STATE(207)] = 2236,
  [SMALL_STATE(208)] = 2360,
  [SMALL_STATE(209)] = 2486,
  [SMALL_STATE(210)] = 2610,
  [SMALL_STATE(211)] = 2734,
  [SMALL_STATE(212)] = 2860,
  [SMALL_STATE(213)] = 2984,
  [SMALL_STATE(214)] = 3108,
  [SMALL_STATE(215)] = 3234,
  [SMALL_STATE(216)] = 3358,
  [SMALL_STATE(217)] = 3482,
  [SMALL_STATE(218)] = 3608,
  [SMALL_STATE(219)] = 3732,
  [SMALL_STATE(220)] = 3856,
  [SMALL_STATE(221)] = 3980,
  [SMALL_STATE(222)] = 4106,
  [SMALL_STATE(223)] = 4213,
  [SMALL_STATE(224)] = 4320,
  [SMALL_STATE(225)] = 4434,
  [SMALL_STATE(226)] = 4548,
  [SMALL_STATE(227)] = 4662,
  [SMALL_STATE(228)] = 4776,
  [SMALL_STATE(229)] = 4890,
  [SMALL_STATE(230)] = 5004,
  [SMALL_STATE(231)] = 5118,
  [SMALL_STATE(232)] = 5234,
  [SMALL_STATE(233)] = 5348,
  [SMALL_STATE(234)] = 5464,
  [SMALL_STATE(235)] = 5575,
  [SMALL_STATE(236)] = 5686,
  [SMALL_STATE(237)] = 5797,
  [SMALL_STATE(238)] = 5908,
  [SMALL_STATE(239)] = 6023,
  [SMALL_STATE(240)] = 6134,
  [SMALL_STATE(241)] = 6245,
  [SMALL_STATE(242)] = 6356,
  [SMALL_STATE(243)] = 6467,
  [SMALL_STATE(244)] = 6582,
  [SMALL_STATE(245)] = 6693,
  [SMALL_STATE(246)] = 6808,
  [SMALL_STATE(247)] = 6923,
  [SMALL_STATE(248)] = 7034,
  [SMALL_STATE(249)] = 7149,
  [SMALL_STATE(250)] = 7254,
  [SMALL_STATE(251)] = 7365,
  [SMALL_STATE(252)] = 7480,
  [SMALL_STATE(253)] = 7591,
  [SMALL_STATE(254)] = 7708,
  [SMALL_STATE(255)] = 7823,
  [SMALL_STATE(256)] = 7934,
  [SMALL_STATE(257)] = 8045,
  [SMALL_STATE(258)] = 8160,
  [SMALL_STATE(259)] = 8271,
  [SMALL_STATE(260)] = 8382,
  [SMALL_STATE(261)] = 8487,
  [SMALL_STATE(262)] = 8598,
  [SMALL_STATE(263)] = 8713,
  [SMALL_STATE(264)] = 8824,
  [SMALL_STATE(265)] = 8935,
  [SMALL_STATE(266)] = 9046,
  [SMALL_STATE(267)] = 9157,
  [SMALL_STATE(268)] = 9268,
  [SMALL_STATE(269)] = 9379,
  [SMALL_STATE(270)] = 9490,
  [SMALL_STATE(271)] = 9601,
  [SMALL_STATE(272)] = 9712,
  [SMALL_STATE(273)] = 9828,
  [SMALL_STATE(274)] = 9940,
  [SMALL_STATE(275)] = 10056,
  [SMALL_STATE(276)] = 10168,
  [SMALL_STATE(277)] = 10280,
  [SMALL_STATE(278)] = 10392,
  [SMALL_STATE(279)] = 10504,
  [SMALL_STATE(280)] = 10616,
  [SMALL_STATE(281)] = 10728,
  [SMALL_STATE(282)] = 10842,
  [SMALL_STATE(283)] = 10956,
  [SMALL_STATE(284)] = 11070,
  [SMALL_STATE(285)] = 11182,
  [SMALL_STATE(286)] = 11296,
  [SMALL_STATE(287)] = 11408,
  [SMALL_STATE(288)] = 11520,
  [SMALL_STATE(289)] = 11632,
  [SMALL_STATE(290)] = 11744,
  [SMALL_STATE(291)] = 11856,
  [SMALL_STATE(292)] = 11968,
  [SMALL_STATE(293)] = 12084,
  [SMALL_STATE(294)] = 12196,
  [SMALL_STATE(295)] = 12310,
  [SMALL_STATE(296)] = 12422,
  [SMALL_STATE(297)] = 12534,
  [SMALL_STATE(298)] = 12650,
  [SMALL_STATE(299)] = 12762,
  [SMALL_STATE(300)] = 12874,
  [SMALL_STATE(301)] = 12986,
  [SMALL_STATE(302)] = 13098,
  [SMALL_STATE(303)] = 13214,
  [SMALL_STATE(304)] = 13326,
  [SMALL_STATE(305)] = 13438,
  [SMALL_STATE(306)] = 13552,
  [SMALL_STATE(307)] = 13664,
  [SMALL_STATE(308)] = 13776,
  [SMALL_STATE(309)] = 13888,
  [SMALL_STATE(310)] = 14000,
  [SMALL_STATE(311)] = 14112,
  [SMALL_STATE(312)] = 14224,
  [SMALL_STATE(313)] = 14336,
  [SMALL_STATE(314)] = 14448,
  [SMALL_STATE(315)] = 14560,
  [SMALL_STATE(316)] = 14672,
  [SMALL_STATE(317)] = 14784,
  [SMALL_STATE(318)] = 14896,
  [SMALL_STATE(319)] = 15008,
  [SMALL_STATE(320)] = 15122,
  [SMALL_STATE(321)] = 15234,
  [SMALL_STATE(322)] = 15346,
  [SMALL_STATE(323)] = 15460,
  [SMALL_STATE(324)] = 15572,
  [SMALL_STATE(325)] = 15688,
  [SMALL_STATE(326)] = 15800,
  [SMALL_STATE(327)] = 15905,
  [SMALL_STATE(328)] = 16014,
  [SMALL_STATE(329)] = 16123,
  [SMALL_STATE(330)] = 16220,
  [SMALL_STATE(331)] = 16329,
  [SMALL_STATE(332)] = 16438,
  [SMALL_STATE(333)] = 16547,
  [SMALL_STATE(334)] = 16656,
  [SMALL_STATE(335)] = 16765,
  [SMALL_STATE(336)] = 16874,
  [SMALL_STATE(337)] = 16983,
  [SMALL_STATE(338)] = 17092,
  [SMALL_STATE(339)] = 17201,
  [SMALL_STATE(340)] = 17310,
  [SMALL_STATE(341)] = 17419,
  [SMALL_STATE(342)] = 17528,
  [SMALL_STATE(343)] = 17637,
  [SMALL_STATE(344)] = 17746,
  [SMALL_STATE(345)] = 17851,
  [SMALL_STATE(346)] = 17960,
  [SMALL_STATE(347)] = 18069,
  [SMALL_STATE(348)] = 18178,
  [SMALL_STATE(349)] = 18286,
  [SMALL_STATE(350)] = 18394,
  [SMALL_STATE(351)] = 18500,
  [SMALL_STATE(352)] = 18608,
  [SMALL_STATE(353)] = 18716,
  [SMALL_STATE(354)] = 18824,
  [SMALL_STATE(355)] = 18930,
  [SMALL_STATE(356)] = 19038,
  [SMALL_STATE(357)] = 19146,
  [SMALL_STATE(358)] = 19254,
  [SMALL_STATE(359)] = 19362,
  [SMALL_STATE(360)] = 19470,
  [SMALL_STATE(361)] = 19578,
  [SMALL_STATE(362)] = 19686,
  [SMALL_STATE(363)] = 19792,
  [SMALL_STATE(364)] = 19900,
  [SMALL_STATE(365)] = 20008,
  [SMALL_STATE(366)] = 20116,
  [SMALL_STATE(367)] = 20224,
  [SMALL_STATE(368)] = 20332,
  [SMALL_STATE(369)] = 20440,
  [SMALL_STATE(370)] = 20548,
  [SMALL_STATE(371)] = 20656,
  [SMALL_STATE(372)] = 20763,
  [SMALL_STATE(373)] = 20870,
  [SMALL_STATE(374)] = 20977,
  [SMALL_STATE(375)] = 21084,
  [SMALL_STATE(376)] = 21191,
  [SMALL_STATE(377)] = 21298,
  [SMALL_STATE(378)] = 21405,
  [SMALL_STATE(379)] = 21500,
  [SMALL_STATE(380)] = 21607,
  [SMALL_STATE(381)] = 21714,
  [SMALL_STATE(382)] = 21821,
  [SMALL_STATE(383)] = 21928,
  [SMALL_STATE(384)] = 22033,
  [SMALL_STATE(385)] = 22140,
  [SMALL_STATE(386)] = 22247,
  [SMALL_STATE(387)] = 22354,
  [SMALL_STATE(388)] = 22461,
  [SMALL_STATE(389)] = 22566,
  [SMALL_STATE(390)] = 22673,
  [SMALL_STATE(391)] = 22780,
  [SMALL_STATE(392)] = 22887,
  [SMALL_STATE(393)] = 22992,
  [SMALL_STATE(394)] = 23099,
  [SMALL_STATE(395)] = 23206,
  [SMALL_STATE(396)] = 23313,
  [SMALL_STATE(397)] = 23420,
  [SMALL_STATE(398)] = 23525,
  [SMALL_STATE(399)] = 23632,
  [SMALL_STATE(400)] = 23739,
  [SMALL_STATE(401)] = 23844,
  [SMALL_STATE(402)] = 23951,
  [SMALL_STATE(403)] = 24058,
  [SMALL_STATE(404)] = 24165,
  [SMALL_STATE(405)] = 24272,
  [SMALL_STATE(406)] = 24367,
  [SMALL_STATE(407)] = 24472,
  [SMALL_STATE(408)] = 24579,
  [SMALL_STATE(409)] = 24686,
  [SMALL_STATE(410)] = 24790,
  [SMALL_STATE(411)] = 24892,
  [SMALL_STATE(412)] = 24994,
  [SMALL_STATE(413)] = 25098,
  [SMALL_STATE(414)] = 25202,
  [SMALL_STATE(415)] = 25304,
  [SMALL_STATE(416)] = 25408,
  [SMALL_STATE(417)] = 25510,
  [SMALL_STATE(418)] = 25612,
  [SMALL_STATE(419)] = 25714,
  [SMALL_STATE(420)] = 25816,
  [SMALL_STATE(421)] = 25918,
  [SMALL_STATE(422)] = 26020,
  [SMALL_STATE(423)] = 26122,
  [SMALL_STATE(424)] = 26216,
  [SMALL_STATE(425)] = 26318,
  [SMALL_STATE(426)] = 26420,
  [SMALL_STATE(427)] = 26524,
  [SMALL_STATE(428)] = 26626,
  [SMALL_STATE(429)] = 26730,
  [SMALL_STATE(430)] = 26832,
  [SMALL_STATE(431)] = 26928,
  [SMALL_STATE(432)] = 27030,
  [SMALL_STATE(433)] = 27132,
  [SMALL_STATE(434)] = 27234,
  [SMALL_STATE(435)] = 27336,
  [SMALL_STATE(436)] = 27430,
  [SMALL_STATE(437)] = 27532,
  [SMALL_STATE(438)] = 27634,
  [SMALL_STATE(439)] = 27736,
  [SMALL_STATE(440)] = 27830,
  [SMALL_STATE(441)] = 27924,
  [SMALL_STATE(442)] = 28026,
  [SMALL_STATE(443)] = 28128,
  [SMALL_STATE(444)] = 28230,
  [SMALL_STATE(445)] = 28332,
  [SMALL_STATE(446)] = 28434,
  [SMALL_STATE(447)] = 28538,
  [SMALL_STATE(448)] = 28640,
  [SMALL_STATE(449)] = 28744,
  [SMALL_STATE(450)] = 28848,
  [SMALL_STATE(451)] = 28952,
  [SMALL_STATE(452)] = 29056,
  [SMALL_STATE(453)] = 29160,
  [SMALL_STATE(454)] = 29264,
  [SMALL_STATE(455)] = 29368,
  [SMALL_STATE(456)] = 29472,
  [SMALL_STATE(457)] = 29576,
  [SMALL_STATE(458)] = 29680,
  [SMALL_STATE(459)] = 29784,
  [SMALL_STATE(460)] = 29888,
  [SMALL_STATE(461)] = 29990,
  [SMALL_STATE(462)] = 30065,
  [SMALL_STATE(463)] = 30166,
  [SMALL_STATE(464)] = 30267,
  [SMALL_STATE(465)] = 30368,
  [SMALL_STATE(466)] = 30469,
  [SMALL_STATE(467)] = 30570,
  [SMALL_STATE(468)] = 30671,
  [SMALL_STATE(469)] = 30772,
  [SMALL_STATE(470)] = 30873,
  [SMALL_STATE(471)] = 30948,
  [SMALL_STATE(472)] = 31025,
  [SMALL_STATE(473)] = 31126,
  [SMALL_STATE(474)] = 31201,
  [SMALL_STATE(475)] = 31302,
  [SMALL_STATE(476)] = 31403,
  [SMALL_STATE(477)] = 31504,
  [SMALL_STATE(478)] = 31605,
  [SMALL_STATE(479)] = 31706,
  [SMALL_STATE(480)] = 31807,
  [SMALL_STATE(481)] = 31905,
  [SMALL_STATE(482)] = 31977,
  [SMALL_STATE(483)] = 32075,
  [SMALL_STATE(484)] = 32173,
  [SMALL_STATE(485)] = 32271,
  [SMALL_STATE(486)] = 32343,
  [SMALL_STATE(487)] = 32441,
  [SMALL_STATE(488)] = 32539,
  [SMALL_STATE(489)] = 32637,
  [SMALL_STATE(490)] = 32735,
  [SMALL_STATE(491)] = 32833,
  [SMALL_STATE(492)] = 32931,
  [SMALL_STATE(493)] = 33003,
  [SMALL_STATE(494)] = 33075,
  [SMALL_STATE(495)] = 33173,
  [SMALL_STATE(496)] = 33271,
  [SMALL_STATE(497)] = 33369,
  [SMALL_STATE(498)] = 33467,
  [SMALL_STATE(499)] = 33565,
  [SMALL_STATE(500)] = 33663,
  [SMALL_STATE(501)] = 33761,
  [SMALL_STATE(502)] = 33833,
  [SMALL_STATE(503)] = 33905,
  [SMALL_STATE(504)] = 34003,
  [SMALL_STATE(505)] = 34101,
  [SMALL_STATE(506)] = 34201,
  [SMALL_STATE(507)] = 34273,
  [SMALL_STATE(508)] = 34345,
  [SMALL_STATE(509)] = 34443,
  [SMALL_STATE(510)] = 34541,
  [SMALL_STATE(511)] = 34639,
  [SMALL_STATE(512)] = 34737,
  [SMALL_STATE(513)] = 34835,
  [SMALL_STATE(514)] = 34933,
  [SMALL_STATE(515)] = 35031,
  [SMALL_STATE(516)] = 35129,
  [SMALL_STATE(517)] = 35227,
  [SMALL_STATE(518)] = 35327,
  [SMALL_STATE(519)] = 35425,
  [SMALL_STATE(520)] = 35523,
  [SMALL_STATE(521)] = 35621,
  [SMALL_STATE(522)] = 35721,
  [SMALL_STATE(523)] = 35819,
  [SMALL_STATE(524)] = 35917,
  [SMALL_STATE(525)] = 36015,
  [SMALL_STATE(526)] = 36113,
  [SMALL_STATE(527)] = 36211,
  [SMALL_STATE(528)] = 36309,
  [SMALL_STATE(529)] = 36407,
  [SMALL_STATE(530)] = 36505,
  [SMALL_STATE(531)] = 36603,
  [SMALL_STATE(532)] = 36701,
  [SMALL_STATE(533)] = 36799,
  [SMALL_STATE(534)] = 36897,
  [SMALL_STATE(535)] = 36997,
  [SMALL_STATE(536)] = 37095,
  [SMALL_STATE(537)] = 37193,
  [SMALL_STATE(538)] = 37291,
  [SMALL_STATE(539)] = 37389,
  [SMALL_STATE(540)] = 37487,
  [SMALL_STATE(541)] = 37587,
  [SMALL_STATE(542)] = 37685,
  [SMALL_STATE(543)] = 37783,
  [SMALL_STATE(544)] = 37881,
  [SMALL_STATE(545)] = 37979,
  [SMALL_STATE(546)] = 38077,
  [SMALL_STATE(547)] = 38175,
  [SMALL_STATE(548)] = 38273,
  [SMALL_STATE(549)] = 38371,
  [SMALL_STATE(550)] = 38469,
  [SMALL_STATE(551)] = 38567,
  [SMALL_STATE(552)] = 38665,
  [SMALL_STATE(553)] = 38763,
  [SMALL_STATE(554)] = 38861,
  [SMALL_STATE(555)] = 38959,
  [SMALL_STATE(556)] = 39057,
  [SMALL_STATE(557)] = 39155,
  [SMALL_STATE(558)] = 39253,
  [SMALL_STATE(559)] = 39351,
  [SMALL_STATE(560)] = 39449,
  [SMALL_STATE(561)] = 39547,
  [SMALL_STATE(562)] = 39645,
  [SMALL_STATE(563)] = 39743,
  [SMALL_STATE(564)] = 39841,
  [SMALL_STATE(565)] = 39939,
  [SMALL_STATE(566)] = 40037,
  [SMALL_STATE(567)] = 40135,
  [SMALL_STATE(568)] = 40233,
  [SMALL_STATE(569)] = 40331,
  [SMALL_STATE(570)] = 40429,
  [SMALL_STATE(571)] = 40527,
  [SMALL_STATE(572)] = 40625,
  [SMALL_STATE(573)] = 40723,
  [SMALL_STATE(574)] = 40821,
  [SMALL_STATE(575)] = 40919,
  [SMALL_STATE(576)] = 41019,
  [SMALL_STATE(577)] = 41117,
  [SMALL_STATE(578)] = 41215,
  [SMALL_STATE(579)] = 41313,
  [SMALL_STATE(580)] = 41411,
  [SMALL_STATE(581)] = 41509,
  [SMALL_STATE(582)] = 41607,
  [SMALL_STATE(583)] = 41705,
  [SMALL_STATE(584)] = 41803,
  [SMALL_STATE(585)] = 41901,
  [SMALL_STATE(586)] = 41999,
  [SMALL_STATE(587)] = 42097,
  [SMALL_STATE(588)] = 42195,
  [SMALL_STATE(589)] = 42293,
  [SMALL_STATE(590)] = 42391,
  [SMALL_STATE(591)] = 42489,
  [SMALL_STATE(592)] = 42587,
  [SMALL_STATE(593)] = 42685,
  [SMALL_STATE(594)] = 42783,
  [SMALL_STATE(595)] = 42881,
  [SMALL_STATE(596)] = 42979,
  [SMALL_STATE(597)] = 43077,
  [SMALL_STATE(598)] = 43175,
  [SMALL_STATE(599)] = 43273,
  [SMALL_STATE(600)] = 43371,
  [SMALL_STATE(601)] = 43469,
  [SMALL_STATE(602)] = 43567,
  [SMALL_STATE(603)] = 43665,
  [SMALL_STATE(604)] = 43763,
  [SMALL_STATE(605)] = 43861,
  [SMALL_STATE(606)] = 43959,
  [SMALL_STATE(607)] = 44057,
  [SMALL_STATE(608)] = 44155,
  [SMALL_STATE(609)] = 44253,
  [SMALL_STATE(610)] = 44326,
  [SMALL_STATE(611)] = 44392,
  [SMALL_STATE(612)] = 44460,
  [SMALL_STATE(613)] = 44528,
  [SMALL_STATE(614)] = 44596,
  [SMALL_STATE(615)] = 44658,
  [SMALL_STATE(616)] = 44726,
  [SMALL_STATE(617)] = 44792,
  [SMALL_STATE(618)] = 44860,
  [SMALL_STATE(619)] = 44926,
  [SMALL_STATE(620)] = 44988,
  [SMALL_STATE(621)] = 45056,
  [SMALL_STATE(622)] = 45124,
  [SMALL_STATE(623)] = 45186,
  [SMALL_STATE(624)] = 45254,
  [SMALL_STATE(625)] = 45316,
  [SMALL_STATE(626)] = 45384,
  [SMALL_STATE(627)] = 45447,
  [SMALL_STATE(628)] = 45504,
  [SMALL_STATE(629)] = 45565,
  [SMALL_STATE(630)] = 45626,
  [SMALL_STATE(631)] = 45689,
  [SMALL_STATE(632)] = 45754,
  [SMALL_STATE(633)] = 45811,
  [SMALL_STATE(634)] = 45868,
  [SMALL_STATE(635)] = 45925,
  [SMALL_STATE(636)] = 45988,
  [SMALL_STATE(637)] = 46051,
  [SMALL_STATE(638)] = 46114,
  [SMALL_STATE(639)] = 46175,
  [SMALL_STATE(640)] = 46232,
  [SMALL_STATE(641)] = 46289,
  [SMALL_STATE(642)] = 46352,
  [SMALL_STATE(643)] = 46415,
  [SMALL_STATE(644)] = 46478,
  [SMALL_STATE(645)] = 46541,
  [SMALL_STATE(646)] = 46598,
  [SMALL_STATE(647)] = 46661,
  [SMALL_STATE(648)] = 46717,
  [SMALL_STATE(649)] = 46773,
  [SMALL_STATE(650)] = 46829,
  [SMALL_STATE(651)] = 46885,
  [SMALL_STATE(652)] = 46941,
  [SMALL_STATE(653)] = 46997,
  [SMALL_STATE(654)] = 47053,
  [SMALL_STATE(655)] = 47109,
  [SMALL_STATE(656)] = 47165,
  [SMALL_STATE(657)] = 47221,
  [SMALL_STATE(658)] = 47277,
  [SMALL_STATE(659)] = 47333,
  [SMALL_STATE(660)] = 47389,
  [SMALL_STATE(661)] = 47445,
  [SMALL_STATE(662)] = 47501,
  [SMALL_STATE(663)] = 47557,
  [SMALL_STATE(664)] = 47613,
  [SMALL_STATE(665)] = 47669,
  [SMALL_STATE(666)] = 47725,
  [SMALL_STATE(667)] = 47781,
  [SMALL_STATE(668)] = 47837,
  [SMALL_STATE(669)] = 47893,
  [SMALL_STATE(670)] = 47949,
  [SMALL_STATE(671)] = 48005,
  [SMALL_STATE(672)] = 48061,
  [SMALL_STATE(673)] = 48117,
  [SMALL_STATE(674)] = 48173,
  [SMALL_STATE(675)] = 48229,
  [SMALL_STATE(676)] = 48285,
  [SMALL_STATE(677)] = 48341,
  [SMALL_STATE(678)] = 48397,
  [SMALL_STATE(679)] = 48453,
  [SMALL_STATE(680)] = 48509,
  [SMALL_STATE(681)] = 48565,
  [SMALL_STATE(682)] = 48621,
  [SMALL_STATE(683)] = 48713,
  [SMALL_STATE(684)] = 48769,
  [SMALL_STATE(685)] = 48825,
  [SMALL_STATE(686)] = 48881,
  [SMALL_STATE(687)] = 48937,
  [SMALL_STATE(688)] = 48993,
  [SMALL_STATE(689)] = 49049,
  [SMALL_STATE(690)] = 49105,
  [SMALL_STATE(691)] = 49161,
  [SMALL_STATE(692)] = 49217,
  [SMALL_STATE(693)] = 49309,
  [SMALL_STATE(694)] = 49365,
  [SMALL_STATE(695)] = 49421,
  [SMALL_STATE(696)] = 49477,
  [SMALL_STATE(697)] = 49533,
  [SMALL_STATE(698)] = 49589,
  [SMALL_STATE(699)] = 49645,
  [SMALL_STATE(700)] = 49704,
  [SMALL_STATE(701)] = 49759,
  [SMALL_STATE(702)] = 49818,
  [SMALL_STATE(703)] = 49877,
  [SMALL_STATE(704)] = 49932,
  [SMALL_STATE(705)] = 49991,
  [SMALL_STATE(706)] = 50050,
  [SMALL_STATE(707)] = 50105,
  [SMALL_STATE(708)] = 50160,
  [SMALL_STATE(709)] = 50219,
  [SMALL_STATE(710)] = 50278,
  [SMALL_STATE(711)] = 50337,
  [SMALL_STATE(712)] = 50396,
  [SMALL_STATE(713)] = 50451,
  [SMALL_STATE(714)] = 50510,
  [SMALL_STATE(715)] = 50569,
  [SMALL_STATE(716)] = 50628,
  [SMALL_STATE(717)] = 50687,
  [SMALL_STATE(718)] = 50746,
  [SMALL_STATE(719)] = 50805,
  [SMALL_STATE(720)] = 50860,
  [SMALL_STATE(721)] = 50919,
  [SMALL_STATE(722)] = 50973,
  [SMALL_STATE(723)] = 51065,
  [SMALL_STATE(724)] = 51119,
  [SMALL_STATE(725)] = 51211,
  [SMALL_STATE(726)] = 51265,
  [SMALL_STATE(727)] = 51319,
  [SMALL_STATE(728)] = 51372,
  [SMALL_STATE(729)] = 51461,
  [SMALL_STATE(730)] = 51514,
  [SMALL_STATE(731)] = 51567,
  [SMALL_STATE(732)] = 51620,
  [SMALL_STATE(733)] = 51673,
  [SMALL_STATE(734)] = 51726,
  [SMALL_STATE(735)] = 51779,
  [SMALL_STATE(736)] = 51832,
  [SMALL_STATE(737)] = 51885,
  [SMALL_STATE(738)] = 51938,
  [SMALL_STATE(739)] = 51991,
  [SMALL_STATE(740)] = 52044,
  [SMALL_STATE(741)] = 52097,
  [SMALL_STATE(742)] = 52150,
  [SMALL_STATE(743)] = 52239,
  [SMALL_STATE(744)] = 52328,
  [SMALL_STATE(745)] = 52381,
  [SMALL_STATE(746)] = 52434,
  [SMALL_STATE(747)] = 52487,
  [SMALL_STATE(748)] = 52540,
  [SMALL_STATE(749)] = 52629,
  [SMALL_STATE(750)] = 52682,
  [SMALL_STATE(751)] = 52735,
  [SMALL_STATE(752)] = 52788,
  [SMALL_STATE(753)] = 52841,
  [SMALL_STATE(754)] = 52894,
  [SMALL_STATE(755)] = 52947,
  [SMALL_STATE(756)] = 53000,
  [SMALL_STATE(757)] = 53053,
  [SMALL_STATE(758)] = 53106,
  [SMALL_STATE(759)] = 53159,
  [SMALL_STATE(760)] = 53212,
  [SMALL_STATE(761)] = 53265,
  [SMALL_STATE(762)] = 53318,
  [SMALL_STATE(763)] = 53407,
  [SMALL_STATE(764)] = 53460,
  [SMALL_STATE(765)] = 53513,
  [SMALL_STATE(766)] = 53566,
  [SMALL_STATE(767)] = 53619,
  [SMALL_STATE(768)] = 53708,
  [SMALL_STATE(769)] = 53761,
  [SMALL_STATE(770)] = 53814,
  [SMALL_STATE(771)] = 53867,
  [SMALL_STATE(772)] = 53956,
  [SMALL_STATE(773)] = 54009,
  [SMALL_STATE(774)] = 54098,
  [SMALL_STATE(775)] = 54151,
  [SMALL_STATE(776)] = 54204,
  [SMALL_STATE(777)] = 54257,
  [SMALL_STATE(778)] = 54310,
  [SMALL_STATE(779)] = 54363,
  [SMALL_STATE(780)] = 54416,
  [SMALL_STATE(781)] = 54469,
  [SMALL_STATE(782)] = 54522,
  [SMALL_STATE(783)] = 54575,
  [SMALL_STATE(784)] = 54628,
  [SMALL_STATE(785)] = 54681,
  [SMALL_STATE(786)] = 54734,
  [SMALL_STATE(787)] = 54787,
  [SMALL_STATE(788)] = 54840,
  [SMALL_STATE(789)] = 54893,
  [SMALL_STATE(790)] = 54982,
  [SMALL_STATE(791)] = 55035,
  [SMALL_STATE(792)] = 55088,
  [SMALL_STATE(793)] = 55141,
  [SMALL_STATE(794)] = 55194,
  [SMALL_STATE(795)] = 55247,
  [SMALL_STATE(796)] = 55300,
  [SMALL_STATE(797)] = 55353,
  [SMALL_STATE(798)] = 55406,
  [SMALL_STATE(799)] = 55459,
  [SMALL_STATE(800)] = 55512,
  [SMALL_STATE(801)] = 55565,
  [SMALL_STATE(802)] = 55618,
  [SMALL_STATE(803)] = 55671,
  [SMALL_STATE(804)] = 55724,
  [SMALL_STATE(805)] = 55777,
  [SMALL_STATE(806)] = 55830,
  [SMALL_STATE(807)] = 55883,
  [SMALL_STATE(808)] = 55936,
  [SMALL_STATE(809)] = 55989,
  [SMALL_STATE(810)] = 56042,
  [SMALL_STATE(811)] = 56131,
  [SMALL_STATE(812)] = 56184,
  [SMALL_STATE(813)] = 56237,
  [SMALL_STATE(814)] = 56290,
  [SMALL_STATE(815)] = 56343,
  [SMALL_STATE(816)] = 56396,
  [SMALL_STATE(817)] = 56449,
  [SMALL_STATE(818)] = 56502,
  [SMALL_STATE(819)] = 56555,
  [SMALL_STATE(820)] = 56608,
  [SMALL_STATE(821)] = 56661,
  [SMALL_STATE(822)] = 56714,
  [SMALL_STATE(823)] = 56767,
  [SMALL_STATE(824)] = 56820,
  [SMALL_STATE(825)] = 56873,
  [SMALL_STATE(826)] = 56926,
  [SMALL_STATE(827)] = 56979,
  [SMALL_STATE(828)] = 57032,
  [SMALL_STATE(829)] = 57085,
  [SMALL_STATE(830)] = 57138,
  [SMALL_STATE(831)] = 57191,
  [SMALL_STATE(832)] = 57244,
  [SMALL_STATE(833)] = 57333,
  [SMALL_STATE(834)] = 57386,
  [SMALL_STATE(835)] = 57439,
  [SMALL_STATE(836)] = 57492,
  [SMALL_STATE(837)] = 57545,
  [SMALL_STATE(838)] = 57598,
  [SMALL_STATE(839)] = 57651,
  [SMALL_STATE(840)] = 57704,
  [SMALL_STATE(841)] = 57757,
  [SMALL_STATE(842)] = 57810,
  [SMALL_STATE(843)] = 57863,
  [SMALL_STATE(844)] = 57916,
  [SMALL_STATE(845)] = 57969,
  [SMALL_STATE(846)] = 58058,
  [SMALL_STATE(847)] = 58147,
  [SMALL_STATE(848)] = 58236,
  [SMALL_STATE(849)] = 58325,
  [SMALL_STATE(850)] = 58414,
  [SMALL_STATE(851)] = 58467,
  [SMALL_STATE(852)] = 58553,
  [SMALL_STATE(853)] = 58639,
  [SMALL_STATE(854)] = 58725,
  [SMALL_STATE(855)] = 58811,
  [SMALL_STATE(856)] = 58897,
  [SMALL_STATE(857)] = 58983,
  [SMALL_STATE(858)] = 59066,
  [SMALL_STATE(859)] = 59149,
  [SMALL_STATE(860)] = 59227,
  [SMALL_STATE(861)] = 59305,
  [SMALL_STATE(862)] = 59383,
  [SMALL_STATE(863)] = 59461,
  [SMALL_STATE(864)] = 59539,
  [SMALL_STATE(865)] = 59617,
  [SMALL_STATE(866)] = 59695,
  [SMALL_STATE(867)] = 59773,
  [SMALL_STATE(868)] = 59848,
  [SMALL_STATE(869)] = 59927,
  [SMALL_STATE(870)] = 60002,
  [SMALL_STATE(871)] = 60077,
  [SMALL_STATE(872)] = 60152,
  [SMALL_STATE(873)] = 60227,
  [SMALL_STATE(874)] = 60302,
  [SMALL_STATE(875)] = 60377,
  [SMALL_STATE(876)] = 60452,
  [SMALL_STATE(877)] = 60527,
  [SMALL_STATE(878)] = 60602,
  [SMALL_STATE(879)] = 60677,
  [SMALL_STATE(880)] = 60752,
  [SMALL_STATE(881)] = 60827,
  [SMALL_STATE(882)] = 60902,
  [SMALL_STATE(883)] = 60977,
  [SMALL_STATE(884)] = 61056,
  [SMALL_STATE(885)] = 61131,
  [SMALL_STATE(886)] = 61206,
  [SMALL_STATE(887)] = 61281,
  [SMALL_STATE(888)] = 61356,
  [SMALL_STATE(889)] = 61431,
  [SMALL_STATE(890)] = 61506,
  [SMALL_STATE(891)] = 61581,
  [SMALL_STATE(892)] = 61656,
  [SMALL_STATE(893)] = 61731,
  [SMALL_STATE(894)] = 61806,
  [SMALL_STATE(895)] = 61881,
  [SMALL_STATE(896)] = 61956,
  [SMALL_STATE(897)] = 62031,
  [SMALL_STATE(898)] = 62106,
  [SMALL_STATE(899)] = 62181,
  [SMALL_STATE(900)] = 62256,
  [SMALL_STATE(901)] = 62331,
  [SMALL_STATE(902)] = 62406,
  [SMALL_STATE(903)] = 62481,
  [SMALL_STATE(904)] = 62556,
  [SMALL_STATE(905)] = 62631,
  [SMALL_STATE(906)] = 62710,
  [SMALL_STATE(907)] = 62785,
  [SMALL_STATE(908)] = 62860,
  [SMALL_STATE(909)] = 62939,
  [SMALL_STATE(910)] = 63014,
  [SMALL_STATE(911)] = 63093,
  [SMALL_STATE(912)] = 63168,
  [SMALL_STATE(913)] = 63243,
  [SMALL_STATE(914)] = 63322,
  [SMALL_STATE(915)] = 63397,
  [SMALL_STATE(916)] = 63472,
  [SMALL_STATE(917)] = 63547,
  [SMALL_STATE(918)] = 63622,
  [SMALL_STATE(919)] = 63697,
  [SMALL_STATE(920)] = 63772,
  [SMALL_STATE(921)] = 63847,
  [SMALL_STATE(922)] = 63922,
  [SMALL_STATE(923)] = 63997,
  [SMALL_STATE(924)] = 64076,
  [SMALL_STATE(925)] = 64151,
  [SMALL_STATE(926)] = 64226,
  [SMALL_STATE(927)] = 64305,
  [SMALL_STATE(928)] = 64380,
  [SMALL_STATE(929)] = 64459,
  [SMALL_STATE(930)] = 64534,
  [SMALL_STATE(931)] = 64609,
  [SMALL_STATE(932)] = 64684,
  [SMALL_STATE(933)] = 64759,
  [SMALL_STATE(934)] = 64834,
  [SMALL_STATE(935)] = 64913,
  [SMALL_STATE(936)] = 64988,
  [SMALL_STATE(937)] = 65063,
  [SMALL_STATE(938)] = 65138,
  [SMALL_STATE(939)] = 65213,
  [SMALL_STATE(940)] = 65292,
  [SMALL_STATE(941)] = 65367,
  [SMALL_STATE(942)] = 65442,
  [SMALL_STATE(943)] = 65521,
  [SMALL_STATE(944)] = 65596,
  [SMALL_STATE(945)] = 65671,
  [SMALL_STATE(946)] = 65746,
  [SMALL_STATE(947)] = 65821,
  [SMALL_STATE(948)] = 65896,
  [SMALL_STATE(949)] = 65971,
  [SMALL_STATE(950)] = 66046,
  [SMALL_STATE(951)] = 66125,
  [SMALL_STATE(952)] = 66200,
  [SMALL_STATE(953)] = 66275,
  [SMALL_STATE(954)] = 66354,
  [SMALL_STATE(955)] = 66429,
  [SMALL_STATE(956)] = 66504,
  [SMALL_STATE(957)] = 66583,
  [SMALL_STATE(958)] = 66658,
  [SMALL_STATE(959)] = 66733,
  [SMALL_STATE(960)] = 66808,
  [SMALL_STATE(961)] = 66883,
  [SMALL_STATE(962)] = 66958,
  [SMALL_STATE(963)] = 67033,
  [SMALL_STATE(964)] = 67108,
  [SMALL_STATE(965)] = 67183,
  [SMALL_STATE(966)] = 67258,
  [SMALL_STATE(967)] = 67333,
  [SMALL_STATE(968)] = 67408,
  [SMALL_STATE(969)] = 67483,
  [SMALL_STATE(970)] = 67562,
  [SMALL_STATE(971)] = 67641,
  [SMALL_STATE(972)] = 67720,
  [SMALL_STATE(973)] = 67799,
  [SMALL_STATE(974)] = 67878,
  [SMALL_STATE(975)] = 67953,
  [SMALL_STATE(976)] = 68035,
  [SMALL_STATE(977)] = 68087,
  [SMALL_STATE(978)] = 68139,
  [SMALL_STATE(979)] = 68191,
  [SMALL_STATE(980)] = 68248,
  [SMALL_STATE(981)] = 68305,
  [SMALL_STATE(982)] = 68356,
  [SMALL_STATE(983)] = 68417,
  [SMALL_STATE(984)] = 68486,
  [SMALL_STATE(985)] = 68537,
  [SMALL_STATE(986)] = 68604,
  [SMALL_STATE(987)] = 68669,
  [SMALL_STATE(988)] = 68720,
  [SMALL_STATE(989)] = 68801,
  [SMALL_STATE(990)] = 68852,
  [SMALL_STATE(991)] = 68923,
  [SMALL_STATE(992)] = 68980,
  [SMALL_STATE(993)] = 69051,
  [SMALL_STATE(994)] = 69122,
  [SMALL_STATE(995)] = 69185,
  [SMALL_STATE(996)] = 69242,
  [SMALL_STATE(997)] = 69323,
  [SMALL_STATE(998)] = 69374,
  [SMALL_STATE(999)] = 69425,
  [SMALL_STATE(1000)] = 69495,
  [SMALL_STATE(1001)] = 69551,
  [SMALL_STATE(1002)] = 69597,
  [SMALL_STATE(1003)] = 69643,
  [SMALL_STATE(1004)] = 69713,
  [SMALL_STATE(1005)] = 69763,
  [SMALL_STATE(1006)] = 69843,
  [SMALL_STATE(1007)] = 69891,
  [SMALL_STATE(1008)] = 69941,
  [SMALL_STATE(1009)] = 70011,
  [SMALL_STATE(1010)] = 70057,
  [SMALL_STATE(1011)] = 70103,
  [SMALL_STATE(1012)] = 70159,
  [SMALL_STATE(1013)] = 70209,
  [SMALL_STATE(1014)] = 70255,
  [SMALL_STATE(1015)] = 70303,
  [SMALL_STATE(1016)] = 70365,
  [SMALL_STATE(1017)] = 70443,
  [SMALL_STATE(1018)] = 70499,
  [SMALL_STATE(1019)] = 70555,
  [SMALL_STATE(1020)] = 70625,
  [SMALL_STATE(1021)] = 70681,
  [SMALL_STATE(1022)] = 70727,
  [SMALL_STATE(1023)] = 70807,
  [SMALL_STATE(1024)] = 70863,
  [SMALL_STATE(1025)] = 70913,
  [SMALL_STATE(1026)] = 70959,
  [SMALL_STATE(1027)] = 71009,
  [SMALL_STATE(1028)] = 71077,
  [SMALL_STATE(1029)] = 71127,
  [SMALL_STATE(1030)] = 71193,
  [SMALL_STATE(1031)] = 71243,
  [SMALL_STATE(1032)] = 71289,
  [SMALL_STATE(1033)] = 71359,
  [SMALL_STATE(1034)] = 71429,
  [SMALL_STATE(1035)] = 71479,
  [SMALL_STATE(1036)] = 71527,
  [SMALL_STATE(1037)] = 71591,
  [SMALL_STATE(1038)] = 71641,
  [SMALL_STATE(1039)] = 71721,
  [SMALL_STATE(1040)] = 71785,
  [SMALL_STATE(1041)] = 71865,
  [SMALL_STATE(1042)] = 71915,
  [SMALL_STATE(1043)] = 71971,
  [SMALL_STATE(1044)] = 72033,
  [SMALL_STATE(1045)] = 72099,
  [SMALL_STATE(1046)] = 72149,
  [SMALL_STATE(1047)] = 72199,
  [SMALL_STATE(1048)] = 72245,
  [SMALL_STATE(1049)] = 72301,
  [SMALL_STATE(1050)] = 72361,
  [SMALL_STATE(1051)] = 72429,
  [SMALL_STATE(1052)] = 72489,
  [SMALL_STATE(1053)] = 72540,
  [SMALL_STATE(1054)] = 72589,
  [SMALL_STATE(1055)] = 72638,
  [SMALL_STATE(1056)] = 72683,
  [SMALL_STATE(1057)] = 72728,
  [SMALL_STATE(1058)] = 72773,
  [SMALL_STATE(1059)] = 72818,
  [SMALL_STATE(1060)] = 72867,
  [SMALL_STATE(1061)] = 72912,
  [SMALL_STATE(1062)] = 72979,
  [SMALL_STATE(1063)] = 73024,
  [SMALL_STATE(1064)] = 73075,
  [SMALL_STATE(1065)] = 73130,
  [SMALL_STATE(1066)] = 73185,
  [SMALL_STATE(1067)] = 73240,
  [SMALL_STATE(1068)] = 73289,
  [SMALL_STATE(1069)] = 73344,
  [SMALL_STATE(1070)] = 73399,
  [SMALL_STATE(1071)] = 73444,
  [SMALL_STATE(1072)] = 73499,
  [SMALL_STATE(1073)] = 73554,
  [SMALL_STATE(1074)] = 73599,
  [SMALL_STATE(1075)] = 73644,
  [SMALL_STATE(1076)] = 73695,
  [SMALL_STATE(1077)] = 73740,
  [SMALL_STATE(1078)] = 73785,
  [SMALL_STATE(1079)] = 73836,
  [SMALL_STATE(1080)] = 73881,
  [SMALL_STATE(1081)] = 73932,
  [SMALL_STATE(1082)] = 73977,
  [SMALL_STATE(1083)] = 74022,
  [SMALL_STATE(1084)] = 74091,
  [SMALL_STATE(1085)] = 74146,
  [SMALL_STATE(1086)] = 74207,
  [SMALL_STATE(1087)] = 74276,
  [SMALL_STATE(1088)] = 74331,
  [SMALL_STATE(1089)] = 74390,
  [SMALL_STATE(1090)] = 74457,
  [SMALL_STATE(1091)] = 74512,
  [SMALL_STATE(1092)] = 74577,
  [SMALL_STATE(1093)] = 74640,
  [SMALL_STATE(1094)] = 74701,
  [SMALL_STATE(1095)] = 74770,
  [SMALL_STATE(1096)] = 74825,
  [SMALL_STATE(1097)] = 74884,
  [SMALL_STATE(1098)] = 74951,
  [SMALL_STATE(1099)] = 74996,
  [SMALL_STATE(1100)] = 75061,
  [SMALL_STATE(1101)] = 75124,
  [SMALL_STATE(1102)] = 75193,
  [SMALL_STATE(1103)] = 75238,
  [SMALL_STATE(1104)] = 75283,
  [SMALL_STATE(1105)] = 75328,
  [SMALL_STATE(1106)] = 75373,
  [SMALL_STATE(1107)] = 75418,
  [SMALL_STATE(1108)] = 75463,
  [SMALL_STATE(1109)] = 75508,
  [SMALL_STATE(1110)] = 75577,
  [SMALL_STATE(1111)] = 75646,
  [SMALL_STATE(1112)] = 75715,
  [SMALL_STATE(1113)] = 75760,
  [SMALL_STATE(1114)] = 75815,
  [SMALL_STATE(1115)] = 75876,
  [SMALL_STATE(1116)] = 75945,
  [SMALL_STATE(1117)] = 76000,
  [SMALL_STATE(1118)] = 76059,
  [SMALL_STATE(1119)] = 76126,
  [SMALL_STATE(1120)] = 76191,
  [SMALL_STATE(1121)] = 76254,
  [SMALL_STATE(1122)] = 76299,
  [SMALL_STATE(1123)] = 76348,
  [SMALL_STATE(1124)] = 76417,
  [SMALL_STATE(1125)] = 76486,
  [SMALL_STATE(1126)] = 76531,
  [SMALL_STATE(1127)] = 76580,
  [SMALL_STATE(1128)] = 76625,
  [SMALL_STATE(1129)] = 76674,
  [SMALL_STATE(1130)] = 76721,
  [SMALL_STATE(1131)] = 76768,
  [SMALL_STATE(1132)] = 76815,
  [SMALL_STATE(1133)] = 76860,
  [SMALL_STATE(1134)] = 76905,
  [SMALL_STATE(1135)] = 76950,
  [SMALL_STATE(1136)] = 76995,
  [SMALL_STATE(1137)] = 77040,
  [SMALL_STATE(1138)] = 77085,
  [SMALL_STATE(1139)] = 77130,
  [SMALL_STATE(1140)] = 77195,
  [SMALL_STATE(1141)] = 77258,
  [SMALL_STATE(1142)] = 77317,
  [SMALL_STATE(1143)] = 77372,
  [SMALL_STATE(1144)] = 77421,
  [SMALL_STATE(1145)] = 77482,
  [SMALL_STATE(1146)] = 77527,
  [SMALL_STATE(1147)] = 77596,
  [SMALL_STATE(1148)] = 77641,
  [SMALL_STATE(1149)] = 77696,
  [SMALL_STATE(1150)] = 77741,
  [SMALL_STATE(1151)] = 77818,
  [SMALL_STATE(1152)] = 77863,
  [SMALL_STATE(1153)] = 77912,
  [SMALL_STATE(1154)] = 77961,
  [SMALL_STATE(1155)] = 78010,
  [SMALL_STATE(1156)] = 78059,
  [SMALL_STATE(1157)] = 78106,
  [SMALL_STATE(1158)] = 78153,
  [SMALL_STATE(1159)] = 78200,
  [SMALL_STATE(1160)] = 78255,
  [SMALL_STATE(1161)] = 78324,
  [SMALL_STATE(1162)] = 78368,
  [SMALL_STATE(1163)] = 78412,
  [SMALL_STATE(1164)] = 78456,
  [SMALL_STATE(1165)] = 78504,
  [SMALL_STATE(1166)] = 78548,
  [SMALL_STATE(1167)] = 78592,
  [SMALL_STATE(1168)] = 78636,
  [SMALL_STATE(1169)] = 78680,
  [SMALL_STATE(1170)] = 78724,
  [SMALL_STATE(1171)] = 78772,
  [SMALL_STATE(1172)] = 78820,
  [SMALL_STATE(1173)] = 78864,
  [SMALL_STATE(1174)] = 78908,
  [SMALL_STATE(1175)] = 78952,
  [SMALL_STATE(1176)] = 78998,
  [SMALL_STATE(1177)] = 79046,
  [SMALL_STATE(1178)] = 79090,
  [SMALL_STATE(1179)] = 79138,
  [SMALL_STATE(1180)] = 79182,
  [SMALL_STATE(1181)] = 79230,
  [SMALL_STATE(1182)] = 79278,
  [SMALL_STATE(1183)] = 79322,
  [SMALL_STATE(1184)] = 79366,
  [SMALL_STATE(1185)] = 79410,
  [SMALL_STATE(1186)] = 79454,
  [SMALL_STATE(1187)] = 79498,
  [SMALL_STATE(1188)] = 79574,
  [SMALL_STATE(1189)] = 79618,
  [SMALL_STATE(1190)] = 79662,
  [SMALL_STATE(1191)] = 79710,
  [SMALL_STATE(1192)] = 79754,
  [SMALL_STATE(1193)] = 79798,
  [SMALL_STATE(1194)] = 79842,
  [SMALL_STATE(1195)] = 79886,
  [SMALL_STATE(1196)] = 79930,
  [SMALL_STATE(1197)] = 79974,
  [SMALL_STATE(1198)] = 80018,
  [SMALL_STATE(1199)] = 80062,
  [SMALL_STATE(1200)] = 80108,
  [SMALL_STATE(1201)] = 80152,
  [SMALL_STATE(1202)] = 80198,
  [SMALL_STATE(1203)] = 80242,
  [SMALL_STATE(1204)] = 80286,
  [SMALL_STATE(1205)] = 80332,
  [SMALL_STATE(1206)] = 80376,
  [SMALL_STATE(1207)] = 80424,
  [SMALL_STATE(1208)] = 80468,
  [SMALL_STATE(1209)] = 80512,
  [SMALL_STATE(1210)] = 80556,
  [SMALL_STATE(1211)] = 80604,
  [SMALL_STATE(1212)] = 80650,
  [SMALL_STATE(1213)] = 80696,
  [SMALL_STATE(1214)] = 80742,
  [SMALL_STATE(1215)] = 80788,
  [SMALL_STATE(1216)] = 80832,
  [SMALL_STATE(1217)] = 80876,
  [SMALL_STATE(1218)] = 80926,
  [SMALL_STATE(1219)] = 80980,
  [SMALL_STATE(1220)] = 81024,
  [SMALL_STATE(1221)] = 81068,
  [SMALL_STATE(1222)] = 81112,
  [SMALL_STATE(1223)] = 81160,
  [SMALL_STATE(1224)] = 81214,
  [SMALL_STATE(1225)] = 81258,
  [SMALL_STATE(1226)] = 81302,
  [SMALL_STATE(1227)] = 81346,
  [SMALL_STATE(1228)] = 81390,
  [SMALL_STATE(1229)] = 81436,
  [SMALL_STATE(1230)] = 81480,
  [SMALL_STATE(1231)] = 81526,
  [SMALL_STATE(1232)] = 81570,
  [SMALL_STATE(1233)] = 81616,
  [SMALL_STATE(1234)] = 81662,
  [SMALL_STATE(1235)] = 81706,
  [SMALL_STATE(1236)] = 81750,
  [SMALL_STATE(1237)] = 81794,
  [SMALL_STATE(1238)] = 81842,
  [SMALL_STATE(1239)] = 81886,
  [SMALL_STATE(1240)] = 81930,
  [SMALL_STATE(1241)] = 81978,
  [SMALL_STATE(1242)] = 82022,
  [SMALL_STATE(1243)] = 82090,
  [SMALL_STATE(1244)] = 82134,
  [SMALL_STATE(1245)] = 82178,
  [SMALL_STATE(1246)] = 82222,
  [SMALL_STATE(1247)] = 82266,
  [SMALL_STATE(1248)] = 82310,
  [SMALL_STATE(1249)] = 82356,
  [SMALL_STATE(1250)] = 82402,
  [SMALL_STATE(1251)] = 82448,
  [SMALL_STATE(1252)] = 82492,
  [SMALL_STATE(1253)] = 82536,
  [SMALL_STATE(1254)] = 82580,
  [SMALL_STATE(1255)] = 82624,
  [SMALL_STATE(1256)] = 82670,
  [SMALL_STATE(1257)] = 82716,
  [SMALL_STATE(1258)] = 82760,
  [SMALL_STATE(1259)] = 82836,
  [SMALL_STATE(1260)] = 82884,
  [SMALL_STATE(1261)] = 82932,
  [SMALL_STATE(1262)] = 82976,
  [SMALL_STATE(1263)] = 83024,
  [SMALL_STATE(1264)] = 83078,
  [SMALL_STATE(1265)] = 83138,
  [SMALL_STATE(1266)] = 83182,
  [SMALL_STATE(1267)] = 83230,
  [SMALL_STATE(1268)] = 83274,
  [SMALL_STATE(1269)] = 83318,
  [SMALL_STATE(1270)] = 83362,
  [SMALL_STATE(1271)] = 83406,
  [SMALL_STATE(1272)] = 83454,
  [SMALL_STATE(1273)] = 83498,
  [SMALL_STATE(1274)] = 83542,
  [SMALL_STATE(1275)] = 83586,
  [SMALL_STATE(1276)] = 83654,
  [SMALL_STATE(1277)] = 83708,
  [SMALL_STATE(1278)] = 83758,
  [SMALL_STATE(1279)] = 83816,
  [SMALL_STATE(1280)] = 83882,
  [SMALL_STATE(1281)] = 83926,
  [SMALL_STATE(1282)] = 83990,
  [SMALL_STATE(1283)] = 84052,
  [SMALL_STATE(1284)] = 84096,
  [SMALL_STATE(1285)] = 84164,
  [SMALL_STATE(1286)] = 84240,
  [SMALL_STATE(1287)] = 84284,
  [SMALL_STATE(1288)] = 84327,
  [SMALL_STATE(1289)] = 84372,
  [SMALL_STATE(1290)] = 84419,
  [SMALL_STATE(1291)] = 84464,
  [SMALL_STATE(1292)] = 84511,
  [SMALL_STATE(1293)] = 84554,
  [SMALL_STATE(1294)] = 84597,
  [SMALL_STATE(1295)] = 84640,
  [SMALL_STATE(1296)] = 84683,
  [SMALL_STATE(1297)] = 84726,
  [SMALL_STATE(1298)] = 84769,
  [SMALL_STATE(1299)] = 84812,
  [SMALL_STATE(1300)] = 84863,
  [SMALL_STATE(1301)] = 84908,
  [SMALL_STATE(1302)] = 84951,
  [SMALL_STATE(1303)] = 84994,
  [SMALL_STATE(1304)] = 85037,
  [SMALL_STATE(1305)] = 85080,
  [SMALL_STATE(1306)] = 85125,
  [SMALL_STATE(1307)] = 85168,
  [SMALL_STATE(1308)] = 85211,
  [SMALL_STATE(1309)] = 85254,
  [SMALL_STATE(1310)] = 85299,
  [SMALL_STATE(1311)] = 85342,
  [SMALL_STATE(1312)] = 85385,
  [SMALL_STATE(1313)] = 85428,
  [SMALL_STATE(1314)] = 85473,
  [SMALL_STATE(1315)] = 85516,
  [SMALL_STATE(1316)] = 85561,
  [SMALL_STATE(1317)] = 85604,
  [SMALL_STATE(1318)] = 85649,
  [SMALL_STATE(1319)] = 85696,
  [SMALL_STATE(1320)] = 85743,
  [SMALL_STATE(1321)] = 85788,
  [SMALL_STATE(1322)] = 85831,
  [SMALL_STATE(1323)] = 85874,
  [SMALL_STATE(1324)] = 85917,
  [SMALL_STATE(1325)] = 85960,
  [SMALL_STATE(1326)] = 86003,
  [SMALL_STATE(1327)] = 86048,
  [SMALL_STATE(1328)] = 86091,
  [SMALL_STATE(1329)] = 86134,
  [SMALL_STATE(1330)] = 86181,
  [SMALL_STATE(1331)] = 86224,
  [SMALL_STATE(1332)] = 86271,
  [SMALL_STATE(1333)] = 86316,
  [SMALL_STATE(1334)] = 86361,
  [SMALL_STATE(1335)] = 86406,
  [SMALL_STATE(1336)] = 86449,
  [SMALL_STATE(1337)] = 86492,
  [SMALL_STATE(1338)] = 86535,
  [SMALL_STATE(1339)] = 86578,
  [SMALL_STATE(1340)] = 86621,
  [SMALL_STATE(1341)] = 86664,
  [SMALL_STATE(1342)] = 86707,
  [SMALL_STATE(1343)] = 86750,
  [SMALL_STATE(1344)] = 86793,
  [SMALL_STATE(1345)] = 86836,
  [SMALL_STATE(1346)] = 86879,
  [SMALL_STATE(1347)] = 86930,
  [SMALL_STATE(1348)] = 86973,
  [SMALL_STATE(1349)] = 87016,
  [SMALL_STATE(1350)] = 87059,
  [SMALL_STATE(1351)] = 87102,
  [SMALL_STATE(1352)] = 87145,
  [SMALL_STATE(1353)] = 87188,
  [SMALL_STATE(1354)] = 87231,
  [SMALL_STATE(1355)] = 87274,
  [SMALL_STATE(1356)] = 87317,
  [SMALL_STATE(1357)] = 87360,
  [SMALL_STATE(1358)] = 87407,
  [SMALL_STATE(1359)] = 87454,
  [SMALL_STATE(1360)] = 87501,
  [SMALL_STATE(1361)] = 87544,
  [SMALL_STATE(1362)] = 87587,
  [SMALL_STATE(1363)] = 87630,
  [SMALL_STATE(1364)] = 87673,
  [SMALL_STATE(1365)] = 87716,
  [SMALL_STATE(1366)] = 87759,
  [SMALL_STATE(1367)] = 87804,
  [SMALL_STATE(1368)] = 87847,
  [SMALL_STATE(1369)] = 87890,
  [SMALL_STATE(1370)] = 87933,
  [SMALL_STATE(1371)] = 87976,
  [SMALL_STATE(1372)] = 88019,
  [SMALL_STATE(1373)] = 88062,
  [SMALL_STATE(1374)] = 88105,
  [SMALL_STATE(1375)] = 88148,
  [SMALL_STATE(1376)] = 88191,
  [SMALL_STATE(1377)] = 88234,
  [SMALL_STATE(1378)] = 88277,
  [SMALL_STATE(1379)] = 88320,
  [SMALL_STATE(1380)] = 88363,
  [SMALL_STATE(1381)] = 88406,
  [SMALL_STATE(1382)] = 88449,
  [SMALL_STATE(1383)] = 88492,
  [SMALL_STATE(1384)] = 88535,
  [SMALL_STATE(1385)] = 88578,
  [SMALL_STATE(1386)] = 88621,
  [SMALL_STATE(1387)] = 88664,
  [SMALL_STATE(1388)] = 88707,
  [SMALL_STATE(1389)] = 88750,
  [SMALL_STATE(1390)] = 88793,
  [SMALL_STATE(1391)] = 88836,
  [SMALL_STATE(1392)] = 88879,
  [SMALL_STATE(1393)] = 88922,
  [SMALL_STATE(1394)] = 88965,
  [SMALL_STATE(1395)] = 89008,
  [SMALL_STATE(1396)] = 89051,
  [SMALL_STATE(1397)] = 89094,
  [SMALL_STATE(1398)] = 89137,
  [SMALL_STATE(1399)] = 89180,
  [SMALL_STATE(1400)] = 89223,
  [SMALL_STATE(1401)] = 89266,
  [SMALL_STATE(1402)] = 89309,
  [SMALL_STATE(1403)] = 89356,
  [SMALL_STATE(1404)] = 89403,
  [SMALL_STATE(1405)] = 89446,
  [SMALL_STATE(1406)] = 89489,
  [SMALL_STATE(1407)] = 89532,
  [SMALL_STATE(1408)] = 89575,
  [SMALL_STATE(1409)] = 89618,
  [SMALL_STATE(1410)] = 89661,
  [SMALL_STATE(1411)] = 89704,
  [SMALL_STATE(1412)] = 89749,
  [SMALL_STATE(1413)] = 89794,
  [SMALL_STATE(1414)] = 89837,
  [SMALL_STATE(1415)] = 89880,
  [SMALL_STATE(1416)] = 89923,
  [SMALL_STATE(1417)] = 89966,
  [SMALL_STATE(1418)] = 90009,
  [SMALL_STATE(1419)] = 90052,
  [SMALL_STATE(1420)] = 90095,
  [SMALL_STATE(1421)] = 90140,
  [SMALL_STATE(1422)] = 90183,
  [SMALL_STATE(1423)] = 90226,
  [SMALL_STATE(1424)] = 90269,
  [SMALL_STATE(1425)] = 90312,
  [SMALL_STATE(1426)] = 90355,
  [SMALL_STATE(1427)] = 90398,
  [SMALL_STATE(1428)] = 90441,
  [SMALL_STATE(1429)] = 90484,
  [SMALL_STATE(1430)] = 90527,
  [SMALL_STATE(1431)] = 90570,
  [SMALL_STATE(1432)] = 90613,
  [SMALL_STATE(1433)] = 90656,
  [SMALL_STATE(1434)] = 90699,
  [SMALL_STATE(1435)] = 90742,
  [SMALL_STATE(1436)] = 90785,
  [SMALL_STATE(1437)] = 90828,
  [SMALL_STATE(1438)] = 90871,
  [SMALL_STATE(1439)] = 90914,
  [SMALL_STATE(1440)] = 90957,
  [SMALL_STATE(1441)] = 91004,
  [SMALL_STATE(1442)] = 91047,
  [SMALL_STATE(1443)] = 91094,
  [SMALL_STATE(1444)] = 91141,
  [SMALL_STATE(1445)] = 91188,
  [SMALL_STATE(1446)] = 91231,
  [SMALL_STATE(1447)] = 91274,
  [SMALL_STATE(1448)] = 91317,
  [SMALL_STATE(1449)] = 91362,
  [SMALL_STATE(1450)] = 91407,
  [SMALL_STATE(1451)] = 91449,
  [SMALL_STATE(1452)] = 91495,
  [SMALL_STATE(1453)] = 91541,
  [SMALL_STATE(1454)] = 91587,
  [SMALL_STATE(1455)] = 91631,
  [SMALL_STATE(1456)] = 91675,
  [SMALL_STATE(1457)] = 91719,
  [SMALL_STATE(1458)] = 91761,
  [SMALL_STATE(1459)] = 91803,
  [SMALL_STATE(1460)] = 91845,
  [SMALL_STATE(1461)] = 91887,
  [SMALL_STATE(1462)] = 91929,
  [SMALL_STATE(1463)] = 91973,
  [SMALL_STATE(1464)] = 92023,
  [SMALL_STATE(1465)] = 92065,
  [SMALL_STATE(1466)] = 92107,
  [SMALL_STATE(1467)] = 92149,
  [SMALL_STATE(1468)] = 92191,
  [SMALL_STATE(1469)] = 92233,
  [SMALL_STATE(1470)] = 92275,
  [SMALL_STATE(1471)] = 92317,
  [SMALL_STATE(1472)] = 92359,
  [SMALL_STATE(1473)] = 92403,
  [SMALL_STATE(1474)] = 92447,
  [SMALL_STATE(1475)] = 92491,
  [SMALL_STATE(1476)] = 92533,
  [SMALL_STATE(1477)] = 92575,
  [SMALL_STATE(1478)] = 92617,
  [SMALL_STATE(1479)] = 92659,
  [SMALL_STATE(1480)] = 92701,
  [SMALL_STATE(1481)] = 92743,
  [SMALL_STATE(1482)] = 92785,
  [SMALL_STATE(1483)] = 92829,
  [SMALL_STATE(1484)] = 92871,
  [SMALL_STATE(1485)] = 92913,
  [SMALL_STATE(1486)] = 92955,
  [SMALL_STATE(1487)] = 92997,
  [SMALL_STATE(1488)] = 93039,
  [SMALL_STATE(1489)] = 93087,
  [SMALL_STATE(1490)] = 93131,
  [SMALL_STATE(1491)] = 93173,
  [SMALL_STATE(1492)] = 93215,
  [SMALL_STATE(1493)] = 93257,
  [SMALL_STATE(1494)] = 93299,
  [SMALL_STATE(1495)] = 93341,
  [SMALL_STATE(1496)] = 93383,
  [SMALL_STATE(1497)] = 93425,
  [SMALL_STATE(1498)] = 93468,
  [SMALL_STATE(1499)] = 93509,
  [SMALL_STATE(1500)] = 93552,
  [SMALL_STATE(1501)] = 93593,
  [SMALL_STATE(1502)] = 93636,
  [SMALL_STATE(1503)] = 93677,
  [SMALL_STATE(1504)] = 93718,
  [SMALL_STATE(1505)] = 93759,
  [SMALL_STATE(1506)] = 93802,
  [SMALL_STATE(1507)] = 93845,
  [SMALL_STATE(1508)] = 93888,
  [SMALL_STATE(1509)] = 93929,
  [SMALL_STATE(1510)] = 93970,
  [SMALL_STATE(1511)] = 94013,
  [SMALL_STATE(1512)] = 94054,
  [SMALL_STATE(1513)] = 94095,
  [SMALL_STATE(1514)] = 94138,
  [SMALL_STATE(1515)] = 94181,
  [SMALL_STATE(1516)] = 94222,
  [SMALL_STATE(1517)] = 94296,
  [SMALL_STATE(1518)] = 94370,
  [SMALL_STATE(1519)] = 94438,
  [SMALL_STATE(1520)] = 94506,
  [SMALL_STATE(1521)] = 94574,
  [SMALL_STATE(1522)] = 94642,
  [SMALL_STATE(1523)] = 94710,
  [SMALL_STATE(1524)] = 94778,
  [SMALL_STATE(1525)] = 94846,
  [SMALL_STATE(1526)] = 94914,
  [SMALL_STATE(1527)] = 94982,
  [SMALL_STATE(1528)] = 95050,
  [SMALL_STATE(1529)] = 95118,
  [SMALL_STATE(1530)] = 95186,
  [SMALL_STATE(1531)] = 95254,
  [SMALL_STATE(1532)] = 95322,
  [SMALL_STATE(1533)] = 95390,
  [SMALL_STATE(1534)] = 95458,
  [SMALL_STATE(1535)] = 95526,
  [SMALL_STATE(1536)] = 95594,
  [SMALL_STATE(1537)] = 95662,
  [SMALL_STATE(1538)] = 95730,
  [SMALL_STATE(1539)] = 95798,
  [SMALL_STATE(1540)] = 95866,
  [SMALL_STATE(1541)] = 95934,
  [SMALL_STATE(1542)] = 96002,
  [SMALL_STATE(1543)] = 96070,
  [SMALL_STATE(1544)] = 96138,
  [SMALL_STATE(1545)] = 96206,
  [SMALL_STATE(1546)] = 96274,
  [SMALL_STATE(1547)] = 96342,
  [SMALL_STATE(1548)] = 96410,
  [SMALL_STATE(1549)] = 96478,
  [SMALL_STATE(1550)] = 96546,
  [SMALL_STATE(1551)] = 96614,
  [SMALL_STATE(1552)] = 96682,
  [SMALL_STATE(1553)] = 96750,
  [SMALL_STATE(1554)] = 96818,
  [SMALL_STATE(1555)] = 96883,
  [SMALL_STATE(1556)] = 96948,
  [SMALL_STATE(1557)] = 97013,
  [SMALL_STATE(1558)] = 97078,
  [SMALL_STATE(1559)] = 97143,
  [SMALL_STATE(1560)] = 97209,
  [SMALL_STATE(1561)] = 97275,
  [SMALL_STATE(1562)] = 97341,
  [SMALL_STATE(1563)] = 97407,
  [SMALL_STATE(1564)] = 97473,
  [SMALL_STATE(1565)] = 97539,
  [SMALL_STATE(1566)] = 97605,
  [SMALL_STATE(1567)] = 97671,
  [SMALL_STATE(1568)] = 97737,
  [SMALL_STATE(1569)] = 97803,
  [SMALL_STATE(1570)] = 97869,
  [SMALL_STATE(1571)] = 97935,
  [SMALL_STATE(1572)] = 98001,
  [SMALL_STATE(1573)] = 98067,
  [SMALL_STATE(1574)] = 98133,
  [SMALL_STATE(1575)] = 98199,
  [SMALL_STATE(1576)] = 98265,
  [SMALL_STATE(1577)] = 98331,
  [SMALL_STATE(1578)] = 98397,
  [SMALL_STATE(1579)] = 98463,
  [SMALL_STATE(1580)] = 98526,
  [SMALL_STATE(1581)] = 98584,
  [SMALL_STATE(1582)] = 98642,
  [SMALL_STATE(1583)] = 98700,
  [SMALL_STATE(1584)] = 98758,
  [SMALL_STATE(1585)] = 98816,
  [SMALL_STATE(1586)] = 98874,
  [SMALL_STATE(1587)] = 98932,
  [SMALL_STATE(1588)] = 98990,
  [SMALL_STATE(1589)] = 99032,
  [SMALL_STATE(1590)] = 99074,
  [SMALL_STATE(1591)] = 99106,
  [SMALL_STATE(1592)] = 99138,
  [SMALL_STATE(1593)] = 99178,
  [SMALL_STATE(1594)] = 99210,
  [SMALL_STATE(1595)] = 99242,
  [SMALL_STATE(1596)] = 99282,
  [SMALL_STATE(1597)] = 99322,
  [SMALL_STATE(1598)] = 99354,
  [SMALL_STATE(1599)] = 99386,
  [SMALL_STATE(1600)] = 99426,
  [SMALL_STATE(1601)] = 99465,
  [SMALL_STATE(1602)] = 99502,
  [SMALL_STATE(1603)] = 99539,
  [SMALL_STATE(1604)] = 99578,
  [SMALL_STATE(1605)] = 99617,
  [SMALL_STATE(1606)] = 99656,
  [SMALL_STATE(1607)] = 99686,
  [SMALL_STATE(1608)] = 99716,
  [SMALL_STATE(1609)] = 99746,
  [SMALL_STATE(1610)] = 99776,
  [SMALL_STATE(1611)] = 99806,
  [SMALL_STATE(1612)] = 99844,
  [SMALL_STATE(1613)] = 99874,
  [SMALL_STATE(1614)] = 99904,
  [SMALL_STATE(1615)] = 99934,
  [SMALL_STATE(1616)] = 99972,
  [SMALL_STATE(1617)] = 100010,
  [SMALL_STATE(1618)] = 100048,
  [SMALL_STATE(1619)] = 100077,
  [SMALL_STATE(1620)] = 100106,
  [SMALL_STATE(1621)] = 100135,
  [SMALL_STATE(1622)] = 100164,
  [SMALL_STATE(1623)] = 100193,
  [SMALL_STATE(1624)] = 100222,
  [SMALL_STATE(1625)] = 100269,
  [SMALL_STATE(1626)] = 100294,
  [SMALL_STATE(1627)] = 100341,
  [SMALL_STATE(1628)] = 100370,
  [SMALL_STATE(1629)] = 100417,
  [SMALL_STATE(1630)] = 100446,
  [SMALL_STATE(1631)] = 100493,
  [SMALL_STATE(1632)] = 100522,
  [SMALL_STATE(1633)] = 100569,
  [SMALL_STATE(1634)] = 100616,
  [SMALL_STATE(1635)] = 100645,
  [SMALL_STATE(1636)] = 100692,
  [SMALL_STATE(1637)] = 100721,
  [SMALL_STATE(1638)] = 100746,
  [SMALL_STATE(1639)] = 100793,
  [SMALL_STATE(1640)] = 100840,
  [SMALL_STATE(1641)] = 100869,
  [SMALL_STATE(1642)] = 100898,
  [SMALL_STATE(1643)] = 100927,
  [SMALL_STATE(1644)] = 100956,
  [SMALL_STATE(1645)] = 100981,
  [SMALL_STATE(1646)] = 101010,
  [SMALL_STATE(1647)] = 101057,
  [SMALL_STATE(1648)] = 101082,
  [SMALL_STATE(1649)] = 101111,
  [SMALL_STATE(1650)] = 101140,
  [SMALL_STATE(1651)] = 101169,
  [SMALL_STATE(1652)] = 101198,
  [SMALL_STATE(1653)] = 101227,
  [SMALL_STATE(1654)] = 101256,
  [SMALL_STATE(1655)] = 101285,
  [SMALL_STATE(1656)] = 101314,
  [SMALL_STATE(1657)] = 101338,
  [SMALL_STATE(1658)] = 101384,
  [SMALL_STATE(1659)] = 101408,
  [SMALL_STATE(1660)] = 101436,
  [SMALL_STATE(1661)] = 101466,
  [SMALL_STATE(1662)] = 101512,
  [SMALL_STATE(1663)] = 101544,
  [SMALL_STATE(1664)] = 101568,
  [SMALL_STATE(1665)] = 101614,
  [SMALL_STATE(1666)] = 101660,
  [SMALL_STATE(1667)] = 101706,
  [SMALL_STATE(1668)] = 101752,
  [SMALL_STATE(1669)] = 101784,
  [SMALL_STATE(1670)] = 101830,
  [SMALL_STATE(1671)] = 101858,
  [SMALL_STATE(1672)] = 101904,
  [SMALL_STATE(1673)] = 101950,
  [SMALL_STATE(1674)] = 101974,
  [SMALL_STATE(1675)] = 102020,
  [SMALL_STATE(1676)] = 102066,
  [SMALL_STATE(1677)] = 102109,
  [SMALL_STATE(1678)] = 102149,
  [SMALL_STATE(1679)] = 102189,
  [SMALL_STATE(1680)] = 102229,
  [SMALL_STATE(1681)] = 102255,
  [SMALL_STATE(1682)] = 102295,
  [SMALL_STATE(1683)] = 102332,
  [SMALL_STATE(1684)] = 102369,
  [SMALL_STATE(1685)] = 102410,
  [SMALL_STATE(1686)] = 102431,
  [SMALL_STATE(1687)] = 102450,
  [SMALL_STATE(1688)] = 102477,
  [SMALL_STATE(1689)] = 102518,
  [SMALL_STATE(1690)] = 102559,
  [SMALL_STATE(1691)] = 102600,
  [SMALL_STATE(1692)] = 102627,
  [SMALL_STATE(1693)] = 102668,
  [SMALL_STATE(1694)] = 102693,
  [SMALL_STATE(1695)] = 102734,
  [SMALL_STATE(1696)] = 102775,
  [SMALL_STATE(1697)] = 102798,
  [SMALL_STATE(1698)] = 102817,
  [SMALL_STATE(1699)] = 102844,
  [SMALL_STATE(1700)] = 102863,
  [SMALL_STATE(1701)] = 102904,
  [SMALL_STATE(1702)] = 102934,
  [SMALL_STATE(1703)] = 102964,
  [SMALL_STATE(1704)] = 103002,
  [SMALL_STATE(1705)] = 103034,
  [SMALL_STATE(1706)] = 103064,
  [SMALL_STATE(1707)] = 103094,
  [SMALL_STATE(1708)] = 103124,
  [SMALL_STATE(1709)] = 103162,
  [SMALL_STATE(1710)] = 103200,
  [SMALL_STATE(1711)] = 103230,
  [SMALL_STATE(1712)] = 103260,
  [SMALL_STATE(1713)] = 103298,
  [SMALL_STATE(1714)] = 103336,
  [SMALL_STATE(1715)] = 103366,
  [SMALL_STATE(1716)] = 103396,
  [SMALL_STATE(1717)] = 103434,
  [SMALL_STATE(1718)] = 103472,
  [SMALL_STATE(1719)] = 103510,
  [SMALL_STATE(1720)] = 103540,
  [SMALL_STATE(1721)] = 103570,
  [SMALL_STATE(1722)] = 103608,
  [SMALL_STATE(1723)] = 103646,
  [SMALL_STATE(1724)] = 103676,
  [SMALL_STATE(1725)] = 103706,
  [SMALL_STATE(1726)] = 103744,
  [SMALL_STATE(1727)] = 103782,
  [SMALL_STATE(1728)] = 103812,
  [SMALL_STATE(1729)] = 103842,
  [SMALL_STATE(1730)] = 103880,
  [SMALL_STATE(1731)] = 103918,
  [SMALL_STATE(1732)] = 103948,
  [SMALL_STATE(1733)] = 103978,
  [SMALL_STATE(1734)] = 104008,
  [SMALL_STATE(1735)] = 104046,
  [SMALL_STATE(1736)] = 104084,
  [SMALL_STATE(1737)] = 104122,
  [SMALL_STATE(1738)] = 104152,
  [SMALL_STATE(1739)] = 104190,
  [SMALL_STATE(1740)] = 104228,
  [SMALL_STATE(1741)] = 104266,
  [SMALL_STATE(1742)] = 104304,
  [SMALL_STATE(1743)] = 104342,
  [SMALL_STATE(1744)] = 104380,
  [SMALL_STATE(1745)] = 104418,
  [SMALL_STATE(1746)] = 104456,
  [SMALL_STATE(1747)] = 104481,
  [SMALL_STATE(1748)] = 104504,
  [SMALL_STATE(1749)] = 104525,
  [SMALL_STATE(1750)] = 104550,
  [SMALL_STATE(1751)] = 104575,
  [SMALL_STATE(1752)] = 104592,
  [SMALL_STATE(1753)] = 104611,
  [SMALL_STATE(1754)] = 104636,
  [SMALL_STATE(1755)] = 104661,
  [SMALL_STATE(1756)] = 104686,
  [SMALL_STATE(1757)] = 104703,
  [SMALL_STATE(1758)] = 104732,
  [SMALL_STATE(1759)] = 104749,
  [SMALL_STATE(1760)] = 104778,
  [SMALL_STATE(1761)] = 104795,
  [SMALL_STATE(1762)] = 104812,
  [SMALL_STATE(1763)] = 104837,
  [SMALL_STATE(1764)] = 104862,
  [SMALL_STATE(1765)] = 104885,
  [SMALL_STATE(1766)] = 104906,
  [SMALL_STATE(1767)] = 104923,
  [SMALL_STATE(1768)] = 104942,
  [SMALL_STATE(1769)] = 104964,
  [SMALL_STATE(1770)] = 104988,
  [SMALL_STATE(1771)] = 105010,
  [SMALL_STATE(1772)] = 105034,
  [SMALL_STATE(1773)] = 105058,
  [SMALL_STATE(1774)] = 105074,
  [SMALL_STATE(1775)] = 105090,
  [SMALL_STATE(1776)] = 105114,
  [SMALL_STATE(1777)] = 105134,
  [SMALL_STATE(1778)] = 105164,
  [SMALL_STATE(1779)] = 105188,
  [SMALL_STATE(1780)] = 105212,
  [SMALL_STATE(1781)] = 105236,
  [SMALL_STATE(1782)] = 105260,
  [SMALL_STATE(1783)] = 105276,
  [SMALL_STATE(1784)] = 105296,
  [SMALL_STATE(1785)] = 105320,
  [SMALL_STATE(1786)] = 105336,
  [SMALL_STATE(1787)] = 105360,
  [SMALL_STATE(1788)] = 105384,
  [SMALL_STATE(1789)] = 105406,
  [SMALL_STATE(1790)] = 105426,
  [SMALL_STATE(1791)] = 105446,
  [SMALL_STATE(1792)] = 105462,
  [SMALL_STATE(1793)] = 105480,
  [SMALL_STATE(1794)] = 105498,
  [SMALL_STATE(1795)] = 105514,
  [SMALL_STATE(1796)] = 105538,
  [SMALL_STATE(1797)] = 105562,
  [SMALL_STATE(1798)] = 105580,
  [SMALL_STATE(1799)] = 105602,
  [SMALL_STATE(1800)] = 105624,
  [SMALL_STATE(1801)] = 105642,
  [SMALL_STATE(1802)] = 105662,
  [SMALL_STATE(1803)] = 105682,
  [SMALL_STATE(1804)] = 105700,
  [SMALL_STATE(1805)] = 105717,
  [SMALL_STATE(1806)] = 105740,
  [SMALL_STATE(1807)] = 105765,
  [SMALL_STATE(1808)] = 105788,
  [SMALL_STATE(1809)] = 105811,
  [SMALL_STATE(1810)] = 105832,
  [SMALL_STATE(1811)] = 105859,
  [SMALL_STATE(1812)] = 105888,
  [SMALL_STATE(1813)] = 105909,
  [SMALL_STATE(1814)] = 105926,
  [SMALL_STATE(1815)] = 105945,
  [SMALL_STATE(1816)] = 105974,
  [SMALL_STATE(1817)] = 105997,
  [SMALL_STATE(1818)] = 106020,
  [SMALL_STATE(1819)] = 106041,
  [SMALL_STATE(1820)] = 106070,
  [SMALL_STATE(1821)] = 106093,
  [SMALL_STATE(1822)] = 106114,
  [SMALL_STATE(1823)] = 106135,
  [SMALL_STATE(1824)] = 106156,
  [SMALL_STATE(1825)] = 106177,
  [SMALL_STATE(1826)] = 106206,
  [SMALL_STATE(1827)] = 106227,
  [SMALL_STATE(1828)] = 106252,
  [SMALL_STATE(1829)] = 106281,
  [SMALL_STATE(1830)] = 106310,
  [SMALL_STATE(1831)] = 106335,
  [SMALL_STATE(1832)] = 106356,
  [SMALL_STATE(1833)] = 106381,
  [SMALL_STATE(1834)] = 106402,
  [SMALL_STATE(1835)] = 106423,
  [SMALL_STATE(1836)] = 106444,
  [SMALL_STATE(1837)] = 106461,
  [SMALL_STATE(1838)] = 106488,
  [SMALL_STATE(1839)] = 106517,
  [SMALL_STATE(1840)] = 106540,
  [SMALL_STATE(1841)] = 106569,
  [SMALL_STATE(1842)] = 106596,
  [SMALL_STATE(1843)] = 106625,
  [SMALL_STATE(1844)] = 106648,
  [SMALL_STATE(1845)] = 106671,
  [SMALL_STATE(1846)] = 106698,
  [SMALL_STATE(1847)] = 106719,
  [SMALL_STATE(1848)] = 106746,
  [SMALL_STATE(1849)] = 106767,
  [SMALL_STATE(1850)] = 106796,
  [SMALL_STATE(1851)] = 106813,
  [SMALL_STATE(1852)] = 106830,
  [SMALL_STATE(1853)] = 106849,
  [SMALL_STATE(1854)] = 106870,
  [SMALL_STATE(1855)] = 106897,
  [SMALL_STATE(1856)] = 106920,
  [SMALL_STATE(1857)] = 106937,
  [SMALL_STATE(1858)] = 106956,
  [SMALL_STATE(1859)] = 106977,
  [SMALL_STATE(1860)] = 107004,
  [SMALL_STATE(1861)] = 107019,
  [SMALL_STATE(1862)] = 107044,
  [SMALL_STATE(1863)] = 107071,
  [SMALL_STATE(1864)] = 107096,
  [SMALL_STATE(1865)] = 107122,
  [SMALL_STATE(1866)] = 107140,
  [SMALL_STATE(1867)] = 107164,
  [SMALL_STATE(1868)] = 107190,
  [SMALL_STATE(1869)] = 107208,
  [SMALL_STATE(1870)] = 107226,
  [SMALL_STATE(1871)] = 107244,
  [SMALL_STATE(1872)] = 107260,
  [SMALL_STATE(1873)] = 107286,
  [SMALL_STATE(1874)] = 107310,
  [SMALL_STATE(1875)] = 107336,
  [SMALL_STATE(1876)] = 107354,
  [SMALL_STATE(1877)] = 107380,
  [SMALL_STATE(1878)] = 107398,
  [SMALL_STATE(1879)] = 107422,
  [SMALL_STATE(1880)] = 107448,
  [SMALL_STATE(1881)] = 107470,
  [SMALL_STATE(1882)] = 107488,
  [SMALL_STATE(1883)] = 107510,
  [SMALL_STATE(1884)] = 107532,
  [SMALL_STATE(1885)] = 107556,
  [SMALL_STATE(1886)] = 107582,
  [SMALL_STATE(1887)] = 107604,
  [SMALL_STATE(1888)] = 107630,
  [SMALL_STATE(1889)] = 107652,
  [SMALL_STATE(1890)] = 107678,
  [SMALL_STATE(1891)] = 107696,
  [SMALL_STATE(1892)] = 107722,
  [SMALL_STATE(1893)] = 107742,
  [SMALL_STATE(1894)] = 107764,
  [SMALL_STATE(1895)] = 107782,
  [SMALL_STATE(1896)] = 107808,
  [SMALL_STATE(1897)] = 107830,
  [SMALL_STATE(1898)] = 107856,
  [SMALL_STATE(1899)] = 107878,
  [SMALL_STATE(1900)] = 107900,
  [SMALL_STATE(1901)] = 107918,
  [SMALL_STATE(1902)] = 107944,
  [SMALL_STATE(1903)] = 107966,
  [SMALL_STATE(1904)] = 107992,
  [SMALL_STATE(1905)] = 108010,
  [SMALL_STATE(1906)] = 108036,
  [SMALL_STATE(1907)] = 108056,
  [SMALL_STATE(1908)] = 108078,
  [SMALL_STATE(1909)] = 108098,
  [SMALL_STATE(1910)] = 108116,
  [SMALL_STATE(1911)] = 108142,
  [SMALL_STATE(1912)] = 108158,
  [SMALL_STATE(1913)] = 108184,
  [SMALL_STATE(1914)] = 108210,
  [SMALL_STATE(1915)] = 108227,
  [SMALL_STATE(1916)] = 108240,
  [SMALL_STATE(1917)] = 108263,
  [SMALL_STATE(1918)] = 108278,
  [SMALL_STATE(1919)] = 108295,
  [SMALL_STATE(1920)] = 108312,
  [SMALL_STATE(1921)] = 108329,
  [SMALL_STATE(1922)] = 108344,
  [SMALL_STATE(1923)] = 108367,
  [SMALL_STATE(1924)] = 108384,
  [SMALL_STATE(1925)] = 108405,
  [SMALL_STATE(1926)] = 108422,
  [SMALL_STATE(1927)] = 108439,
  [SMALL_STATE(1928)] = 108460,
  [SMALL_STATE(1929)] = 108477,
  [SMALL_STATE(1930)] = 108494,
  [SMALL_STATE(1931)] = 108511,
  [SMALL_STATE(1932)] = 108526,
  [SMALL_STATE(1933)] = 108543,
  [SMALL_STATE(1934)] = 108556,
  [SMALL_STATE(1935)] = 108573,
  [SMALL_STATE(1936)] = 108596,
  [SMALL_STATE(1937)] = 108617,
  [SMALL_STATE(1938)] = 108638,
  [SMALL_STATE(1939)] = 108655,
  [SMALL_STATE(1940)] = 108676,
  [SMALL_STATE(1941)] = 108689,
  [SMALL_STATE(1942)] = 108702,
  [SMALL_STATE(1943)] = 108719,
  [SMALL_STATE(1944)] = 108740,
  [SMALL_STATE(1945)] = 108761,
  [SMALL_STATE(1946)] = 108778,
  [SMALL_STATE(1947)] = 108801,
  [SMALL_STATE(1948)] = 108822,
  [SMALL_STATE(1949)] = 108843,
  [SMALL_STATE(1950)] = 108864,
  [SMALL_STATE(1951)] = 108885,
  [SMALL_STATE(1952)] = 108898,
  [SMALL_STATE(1953)] = 108919,
  [SMALL_STATE(1954)] = 108940,
  [SMALL_STATE(1955)] = 108953,
  [SMALL_STATE(1956)] = 108966,
  [SMALL_STATE(1957)] = 108979,
  [SMALL_STATE(1958)] = 108996,
  [SMALL_STATE(1959)] = 109009,
  [SMALL_STATE(1960)] = 109026,
  [SMALL_STATE(1961)] = 109045,
  [SMALL_STATE(1962)] = 109058,
  [SMALL_STATE(1963)] = 109079,
  [SMALL_STATE(1964)] = 109096,
  [SMALL_STATE(1965)] = 109109,
  [SMALL_STATE(1966)] = 109130,
  [SMALL_STATE(1967)] = 109151,
  [SMALL_STATE(1968)] = 109168,
  [SMALL_STATE(1969)] = 109181,
  [SMALL_STATE(1970)] = 109194,
  [SMALL_STATE(1971)] = 109211,
  [SMALL_STATE(1972)] = 109228,
  [SMALL_STATE(1973)] = 109245,
  [SMALL_STATE(1974)] = 109260,
  [SMALL_STATE(1975)] = 109281,
  [SMALL_STATE(1976)] = 109300,
  [SMALL_STATE(1977)] = 109313,
  [SMALL_STATE(1978)] = 109330,
  [SMALL_STATE(1979)] = 109347,
  [SMALL_STATE(1980)] = 109360,
  [SMALL_STATE(1981)] = 109375,
  [SMALL_STATE(1982)] = 109396,
  [SMALL_STATE(1983)] = 109409,
  [SMALL_STATE(1984)] = 109430,
  [SMALL_STATE(1985)] = 109447,
  [SMALL_STATE(1986)] = 109464,
  [SMALL_STATE(1987)] = 109479,
  [SMALL_STATE(1988)] = 109500,
  [SMALL_STATE(1989)] = 109513,
  [SMALL_STATE(1990)] = 109534,
  [SMALL_STATE(1991)] = 109555,
  [SMALL_STATE(1992)] = 109572,
  [SMALL_STATE(1993)] = 109593,
  [SMALL_STATE(1994)] = 109608,
  [SMALL_STATE(1995)] = 109625,
  [SMALL_STATE(1996)] = 109638,
  [SMALL_STATE(1997)] = 109651,
  [SMALL_STATE(1998)] = 109668,
  [SMALL_STATE(1999)] = 109681,
  [SMALL_STATE(2000)] = 109694,
  [SMALL_STATE(2001)] = 109715,
  [SMALL_STATE(2002)] = 109736,
  [SMALL_STATE(2003)] = 109759,
  [SMALL_STATE(2004)] = 109780,
  [SMALL_STATE(2005)] = 109797,
  [SMALL_STATE(2006)] = 109820,
  [SMALL_STATE(2007)] = 109835,
  [SMALL_STATE(2008)] = 109856,
  [SMALL_STATE(2009)] = 109879,
  [SMALL_STATE(2010)] = 109896,
  [SMALL_STATE(2011)] = 109917,
  [SMALL_STATE(2012)] = 109934,
  [SMALL_STATE(2013)] = 109955,
  [SMALL_STATE(2014)] = 109972,
  [SMALL_STATE(2015)] = 109989,
  [SMALL_STATE(2016)] = 110010,
  [SMALL_STATE(2017)] = 110027,
  [SMALL_STATE(2018)] = 110040,
  [SMALL_STATE(2019)] = 110061,
  [SMALL_STATE(2020)] = 110082,
  [SMALL_STATE(2021)] = 110099,
  [SMALL_STATE(2022)] = 110119,
  [SMALL_STATE(2023)] = 110131,
  [SMALL_STATE(2024)] = 110143,
  [SMALL_STATE(2025)] = 110161,
  [SMALL_STATE(2026)] = 110173,
  [SMALL_STATE(2027)] = 110185,
  [SMALL_STATE(2028)] = 110205,
  [SMALL_STATE(2029)] = 110225,
  [SMALL_STATE(2030)] = 110237,
  [SMALL_STATE(2031)] = 110257,
  [SMALL_STATE(2032)] = 110277,
  [SMALL_STATE(2033)] = 110289,
  [SMALL_STATE(2034)] = 110301,
  [SMALL_STATE(2035)] = 110313,
  [SMALL_STATE(2036)] = 110325,
  [SMALL_STATE(2037)] = 110345,
  [SMALL_STATE(2038)] = 110357,
  [SMALL_STATE(2039)] = 110369,
  [SMALL_STATE(2040)] = 110381,
  [SMALL_STATE(2041)] = 110399,
  [SMALL_STATE(2042)] = 110411,
  [SMALL_STATE(2043)] = 110425,
  [SMALL_STATE(2044)] = 110441,
  [SMALL_STATE(2045)] = 110461,
  [SMALL_STATE(2046)] = 110473,
  [SMALL_STATE(2047)] = 110487,
  [SMALL_STATE(2048)] = 110505,
  [SMALL_STATE(2049)] = 110521,
  [SMALL_STATE(2050)] = 110533,
  [SMALL_STATE(2051)] = 110547,
  [SMALL_STATE(2052)] = 110567,
  [SMALL_STATE(2053)] = 110579,
  [SMALL_STATE(2054)] = 110599,
  [SMALL_STATE(2055)] = 110619,
  [SMALL_STATE(2056)] = 110631,
  [SMALL_STATE(2057)] = 110647,
  [SMALL_STATE(2058)] = 110663,
  [SMALL_STATE(2059)] = 110675,
  [SMALL_STATE(2060)] = 110691,
  [SMALL_STATE(2061)] = 110705,
  [SMALL_STATE(2062)] = 110721,
  [SMALL_STATE(2063)] = 110735,
  [SMALL_STATE(2064)] = 110753,
  [SMALL_STATE(2065)] = 110765,
  [SMALL_STATE(2066)] = 110785,
  [SMALL_STATE(2067)] = 110797,
  [SMALL_STATE(2068)] = 110809,
  [SMALL_STATE(2069)] = 110821,
  [SMALL_STATE(2070)] = 110833,
  [SMALL_STATE(2071)] = 110845,
  [SMALL_STATE(2072)] = 110857,
  [SMALL_STATE(2073)] = 110877,
  [SMALL_STATE(2074)] = 110897,
  [SMALL_STATE(2075)] = 110913,
  [SMALL_STATE(2076)] = 110925,
  [SMALL_STATE(2077)] = 110941,
  [SMALL_STATE(2078)] = 110959,
  [SMALL_STATE(2079)] = 110979,
  [SMALL_STATE(2080)] = 110991,
  [SMALL_STATE(2081)] = 111007,
  [SMALL_STATE(2082)] = 111019,
  [SMALL_STATE(2083)] = 111039,
  [SMALL_STATE(2084)] = 111051,
  [SMALL_STATE(2085)] = 111071,
  [SMALL_STATE(2086)] = 111091,
  [SMALL_STATE(2087)] = 111107,
  [SMALL_STATE(2088)] = 111125,
  [SMALL_STATE(2089)] = 111137,
  [SMALL_STATE(2090)] = 111157,
  [SMALL_STATE(2091)] = 111175,
  [SMALL_STATE(2092)] = 111187,
  [SMALL_STATE(2093)] = 111207,
  [SMALL_STATE(2094)] = 111223,
  [SMALL_STATE(2095)] = 111243,
  [SMALL_STATE(2096)] = 111263,
  [SMALL_STATE(2097)] = 111283,
  [SMALL_STATE(2098)] = 111295,
  [SMALL_STATE(2099)] = 111315,
  [SMALL_STATE(2100)] = 111327,
  [SMALL_STATE(2101)] = 111339,
  [SMALL_STATE(2102)] = 111351,
  [SMALL_STATE(2103)] = 111363,
  [SMALL_STATE(2104)] = 111375,
  [SMALL_STATE(2105)] = 111387,
  [SMALL_STATE(2106)] = 111407,
  [SMALL_STATE(2107)] = 111419,
  [SMALL_STATE(2108)] = 111439,
  [SMALL_STATE(2109)] = 111459,
  [SMALL_STATE(2110)] = 111475,
  [SMALL_STATE(2111)] = 111493,
  [SMALL_STATE(2112)] = 111505,
  [SMALL_STATE(2113)] = 111523,
  [SMALL_STATE(2114)] = 111535,
  [SMALL_STATE(2115)] = 111547,
  [SMALL_STATE(2116)] = 111565,
  [SMALL_STATE(2117)] = 111577,
  [SMALL_STATE(2118)] = 111595,
  [SMALL_STATE(2119)] = 111615,
  [SMALL_STATE(2120)] = 111627,
  [SMALL_STATE(2121)] = 111647,
  [SMALL_STATE(2122)] = 111659,
  [SMALL_STATE(2123)] = 111679,
  [SMALL_STATE(2124)] = 111697,
  [SMALL_STATE(2125)] = 111713,
  [SMALL_STATE(2126)] = 111731,
  [SMALL_STATE(2127)] = 111743,
  [SMALL_STATE(2128)] = 111755,
  [SMALL_STATE(2129)] = 111775,
  [SMALL_STATE(2130)] = 111787,
  [SMALL_STATE(2131)] = 111799,
  [SMALL_STATE(2132)] = 111819,
  [SMALL_STATE(2133)] = 111831,
  [SMALL_STATE(2134)] = 111843,
  [SMALL_STATE(2135)] = 111859,
  [SMALL_STATE(2136)] = 111871,
  [SMALL_STATE(2137)] = 111883,
  [SMALL_STATE(2138)] = 111897,
  [SMALL_STATE(2139)] = 111913,
  [SMALL_STATE(2140)] = 111928,
  [SMALL_STATE(2141)] = 111943,
  [SMALL_STATE(2142)] = 111960,
  [SMALL_STATE(2143)] = 111971,
  [SMALL_STATE(2144)] = 111982,
  [SMALL_STATE(2145)] = 111993,
  [SMALL_STATE(2146)] = 112010,
  [SMALL_STATE(2147)] = 112021,
  [SMALL_STATE(2148)] = 112032,
  [SMALL_STATE(2149)] = 112043,
  [SMALL_STATE(2150)] = 112054,
  [SMALL_STATE(2151)] = 112065,
  [SMALL_STATE(2152)] = 112082,
  [SMALL_STATE(2153)] = 112093,
  [SMALL_STATE(2154)] = 112108,
  [SMALL_STATE(2155)] = 112119,
  [SMALL_STATE(2156)] = 112130,
  [SMALL_STATE(2157)] = 112141,
  [SMALL_STATE(2158)] = 112152,
  [SMALL_STATE(2159)] = 112163,
  [SMALL_STATE(2160)] = 112174,
  [SMALL_STATE(2161)] = 112191,
  [SMALL_STATE(2162)] = 112202,
  [SMALL_STATE(2163)] = 112219,
  [SMALL_STATE(2164)] = 112230,
  [SMALL_STATE(2165)] = 112241,
  [SMALL_STATE(2166)] = 112252,
  [SMALL_STATE(2167)] = 112269,
  [SMALL_STATE(2168)] = 112286,
  [SMALL_STATE(2169)] = 112297,
  [SMALL_STATE(2170)] = 112308,
  [SMALL_STATE(2171)] = 112319,
  [SMALL_STATE(2172)] = 112330,
  [SMALL_STATE(2173)] = 112341,
  [SMALL_STATE(2174)] = 112358,
  [SMALL_STATE(2175)] = 112369,
  [SMALL_STATE(2176)] = 112380,
  [SMALL_STATE(2177)] = 112391,
  [SMALL_STATE(2178)] = 112402,
  [SMALL_STATE(2179)] = 112413,
  [SMALL_STATE(2180)] = 112424,
  [SMALL_STATE(2181)] = 112441,
  [SMALL_STATE(2182)] = 112456,
  [SMALL_STATE(2183)] = 112471,
  [SMALL_STATE(2184)] = 112486,
  [SMALL_STATE(2185)] = 112501,
  [SMALL_STATE(2186)] = 112518,
  [SMALL_STATE(2187)] = 112535,
  [SMALL_STATE(2188)] = 112552,
  [SMALL_STATE(2189)] = 112567,
  [SMALL_STATE(2190)] = 112584,
  [SMALL_STATE(2191)] = 112601,
  [SMALL_STATE(2192)] = 112612,
  [SMALL_STATE(2193)] = 112623,
  [SMALL_STATE(2194)] = 112640,
  [SMALL_STATE(2195)] = 112651,
  [SMALL_STATE(2196)] = 112666,
  [SMALL_STATE(2197)] = 112677,
  [SMALL_STATE(2198)] = 112692,
  [SMALL_STATE(2199)] = 112707,
  [SMALL_STATE(2200)] = 112724,
  [SMALL_STATE(2201)] = 112739,
  [SMALL_STATE(2202)] = 112756,
  [SMALL_STATE(2203)] = 112773,
  [SMALL_STATE(2204)] = 112790,
  [SMALL_STATE(2205)] = 112807,
  [SMALL_STATE(2206)] = 112822,
  [SMALL_STATE(2207)] = 112839,
  [SMALL_STATE(2208)] = 112852,
  [SMALL_STATE(2209)] = 112869,
  [SMALL_STATE(2210)] = 112880,
  [SMALL_STATE(2211)] = 112895,
  [SMALL_STATE(2212)] = 112906,
  [SMALL_STATE(2213)] = 112921,
  [SMALL_STATE(2214)] = 112932,
  [SMALL_STATE(2215)] = 112943,
  [SMALL_STATE(2216)] = 112954,
  [SMALL_STATE(2217)] = 112965,
  [SMALL_STATE(2218)] = 112980,
  [SMALL_STATE(2219)] = 112991,
  [SMALL_STATE(2220)] = 113002,
  [SMALL_STATE(2221)] = 113013,
  [SMALL_STATE(2222)] = 113024,
  [SMALL_STATE(2223)] = 113035,
  [SMALL_STATE(2224)] = 113046,
  [SMALL_STATE(2225)] = 113057,
  [SMALL_STATE(2226)] = 113068,
  [SMALL_STATE(2227)] = 113079,
  [SMALL_STATE(2228)] = 113090,
  [SMALL_STATE(2229)] = 113101,
  [SMALL_STATE(2230)] = 113112,
  [SMALL_STATE(2231)] = 113123,
  [SMALL_STATE(2232)] = 113138,
  [SMALL_STATE(2233)] = 113149,
  [SMALL_STATE(2234)] = 113160,
  [SMALL_STATE(2235)] = 113171,
  [SMALL_STATE(2236)] = 113182,
  [SMALL_STATE(2237)] = 113193,
  [SMALL_STATE(2238)] = 113204,
  [SMALL_STATE(2239)] = 113215,
  [SMALL_STATE(2240)] = 113226,
  [SMALL_STATE(2241)] = 113237,
  [SMALL_STATE(2242)] = 113248,
  [SMALL_STATE(2243)] = 113259,
  [SMALL_STATE(2244)] = 113270,
  [SMALL_STATE(2245)] = 113287,
  [SMALL_STATE(2246)] = 113298,
  [SMALL_STATE(2247)] = 113315,
  [SMALL_STATE(2248)] = 113332,
  [SMALL_STATE(2249)] = 113349,
  [SMALL_STATE(2250)] = 113364,
  [SMALL_STATE(2251)] = 113379,
  [SMALL_STATE(2252)] = 113392,
  [SMALL_STATE(2253)] = 113403,
  [SMALL_STATE(2254)] = 113414,
  [SMALL_STATE(2255)] = 113425,
  [SMALL_STATE(2256)] = 113436,
  [SMALL_STATE(2257)] = 113447,
  [SMALL_STATE(2258)] = 113464,
  [SMALL_STATE(2259)] = 113475,
  [SMALL_STATE(2260)] = 113492,
  [SMALL_STATE(2261)] = 113507,
  [SMALL_STATE(2262)] = 113524,
  [SMALL_STATE(2263)] = 113535,
  [SMALL_STATE(2264)] = 113552,
  [SMALL_STATE(2265)] = 113563,
  [SMALL_STATE(2266)] = 113580,
  [SMALL_STATE(2267)] = 113597,
  [SMALL_STATE(2268)] = 113610,
  [SMALL_STATE(2269)] = 113624,
  [SMALL_STATE(2270)] = 113638,
  [SMALL_STATE(2271)] = 113652,
  [SMALL_STATE(2272)] = 113666,
  [SMALL_STATE(2273)] = 113680,
  [SMALL_STATE(2274)] = 113694,
  [SMALL_STATE(2275)] = 113708,
  [SMALL_STATE(2276)] = 113718,
  [SMALL_STATE(2277)] = 113732,
  [SMALL_STATE(2278)] = 113746,
  [SMALL_STATE(2279)] = 113760,
  [SMALL_STATE(2280)] = 113774,
  [SMALL_STATE(2281)] = 113788,
  [SMALL_STATE(2282)] = 113802,
  [SMALL_STATE(2283)] = 113816,
  [SMALL_STATE(2284)] = 113830,
  [SMALL_STATE(2285)] = 113842,
  [SMALL_STATE(2286)] = 113856,
  [SMALL_STATE(2287)] = 113870,
  [SMALL_STATE(2288)] = 113884,
  [SMALL_STATE(2289)] = 113898,
  [SMALL_STATE(2290)] = 113912,
  [SMALL_STATE(2291)] = 113926,
  [SMALL_STATE(2292)] = 113940,
  [SMALL_STATE(2293)] = 113954,
  [SMALL_STATE(2294)] = 113968,
  [SMALL_STATE(2295)] = 113982,
  [SMALL_STATE(2296)] = 113996,
  [SMALL_STATE(2297)] = 114010,
  [SMALL_STATE(2298)] = 114024,
  [SMALL_STATE(2299)] = 114038,
  [SMALL_STATE(2300)] = 114052,
  [SMALL_STATE(2301)] = 114066,
  [SMALL_STATE(2302)] = 114080,
  [SMALL_STATE(2303)] = 114094,
  [SMALL_STATE(2304)] = 114108,
  [SMALL_STATE(2305)] = 114122,
  [SMALL_STATE(2306)] = 114136,
  [SMALL_STATE(2307)] = 114148,
  [SMALL_STATE(2308)] = 114162,
  [SMALL_STATE(2309)] = 114176,
  [SMALL_STATE(2310)] = 114190,
  [SMALL_STATE(2311)] = 114204,
  [SMALL_STATE(2312)] = 114218,
  [SMALL_STATE(2313)] = 114232,
  [SMALL_STATE(2314)] = 114246,
  [SMALL_STATE(2315)] = 114258,
  [SMALL_STATE(2316)] = 114272,
  [SMALL_STATE(2317)] = 114286,
  [SMALL_STATE(2318)] = 114300,
  [SMALL_STATE(2319)] = 114314,
  [SMALL_STATE(2320)] = 114328,
  [SMALL_STATE(2321)] = 114342,
  [SMALL_STATE(2322)] = 114356,
  [SMALL_STATE(2323)] = 114370,
  [SMALL_STATE(2324)] = 114384,
  [SMALL_STATE(2325)] = 114398,
  [SMALL_STATE(2326)] = 114408,
  [SMALL_STATE(2327)] = 114418,
  [SMALL_STATE(2328)] = 114432,
  [SMALL_STATE(2329)] = 114446,
  [SMALL_STATE(2330)] = 114458,
  [SMALL_STATE(2331)] = 114472,
  [SMALL_STATE(2332)] = 114484,
  [SMALL_STATE(2333)] = 114498,
  [SMALL_STATE(2334)] = 114512,
  [SMALL_STATE(2335)] = 114526,
  [SMALL_STATE(2336)] = 114540,
  [SMALL_STATE(2337)] = 114554,
  [SMALL_STATE(2338)] = 114568,
  [SMALL_STATE(2339)] = 114582,
  [SMALL_STATE(2340)] = 114594,
  [SMALL_STATE(2341)] = 114608,
  [SMALL_STATE(2342)] = 114620,
  [SMALL_STATE(2343)] = 114634,
  [SMALL_STATE(2344)] = 114646,
  [SMALL_STATE(2345)] = 114660,
  [SMALL_STATE(2346)] = 114674,
  [SMALL_STATE(2347)] = 114688,
  [SMALL_STATE(2348)] = 114702,
  [SMALL_STATE(2349)] = 114714,
  [SMALL_STATE(2350)] = 114728,
  [SMALL_STATE(2351)] = 114738,
  [SMALL_STATE(2352)] = 114748,
  [SMALL_STATE(2353)] = 114762,
  [SMALL_STATE(2354)] = 114776,
  [SMALL_STATE(2355)] = 114790,
  [SMALL_STATE(2356)] = 114804,
  [SMALL_STATE(2357)] = 114818,
  [SMALL_STATE(2358)] = 114832,
  [SMALL_STATE(2359)] = 114846,
  [SMALL_STATE(2360)] = 114860,
  [SMALL_STATE(2361)] = 114874,
  [SMALL_STATE(2362)] = 114888,
  [SMALL_STATE(2363)] = 114902,
  [SMALL_STATE(2364)] = 114916,
  [SMALL_STATE(2365)] = 114930,
  [SMALL_STATE(2366)] = 114944,
  [SMALL_STATE(2367)] = 114958,
  [SMALL_STATE(2368)] = 114972,
  [SMALL_STATE(2369)] = 114984,
  [SMALL_STATE(2370)] = 114998,
  [SMALL_STATE(2371)] = 115012,
  [SMALL_STATE(2372)] = 115026,
  [SMALL_STATE(2373)] = 115040,
  [SMALL_STATE(2374)] = 115054,
  [SMALL_STATE(2375)] = 115068,
  [SMALL_STATE(2376)] = 115082,
  [SMALL_STATE(2377)] = 115096,
  [SMALL_STATE(2378)] = 115110,
  [SMALL_STATE(2379)] = 115124,
  [SMALL_STATE(2380)] = 115138,
  [SMALL_STATE(2381)] = 115152,
  [SMALL_STATE(2382)] = 115166,
  [SMALL_STATE(2383)] = 115180,
  [SMALL_STATE(2384)] = 115194,
  [SMALL_STATE(2385)] = 115204,
  [SMALL_STATE(2386)] = 115218,
  [SMALL_STATE(2387)] = 115230,
  [SMALL_STATE(2388)] = 115244,
  [SMALL_STATE(2389)] = 115258,
  [SMALL_STATE(2390)] = 115272,
  [SMALL_STATE(2391)] = 115286,
  [SMALL_STATE(2392)] = 115300,
  [SMALL_STATE(2393)] = 115314,
  [SMALL_STATE(2394)] = 115328,
  [SMALL_STATE(2395)] = 115342,
  [SMALL_STATE(2396)] = 115356,
  [SMALL_STATE(2397)] = 115366,
  [SMALL_STATE(2398)] = 115378,
  [SMALL_STATE(2399)] = 115392,
  [SMALL_STATE(2400)] = 115406,
  [SMALL_STATE(2401)] = 115420,
  [SMALL_STATE(2402)] = 115434,
  [SMALL_STATE(2403)] = 115448,
  [SMALL_STATE(2404)] = 115460,
  [SMALL_STATE(2405)] = 115474,
  [SMALL_STATE(2406)] = 115488,
  [SMALL_STATE(2407)] = 115502,
  [SMALL_STATE(2408)] = 115516,
  [SMALL_STATE(2409)] = 115530,
  [SMALL_STATE(2410)] = 115544,
  [SMALL_STATE(2411)] = 115558,
  [SMALL_STATE(2412)] = 115572,
  [SMALL_STATE(2413)] = 115586,
  [SMALL_STATE(2414)] = 115598,
  [SMALL_STATE(2415)] = 115612,
  [SMALL_STATE(2416)] = 115626,
  [SMALL_STATE(2417)] = 115640,
  [SMALL_STATE(2418)] = 115654,
  [SMALL_STATE(2419)] = 115668,
  [SMALL_STATE(2420)] = 115682,
  [SMALL_STATE(2421)] = 115694,
  [SMALL_STATE(2422)] = 115708,
  [SMALL_STATE(2423)] = 115722,
  [SMALL_STATE(2424)] = 115736,
  [SMALL_STATE(2425)] = 115750,
  [SMALL_STATE(2426)] = 115764,
  [SMALL_STATE(2427)] = 115776,
  [SMALL_STATE(2428)] = 115790,
  [SMALL_STATE(2429)] = 115804,
  [SMALL_STATE(2430)] = 115818,
  [SMALL_STATE(2431)] = 115832,
  [SMALL_STATE(2432)] = 115846,
  [SMALL_STATE(2433)] = 115860,
  [SMALL_STATE(2434)] = 115874,
  [SMALL_STATE(2435)] = 115888,
  [SMALL_STATE(2436)] = 115902,
  [SMALL_STATE(2437)] = 115916,
  [SMALL_STATE(2438)] = 115930,
  [SMALL_STATE(2439)] = 115944,
  [SMALL_STATE(2440)] = 115958,
  [SMALL_STATE(2441)] = 115972,
  [SMALL_STATE(2442)] = 115986,
  [SMALL_STATE(2443)] = 116000,
  [SMALL_STATE(2444)] = 116014,
  [SMALL_STATE(2445)] = 116028,
  [SMALL_STATE(2446)] = 116042,
  [SMALL_STATE(2447)] = 116056,
  [SMALL_STATE(2448)] = 116070,
  [SMALL_STATE(2449)] = 116080,
  [SMALL_STATE(2450)] = 116094,
  [SMALL_STATE(2451)] = 116108,
  [SMALL_STATE(2452)] = 116122,
  [SMALL_STATE(2453)] = 116136,
  [SMALL_STATE(2454)] = 116150,
  [SMALL_STATE(2455)] = 116164,
  [SMALL_STATE(2456)] = 116176,
  [SMALL_STATE(2457)] = 116190,
  [SMALL_STATE(2458)] = 116204,
  [SMALL_STATE(2459)] = 116218,
  [SMALL_STATE(2460)] = 116232,
  [SMALL_STATE(2461)] = 116244,
  [SMALL_STATE(2462)] = 116258,
  [SMALL_STATE(2463)] = 116272,
  [SMALL_STATE(2464)] = 116282,
  [SMALL_STATE(2465)] = 116296,
  [SMALL_STATE(2466)] = 116310,
  [SMALL_STATE(2467)] = 116324,
  [SMALL_STATE(2468)] = 116338,
  [SMALL_STATE(2469)] = 116348,
  [SMALL_STATE(2470)] = 116362,
  [SMALL_STATE(2471)] = 116376,
  [SMALL_STATE(2472)] = 116390,
  [SMALL_STATE(2473)] = 116404,
  [SMALL_STATE(2474)] = 116418,
  [SMALL_STATE(2475)] = 116432,
  [SMALL_STATE(2476)] = 116446,
  [SMALL_STATE(2477)] = 116460,
  [SMALL_STATE(2478)] = 116474,
  [SMALL_STATE(2479)] = 116488,
  [SMALL_STATE(2480)] = 116502,
  [SMALL_STATE(2481)] = 116516,
  [SMALL_STATE(2482)] = 116530,
  [SMALL_STATE(2483)] = 116544,
  [SMALL_STATE(2484)] = 116558,
  [SMALL_STATE(2485)] = 116570,
  [SMALL_STATE(2486)] = 116584,
  [SMALL_STATE(2487)] = 116598,
  [SMALL_STATE(2488)] = 116608,
  [SMALL_STATE(2489)] = 116620,
  [SMALL_STATE(2490)] = 116634,
  [SMALL_STATE(2491)] = 116648,
  [SMALL_STATE(2492)] = 116662,
  [SMALL_STATE(2493)] = 116676,
  [SMALL_STATE(2494)] = 116690,
  [SMALL_STATE(2495)] = 116704,
  [SMALL_STATE(2496)] = 116718,
  [SMALL_STATE(2497)] = 116732,
  [SMALL_STATE(2498)] = 116742,
  [SMALL_STATE(2499)] = 116756,
  [SMALL_STATE(2500)] = 116770,
  [SMALL_STATE(2501)] = 116784,
  [SMALL_STATE(2502)] = 116798,
  [SMALL_STATE(2503)] = 116812,
  [SMALL_STATE(2504)] = 116826,
  [SMALL_STATE(2505)] = 116840,
  [SMALL_STATE(2506)] = 116854,
  [SMALL_STATE(2507)] = 116868,
  [SMALL_STATE(2508)] = 116882,
  [SMALL_STATE(2509)] = 116896,
  [SMALL_STATE(2510)] = 116910,
  [SMALL_STATE(2511)] = 116924,
  [SMALL_STATE(2512)] = 116938,
  [SMALL_STATE(2513)] = 116952,
  [SMALL_STATE(2514)] = 116966,
  [SMALL_STATE(2515)] = 116978,
  [SMALL_STATE(2516)] = 116992,
  [SMALL_STATE(2517)] = 117004,
  [SMALL_STATE(2518)] = 117016,
  [SMALL_STATE(2519)] = 117030,
  [SMALL_STATE(2520)] = 117044,
  [SMALL_STATE(2521)] = 117056,
  [SMALL_STATE(2522)] = 117066,
  [SMALL_STATE(2523)] = 117076,
  [SMALL_STATE(2524)] = 117090,
  [SMALL_STATE(2525)] = 117104,
  [SMALL_STATE(2526)] = 117118,
  [SMALL_STATE(2527)] = 117132,
  [SMALL_STATE(2528)] = 117146,
  [SMALL_STATE(2529)] = 117155,
  [SMALL_STATE(2530)] = 117166,
  [SMALL_STATE(2531)] = 117177,
  [SMALL_STATE(2532)] = 117186,
  [SMALL_STATE(2533)] = 117195,
  [SMALL_STATE(2534)] = 117204,
  [SMALL_STATE(2535)] = 117213,
  [SMALL_STATE(2536)] = 117222,
  [SMALL_STATE(2537)] = 117231,
  [SMALL_STATE(2538)] = 117240,
  [SMALL_STATE(2539)] = 117249,
  [SMALL_STATE(2540)] = 117258,
  [SMALL_STATE(2541)] = 117267,
  [SMALL_STATE(2542)] = 117276,
  [SMALL_STATE(2543)] = 117287,
  [SMALL_STATE(2544)] = 117296,
  [SMALL_STATE(2545)] = 117305,
  [SMALL_STATE(2546)] = 117314,
  [SMALL_STATE(2547)] = 117323,
  [SMALL_STATE(2548)] = 117332,
  [SMALL_STATE(2549)] = 117341,
  [SMALL_STATE(2550)] = 117350,
  [SMALL_STATE(2551)] = 117359,
  [SMALL_STATE(2552)] = 117368,
  [SMALL_STATE(2553)] = 117377,
  [SMALL_STATE(2554)] = 117386,
  [SMALL_STATE(2555)] = 117397,
  [SMALL_STATE(2556)] = 117408,
  [SMALL_STATE(2557)] = 117419,
  [SMALL_STATE(2558)] = 117428,
  [SMALL_STATE(2559)] = 117437,
  [SMALL_STATE(2560)] = 117446,
  [SMALL_STATE(2561)] = 117457,
  [SMALL_STATE(2562)] = 117466,
  [SMALL_STATE(2563)] = 117477,
  [SMALL_STATE(2564)] = 117486,
  [SMALL_STATE(2565)] = 117495,
  [SMALL_STATE(2566)] = 117506,
  [SMALL_STATE(2567)] = 117515,
  [SMALL_STATE(2568)] = 117524,
  [SMALL_STATE(2569)] = 117533,
  [SMALL_STATE(2570)] = 117542,
  [SMALL_STATE(2571)] = 117551,
  [SMALL_STATE(2572)] = 117560,
  [SMALL_STATE(2573)] = 117571,
  [SMALL_STATE(2574)] = 117582,
  [SMALL_STATE(2575)] = 117591,
  [SMALL_STATE(2576)] = 117600,
  [SMALL_STATE(2577)] = 117609,
  [SMALL_STATE(2578)] = 117618,
  [SMALL_STATE(2579)] = 117627,
  [SMALL_STATE(2580)] = 117638,
  [SMALL_STATE(2581)] = 117647,
  [SMALL_STATE(2582)] = 117658,
  [SMALL_STATE(2583)] = 117669,
  [SMALL_STATE(2584)] = 117678,
  [SMALL_STATE(2585)] = 117687,
  [SMALL_STATE(2586)] = 117696,
  [SMALL_STATE(2587)] = 117705,
  [SMALL_STATE(2588)] = 117714,
  [SMALL_STATE(2589)] = 117723,
  [SMALL_STATE(2590)] = 117732,
  [SMALL_STATE(2591)] = 117741,
  [SMALL_STATE(2592)] = 117750,
  [SMALL_STATE(2593)] = 117761,
  [SMALL_STATE(2594)] = 117772,
  [SMALL_STATE(2595)] = 117783,
  [SMALL_STATE(2596)] = 117792,
  [SMALL_STATE(2597)] = 117803,
  [SMALL_STATE(2598)] = 117812,
  [SMALL_STATE(2599)] = 117821,
  [SMALL_STATE(2600)] = 117832,
  [SMALL_STATE(2601)] = 117841,
  [SMALL_STATE(2602)] = 117850,
  [SMALL_STATE(2603)] = 117861,
  [SMALL_STATE(2604)] = 117870,
  [SMALL_STATE(2605)] = 117879,
  [SMALL_STATE(2606)] = 117888,
  [SMALL_STATE(2607)] = 117897,
  [SMALL_STATE(2608)] = 117906,
  [SMALL_STATE(2609)] = 117915,
  [SMALL_STATE(2610)] = 117924,
  [SMALL_STATE(2611)] = 117935,
  [SMALL_STATE(2612)] = 117944,
  [SMALL_STATE(2613)] = 117953,
  [SMALL_STATE(2614)] = 117962,
  [SMALL_STATE(2615)] = 117971,
  [SMALL_STATE(2616)] = 117980,
  [SMALL_STATE(2617)] = 117991,
  [SMALL_STATE(2618)] = 118000,
  [SMALL_STATE(2619)] = 118011,
  [SMALL_STATE(2620)] = 118020,
  [SMALL_STATE(2621)] = 118031,
  [SMALL_STATE(2622)] = 118040,
  [SMALL_STATE(2623)] = 118049,
  [SMALL_STATE(2624)] = 118058,
  [SMALL_STATE(2625)] = 118067,
  [SMALL_STATE(2626)] = 118076,
  [SMALL_STATE(2627)] = 118085,
  [SMALL_STATE(2628)] = 118094,
  [SMALL_STATE(2629)] = 118105,
  [SMALL_STATE(2630)] = 118113,
  [SMALL_STATE(2631)] = 118121,
  [SMALL_STATE(2632)] = 118129,
  [SMALL_STATE(2633)] = 118137,
  [SMALL_STATE(2634)] = 118145,
  [SMALL_STATE(2635)] = 118153,
  [SMALL_STATE(2636)] = 118161,
  [SMALL_STATE(2637)] = 118169,
  [SMALL_STATE(2638)] = 118177,
  [SMALL_STATE(2639)] = 118185,
  [SMALL_STATE(2640)] = 118193,
  [SMALL_STATE(2641)] = 118201,
  [SMALL_STATE(2642)] = 118209,
  [SMALL_STATE(2643)] = 118217,
  [SMALL_STATE(2644)] = 118225,
  [SMALL_STATE(2645)] = 118233,
  [SMALL_STATE(2646)] = 118241,
  [SMALL_STATE(2647)] = 118249,
  [SMALL_STATE(2648)] = 118257,
  [SMALL_STATE(2649)] = 118265,
  [SMALL_STATE(2650)] = 118273,
  [SMALL_STATE(2651)] = 118281,
  [SMALL_STATE(2652)] = 118289,
  [SMALL_STATE(2653)] = 118297,
  [SMALL_STATE(2654)] = 118305,
  [SMALL_STATE(2655)] = 118313,
  [SMALL_STATE(2656)] = 118321,
  [SMALL_STATE(2657)] = 118329,
  [SMALL_STATE(2658)] = 118337,
  [SMALL_STATE(2659)] = 118345,
  [SMALL_STATE(2660)] = 118353,
  [SMALL_STATE(2661)] = 118361,
  [SMALL_STATE(2662)] = 118369,
  [SMALL_STATE(2663)] = 118377,
  [SMALL_STATE(2664)] = 118385,
  [SMALL_STATE(2665)] = 118393,
  [SMALL_STATE(2666)] = 118401,
  [SMALL_STATE(2667)] = 118409,
  [SMALL_STATE(2668)] = 118417,
  [SMALL_STATE(2669)] = 118425,
  [SMALL_STATE(2670)] = 118433,
  [SMALL_STATE(2671)] = 118441,
  [SMALL_STATE(2672)] = 118449,
  [SMALL_STATE(2673)] = 118457,
  [SMALL_STATE(2674)] = 118465,
  [SMALL_STATE(2675)] = 118473,
  [SMALL_STATE(2676)] = 118481,
  [SMALL_STATE(2677)] = 118489,
  [SMALL_STATE(2678)] = 118497,
  [SMALL_STATE(2679)] = 118505,
  [SMALL_STATE(2680)] = 118513,
  [SMALL_STATE(2681)] = 118521,
  [SMALL_STATE(2682)] = 118529,
  [SMALL_STATE(2683)] = 118537,
  [SMALL_STATE(2684)] = 118545,
  [SMALL_STATE(2685)] = 118553,
  [SMALL_STATE(2686)] = 118561,
  [SMALL_STATE(2687)] = 118569,
  [SMALL_STATE(2688)] = 118577,
  [SMALL_STATE(2689)] = 118585,
  [SMALL_STATE(2690)] = 118593,
  [SMALL_STATE(2691)] = 118601,
  [SMALL_STATE(2692)] = 118609,
  [SMALL_STATE(2693)] = 118617,
  [SMALL_STATE(2694)] = 118625,
  [SMALL_STATE(2695)] = 118633,
  [SMALL_STATE(2696)] = 118641,
  [SMALL_STATE(2697)] = 118649,
  [SMALL_STATE(2698)] = 118657,
  [SMALL_STATE(2699)] = 118665,
  [SMALL_STATE(2700)] = 118673,
  [SMALL_STATE(2701)] = 118681,
  [SMALL_STATE(2702)] = 118689,
  [SMALL_STATE(2703)] = 118697,
  [SMALL_STATE(2704)] = 118705,
  [SMALL_STATE(2705)] = 118713,
  [SMALL_STATE(2706)] = 118721,
  [SMALL_STATE(2707)] = 118729,
  [SMALL_STATE(2708)] = 118737,
  [SMALL_STATE(2709)] = 118745,
  [SMALL_STATE(2710)] = 118753,
  [SMALL_STATE(2711)] = 118761,
  [SMALL_STATE(2712)] = 118769,
  [SMALL_STATE(2713)] = 118777,
  [SMALL_STATE(2714)] = 118785,
  [SMALL_STATE(2715)] = 118793,
  [SMALL_STATE(2716)] = 118801,
  [SMALL_STATE(2717)] = 118809,
  [SMALL_STATE(2718)] = 118817,
  [SMALL_STATE(2719)] = 118825,
  [SMALL_STATE(2720)] = 118833,
  [SMALL_STATE(2721)] = 118841,
  [SMALL_STATE(2722)] = 118849,
  [SMALL_STATE(2723)] = 118857,
  [SMALL_STATE(2724)] = 118865,
  [SMALL_STATE(2725)] = 118873,
  [SMALL_STATE(2726)] = 118881,
  [SMALL_STATE(2727)] = 118889,
  [SMALL_STATE(2728)] = 118897,
  [SMALL_STATE(2729)] = 118905,
  [SMALL_STATE(2730)] = 118913,
  [SMALL_STATE(2731)] = 118921,
  [SMALL_STATE(2732)] = 118929,
  [SMALL_STATE(2733)] = 118937,
  [SMALL_STATE(2734)] = 118945,
  [SMALL_STATE(2735)] = 118953,
  [SMALL_STATE(2736)] = 118961,
  [SMALL_STATE(2737)] = 118969,
  [SMALL_STATE(2738)] = 118977,
  [SMALL_STATE(2739)] = 118985,
  [SMALL_STATE(2740)] = 118993,
  [SMALL_STATE(2741)] = 119001,
  [SMALL_STATE(2742)] = 119009,
  [SMALL_STATE(2743)] = 119017,
  [SMALL_STATE(2744)] = 119025,
  [SMALL_STATE(2745)] = 119033,
  [SMALL_STATE(2746)] = 119041,
  [SMALL_STATE(2747)] = 119049,
  [SMALL_STATE(2748)] = 119057,
  [SMALL_STATE(2749)] = 119065,
  [SMALL_STATE(2750)] = 119073,
  [SMALL_STATE(2751)] = 119081,
  [SMALL_STATE(2752)] = 119089,
  [SMALL_STATE(2753)] = 119097,
  [SMALL_STATE(2754)] = 119105,
  [SMALL_STATE(2755)] = 119113,
  [SMALL_STATE(2756)] = 119121,
  [SMALL_STATE(2757)] = 119129,
  [SMALL_STATE(2758)] = 119137,
  [SMALL_STATE(2759)] = 119145,
  [SMALL_STATE(2760)] = 119153,
  [SMALL_STATE(2761)] = 119161,
  [SMALL_STATE(2762)] = 119169,
  [SMALL_STATE(2763)] = 119177,
  [SMALL_STATE(2764)] = 119185,
  [SMALL_STATE(2765)] = 119193,
  [SMALL_STATE(2766)] = 119201,
  [SMALL_STATE(2767)] = 119209,
  [SMALL_STATE(2768)] = 119217,
  [SMALL_STATE(2769)] = 119225,
  [SMALL_STATE(2770)] = 119233,
  [SMALL_STATE(2771)] = 119241,
  [SMALL_STATE(2772)] = 119249,
  [SMALL_STATE(2773)] = 119257,
  [SMALL_STATE(2774)] = 119265,
  [SMALL_STATE(2775)] = 119273,
  [SMALL_STATE(2776)] = 119281,
  [SMALL_STATE(2777)] = 119289,
  [SMALL_STATE(2778)] = 119297,
  [SMALL_STATE(2779)] = 119305,
  [SMALL_STATE(2780)] = 119313,
  [SMALL_STATE(2781)] = 119321,
  [SMALL_STATE(2782)] = 119329,
  [SMALL_STATE(2783)] = 119337,
  [SMALL_STATE(2784)] = 119345,
  [SMALL_STATE(2785)] = 119353,
  [SMALL_STATE(2786)] = 119361,
  [SMALL_STATE(2787)] = 119369,
  [SMALL_STATE(2788)] = 119377,
  [SMALL_STATE(2789)] = 119385,
  [SMALL_STATE(2790)] = 119393,
  [SMALL_STATE(2791)] = 119401,
  [SMALL_STATE(2792)] = 119409,
  [SMALL_STATE(2793)] = 119417,
  [SMALL_STATE(2794)] = 119425,
  [SMALL_STATE(2795)] = 119433,
  [SMALL_STATE(2796)] = 119441,
  [SMALL_STATE(2797)] = 119449,
  [SMALL_STATE(2798)] = 119457,
  [SMALL_STATE(2799)] = 119465,
  [SMALL_STATE(2800)] = 119473,
  [SMALL_STATE(2801)] = 119481,
  [SMALL_STATE(2802)] = 119489,
  [SMALL_STATE(2803)] = 119497,
  [SMALL_STATE(2804)] = 119505,
  [SMALL_STATE(2805)] = 119513,
  [SMALL_STATE(2806)] = 119521,
  [SMALL_STATE(2807)] = 119529,
  [SMALL_STATE(2808)] = 119537,
  [SMALL_STATE(2809)] = 119545,
  [SMALL_STATE(2810)] = 119553,
  [SMALL_STATE(2811)] = 119561,
  [SMALL_STATE(2812)] = 119569,
  [SMALL_STATE(2813)] = 119577,
  [SMALL_STATE(2814)] = 119585,
  [SMALL_STATE(2815)] = 119593,
  [SMALL_STATE(2816)] = 119601,
  [SMALL_STATE(2817)] = 119609,
  [SMALL_STATE(2818)] = 119617,
  [SMALL_STATE(2819)] = 119625,
  [SMALL_STATE(2820)] = 119633,
  [SMALL_STATE(2821)] = 119641,
  [SMALL_STATE(2822)] = 119649,
  [SMALL_STATE(2823)] = 119657,
  [SMALL_STATE(2824)] = 119665,
  [SMALL_STATE(2825)] = 119673,
  [SMALL_STATE(2826)] = 119681,
  [SMALL_STATE(2827)] = 119689,
  [SMALL_STATE(2828)] = 119697,
  [SMALL_STATE(2829)] = 119705,
  [SMALL_STATE(2830)] = 119713,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2615),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2204),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1866),
  [126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(193),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(84),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(566),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(383),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(463),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(357),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2608),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2615),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2551),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(598),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2794),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(458),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2819),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2784),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2637),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(470),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2796),
  [195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(195),
  [198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(586),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(925),
  [204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(207),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(490),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(361),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1121),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1121),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(155),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1732),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1, 0, 0),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(530),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(85),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(848),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2797),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2671),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2812),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(319),
  [284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 1), REDUCE(sym_primary_expression, 1, 0, 1),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(883),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, 0, 1),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 1),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(2672),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(280),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(927),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(504),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 1),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 1), REDUCE(sym_primary_expression, 1, 0, 1),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(285),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(926),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(296),
  [398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(925),
  [401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(490),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_list_splat_pattern, 2, 0, 5),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3, 0, 0),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2, 0, 0),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1, 0, 0),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3, 0, 0),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, 0, 99),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 99),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, 0, 98),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 98),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, 0, 110),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, 0, 110),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3, 0, 0),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, 0, 79),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 79),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2, 0, 0),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, 0, 0),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1, 0, 0),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2, 0, 0),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1, 0, 0),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3, 0, 0),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, 0, 5),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2, 0, 0),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 0),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, 0, 0),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, -1, 6),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, 0, 0),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3, 0, 0),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, 0, 14),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, -1, 15),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4, 0, 0),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 42),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 42),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 63),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 63),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [1506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [1544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 0),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, 0, 0),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 0),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 57),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 57),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 83),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 83),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [1576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 37),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 37),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0),
  [1587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(594),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 56),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 56),
  [1594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [1597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2, 0, 0), SHIFT_REPEAT(601),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 2),
  [1602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 2),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, 0, 72),
  [1609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, 0, 72),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 81),
  [1623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 81),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 81), SHIFT_REPEAT(600),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_type, 2, 0, 0),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_type, 2, 0, 0),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, 0, 48),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, 0, 48),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, 0, 48),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, 0, 48),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, 0, 72),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, 0, 72),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 23),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, 0, 23),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2, 0, 0),
  [1650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0), REDUCE(sym_tuple, 2, 0, 0),
  [1653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2, 0, 0),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [1659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 81), SHIFT_REPEAT(603),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2, 0, 0),
  [1664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0), REDUCE(sym_list, 2, 0, 0),
  [1667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2, 0, 0),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [1673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3, 0, 0),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3, 0, 0),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, 0, 106),
  [1679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, 0, 106),
  [1681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [1683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4, 0, 0),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4, 0, 0),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2, 0, 0),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2, 0, 0),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, 0, 0),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, 0, 0),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 4, 0, 106),
  [1699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 4, 0, 106),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1, 0, 0),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1, 0, 0),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, 0, 129),
  [1707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, 0, 129),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 6, 0, 129),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 6, 0, 129),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5, 0, 0),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5, 0, 0),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 5, 0, 0),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 5, 0, 0),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7, 0, 0),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7, 0, 0),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 7, 0, 0),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 7, 0, 0),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, 0, 90),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, 0, 90),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 41),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 41),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, 0, 57),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, 0, 57),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 88),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 88),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 63),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 63),
  [1763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, 0, 37),
  [1765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, 0, 37),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 101),
  [1769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 101),
  [1771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 105),
  [1773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 105),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 54),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 54),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 114),
  [1781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 114),
  [1783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 62),
  [1785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 62),
  [1787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 42),
  [1789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 42),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, 0, 63),
  [1793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, 0, 63),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 42),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, 0, 42),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 113),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 113),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 104),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 104),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, 0, 86),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, 0, 86),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4, 0, 0),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4, 0, 0),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, 0, 63),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, 0, 63),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorated_definition, 2, 0, 12),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorated_definition, 2, 0, 12),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 107),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 107),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 108),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 108),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, 0, 109),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 7, 0, 109),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, 0, 43),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, 0, 43),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 87),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 87),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 82),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 82),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 44),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, 0, 44),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2, 0, 0),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 89),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 89),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 115),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 115),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 116),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 116),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 117),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 117),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 118),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 118),
  [1903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 119),
  [1905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 119),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, 0, 90),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, 0, 90),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 126),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 126),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 127),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 127),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 128),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 128),
  [1923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 42),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 42),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 130),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 130),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 10, 0, 135),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 10, 0, 135),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 55),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 55),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, 0, 58),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, 0, 58),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2, 0, 0),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 2, 0, 0),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 2, 0, 0),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, 0, 59),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, 0, 59),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 60),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 60),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 61),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 61),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 91),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 91),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 92),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 92),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3, 0, 0),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3, 0, 0),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 1, 0, 0),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 1, 0, 0),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, 0, 39),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, 0, 39),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 93),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 93),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 94),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 94),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 64),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 64),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 80),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 80),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 65),
  [2013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 65),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 66),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 66),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 67),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 67),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 68),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 68),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 3, 0, 84),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 3, 0, 84),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 6, 0, 85),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 6, 0, 85),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 95),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 95),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 100),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 100),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 102),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 102),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 103),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 103),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1, 0, 0),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1732),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2, 0, 0),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await, 2, 0, 0),
  [2236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, 0, 21),
  [2238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, 0, 21),
  [2240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1723),
  [2243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1727),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 50),
  [2278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 50),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 9),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 9),
  [2284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 49),
  [2286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 49),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 24),
  [2290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 24),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1719),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1706),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1731),
  [2395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [2399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1710),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1737),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 33),
  [2477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 33),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2, 0, 0),
  [2481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2, 0, 0),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 0),
  [2487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, 0, 0),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3, 0, 0),
  [2491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3, 0, 0),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3, 0, 0),
  [2495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3, 0, 0),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [2499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 33),
  [2503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 33),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, 0, 34),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, 0, 34),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, 0, 34),
  [2511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, 0, 34),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, 0, 34),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, 0, 34),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4, 0, 0),
  [2529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4, 0, 0),
  [2531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, 0, 0),
  [2533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, 0, 0),
  [2535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5, 0, 0),
  [2537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5, 0, 0),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 33),
  [2545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 33),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 10),
  [2549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 10),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, 0, 34),
  [2583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, 0, 34),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [2747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, 0, 11),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, 0, 11),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25),
  [2817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(945),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25),
  [2822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2767),
  [2825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(945),
  [2828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(860),
  [2831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(887),
  [2834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2728),
  [2837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(887),
  [2840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(866),
  [2843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(880),
  [2846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2663),
  [2849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(880),
  [2852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(861),
  [2855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(896),
  [2858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2649),
  [2861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(896),
  [2864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(864),
  [2867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(874),
  [2870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2757),
  [2873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(874),
  [2876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(863),
  [2879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(963),
  [2882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2748),
  [2885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(963),
  [2888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(865),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0),
  [2893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(855),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(917),
  [2901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2712),
  [2904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(917),
  [2907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(862),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, 0, 0),
  [2912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(931),
  [2915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(2681),
  [2918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(931),
  [2921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 25), SHIFT_REPEAT(859),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1, 0, 0),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(851),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2, 0, 0),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3, 0, 0),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1, 0, 0),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, 0, 21),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, 0, 6),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 17),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 0),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 18),
  [3033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(498),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 22),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, 0, 47),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [3068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [3072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(231),
  [3075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1805),
  [3078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1805),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, 1, 7), SHIFT(340),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(578),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1, 0, 0),
  [3211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(525),
  [3214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(570),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [3227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1, 0, 0),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2, 0, 0),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3, 0, 0),
  [3239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(604),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2, 0, 0),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, 0, 6),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0),
  [3248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(557),
  [3251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 22),
  [3253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, 0, 21),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0),
  [3257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2717),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1, 0, 0),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [3272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(543),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0),
  [3287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1816),
  [3290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1816),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1, 0, 0),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, 0, 8),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, -1, 6),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [3353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 18), SHIFT(486),
  [3356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 45),
  [3364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 1, 0, 0),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [3368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2, 0, 0),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2664),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [3397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2684),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 71),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1, 0, 0),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2, 0, 0),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(508),
  [3427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2827),
  [3430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(849),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 6),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(510),
  [3454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2824),
  [3457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(845),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2, 0, 0),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [3475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2641),
  [3478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(748),
  [3481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2753),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 2, 0, 0),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 74),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 74),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [3514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2739),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 98),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, 0, 79),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 110),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0),
  [3537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(433),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, 0, 97),
  [3544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, 0, 97),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2, 0, 0),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 99),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 75),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 75),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 76),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 76),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [3570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, 0, 18),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [3574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, 0, 46),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_pattern, 2, 0, 0),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 0),
  [3588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 70),
  [3590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(856),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, 0, 16),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 18),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 0),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, 1, 7),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, 0, 96),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 5, 0, 0),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 26),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 26),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3, 0, 0),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2, 0, 0),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(586),
  [3620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [3624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 19),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 52),
  [3636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 52),
  [3638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, 0, 36),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5, 0, 0),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 0),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 53),
  [3648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 53),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [3656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 38),
  [3658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(417),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 0),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0),
  [3675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1580),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [3686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2, 0, 0),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [3704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_pattern, 1, 0, 0),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(491),
  [3711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 26),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 26),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, 0, 13),
  [3724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 120),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 2, 0, 0),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_pattern, 2, 0, 0),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 2, 0, 0),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, 0, 17),
  [3746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 0),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 2, 0, 0),
  [3752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 6, 0, 0),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [3782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 3, 0, 0),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [3788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 3, 0, 0),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1584),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 4),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3, 0, 111),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3, 0, 0),
  [3803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 3, 0, 0),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 3, 0, 0),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1587),
  [3816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, 0, 47),
  [3818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2, 0, 0),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1586),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 5, 0, 0),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, 0, 4),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [3855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1, 0, 0),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [3859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 122),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [3865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 4, 0, 0),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [3873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(584),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_statement, 4, 1, 0),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 4, 0, 0),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [3888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(233),
  [3891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0),
  [3893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2122),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [3900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 4, 0, 0),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 5, 0, 0),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 5, 0, 0),
  [3908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2, 0, 0),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [3912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, 0, 120),
  [3914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, 0, 122),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 4, 0, 0),
  [3918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 111),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 28),
  [3924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 28), SHIFT_REPEAT(2345),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [3943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, 0, 0),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2, 0, 0),
  [3965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2695),
  [3968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2, 0, 0),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [3972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2, 0, 0),
  [3974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1, 0, 0),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 35),
  [3988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 35), SHIFT_REPEAT(599),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, 0, 14),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, -1, 15),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3, 0, 0),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [4041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__as_pattern, 3, 0, 0),
  [4043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 13),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [4047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1554),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [4052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2, 0, 0),
  [4054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2, 0, 0), SHIFT_REPEAT(2231),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, 0, 81), SHIFT_REPEAT(1558),
  [4062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, 0, 81),
  [4064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3, 0, 0),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3, 0, 0),
  [4068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 27),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [4074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 3, 0, 0),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, 0, 8),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 0),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1, 0, 0),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [4100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0),
  [4102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1683),
  [4105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, 0, 29),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [4136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 40), SHIFT_REPEAT(551),
  [4139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 40),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(515),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [4192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, 0, 51),
  [4194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, 0, 51),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1, 0, 0),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1556),
  [4245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(854),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [4260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(500),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0),
  [4265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(464),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [4291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [4294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2, 0, 0),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, 0, 8),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 121), SHIFT_REPEAT(1579),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 121),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [4347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(362),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1, 0, 0),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1555),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [4375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [4378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, 0, 0),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(350),
  [4483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1682),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1, 0, 0),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 73), SHIFT_REPEAT(449),
  [4527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 73),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(468),
  [4541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(853),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [4558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [4584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_value_pattern, 3, 0, 45),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 28), SHIFT_REPEAT(2481),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [4609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [4613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, 0, 0),
  [4615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, 0, 33),
  [4617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 133),
  [4619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, 0, 124),
  [4621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 20),
  [4623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 134),
  [4625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [4627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 3),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, 0, 125),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, 0, 31),
  [4637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, 0, 77),
  [4639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, 0, 69),
  [4641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [4643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, 0, 21),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [4651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [4659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 1, 0, 54),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [4667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, 0, 32),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, 0, 136),
  [4679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, 0, 137),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, 0, 138),
  [4683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 8, 0, 139),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [4693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, 0, 78),
  [4695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1, 0, 0),
  [4707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 33),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [4729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, 0, 30),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1, 0, 0),
  [4733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, 0, 123),
  [4735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1, 0, 0),
  [4741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 4, 0, 112),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 131),
  [4751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 111),
  [4753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 132),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [4763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2, 0, 0),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [4811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 0),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4893] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 0),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1, 0, 0),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token_escape_interpolation = 5,
  ts_external_token_string_end = 6,
  ts_external_token_comment = 7,
  ts_external_token_RBRACK = 8,
  ts_external_token_RPAREN = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_except = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_string_start] = sym_string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_escape_interpolation] = sym_escape_interpolation,
  [ts_external_token_string_end] = sym_string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_except] = anon_sym_except,
};

static const bool ts_external_scanner_states[20][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_except] = true,
  },
  [2] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [7] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [8] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
  },
  [10] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [11] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [15] = {
    [ts_external_token_comment] = true,
  },
  [16] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
  },
  [17] = {
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [18] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_comment] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_python_external_scanner_create(void);
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_python(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
